/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ne){for(var t=[],i=0,N=ne.length;i<N;i++)t[i]=me[ne[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:xt,setPrototypeOf:Wt,isFrozen:ii,getPrototypeOf:si,getOwnPropertyDescriptor:ni}=Object;let{freeze:ot,seal:dt,create:ri}=Object,{apply:Ft,construct:Lt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,i,N){return t.apply(i,N)}),ot||(ot=function(t){return t}),dt||(dt=function(t){return t}),Lt||(Lt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),Ht=ct(Array.prototype.pop),Dt=ct(Array.prototype.push),Et=ct(String.prototype.toLowerCase),kt=ct(String.prototype.toString),ai=ct(String.prototype.match),ft=ct(String.prototype.replace),li=ct(String.prototype.indexOf),ui=ct(String.prototype.trim),ut=ct(RegExp.prototype.test),wt=hi(TypeError);function ct(ne){return function(t){for(var i=arguments.length,N=new Array(i>1?i-1:0),x=1;x<i;x++)N[x-1]=arguments[x];return Ft(ne,t,N)}}function hi(ne){return function(){for(var t=arguments.length,i=new Array(t),N=0;N<t;N++)i[N]=arguments[N];return Lt(ne,i)}}function ze(ne,t,i){var N;i=(N=i)!==null&&N!==void 0?N:Et,Wt&&Wt(ne,null);let x=t.length;for(;x--;){let z=t[x];if(typeof z=="string"){const _=i(z);_!==z&&(ii(t)||(t[x]=_),z=_)}ne[z]=!0}return ne}function pt(ne){const t=ri(null);for(const[i,N]of xt(ne))t[i]=N;return t}function St(ne,t){for(;ne!==null;){const N=ni(ne,t);if(N){if(N.get)return ct(N.get);if(typeof N.value=="function")return ct(N.value)}ne=si(ne)}function i(N){return console.warn("fallback value for",N),null}return i}const zt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ot=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Rt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),di=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=ot(["#text"]),$t=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Ct=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),fi=dt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=dt(/<%[\w\W]*|[\w\W]*%>/gm),mi=dt(/\${[\w\W]*}/gm),pi=dt(/^data-[\-\w.\u00B7-\uFFFF]/),bi=dt(/^aria-[\-\w]+$/),Kt=dt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),vi=dt(/^(?:\w+script|data):/i),Di=dt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),jt=dt(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:fi,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:pi,ARIA_ATTR:bi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:vi,ATTR_WHITESPACE:Di,DOCTYPE_NAME:jt});const wi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const x="data-tt-policy-suffix";i&&i.hasAttribute(x)&&(N=i.getAttribute(x));const z="dompurify"+(N?"#"+N:"");try{return t.createPolicy(z,{createHTML(_){return _},createScriptURL(_){return _}})}catch{return console.warn("TrustedTypes policy "+z+" could not be created."),null}};function Ut(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:wi();const t=xe=>Ut(xe);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const i=ne.document,N=i.currentScript;let{document:x}=ne;const{DocumentFragment:z,HTMLTemplateElement:_,Node:T,Element:f,NodeFilter:g,NamedNodeMap:b=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:B,DOMParser:c,trustedTypes:u}=ne,e=f.prototype,s=St(e,"cloneNode"),o=St(e,"nextSibling"),l=St(e,"childNodes"),d=St(e,"parentNode");if(typeof _=="function"){const xe=x.createElement("template");xe.content&&xe.content.ownerDocument&&(x=xe.content.ownerDocument)}let C,m="";const{implementation:p,createNodeIterator:r,createDocumentFragment:S,getElementsByTagName:A}=x,{importNode:I}=i;let P={};t.isSupported=typeof xt=="function"&&typeof d=="function"&&p&&p.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:$,ERB_EXPR:v,TMPLIT_EXPR:O,DATA_ATTR:q,ARIA_ATTR:L,IS_SCRIPT_OR_DATA:W,ATTR_WHITESPACE:M}=Gt;let{IS_ALLOWED_URI:G}=Gt,K=null;const ae=ze({},[...zt,...Pt,...Ot,...Rt,...Vt]);let ie=null;const ee=ze({},[...$t,...Mt,...qt,...Ct]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ee=null,Se=null,Pe=!0,le=!0,J=!1,he=!0,re=!1,ye=!1,V=!1,Q=!1,ge=!1,De=!1,Ae=!1,Ie=!0,Oe=!1;const H="user-content-";let h=!0,y=!1,a={},w=null;const F=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let n=null;const E=ze({},["audio","video","img","source","image","track"]);let D=null;const k=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),R="http://www.w3.org/1998/Math/MathML",U="http://www.w3.org/2000/svg",Z="http://www.w3.org/1999/xhtml";let oe=Z,ve=!1,de=null;const ke=ze({},[R,U,Z],kt);let Te;const Me=["application/xhtml+xml","text/html"],Ce="text/html";let Ne,Ve=null;const Ye=x.createElement("form"),Ue=function(ue){return ue instanceof RegExp||ue instanceof Function},Je=function(ue){if(!(Ve&&Ve===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=pt(ue),Te=Me.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Te=Ce:Te=ue.PARSER_MEDIA_TYPE,Ne=Te==="application/xhtml+xml"?kt:Et,K="ALLOWED_TAGS"in ue?ze({},ue.ALLOWED_TAGS,Ne):ae,ie="ALLOWED_ATTR"in ue?ze({},ue.ALLOWED_ATTR,Ne):ee,de="ALLOWED_NAMESPACES"in ue?ze({},ue.ALLOWED_NAMESPACES,kt):ke,D="ADD_URI_SAFE_ATTR"in ue?ze(pt(k),ue.ADD_URI_SAFE_ATTR,Ne):k,n="ADD_DATA_URI_TAGS"in ue?ze(pt(E),ue.ADD_DATA_URI_TAGS,Ne):E,w="FORBID_CONTENTS"in ue?ze({},ue.FORBID_CONTENTS,Ne):F,Ee="FORBID_TAGS"in ue?ze({},ue.FORBID_TAGS,Ne):{},Se="FORBID_ATTR"in ue?ze({},ue.FORBID_ATTR,Ne):{},a="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Pe=ue.ALLOW_ARIA_ATTR!==!1,le=ue.ALLOW_DATA_ATTR!==!1,J=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,he=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=ue.SAFE_FOR_TEMPLATES||!1,ye=ue.WHOLE_DOCUMENT||!1,ge=ue.RETURN_DOM||!1,De=ue.RETURN_DOM_FRAGMENT||!1,Ae=ue.RETURN_TRUSTED_TYPE||!1,Q=ue.FORCE_BODY||!1,Ie=ue.SANITIZE_DOM!==!1,Oe=ue.SANITIZE_NAMED_PROPS||!1,h=ue.KEEP_CONTENT!==!1,y=ue.IN_PLACE||!1,G=ue.ALLOWED_URI_REGEXP||Kt,oe=ue.NAMESPACE||Z,ce=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ue(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ue(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),De&&(ge=!0),a&&(K=ze({},[...Vt]),ie=[],a.html===!0&&(ze(K,zt),ze(ie,$t)),a.svg===!0&&(ze(K,Pt),ze(ie,Mt),ze(ie,Ct)),a.svgFilters===!0&&(ze(K,Ot),ze(ie,Mt),ze(ie,Ct)),a.mathMl===!0&&(ze(K,Rt),ze(ie,qt),ze(ie,Ct))),ue.ADD_TAGS&&(K===ae&&(K=pt(K)),ze(K,ue.ADD_TAGS,Ne)),ue.ADD_ATTR&&(ie===ee&&(ie=pt(ie)),ze(ie,ue.ADD_ATTR,Ne)),ue.ADD_URI_SAFE_ATTR&&ze(D,ue.ADD_URI_SAFE_ATTR,Ne),ue.FORBID_CONTENTS&&(w===F&&(w=pt(w)),ze(w,ue.FORBID_CONTENTS,Ne)),h&&(K["#text"]=!0),ye&&ze(K,["html","head","body"]),K.table&&(ze(K,["tbody"]),delete Ee.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');C=ue.TRUSTED_TYPES_POLICY,m=C.createHTML("")}else C===void 0&&(C=yi(u,N)),C!==null&&typeof m=="string"&&(m=C.createHTML(""));ot&&ot(ue),Ve=ue}},X=ze({},["mi","mo","mn","ms","mtext"]),se=ze({},["foreignobject","desc","title","annotation-xml"]),be=ze({},["title","style","font","a","script"]),we=ze({},Pt);ze(we,Ot),ze(we,ci);const Le=ze({},Rt);ze(Le,di);const He=function(ue){let Fe=d(ue);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:oe,tagName:"template"});const Re=Et(ue.tagName),je=Et(Fe.tagName);return de[ue.namespaceURI]?ue.namespaceURI===U?Fe.namespaceURI===Z?Re==="svg":Fe.namespaceURI===R?Re==="svg"&&(je==="annotation-xml"||X[je]):!!we[Re]:ue.namespaceURI===R?Fe.namespaceURI===Z?Re==="math":Fe.namespaceURI===U?Re==="math"&&se[je]:!!Le[Re]:ue.namespaceURI===Z?Fe.namespaceURI===U&&!se[je]||Fe.namespaceURI===R&&!X[je]?!1:!Le[Re]&&(be[Re]||!we[Re]):!!(Te==="application/xhtml+xml"&&de[ue.namespaceURI]):!1},$e=function(ue){Dt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},et=function(ue,Fe){try{Dt(t.removed,{attribute:Fe.getAttributeNode(ue),from:Fe})}catch{Dt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(ue),ue==="is"&&!ie[ue])if(ge||De)try{$e(Fe)}catch{}else try{Fe.setAttribute(ue,"")}catch{}},it=function(ue){let Fe,Re;if(Q)ue="<remove></remove>"+ue;else{const lt=ai(ue,/^[\r\n\t ]+/);Re=lt&&lt[0]}Te==="application/xhtml+xml"&&oe===Z&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const je=C?C.createHTML(ue):ue;if(oe===Z)try{Fe=new c().parseFromString(je,Te)}catch{}if(!Fe||!Fe.documentElement){Fe=p.createDocument(oe,"template",null);try{Fe.documentElement.innerHTML=ve?m:je}catch{}}const st=Fe.body||Fe.documentElement;return ue&&Re&&st.insertBefore(x.createTextNode(Re),st.childNodes[0]||null),oe===Z?A.call(Fe,ye?"html":"body")[0]:ye?Fe.documentElement:st},nt=function(ue){return r.call(ue.ownerDocument||ue,ue,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Qe=function(ue){return ue instanceof B&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof b)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof T=="object"?ue instanceof T:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},tt=function(ue,Fe,Re){P[ue]&&oi(P[ue],je=>{je.call(t,Fe,Re,Ve)})},mt=function(ue){let Fe;if(tt("beforeSanitizeElements",ue,null),Qe(ue))return $e(ue),!0;const Re=Ne(ue.nodeName);if(tt("uponSanitizeElement",ue,{tagName:Re,allowedTags:K}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ut(/<[/\w]/g,ue.innerHTML)&&ut(/<[/\w]/g,ue.textContent))return $e(ue),!0;if(!K[Re]||Ee[Re]){if(!Ee[Re]&&_t(Re)&&(ce.tagNameCheck instanceof RegExp&&ut(ce.tagNameCheck,Re)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Re)))return!1;if(h&&!w[Re]){const je=d(ue)||ue.parentNode,st=l(ue)||ue.childNodes;if(st&&je){const lt=st.length;for(let Xe=lt-1;Xe>=0;--Xe)je.insertBefore(s(st[Xe],!0),o(ue))}}return $e(ue),!0}return ue instanceof f&&!He(ue)||(Re==="noscript"||Re==="noembed"||Re==="noframes")&&ut(/<\/no(script|embed|frames)/i,ue.innerHTML)?($e(ue),!0):(re&&ue.nodeType===3&&(Fe=ue.textContent,Fe=ft(Fe,$," "),Fe=ft(Fe,v," "),Fe=ft(Fe,O," "),ue.textContent!==Fe&&(Dt(t.removed,{element:ue.cloneNode()}),ue.textContent=Fe)),tt("afterSanitizeElements",ue,null),!1)},gt=function(ue,Fe,Re){if(Ie&&(Fe==="id"||Fe==="name")&&(Re in x||Re in Ye))return!1;if(!(le&&!Se[Fe]&&ut(q,Fe))){if(!(Pe&&ut(L,Fe))){if(!ie[Fe]||Se[Fe]){if(!(_t(ue)&&(ce.tagNameCheck instanceof RegExp&&ut(ce.tagNameCheck,ue)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(ue))&&(ce.attributeNameCheck instanceof RegExp&&ut(ce.attributeNameCheck,Fe)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Fe))||Fe==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&ut(ce.tagNameCheck,Re)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Re))))return!1}else if(!D[Fe]){if(!ut(G,ft(Re,M,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&ue!=="script"&&li(Re,"data:")===0&&n[ue])){if(!(J&&!ut(W,ft(Re,M,"")))){if(Re)return!1}}}}}}return!0},_t=function(ue){return ue.indexOf("-")>0},At=function(ue){let Fe,Re,je,st;tt("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(st=lt.length;st--;){Fe=lt[st];const{name:ht,namespaceURI:bt}=Fe;if(Re=ht==="value"?Fe.value:ui(Fe.value),je=Ne(ht),Xe.attrName=je,Xe.attrValue=Re,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ue,Xe),Re=Xe.attrValue,Xe.forceKeepAttr||(et(ht,ue),!Xe.keepAttr))continue;if(!he&&ut(/\/>/i,Re)){et(ht,ue);continue}re&&(Re=ft(Re,$," "),Re=ft(Re,v," "),Re=ft(Re,O," "));const It=Ne(ue.nodeName);if(gt(It,je,Re)){if(Oe&&(je==="id"||je==="name")&&(et(ht,ue),Re=H+Re),C&&typeof u=="object"&&typeof u.getAttributeType=="function"&&!bt)switch(u.getAttributeType(It,je)){case"TrustedHTML":{Re=C.createHTML(Re);break}case"TrustedScriptURL":{Re=C.createScriptURL(Re);break}}try{bt?ue.setAttributeNS(bt,ht,Re):ue.setAttribute(ht,Re),Ht(t.removed)}catch{}}}tt("afterSanitizeAttributes",ue,null)},Tt=function xe(ue){let Fe;const Re=nt(ue);for(tt("beforeSanitizeShadowDOM",ue,null);Fe=Re.nextNode();)tt("uponSanitizeShadowNode",Fe,null),!mt(Fe)&&(Fe.content instanceof z&&xe(Fe.content),At(Fe));tt("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(xe){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Re,je,st;if(ve=!xe,ve&&(xe="<!-->"),typeof xe!="string"&&!rt(xe))if(typeof xe.toString=="function"){if(xe=xe.toString(),typeof xe!="string")throw wt("dirty is not a string, aborting")}else throw wt("toString is not a function");if(!t.isSupported)return xe;if(V||Je(ue),t.removed=[],typeof xe=="string"&&(y=!1),y){if(xe.nodeName){const ht=Ne(xe.nodeName);if(!K[ht]||Ee[ht])throw wt("root node is forbidden and cannot be sanitized in-place")}}else if(xe instanceof T)Fe=it("<!---->"),Re=Fe.ownerDocument.importNode(xe,!0),Re.nodeType===1&&Re.nodeName==="BODY"||Re.nodeName==="HTML"?Fe=Re:Fe.appendChild(Re);else{if(!ge&&!re&&!ye&&xe.indexOf("<")===-1)return C&&Ae?C.createHTML(xe):xe;if(Fe=it(xe),!Fe)return ge?null:Ae?m:""}Fe&&Q&&$e(Fe.firstChild);const lt=nt(y?xe:Fe);for(;je=lt.nextNode();)mt(je)||(je.content instanceof z&&Tt(je.content),At(je));if(y)return xe;if(ge){if(De)for(st=S.call(Fe.ownerDocument);Fe.firstChild;)st.appendChild(Fe.firstChild);else st=Fe;return(ie.shadowroot||ie.shadowrootmode)&&(st=I.call(i,st,!0)),st}let Xe=ye?Fe.outerHTML:Fe.innerHTML;return ye&&K["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ut(jt,Fe.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Xe),re&&(Xe=ft(Xe,$," "),Xe=ft(Xe,v," "),Xe=ft(Xe,O," ")),C&&Ae?C.createHTML(Xe):Xe},t.setConfig=function(xe){Je(xe),V=!0},t.clearConfig=function(){Ve=null,V=!1},t.isValidAttribute=function(xe,ue,Fe){Ve||Je({});const Re=Ne(xe),je=Ne(ue);return gt(Re,je,Fe)},t.addHook=function(xe,ue){typeof ue=="function"&&(P[xe]=P[xe]||[],Dt(P[xe],ue))},t.removeHook=function(xe){if(P[xe])return Ht(P[xe])},t.removeHooks=function(xe){P[xe]&&(P[xe]=[])},t.removeAllHooks=function(){P={}},t}var Ei=Ut();define("vs/base/browser/dompurify/dompurify",function(){return Ei}),define(me[51],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=x;class i{constructor(_){this.domNode=_,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(_){const T=N(_);this._maxWidth!==T&&(this._maxWidth=T,this.domNode.style.maxWidth=this._maxWidth)}setWidth(_){const T=N(_);this._width!==T&&(this._width=T,this.domNode.style.width=this._width)}setHeight(_){const T=N(_);this._height!==T&&(this._height=T,this.domNode.style.height=this._height)}setTop(_){const T=N(_);this._top!==T&&(this._top=T,this.domNode.style.top=this._top)}setLeft(_){const T=N(_);this._left!==T&&(this._left=T,this.domNode.style.left=this._left)}setBottom(_){const T=N(_);this._bottom!==T&&(this._bottom=T,this.domNode.style.bottom=this._bottom)}setRight(_){const T=N(_);this._right!==T&&(this._right=T,this.domNode.style.right=this._right)}setPaddingTop(_){const T=N(_);this._paddingTop!==T&&(this._paddingTop=T,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(_){const T=N(_);this._paddingLeft!==T&&(this._paddingLeft=T,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(_){const T=N(_);this._paddingBottom!==T&&(this._paddingBottom=T,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(_){const T=N(_);this._paddingRight!==T&&(this._paddingRight=T,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(_){this._fontFamily!==_&&(this._fontFamily=_,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(_){this._fontWeight!==_&&(this._fontWeight=_,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(_){const T=N(_);this._fontSize!==T&&(this._fontSize=T,this.domNode.style.fontSize=this._fontSize)}setFontStyle(_){this._fontStyle!==_&&(this._fontStyle=_,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(_){this._fontFeatureSettings!==_&&(this._fontFeatureSettings=_,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(_){this._fontVariationSettings!==_&&(this._fontVariationSettings=_,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(_){this._textDecoration!==_&&(this._textDecoration=_,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(_){const T=N(_);this._lineHeight!==T&&(this._lineHeight=T,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(_){const T=N(_);this._letterSpacing!==T&&(this._letterSpacing=T,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(_){this._className!==_&&(this._className=_,this.domNode.className=this._className)}toggleClassName(_,T){this.domNode.classList.toggle(_,T),this._className=this.domNode.className}setDisplay(_){this._display!==_&&(this._display=_,this.domNode.style.display=this._display)}setPosition(_){this._position!==_&&(this._position=_,this.domNode.style.position=this._position)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this.domNode.style.visibility=this._visibility)}setColor(_){this._color!==_&&(this._color=_,this.domNode.style.color=this._color)}setBackgroundColor(_){this._backgroundColor!==_&&(this._backgroundColor=_,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(_){this._layerHint!==_&&(this._layerHint=_,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(_){this._boxShadow!==_&&(this._boxShadow=_,this.domNode.style.boxShadow=_)}setContain(_){this._contain!==_&&(this._contain=_,this.domNode.style.contain=this._contain)}setAttribute(_,T){this.domNode.setAttribute(_,T)}removeAttribute(_){this.domNode.removeAttribute(_)}appendChild(_){this.domNode.appendChild(_.domNode)}removeChild(_){this.domNode.removeChild(_.domNode)}}t.FastDomNode=i;function N(z){return typeof z=="number"?`${z}px`:z}function x(z){return new i(z)}}),define(me[79],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=z;const i=new WeakMap;function N(T){if(!T.parent||T.parent===T)return null;try{const f=T.location,g=T.parent.location;if(f.origin!=="null"&&g.origin!=="null"&&f.origin!==g.origin)return null}catch{return null}return T.parent}class x{static getSameOriginWindowChain(f){let g=i.get(f);if(!g){g=[],i.set(f,g);let b=f,B;do B=N(b),B?g.push({window:new WeakRef(b),iframeElement:b.frameElement||null}):g.push({window:new WeakRef(b),iframeElement:null}),b=B;while(b)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(f,g){if(!g||f===g)return{top:0,left:0};let b=0,B=0;const c=this.getSameOriginWindowChain(f);for(const u of c){const e=u.window.deref();if(b+=e?.scrollY??0,B+=e?.scrollX??0,e===g||!u.iframeElement)break;const s=u.iframeElement.getBoundingClientRect();b+=s.top,B+=s.left}return{top:b,left:B}}}t.IframeUtils=x;async function z(T,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:T,salt:f}),B=new TextEncoder().encode(g),c=await crypto.subtle.digest("sha-256",B);return _(c)}function _(T){const g=Array.from(new Uint8Array(T)).map(b=>b.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(me[29],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setBaseLayerHoverDelegate=N,t.getBaseLayerHoverDelegate=x;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function N(z){i=z}function x(){return i}}),define(me[80],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(_){_[_.Copy=0]="Copy",_[_.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var N;(function(_){_.Over="drop-target",_.Before="drop-target-before",_.After="drop-target-after"})(N||(t.ListDragOverEffectPosition=N={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class x extends Error{constructor(T,f){super(`ListError [${T}] ${f}`)}}t.ListError=x;class z{constructor(){this.cache=new WeakMap}getHeight(T){return this.cache.get(T)??this.estimateHeight(T)}setDynamicHeight(T,f){f>0&&this.cache.set(T,f)}}t.CachedListVirtualDelegate=z}),define(me[81],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class i{constructor(x){this.spliceables=x}splice(x,z,_){this.spliceables.forEach(T=>T.splice(x,z,_))}}t.CombinedSpliceable=i}),define(me[52],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const i=20;class N{constructor(z,_,T,f,g,b){this._scrollbarSize=Math.round(_),this._oppositeScrollbarSize=Math.round(T),this._arrowSize=Math.round(z),this._visibleSize=f,this._scrollSize=g,this._scrollPosition=b,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new N(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(z){const _=Math.round(z);return this._visibleSize!==_?(this._visibleSize=_,this._refreshComputedValues(),!0):!1}setScrollSize(z){const _=Math.round(z);return this._scrollSize!==_?(this._scrollSize=_,this._refreshComputedValues(),!0):!1}setScrollPosition(z){const _=Math.round(z);return this._scrollPosition!==_?(this._scrollPosition=_,this._refreshComputedValues(),!0):!1}setScrollbarSize(z){this._scrollbarSize=Math.round(z)}setOppositeScrollbarSize(z){this._oppositeScrollbarSize=Math.round(z)}static _computeValues(z,_,T,f,g){const b=Math.max(0,T-z),B=Math.max(0,b-2*_),c=f>0&&f>T;if(!c)return{computedAvailableSize:Math.round(b),computedIsNeeded:c,computedSliderSize:Math.round(B),computedSliderRatio:0,computedSliderPosition:0};const u=Math.round(Math.max(i,Math.floor(T*B/f))),e=(B-u)/(f-T),s=g*e;return{computedAvailableSize:Math.round(b),computedIsNeeded:c,computedSliderSize:Math.round(u),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const z=N._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=z.computedAvailableSize,this._computedIsNeeded=z.computedIsNeeded,this._computedSliderSize=z.computedSliderSize,this._computedSliderRatio=z.computedSliderRatio,this._computedSliderPosition=z.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(z){if(!this._computedIsNeeded)return 0;const _=z-this._arrowSize-this._computedSliderSize/2;return Math.round(_/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(z){if(!this._computedIsNeeded)return 0;const _=z-this._arrowSize;let T=this._scrollPosition;return _<this._computedSliderPosition?T-=this._visibleSize:T+=this._visibleSize,T}getDesiredScrollPositionFromDelta(z){if(!this._computedIsNeeded)return 0;const _=this._computedSliderPosition+z;return Math.round(_/this._computedSliderRatio)}}t.ScrollbarState=N}),define(me[30],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var N;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var x;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(x||(t.TreeMouseEventTarget=x={}));var z;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(z||(t.TreeDragOverBubble=z={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(f=!1){return{accept:!0,bubble:0,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:f}}};class _ extends Error{constructor(g,b){super(`TreeError [${g}] ${b}`)}}t.TreeError=_;class T{constructor(g){this.fn=g,this._map=new WeakMap}map(g){let b=this._map.get(g);return b||(b=this.fn(g),this._map.set(g,b)),b}}t.WeakMapper=T}),define(me[22],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=i,t.isAuxiliaryWindow=N;function i(x,z){const _=x;typeof _.vscodeWindowId!="number"&&Object.defineProperty(_,"vscodeWindowId",{get:()=>z})}t.mainWindow=window;function N(x){return x===t.mainWindow?!1:typeof x?.vscodeWindowId=="number"}}),define(me[82],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=N,t.findLastMonotonous=x,t.findLastIdxMonotonous=z,t.findFirstMonotonous=_,t.findFirstIdxMonotonousOrArrLen=T,t.findFirstIdxMonotonous=f,t.findFirstMax=b,t.findLastMax=B,t.findFirstMin=c,t.findMaxIdx=u,t.mapFindFirst=e;function i(s,o){const l=N(s,o);if(l!==-1)return s[l]}function N(s,o,l=s.length-1){for(let d=l;d>=0;d--){const C=s[d];if(o(C))return d}return-1}function x(s,o){const l=z(s,o);return l===-1?void 0:s[l]}function z(s,o,l=0,d=s.length){let C=l,m=d;for(;C<m;){const p=Math.floor((C+m)/2);o(s[p])?C=p+1:m=p}return C-1}function _(s,o){const l=T(s,o);return l===s.length?void 0:s[l]}function T(s,o,l=0,d=s.length){let C=l,m=d;for(;C<m;){const p=Math.floor((C+m)/2);o(s[p])?m=p:C=p+1}return C}function f(s,o,l=0,d=s.length){const C=T(s,o,l,d);return C===s.length?-1:C}class g{static{this.assertInvariants=!1}constructor(o){this._array=o,this._findLastMonotonousLastIdx=0}findLastMonotonous(o){if(g.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!o(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=o}const l=z(this._array,o,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=l+1,l===-1?void 0:this._array[l]}}t.MonotonousArray=g;function b(s,o){if(s.length===0)return;let l=s[0];for(let d=1;d<s.length;d++){const C=s[d];o(C,l)>0&&(l=C)}return l}function B(s,o){if(s.length===0)return;let l=s[0];for(let d=1;d<s.length;d++){const C=s[d];o(C,l)>=0&&(l=C)}return l}function c(s,o){return b(s,(l,d)=>-o(l,d))}function u(s,o){if(s.length===0)return-1;let l=0;for(let d=1;d<s.length;d++){const C=s[d];o(C,s[l])>0&&(l=d)}return l}function e(s,o){for(const l of s){const d=o(l);if(d!==void 0)return d}}}),define(me[83],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=i,t.diffSets=N,t.diffMaps=x,t.intersection=z;function i(_,T){const f=Object.create(null);for(const g of _){const b=T(g);let B=f[b];B||(B=f[b]=[]),B.push(g)}return f}function N(_,T){const f=[],g=[];for(const b of _)T.has(b)||f.push(b);for(const b of T)_.has(b)||g.push(b);return{removed:f,added:g}}function x(_,T){const f=[],g=[];for(const[b,B]of _)T.has(b)||f.push(B);for(const[b,B]of T)_.has(b)||g.push(B);return{removed:f,added:g}}function z(_,T){const f=new Set;for(const g of T)_.has(g)&&f.add(g);return f}}),define(me[84],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function i(T,f){const g=Math.pow(10,f);return Math.round(T*g)/g}class N{constructor(f,g,b,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals(f,g){return f.r===g.r&&f.g===g.g&&f.b===g.b&&f.a===g.a}}t.RGBA=N;class x{constructor(f,g,b,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.l=i(Math.max(Math.min(1,b),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.l===g.l&&f.a===g.a}static fromRGBA(f){const g=f.r/255,b=f.g/255,B=f.b/255,c=f.a,u=Math.max(g,b,B),e=Math.min(g,b,B);let s=0,o=0;const l=(e+u)/2,d=u-e;if(d>0){switch(o=Math.min(l<=.5?d/(2*l):d/(2-2*l),1),u){case g:s=(b-B)/d+(b<B?6:0);break;case b:s=(B-g)/d+2;break;case B:s=(g-b)/d+4;break}s*=60,s=Math.round(s)}return new x(s,o,l,c)}static _hue2rgb(f,g,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?f+(g-f)*6*b:b<1/2?g:b<2/3?f+(g-f)*(2/3-b)*6:f}static toRGBA(f){const g=f.h/360,{s:b,l:B,a:c}=f;let u,e,s;if(b===0)u=e=s=B;else{const o=B<.5?B*(1+b):B+b-B*b,l=2*B-o;u=x._hue2rgb(l,o,g+1/3),e=x._hue2rgb(l,o,g),s=x._hue2rgb(l,o,g-1/3)}return new N(Math.round(u*255),Math.round(e*255),Math.round(s*255),c)}}t.HSLA=x;class z{constructor(f,g,b,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.v=i(Math.max(Math.min(1,b),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.v===g.v&&f.a===g.a}static fromRGBA(f){const g=f.r/255,b=f.g/255,B=f.b/255,c=Math.max(g,b,B),u=Math.min(g,b,B),e=c-u,s=c===0?0:e/c;let o;return e===0?o=0:c===g?o=((b-B)/e%6+6)%6:c===b?o=(B-g)/e+2:o=(g-b)/e+4,new z(Math.round(o*60),s,c,f.a)}static toRGBA(f){const{h:g,s:b,v:B,a:c}=f,u=B*b,e=u*(1-Math.abs(g/60%2-1)),s=B-u;let[o,l,d]=[0,0,0];return g<60?(o=u,l=e):g<120?(o=e,l=u):g<180?(l=u,d=e):g<240?(l=e,d=u):g<300?(o=e,d=u):g<=360&&(o=u,d=e),o=Math.round((o+s)*255),l=Math.round((l+s)*255),d=Math.round((d+s)*255),new N(o,l,d,c)}}t.HSVA=z;class _{static fromHex(f){return _.Format.CSS.parseHex(f)||_.red}static equals(f,g){return!f&&!g?!0:!f||!g?!1:f.equals(g)}get hsla(){return this._hsla?this._hsla:x.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:z.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof N)this.rgba=f;else if(f instanceof x)this._hsla=f,this.rgba=x.toRGBA(f);else if(f instanceof z)this._hsva=f,this.rgba=z.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&N.equals(this.rgba,f.rgba)&&x.equals(this.hsla,f.hsla)&&z.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=_._relativeLuminanceForComponent(this.rgba.r),g=_._relativeLuminanceForComponent(this.rgba.g),b=_._relativeLuminanceForComponent(this.rgba.b),B=.2126*f+.7152*g+.0722*b;return i(B,4)}static _relativeLuminanceForComponent(f){const g=f/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(f){const g=this.getRelativeLuminance(),b=f.getRelativeLuminance();return g>b?(g+.05)/(b+.05):(b+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const g=this.getRelativeLuminance(),b=f.getRelativeLuminance();return g>b}isDarkerThan(f){const g=this.getRelativeLuminance(),b=f.getRelativeLuminance();return g<b}lighten(f){return new _(new x(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new _(new x(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:g,g:b,b:B,a:c}=this.rgba;return new _(new N(g,b,B,c*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new _(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const g=f.rgba,b=this.rgba.a,B=g.a,c=b+B*(1-b);if(c<1e-6)return _.transparent;const u=this.rgba.r*b/c+g.r*B*(1-b)/c,e=this.rgba.g*b/c+g.g*B*(1-b)/c,s=this.rgba.b*b/c+g.b*B*(1-b)/c;return new _(new N(u,e,s,c))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:g,g:b,b:B,a:c}=this.rgba;return new _(new N(f.rgba.r-c*(f.rgba.r-g),f.rgba.g-c*(f.rgba.g-b),f.rgba.b-c*(f.rgba.b-B),1))}flatten(...f){const g=f.reduceRight((b,B)=>_._flatten(B,b));return _._flatten(this,g)}static _flatten(f,g){const b=1-f.rgba.a;return new _(new N(b*g.rgba.r+f.rgba.a*f.rgba.r,b*g.rgba.g+f.rgba.a*f.rgba.g,b*g.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=_.Format.CSS.format(this)),this._toString}static getLighterColor(f,g,b){if(f.isLighterThan(g))return f;b=b||.5;const B=f.getRelativeLuminance(),c=g.getRelativeLuminance();return b=b*(c-B)/c,f.lighten(b)}static getDarkerColor(f,g,b){if(f.isDarkerThan(g))return f;b=b||.5;const B=f.getRelativeLuminance(),c=g.getRelativeLuminance();return b=b*(B-c)/B,f.darken(b)}static{this.white=new _(new N(255,255,255,1))}static{this.black=new _(new N(0,0,0,1))}static{this.red=new _(new N(255,0,0,1))}static{this.blue=new _(new N(0,0,255,1))}static{this.green=new _(new N(0,255,0,1))}static{this.cyan=new _(new N(0,255,255,1))}static{this.lightgrey=new _(new N(211,211,211,1))}static{this.transparent=new _(new N(0,0,0,0))}}t.Color=_,function(T){let f;(function(g){let b;(function(B){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:T.Format.CSS.formatRGBA(r)}B.formatRGB=c;function u(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}B.formatRGBA=u;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:T.Format.CSS.formatHSLA(r)}B.formatHSL=e;function s(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}B.formatHSLA=s;function o(r){const S=r.toString(16);return S.length!==2?"0"+S:S}function l(r){return`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}`}B.formatHex=l;function d(r,S=!1){return S&&r.rgba.a===1?T.Format.CSS.formatHex(r):`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}${o(Math.round(r.rgba.a*255))}`}B.formatHexA=d;function C(r){return r.isOpaque()?T.Format.CSS.formatHex(r):T.Format.CSS.formatRGBA(r)}B.format=C;function m(r){const S=r.length;if(S===0||r.charCodeAt(0)!==35)return null;if(S===7){const A=16*p(r.charCodeAt(1))+p(r.charCodeAt(2)),I=16*p(r.charCodeAt(3))+p(r.charCodeAt(4)),P=16*p(r.charCodeAt(5))+p(r.charCodeAt(6));return new T(new N(A,I,P,1))}if(S===9){const A=16*p(r.charCodeAt(1))+p(r.charCodeAt(2)),I=16*p(r.charCodeAt(3))+p(r.charCodeAt(4)),P=16*p(r.charCodeAt(5))+p(r.charCodeAt(6)),$=16*p(r.charCodeAt(7))+p(r.charCodeAt(8));return new T(new N(A,I,P,$/255))}if(S===4){const A=p(r.charCodeAt(1)),I=p(r.charCodeAt(2)),P=p(r.charCodeAt(3));return new T(new N(16*A+A,16*I+I,16*P+P))}if(S===5){const A=p(r.charCodeAt(1)),I=p(r.charCodeAt(2)),P=p(r.charCodeAt(3)),$=p(r.charCodeAt(4));return new T(new N(16*A+A,16*I+I,16*P+P,(16*$+$)/255))}return null}B.parseHex=m;function p(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=g.CSS||(g.CSS={}))})(f=T.Format||(T.Format={}))}(_||(t.Color=_={}))}),define(me[31],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=N,t.debounce=x,t.throttle=z;function i(_){return(T,f,g)=>{let b=null,B=null;if(typeof g.value=="function"?(b="value",B=g.value):typeof g.get=="function"&&(b="get",B=g.get),!B)throw new Error("not supported");g[b]=_(B,f)}}function N(_,T,f){let g=null,b=null;if(typeof f.value=="function"?(g="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",b=f.get),!b)throw new Error("not supported");const B=`$memoize$${T}`;f[g]=function(...c){return this.hasOwnProperty(B)||Object.defineProperty(this,B,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,c)}),this[B]}}function x(_,T,f){return i((g,b)=>{const B=`$debounce$${b}`,c=`$debounce$result$${b}`;return function(...u){this[c]||(this[c]=f?f():void 0),clearTimeout(this[B]),T&&(this[c]=T(this[c],...u),u=[this[c]]),this[B]=setTimeout(()=>{g.apply(this,u),this[c]=f?f():void 0},_)}})}function z(_,T,f){return i((g,b)=>{const B=`$throttle$timer$${b}`,c=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,e=`$throttle$pending$${b}`;return function(...s){if(this[c]||(this[c]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),T&&(this[c]=T(this[c],...s)),this[e])return;const o=this[u]+_;o<=Date.now()?(this[u]=Date.now(),g.apply(this,[this[c]]),this[c]=f?f():void 0):(this[e]=!0,this[B]=setTimeout(()=>{this[e]=!1,this[u]=Date.now(),g.apply(this,[this[c]]),this[c]=f?f():void 0},o-Date.now()))}})}}),define(me[85],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(x,z,_,T){this.originalStart=x,this.originalLength=z,this.modifiedStart=_,this.modifiedLength=T}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),define(me[6],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=N,t.isSigPipeError=x,t.onUnexpectedError=z,t.onUnexpectedExternalError=_,t.transformErrorForSerialization=T,t.isCancellationError=g,t.canceled=B,t.illegalArgument=c,t.illegalState=u,t.getErrorMessage=s;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?C.isErrorNoTelemetry(r)?new C(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(S=>{S(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}t.ErrorHandler=i,t.errorHandler=new i;function N(p){t.errorHandler.setUnexpectedErrorHandler(p)}function x(p){if(!p||typeof p!="object")return!1;const r=p;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function z(p){g(p)||t.errorHandler.onUnexpectedError(p)}function _(p){g(p)||t.errorHandler.onUnexpectedExternalError(p)}function T(p){if(p instanceof Error){const{name:r,message:S}=p,A=p.stacktrace||p.stack;return{$isError:!0,name:r,message:S,stack:A,noTelemetry:C.isErrorNoTelemetry(p)}}return p}const f="Canceled";function g(p){return p instanceof b?!0:p instanceof Error&&p.name===f&&p.message===f}class b extends Error{constructor(){super(f),this.name=this.message}}t.CancellationError=b;function B(){const p=new Error(f);return p.name=p.message,p}function c(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function s(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.NotImplementedError=o;class l extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=d;class C extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof C)return r;const S=new C;return S.message=r.message,S.stack=r.stack,S}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.ErrorNoTelemetry=C;class m extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.BugIndicatingError=m}),define(me[8],pe([1,0,6,82]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=x,t.tail2=z,t.equals=_,t.removeFastWithoutKeepingOrder=T,t.binarySearch=f,t.binarySearch2=g,t.quickSelect=b,t.groupBy=B,t.groupAdjacentBy=c,t.forEachAdjacent=u,t.forEachWithNeighbors=e,t.sortedDiff=s,t.delta=o,t.top=l,t.topAsync=d,t.coalesce=m,t.coalesceInPlace=p,t.move=r,t.isFalsyOrEmpty=S,t.isNonEmptyArray=A,t.distinct=I,t.uniqueFilter=P,t.firstOrDefault=$,t.lastOrDefault=v,t.commonPrefixLength=O,t.flatten=q,t.range=L,t.index=W,t.insert=M,t.remove=G,t.arrayInsert=K,t.shuffle=ae,t.pushToStart=ie,t.pushToEnd=ee,t.pushMany=ce,t.mapArrayOrNot=Ee,t.asArray=Se,t.getRandomElement=Pe,t.insertInto=le,t.splice=J,t.compareBy=ye,t.tieBreakComparators=V,t.reverseOrder=De;function x(H,h=0){return H[H.length-(1+h)]}function z(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function _(H,h,y=(a,w)=>a===w){if(H===h)return!0;if(!H||!h||H.length!==h.length)return!1;for(let a=0,w=H.length;a<w;a++)if(!y(H[a],h[a]))return!1;return!0}function T(H,h){const y=H.length-1;h<y&&(H[h]=H[y]),H.pop()}function f(H,h,y){return g(H.length,a=>y(H[a],h))}function g(H,h){let y=0,a=H-1;for(;y<=a;){const w=(y+a)/2|0,F=h(w);if(F<0)y=w+1;else if(F>0)a=w-1;else return w}return-(y+1)}function b(H,h,y){if(H=H|0,H>=h.length)throw new TypeError("invalid index");const a=h[Math.floor(h.length*Math.random())],w=[],F=[],n=[];for(const E of h){const D=y(E,a);D<0?w.push(E):D>0?F.push(E):n.push(E)}return H<w.length?b(H,w,y):H<w.length+n.length?n[0]:b(H-(w.length+n.length),F,y)}function B(H,h){const y=[];let a;for(const w of H.slice(0).sort(h))!a||h(a[0],w)!==0?(a=[w],y.push(a)):a.push(w);return y}function*c(H,h){let y,a;for(const w of H)a!==void 0&&h(a,w)?y.push(w):(y&&(yield y),y=[w]),a=w;y&&(yield y)}function u(H,h){for(let y=0;y<=H.length;y++)h(y===0?void 0:H[y-1],y===H.length?void 0:H[y])}function e(H,h){for(let y=0;y<H.length;y++)h(y===0?void 0:H[y-1],H[y],y+1===H.length?void 0:H[y+1])}function s(H,h,y){const a=[];function w(E,D,k){if(D===0&&k.length===0)return;const R=a[a.length-1];R&&R.start+R.deleteCount===E?(R.deleteCount+=D,R.toInsert.push(...k)):a.push({start:E,deleteCount:D,toInsert:k})}let F=0,n=0;for(;;){if(F===H.length){w(F,0,h.slice(n));break}if(n===h.length){w(F,H.length-F,[]);break}const E=H[F],D=h[n],k=y(E,D);k===0?(F+=1,n+=1):k<0?(w(F,1,[]),F+=1):k>0&&(w(F,0,[D]),n+=1)}return a}function o(H,h,y){const a=s(H,h,y),w=[],F=[];for(const n of a)w.push(...H.slice(n.start,n.start+n.deleteCount)),F.push(...n.toInsert);return{removed:w,added:F}}function l(H,h,y){if(y===0)return[];const a=H.slice(0,y).sort(h);return C(H,h,a,y,H.length),a}function d(H,h,y,a,w){return y===0?Promise.resolve([]):new Promise((F,n)=>{(async()=>{const E=H.length,D=H.slice(0,y).sort(h);for(let k=y,R=Math.min(y+a,E);k<E;k=R,R=Math.min(R+a,E)){if(k>y&&await new Promise(U=>setTimeout(U)),w&&w.isCancellationRequested)throw new i.CancellationError;C(H,h,D,k,R)}return D})().then(F,n)})}function C(H,h,y,a,w){for(const F=y.length;a<w;a++){const n=H[a];if(h(n,y[F-1])<0){y.pop();const E=(0,N.findFirstIdxMonotonousOrArrLen)(y,D=>h(n,D)<0);y.splice(E,0,n)}}}function m(H){return H.filter(h=>!!h)}function p(H){let h=0;for(let y=0;y<H.length;y++)H[y]&&(H[h]=H[y],h+=1);H.length=h}function r(H,h,y){H.splice(y,0,H.splice(h,1)[0])}function S(H){return!Array.isArray(H)||H.length===0}function A(H){return Array.isArray(H)&&H.length>0}function I(H,h=y=>y){const y=new Set;return H.filter(a=>{const w=h(a);return y.has(w)?!1:(y.add(w),!0)})}function P(H){const h=new Set;return y=>{const a=H(y);return h.has(a)?!1:(h.add(a),!0)}}function $(H,h){return H.length>0?H[0]:h}function v(H,h){return H.length>0?H[H.length-1]:h}function O(H,h,y=(a,w)=>a===w){let a=0;for(let w=0,F=Math.min(H.length,h.length);w<F&&y(H[w],h[w]);w++)a++;return a}function q(H){return[].concat(...H)}function L(H,h){let y=typeof h=="number"?H:0;typeof h=="number"?y=H:(y=0,h=H);const a=[];if(y<=h)for(let w=y;w<h;w++)a.push(w);else for(let w=y;w>h;w--)a.push(w);return a}function W(H,h,y){return H.reduce((a,w)=>(a[h(w)]=y?y(w):w,a),Object.create(null))}function M(H,h){return H.push(h),()=>G(H,h)}function G(H,h){const y=H.indexOf(h);if(y>-1)return H.splice(y,1),h}function K(H,h,y){const a=H.slice(0,h),w=H.slice(h);return a.concat(y,w)}function ae(H,h){let y;if(typeof h=="number"){let a=h;y=()=>{const w=Math.sin(a++)*179426549;return w-Math.floor(w)}}else y=Math.random;for(let a=H.length-1;a>0;a-=1){const w=Math.floor(y()*(a+1)),F=H[a];H[a]=H[w],H[w]=F}}function ie(H,h){const y=H.indexOf(h);y>-1&&(H.splice(y,1),H.unshift(h))}function ee(H,h){const y=H.indexOf(h);y>-1&&(H.splice(y,1),H.push(h))}function ce(H,h){for(const y of h)H.push(y)}function Ee(H,h){return Array.isArray(H)?H.map(h):h(H)}function Se(H){return Array.isArray(H)?H:[H]}function Pe(H){return H[Math.floor(Math.random()*H.length)]}function le(H,h,y){const a=he(H,h),w=H.length,F=y.length;H.length=w+F;for(let n=w-1;n>=a;n--)H[n+F]=H[n];for(let n=0;n<F;n++)H[n+a]=y[n]}function J(H,h,y,a){const w=he(H,h);let F=H.splice(w,y);return F===void 0&&(F=[]),le(H,w,a),F}function he(H,h){return h<0?Math.max(h+H.length,0):Math.min(h,H.length)}var re;(function(H){function h(F){return F<0}H.isLessThan=h;function y(F){return F<=0}H.isLessThanOrEqual=y;function a(F){return F>0}H.isGreaterThan=a;function w(F){return F===0}H.isNeitherLessOrGreaterThan=w,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function ye(H,h){return(y,a)=>h(H(y),H(a))}function V(...H){return(h,y)=>{for(const a of H){const w=a(h,y);if(!re.isNeitherLessOrGreaterThan(w))return w}return re.neitherLessOrGreaterThan}}const Q=(H,h)=>H-h;t.numberComparator=Q;const ge=(H,h)=>(0,t.numberComparator)(H?1:0,h?1:0);t.booleanComparator=ge;function De(H){return(h,y)=>-H(h,y)}class Ae{constructor(h){this.items=h,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(h){let y=this.firstIdx;for(;y<this.items.length&&h(this.items[y]);)y++;const a=y===this.firstIdx?null:this.items.slice(this.firstIdx,y);return this.firstIdx=y,a}takeFromEndWhile(h){let y=this.lastIdx;for(;y>=0&&h(this.items[y]);)y--;const a=y===this.lastIdx?null:this.items.slice(y+1,this.lastIdx+1);return this.lastIdx=y,a}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const h=this.items[this.firstIdx];return this.firstIdx++,h}removeLast(){const h=this.items[this.lastIdx];return this.lastIdx--,h}takeCount(h){const y=this.items.slice(this.firstIdx,this.firstIdx+h);return this.firstIdx+=h,y}}t.ArrayQueue=Ae;class Ie{static{this.empty=new Ie(h=>{})}constructor(h){this.iterate=h}forEach(h){this.iterate(y=>(h(y),!0))}toArray(){const h=[];return this.iterate(y=>(h.push(y),!0)),h}filter(h){return new Ie(y=>this.iterate(a=>h(a)?y(a):!0))}map(h){return new Ie(y=>this.iterate(a=>y(h(a))))}some(h){let y=!1;return this.iterate(a=>(y=h(a),!y)),y}findFirst(h){let y;return this.iterate(a=>h(a)?(y=a,!1):!0),y}findLast(h){let y;return this.iterate(a=>(h(a)&&(y=a),!0)),y}findLastMaxBy(h){let y,a=!0;return this.iterate(w=>((a||re.isGreaterThan(h(w,y)))&&(a=!1,y=w),!0)),y}}t.CallbackIterable=Ie;class Oe{constructor(h){this._indexMap=h}static createSortPermutation(h,y){const a=Array.from(h.keys()).sort((w,F)=>y(h[w],h[F]));return new Oe(a)}apply(h){return h.map((y,a)=>h[this._indexMap[a]])}inverse(){const h=this._indexMap.slice();for(let y=0;y<this._indexMap.length;y++)h[this._indexMap[y]]=y;return new Oe(h)}}t.Permutation=Oe}),define(me[37],pe([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=N,t.assertNever=x,t.assert=z,t.softAssert=_,t.assertFn=T,t.checkAdjacentItems=f;function N(g,b){if(!g)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function x(g,b="Unreachable"){throw new Error(b)}function z(g){if(!g)throw new i.BugIndicatingError("Assertion Failed")}function _(g){g||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function T(g){if(!g()){debugger;g(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function f(g,b){let B=0;for(;B<g.length-1;){const c=g[B],u=g[B+1];if(!b(c,u))return!1;B++}return!0}}),define(me[38],pe([1,0,8]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.strictEquals=void 0,t.itemsEquals=x,t.jsonStringifyEquals=z,t.itemEquals=_,t.equalsIfDefined=T,t.structuralEquals=f,t.getStructuralKey=g;const N=(u,e)=>u===e;t.strictEquals=N;function x(u=t.strictEquals){return(e,s)=>i.equals(e,s,u)}function z(){return(u,e)=>JSON.stringify(u)===JSON.stringify(e)}function _(){return(u,e)=>u.equals(e)}function T(u,e,s){return!u||!e?u===e:s(u,e)}function f(u,e){if(u===e)return!0;if(Array.isArray(u)&&Array.isArray(e)){if(u.length!==e.length)return!1;for(let s=0;s<u.length;s++)if(!f(u[s],e[s]))return!1;return!0}if(u&&typeof u=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(u)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=u,o=e,l=Object.keys(s),d=Object.keys(o),C=new Set(d);if(l.length!==d.length)return!1;for(const m of l)if(!C.has(m)||!f(s[m],o[m]))return!1;return!0}return!1}function g(u){return JSON.stringify(c(u))}let b=0;const B=new WeakMap;function c(u){if(Array.isArray(u))return u.map(c);if(u&&typeof u=="object")if(Object.getPrototypeOf(u)===Object.prototype){const e=u,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=c(e[o]);return s}else{let e=B.get(u);return e===void 0&&(e=b++,B.set(u,e)),e+"----2b76a038c20c4bcc"}return u}}),define(me[53],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(N,x){const z=this;let _=!1,T;return function(){if(_)return T;if(_=!0,x)try{T=N.apply(z,arguments)}finally{x()}else T=N.apply(z,arguments);return T}}}),define(me[86],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(x){this._prefix=x,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")}),define(me[32],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(N){function x(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}N.is=x;const z=Object.freeze([]);function _(){return z}N.empty=_;function*T(r){yield r}N.single=T;function f(r){return x(r)?r:T(r)}N.wrap=f;function g(r){return r||z}N.from=g;function*b(r){for(let S=r.length-1;S>=0;S--)yield r[S]}N.reverse=b;function B(r){return!r||r[Symbol.iterator]().next().done===!0}N.isEmpty=B;function c(r){return r[Symbol.iterator]().next().value}N.first=c;function u(r,S){for(const A of r)if(S(A))return!0;return!1}N.some=u;function e(r,S){for(const A of r)if(S(A))return A}N.find=e;function*s(r,S){for(const A of r)S(A)&&(yield A)}N.filter=s;function*o(r,S){let A=0;for(const I of r)yield S(I,A++)}N.map=o;function*l(...r){for(const S of r)yield*S}N.concat=l;function d(r,S,A){let I=A;for(const P of r)I=S(I,P);return I}N.reduce=d;function*C(r,S,A=r.length){for(S<0&&(S+=r.length),A<0?A+=r.length:A>r.length&&(A=r.length);S<A;S++)yield r[S]}N.slice=C;function m(r,S=Number.POSITIVE_INFINITY){const A=[];if(S===0)return[A,r];const I=r[Symbol.iterator]();for(let P=0;P<S;P++){const $=I.next();if($.done)return[A,N.empty()];A.push($.value)}return[A,{[Symbol.iterator](){return I}}]}N.consume=m;async function p(r){const S=[];for await(const A of r)S.push(A);return Promise.resolve(S)}N.asyncToArray=p})(i||(t.Iterable=i={}))}),define(me[54],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=u;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class x{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const z=new x,_=new x,T=new x;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],g=Object.create(null),b=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>b[e]||0,toEnum:e=>g[e]||0,toString:e=>f[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],l=[];for(const d of s){const[C,m,p,r,S,A,I,P,$]=d;if(l[m]||(l[m]=!0,f[m]=p,g[p]=m,b[p.toLowerCase()]=m,C&&(t.IMMUTABLE_CODE_TO_KEY_CODE[m]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=m))),!o[r]){if(o[r]=!0,!S)throw new Error(`String representation missing for key code ${r} around scan code ${p}`);z.define(r,S),_.define(r,P||S),T.define(r,$||P||S)}A&&(t.EVENT_KEY_CODE_MAP[A]=r),I&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[I]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var B;(function(e){function s(p){return z.keyCodeToStr(p)}e.toString=s;function o(p){return z.strToKeyCode(p)}e.fromString=o;function l(p){return _.keyCodeToStr(p)}e.toUserSettingsUS=l;function d(p){return T.keyCodeToStr(p)}e.toUserSettingsGeneral=d;function C(p){return _.strToKeyCode(p)||T.strToKeyCode(p)}e.fromUserSettings=C;function m(p){if(p>=98&&p<=113)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return z.keyCodeToStr(p)}e.toElectronAccelerator=m})(B||(t.KeyCodeUtils=B={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function u(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(me[87],pe([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=x,t.createSimpleKeybinding=z;var N;(function(B){B[B.CtrlCmd=2048]="CtrlCmd",B[B.Shift=1024]="Shift",B[B.Alt=512]="Alt",B[B.WinCtrl=256]="WinCtrl",B[B.KeyCode=255]="KeyCode"})(N||(N={}));function x(B,c){if(typeof B=="number"){if(B===0)return null;const u=(B&65535)>>>0,e=(B&4294901760)>>>16;return e!==0?new f([z(u,c),z(e,c)]):new f([z(u,c)])}else{const u=[];for(let e=0;e<B.length;e++)u.push(z(B[e],c));return new f(u)}}function z(B,c){const u=!!(B&2048),e=!!(B&256),s=c===2?e:u,o=!!(B&1024),l=!!(B&512),d=c===2?u:e,C=B&255;return new _(s,o,l,d,C)}class _{constructor(c,u,e,s,o){this.ctrlKey=c,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.keyCode=o}equals(c){return c instanceof _&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${c}${u}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new f([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=_;class T{constructor(c,u,e,s,o){this.ctrlKey=c,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.scanCode=o}equals(c){return c instanceof T&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${c}${u}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=T;class f{constructor(c){if(c.length===0)throw(0,i.illegalArgument)("chords");this.chords=c}getHashCode(){let c="";for(let u=0,e=this.chords.length;u<e;u++)u!==0&&(c+=";"),c+=this.chords[u].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let u=0;u<this.chords.length;u++)if(!this.chords[u].equals(c.chords[u]))return!1;return!0}}t.Keybinding=f;class g{constructor(c,u,e,s,o,l){this.ctrlKey=c,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.keyLabel=o,this.keyAriaLabel=l}}t.ResolvedChord=g;class b{}t.ResolvedKeybinding=b}),define(me[23],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(x){this.executor=x,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(x){this._error=x}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),define(me[14],pe([1,0,23]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=T,t.getDefaultHoverDelegate=f,t.createInstantHoverDelegate=g;let x=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const z=new i.Lazy(()=>x("mouse",!1)),_=new i.Lazy(()=>x("element",!1));function T(b){x=b}function f(b){return b==="element"?_.value:z.value}function g(){return x("element",!0)}}),define(me[55],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(z){this.element=z,this.next=i.Undefined,this.prev=i.Undefined}}class N{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let z=this._first;for(;z!==i.Undefined;){const _=z.next;z.prev=i.Undefined,z.next=i.Undefined,z=_}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(z){return this._insert(z,!1)}push(z){return this._insert(z,!0)}_insert(z,_){const T=new i(z);if(this._first===i.Undefined)this._first=T,this._last=T;else if(_){const g=this._last;this._last=T,T.prev=g,g.next=T}else{const g=this._first;this._first=T,T.next=g,g.prev=T}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(T))}}shift(){if(this._first!==i.Undefined){const z=this._first.element;return this._remove(this._first),z}}pop(){if(this._last!==i.Undefined){const z=this._last.element;return this._remove(this._last),z}}_remove(z){if(z.prev!==i.Undefined&&z.next!==i.Undefined){const _=z.prev;_.next=z.next,z.next.prev=_}else z.prev===i.Undefined&&z.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):z.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):z.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let z=this._first;for(;z!==i.Undefined;)yield z.element,z=z.next}}t.LinkedList=N}),define(me[39],pe([1,0]),function(ne,t){"use strict";var i,N,x;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=z,t.mapToString=_,t.setToString=T,t.mapsStrictEqualIgnoreOrder=m;function z(p,r,S){let A=p.get(r);return A===void 0&&(A=S,p.set(r,A)),A}function _(p){const r=[];return p.forEach((S,A)=>{r.push(`${A} => ${S}`)}),`Map(${p.size}) {${r.join(", ")}}`}function T(p){const r=[];return p.forEach(S=>{r.push(S)}),`Set(${p.size}) {${r.join(", ")}}`}class f{constructor(r,S){this.uri=r,this.value=S}}function g(p){return Array.isArray(p)}class b{static{this.defaultToKey=r=>r.toString()}constructor(r,S){if(this[i]="ResourceMap",r instanceof b)this.map=new Map(r.map),this.toKey=S??b.defaultToKey;else if(g(r)){this.map=new Map,this.toKey=S??b.defaultToKey;for(const[A,I]of r)this.set(A,I)}else this.map=new Map,this.toKey=r??b.defaultToKey}set(r,S){return this.map.set(this.toKey(r),new f(r,S)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,S){typeof S<"u"&&(r=r.bind(S));for(const[A,I]of this.map)r(I.value,I.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=b;class B{constructor(r,S){this[N]="ResourceSet",!r||typeof r=="function"?this._map=new b(r):(this._map=new b(S),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,S){this._map.forEach((A,I)=>r.call(S,I,I,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=B;var c;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class u{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,S=0){const A=this._map.get(r);if(A)return S!==0&&this.touch(A,S),A.value}set(r,S,A=0){let I=this._map.get(r);if(I)I.value=S,A!==0&&this.touch(I,A);else{switch(I={key:r,value:S,next:void 0,previous:void 0},A){case 0:this.addItemLast(I);break;case 1:this.addItemFirst(I);break;case 2:this.addItemLast(I);break;default:this.addItemLast(I);break}this._map.set(r,I),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const S=this._map.get(r);if(S)return this._map.delete(r),this.removeItem(S),this._size--,S.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,S){const A=this._state;let I=this._head;for(;I;){if(S?r.bind(S)(I.value,I.key,this):r(I.value,I.key,this),this._state!==A)throw new Error("LinkedMap got modified during iteration.");I=I.next}}keys(){const r=this,S=this._state;let A=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==S)throw new Error("LinkedMap got modified during iteration.");if(A){const P={value:A.key,done:!1};return A=A.next,P}else return{value:void 0,done:!0}}};return I}values(){const r=this,S=this._state;let A=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==S)throw new Error("LinkedMap got modified during iteration.");if(A){const P={value:A.value,done:!1};return A=A.next,P}else return{value:void 0,done:!0}}};return I}entries(){const r=this,S=this._state;let A=this._head;const I={[Symbol.iterator](){return I},next(){if(r._state!==S)throw new Error("LinkedMap got modified during iteration.");if(A){const P={value:[A.key,A.value],done:!1};return A=A.next,P}else return{value:void 0,done:!0}}};return I}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let S=this._head,A=this.size;for(;S&&A>r;)this._map.delete(S.key),S=S.next,A--;this._head=S,this._size=A,S&&(S.previous=void 0),this._state++}trimNew(r){if(r>=this.size)return;if(r===0){this.clear();return}let S=this._tail,A=this.size;for(;S&&A>r;)this._map.delete(S.key),S=S.previous,A--;this._tail=S,this._size=A,S&&(S.next=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const S=r.next,A=r.previous;if(!S||!A)throw new Error("Invalid list");S.previous=A,A.next=S}r.next=void 0,r.previous=void 0,this._state++}touch(r,S){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(S!==1&&S!==2)){if(S===1){if(r===this._head)return;const A=r.next,I=r.previous;r===this._tail?(I.next=void 0,this._tail=I):(A.previous=I,I.next=A),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(S===2){if(r===this._tail)return;const A=r.next,I=r.previous;r===this._head?(A.previous=void 0,this._head=A):(A.previous=I,I.next=A),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((S,A)=>{r.push([A,S])}),r}fromJSON(r){this.clear();for(const[S,A]of r)this.set(S,A)}}t.LinkedMap=u;class e extends u{constructor(r,S=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,S),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,S=2){return super.get(r,S)}peek(r){return super.get(r,0)}set(r,S){return super.set(r,S,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class s extends e{constructor(r,S=1){super(r,S)}trim(r){this.trimOld(r)}set(r,S){return super.set(r,S),this.checkTrim(),this}}t.LRUCache=s;class o extends e{constructor(r,S=1){super(r,S)}trim(r){this.trimNew(r)}set(r,S){return this._limit<=this.size&&!this.has(r)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(r,S),this}}t.MRUCache=o;class l{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let S=this.map.get(r)||0;return S===0?!1:(S--,S===0?this.map.delete(r):this.map.set(r,S),!0)}has(r){return this.map.has(r)}}t.CounterSet=l;class d{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[S,A]of r)this.set(S,A)}clear(){this._m1.clear(),this._m2.clear()}set(r,S){this._m1.set(r,S),this._m2.set(S,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const S=this._m1.get(r);return S===void 0?!1:(this._m1.delete(r),this._m2.delete(S),!0)}forEach(r,S){this._m1.forEach((A,I)=>{r.call(S,A,I,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=d;class C{constructor(){this.map=new Map}add(r,S){let A=this.map.get(r);A||(A=new Set,this.map.set(r,A)),A.add(S)}delete(r,S){const A=this.map.get(r);A&&(A.delete(S),A.size===0&&this.map.delete(r))}forEach(r,S){const A=this.map.get(r);A&&A.forEach(S)}get(r){const S=this.map.get(r);return S||new Set}}t.SetMap=C;function m(p,r){if(p===r)return!0;if(p.size!==r.size)return!1;for(const[S,A]of p)if(!r.has(S)||r.get(S)!==A)return!1;for(const[S]of r)if(!p.has(S))return!1;return!0}}),define(me[2],pe([1,0,8,83,39,53,32]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=b,t.trackDisposable=B,t.markAsDisposed=c,t.markAsSingleton=s,t.isDisposable=o,t.dispose=l,t.disposeIfDisposable=d,t.combinedDisposable=C,t.toDisposable=m,t.disposeOnReturn=q;const T=!1;let f=null;class g{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(M){let G=this.livingDisposables.get(M);return G||(G={parent:null,source:null,isSingleton:!1,value:M,idx:g.idx++},this.livingDisposables.set(M,G)),G}trackDisposable(M){const G=this.getDisposableData(M);G.source||(G.source=new Error().stack)}setParent(M,G){const K=this.getDisposableData(M);K.parent=G}markAsDisposed(M){this.livingDisposables.delete(M)}markAsSingleton(M){this.getDisposableData(M).isSingleton=!0}getRootParent(M,G){const K=G.get(M);if(K)return K;const ae=M.parent?this.getRootParent(this.getDisposableData(M.parent),G):M;return G.set(M,ae),ae}getTrackedDisposables(){const M=new Map;return[...this.livingDisposables.entries()].filter(([,K])=>K.source!==null&&!this.getRootParent(K,M).isSingleton).flatMap(([K])=>K)}computeLeakingDisposables(M=10,G){let K;if(G)K=G;else{const Ee=new Map,Se=[...this.livingDisposables.values()].filter(le=>le.source!==null&&!this.getRootParent(le,Ee).isSingleton);if(Se.length===0)return;const Pe=new Set(Se.map(le=>le.value));if(K=Se.filter(le=>!(le.parent&&Pe.has(le.parent))),K.length===0)throw new Error("There are cyclic diposable chains!")}if(!K)return;function ae(Ee){function Se(le,J){for(;le.length>0&&J.some(he=>typeof he=="string"?he===le[0]:le[0].match(he));)le.shift()}const Pe=Ee.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Se(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const ie=new x.SetMap;for(const Ee of K){const Se=ae(Ee);for(let Pe=0;Pe<=Se.length;Pe++)ie.add(Se.slice(0,Pe).join(`
`),Ee)}K.sort((0,i.compareBy)(Ee=>Ee.idx,i.numberComparator));let ee="",ce=0;for(const Ee of K.slice(0,M)){ce++;const Se=ae(Ee),Pe=[];for(let le=0;le<Se.length;le++){let J=Se[le];J=`(shared with ${ie.get(Se.slice(0,le+1).join(`
`)).size}/${K.length} leaks) at ${J}`;const re=ie.get(Se.slice(0,le).join(`
`)),ye=(0,N.groupBy)([...re].map(V=>ae(V)[le]),V=>V);delete ye[Se[le]];for(const[V,Q]of Object.entries(ye))Pe.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${V}`);Pe.unshift(J)}ee+=`


==================== Leaking disposable ${ce}/${K.length}: ${Ee.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return K.length>M&&(ee+=`


... and ${K.length-M} more leaking disposables

`),{leaks:K,details:ee}}}t.DisposableTracker=g;function b(W){f=W}if(T){const W="__is_disposable_tracked__";b(new class{trackDisposable(M){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[W]||console.log(G)},3e3)}setParent(M,G){if(M&&M!==r.None)try{M[W]=!0}catch{}}markAsDisposed(M){if(M&&M!==r.None)try{M[W]=!0}catch{}}markAsSingleton(M){}})}function B(W){return f?.trackDisposable(W),W}function c(W){f?.markAsDisposed(W)}function u(W,M){f?.setParent(W,M)}function e(W,M){if(f)for(const G of W)f.setParent(G,M)}function s(W){return f?.markAsSingleton(W),W}function o(W){return typeof W=="object"&&W!==null&&typeof W.dispose=="function"&&W.dispose.length===0}function l(W){if(_.Iterable.is(W)){const M=[];for(const G of W)if(G)try{G.dispose()}catch(K){M.push(K)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(W)?[]:W}else if(W)return W.dispose(),W}function d(W){for(const M of W)o(M)&&M.dispose();return[]}function C(...W){const M=m(()=>l(W));return e(W,M),M}function m(W){const M=B({dispose:(0,z.createSingleCallFunction)(()=>{c(M),W()})});return M}class p{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,B(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{l(this._toDispose)}finally{this._toDispose.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return u(M,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(M),M.dispose()}}deleteAndLeak(M){M&&this._toDispose.has(M)&&(this._toDispose.delete(M),u(M,null))}}t.DisposableStore=p;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new p,B(this),u(this._store,this)}dispose(){c(this),this._store.dispose()}_register(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(M)}}t.Disposable=r;class S{constructor(){this._isDisposed=!1,B(this)}get value(){return this._isDisposed?void 0:this._value}set value(M){this._isDisposed||M===this._value||(this._value?.dispose(),M&&u(M,this),this._value=M)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,c(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const M=this._value;return this._value=void 0,M&&u(M,null),M}}t.MutableDisposable=S;class A{constructor(M){this._disposable=new S,this._isDisposed=!1,this._disposable.value=M}get value(){return this._disposable.value}set value(M){this._isDisposed||M===this._disposable.value||(this._disposable.value=M)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=A;class I{constructor(M){this._disposable=M,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=I;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(M){let G=M;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,c(this))},this}}t.SafeDisposable=P;class ${constructor(){this.references=new Map}acquire(M,...G){let K=this.references.get(M);K||(K={counter:0,object:this.createReferencedObject(M,...G)},this.references.set(M,K));const{object:ae}=K,ie=(0,z.createSingleCallFunction)(()=>{--K.counter===0&&(this.destroyReferencedObject(M,K.object),this.references.delete(M))});return K.counter++,{object:ae,dispose:ie}}}t.ReferenceCollection=$;class v{constructor(M){this.referenceCollection=M}async acquire(M,...G){const K=this.referenceCollection.acquire(M,...G);try{return{object:await K.object,dispose:()=>K.dispose()}}catch(ae){throw K.dispose(),ae}}}t.AsyncReferenceCollection=v;class O{constructor(M){this.object=M}dispose(){}}t.ImmortalReference=O;function q(W){const M=new p;try{W(M)}finally{M.dispose()}}class L{constructor(){this._store=new Map,this._isDisposed=!1,B(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{l(this._store.values())}finally{this._store.clear()}}has(M){return this._store.has(M)}get size(){return this._store.size}get(M){return this._store.get(M)}set(M,G,K=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),K||this._store.get(M)?.dispose(),this._store.set(M,G)}deleteAndDispose(M){this._store.get(M)?.dispose(),this._store.delete(M)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=L}),function(ne,t){typeof define=="function"&&define.amd?define(me[88],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(H,h){for(var y=0;y<h.length;y++){var a=h[y];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(H,a.key,a)}}function i(H,h,y){return h&&t(H.prototype,h),y&&t(H,y),Object.defineProperty(H,"prototype",{writable:!1}),H}function N(H,h){if(H){if(typeof H=="string")return x(H,h);var y=Object.prototype.toString.call(H).slice(8,-1);if(y==="Object"&&H.constructor&&(y=H.constructor.name),y==="Map"||y==="Set")return Array.from(H);if(y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))return x(H,h)}}function x(H,h){(h==null||h>H.length)&&(h=H.length);for(var y=0,a=new Array(h);y<h;y++)a[y]=H[y];return a}function z(H,h){var y=typeof Symbol<"u"&&H[Symbol.iterator]||H["@@iterator"];if(y)return(y=y.call(H)).next.bind(y);if(Array.isArray(H)||(y=N(H))||h&&H&&typeof H.length=="number"){y&&(H=y);var a=0;return function(){return a>=H.length?{done:!0}:{done:!1,value:H[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function T(H){ne.defaults=H}var f=/[&<>"']/,g=/[&<>"']/g,b=/[<>"']|&(?!#?\w+;)/,B=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(h){return c[h]};function e(H,h){if(h){if(f.test(H))return H.replace(g,u)}else if(b.test(H))return H.replace(B,u);return H}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(H){return H.replace(s,function(h,y){return y=y.toLowerCase(),y==="colon"?":":y.charAt(0)==="#"?y.charAt(1)==="x"?String.fromCharCode(parseInt(y.substring(2),16)):String.fromCharCode(+y.substring(1)):""})}var l=/(^|[^\[])\^/g;function d(H,h){H=typeof H=="string"?H:H.source,h=h||"";var y={replace:function(w,F){return F=F.source||F,F=F.replace(l,"$1"),H=H.replace(w,F),y},getRegex:function(){return new RegExp(H,h)}};return y}var C=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(H,h,y){if(H){var a;try{a=decodeURIComponent(o(y)).replace(C,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}h&&!m.test(y)&&(y=P(h,y));try{y=encodeURI(y).replace(/%25/g,"%")}catch{return null}return y}var r={},S=/^[^:]+:\/*[^/]*$/,A=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function P(H,h){r[" "+H]||(S.test(H)?r[" "+H]=H+"/":r[" "+H]=q(H,"/",!0)),H=r[" "+H];var y=H.indexOf(":")===-1;return h.substring(0,2)==="//"?y?h:H.replace(A,"$1")+h:h.charAt(0)==="/"?y?h:H.replace(I,"$1")+h:H+h}var $={exec:function(){}};function v(H){for(var h=1,y,a;h<arguments.length;h++){y=arguments[h];for(a in y)Object.prototype.hasOwnProperty.call(y,a)&&(H[a]=y[a])}return H}function O(H,h){var y=H.replace(/\|/g,function(F,n,E){for(var D=!1,k=n;--k>=0&&E[k]==="\\";)D=!D;return D?"|":" |"}),a=y.split(/ \|/),w=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>h)a.splice(h);else for(;a.length<h;)a.push("");for(;w<a.length;w++)a[w]=a[w].trim().replace(/\\\|/g,"|");return a}function q(H,h,y){var a=H.length;if(a===0)return"";for(var w=0;w<a;){var F=H.charAt(a-w-1);if(F===h&&!y)w++;else if(F!==h&&y)w++;else break}return H.slice(0,a-w)}function L(H,h){if(H.indexOf(h[1])===-1)return-1;for(var y=H.length,a=0,w=0;w<y;w++)if(H[w]==="\\")w++;else if(H[w]===h[0])a++;else if(H[w]===h[1]&&(a--,a<0))return w;return-1}function W(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(H,h){if(h<1)return"";for(var y="";h>1;)h&1&&(y+=H),h>>=1,H+=H;return y+H}function G(H,h,y,a){var w=h.href,F=h.title?e(h.title):null,n=H[1].replace(/\\([\[\]])/g,"$1");if(H[0].charAt(0)!=="!"){a.state.inLink=!0;var E={type:"link",raw:y,href:w,title:F,text:n,tokens:a.inlineTokens(n)};return a.state.inLink=!1,E}return{type:"image",raw:y,href:w,title:F,text:e(n)}}function K(H,h){var y=H.match(/^(\s+)(?:```)/);if(y===null)return h;var a=y[1];return h.split(`
`).map(function(w){var F=w.match(/^\s+/);if(F===null)return w;var n=F[0];return n.length>=a.length?w.slice(a.length):w}).join(`
`)}var ae=function(){function H(y){this.options=y||ne.defaults}var h=H.prototype;return h.space=function(a){var w=this.rules.block.newline.exec(a);if(w&&w[0].length>0)return{type:"space",raw:w[0]}},h.code=function(a){var w=this.rules.block.code.exec(a);if(w){var F=w[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:w[0],codeBlockStyle:"indented",text:this.options.pedantic?F:q(F,`
`)}}},h.fences=function(a){var w=this.rules.block.fences.exec(a);if(w){var F=w[0],n=K(F,w[3]||"");return{type:"code",raw:F,lang:w[2]?w[2].trim():w[2],text:n}}},h.heading=function(a){var w=this.rules.block.heading.exec(a);if(w){var F=w[2].trim();if(/#$/.test(F)){var n=q(F,"#");(this.options.pedantic||!n||/ $/.test(n))&&(F=n.trim())}return{type:"heading",raw:w[0],depth:w[1].length,text:F,tokens:this.lexer.inline(F)}}},h.hr=function(a){var w=this.rules.block.hr.exec(a);if(w)return{type:"hr",raw:w[0]}},h.blockquote=function(a){var w=this.rules.block.blockquote.exec(a);if(w){var F=w[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:w[0],tokens:this.lexer.blockTokens(F,[]),text:F}}},h.list=function(a){var w=this.rules.block.list.exec(a);if(w){var F,n,E,D,k,R,U,Z,oe,ve,de,ke,Te=w[1].trim(),Me=Te.length>1,Ce={type:"list",raw:"",ordered:Me,start:Me?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Me?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Me?Te:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(ke=!1,!(!(w=Ne.exec(a))||this.rules.block.hr.test(a)));){if(F=w[0],a=a.substring(F.length),Z=w[2].split(`
`,1)[0],oe=a.split(`
`,1)[0],this.options.pedantic?(D=2,de=Z.trimLeft()):(D=w[2].search(/[^ ]/),D=D>4?1:D,de=Z.slice(D),D+=w[1].length),R=!1,!Z&&/^ *$/.test(oe)&&(F+=oe+`
`,a=a.substring(oe.length+1),ke=!0),!ke)for(var Ve=new RegExp("^ {0,"+Math.min(3,D-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ye=new RegExp("^ {0,"+Math.min(3,D-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,D-1)+"}(?:```|~~~)"),Je=new RegExp("^ {0,"+Math.min(3,D-1)+"}#");a&&(ve=a.split(`
`,1)[0],Z=ve,this.options.pedantic&&(Z=Z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Z)||Je.test(Z)||Ve.test(Z)||Ye.test(a)));){if(Z.search(/[^ ]/)>=D||!Z.trim())de+=`
`+Z.slice(D);else if(!R)de+=`
`+Z;else break;!R&&!Z.trim()&&(R=!0),F+=ve+`
`,a=a.substring(ve.length+1)}Ce.loose||(U?Ce.loose=!0:/\n *\n *$/.test(F)&&(U=!0)),this.options.gfm&&(n=/^\[[ xX]\] /.exec(de),n&&(E=n[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:F,task:!!n,checked:E,loose:!1,text:de}),Ce.raw+=F}Ce.items[Ce.items.length-1].raw=F.trimRight(),Ce.items[Ce.items.length-1].text=de.trimRight(),Ce.raw=Ce.raw.trimRight();var X=Ce.items.length;for(k=0;k<X;k++){this.lexer.state.top=!1,Ce.items[k].tokens=this.lexer.blockTokens(Ce.items[k].text,[]);var se=Ce.items[k].tokens.filter(function(we){return we.type==="space"}),be=se.every(function(we){for(var Le=we.raw.split(""),He=0,$e=z(Le),et;!(et=$e()).done;){var it=et.value;if(it===`
`&&(He+=1),He>1)return!0}return!1});!Ce.loose&&se.length&&be&&(Ce.loose=!0,Ce.items[k].loose=!0)}return Ce}},h.html=function(a){var w=this.rules.block.html.exec(a);if(w){var F={type:"html",raw:w[0],pre:!this.options.sanitizer&&(w[1]==="pre"||w[1]==="script"||w[1]==="style"),text:w[0]};if(this.options.sanitize){var n=this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]);F.type="paragraph",F.text=n,F.tokens=this.lexer.inline(n)}return F}},h.def=function(a){var w=this.rules.block.def.exec(a);if(w){w[3]&&(w[3]=w[3].substring(1,w[3].length-1));var F=w[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:F,raw:w[0],href:w[2],title:w[3]}}},h.table=function(a){var w=this.rules.block.table.exec(a);if(w){var F={type:"table",header:O(w[1]).map(function(U){return{text:U}}),align:w[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:w[3]&&w[3].trim()?w[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(F.header.length===F.align.length){F.raw=w[0];var n=F.align.length,E,D,k,R;for(E=0;E<n;E++)/^ *-+: *$/.test(F.align[E])?F.align[E]="right":/^ *:-+: *$/.test(F.align[E])?F.align[E]="center":/^ *:-+ *$/.test(F.align[E])?F.align[E]="left":F.align[E]=null;for(n=F.rows.length,E=0;E<n;E++)F.rows[E]=O(F.rows[E],F.header.length).map(function(U){return{text:U}});for(n=F.header.length,D=0;D<n;D++)F.header[D].tokens=this.lexer.inline(F.header[D].text);for(n=F.rows.length,D=0;D<n;D++)for(R=F.rows[D],k=0;k<R.length;k++)R[k].tokens=this.lexer.inline(R[k].text);return F}}},h.lheading=function(a){var w=this.rules.block.lheading.exec(a);if(w)return{type:"heading",raw:w[0],depth:w[2].charAt(0)==="="?1:2,text:w[1],tokens:this.lexer.inline(w[1])}},h.paragraph=function(a){var w=this.rules.block.paragraph.exec(a);if(w){var F=w[1].charAt(w[1].length-1)===`
`?w[1].slice(0,-1):w[1];return{type:"paragraph",raw:w[0],text:F,tokens:this.lexer.inline(F)}}},h.text=function(a){var w=this.rules.block.text.exec(a);if(w)return{type:"text",raw:w[0],text:w[0],tokens:this.lexer.inline(w[0])}},h.escape=function(a){var w=this.rules.inline.escape.exec(a);if(w)return{type:"escape",raw:w[0],text:e(w[1])}},h.tag=function(a){var w=this.rules.inline.tag.exec(a);if(w)return!this.lexer.state.inLink&&/^<a /i.test(w[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(w[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(w[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(w[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:w[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(w[0]):e(w[0]):w[0]}},h.link=function(a){var w=this.rules.inline.link.exec(a);if(w){var F=w[2].trim();if(!this.options.pedantic&&/^</.test(F)){if(!/>$/.test(F))return;var n=q(F.slice(0,-1),"\\");if((F.length-n.length)%2===0)return}else{var E=L(w[2],"()");if(E>-1){var D=w[0].indexOf("!")===0?5:4,k=D+w[1].length+E;w[2]=w[2].substring(0,E),w[0]=w[0].substring(0,k).trim(),w[3]=""}}var R=w[2],U="";if(this.options.pedantic){var Z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(R);Z&&(R=Z[1],U=Z[3])}else U=w[3]?w[3].slice(1,-1):"";return R=R.trim(),/^</.test(R)&&(this.options.pedantic&&!/>$/.test(F)?R=R.slice(1):R=R.slice(1,-1)),G(w,{href:R&&R.replace(this.rules.inline._escapes,"$1"),title:U&&U.replace(this.rules.inline._escapes,"$1")},w[0],this.lexer)}},h.reflink=function(a,w){var F;if((F=this.rules.inline.reflink.exec(a))||(F=this.rules.inline.nolink.exec(a))){var n=(F[2]||F[1]).replace(/\s+/g," ");if(n=w[n.toLowerCase()],!n||!n.href){var E=F[0].charAt(0);return{type:"text",raw:E,text:E}}return G(F,n,F[0],this.lexer)}},h.emStrong=function(a,w,F){F===void 0&&(F="");var n=this.rules.inline.emStrong.lDelim.exec(a);if(n&&!(n[3]&&F.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var E=n[1]||n[2]||"";if(!E||E&&(F===""||this.rules.inline.punctuation.exec(F))){var D=n[0].length-1,k,R,U=D,Z=0,oe=n[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,w=w.slice(-1*a.length+D);(n=oe.exec(w))!=null;)if(k=n[1]||n[2]||n[3]||n[4]||n[5]||n[6],!!k){if(R=k.length,n[3]||n[4]){U+=R;continue}else if((n[5]||n[6])&&D%3&&!((D+R)%3)){Z+=R;continue}if(U-=R,!(U>0)){if(R=Math.min(R,R+U+Z),Math.min(D,R)%2){var ve=a.slice(1,D+n.index+R);return{type:"em",raw:a.slice(0,D+n.index+R+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var de=a.slice(2,D+n.index+R-1);return{type:"strong",raw:a.slice(0,D+n.index+R+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},h.codespan=function(a){var w=this.rules.inline.code.exec(a);if(w){var F=w[2].replace(/\n/g," "),n=/[^ ]/.test(F),E=/^ /.test(F)&&/ $/.test(F);return n&&E&&(F=F.substring(1,F.length-1)),F=e(F,!0),{type:"codespan",raw:w[0],text:F}}},h.br=function(a){var w=this.rules.inline.br.exec(a);if(w)return{type:"br",raw:w[0]}},h.del=function(a){var w=this.rules.inline.del.exec(a);if(w)return{type:"del",raw:w[0],text:w[2],tokens:this.lexer.inlineTokens(w[2])}},h.autolink=function(a,w){var F=this.rules.inline.autolink.exec(a);if(F){var n,E;return F[2]==="@"?(n=e(this.options.mangle?w(F[1]):F[1]),E="mailto:"+n):(n=e(F[1]),E=n),{type:"link",raw:F[0],text:n,href:E,tokens:[{type:"text",raw:n,text:n}]}}},h.url=function(a,w){var F;if(F=this.rules.inline.url.exec(a)){var n,E;if(F[2]==="@")n=e(this.options.mangle?w(F[0]):F[0]),E="mailto:"+n;else{var D;do D=F[0],F[0]=this.rules.inline._backpedal.exec(F[0])[0];while(D!==F[0]);n=e(F[0]),F[1]==="www."?E="http://"+n:E=n}return{type:"link",raw:F[0],text:n,href:E,tokens:[{type:"text",raw:n,text:n}]}}},h.inlineText=function(a,w){var F=this.rules.inline.text.exec(a);if(F){var n;return this.lexer.state.inRawBlock?n=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(F[0]):e(F[0]):F[0]:n=e(this.options.smartypants?w(F[0]):F[0]),{type:"text",raw:F[0],text:n}}},H}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=d(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=d(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=d(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=d(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=d(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=v({},ie),ie.gfm=v({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=d(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=v({},ie.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:d(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=d(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=d(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=d(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=d(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=d(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=d(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=d(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=d(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=d(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=d(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=d(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=v({},ee),ee.pedantic=v({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=v({},ee.normal,{escape:d(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=d(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=v({},ee.gfm,{br:d(ee.br).replace("{2,}","*").getRegex(),text:d(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ee(H){var h="",y,a,w=H.length;for(y=0;y<w;y++)a=H.charCodeAt(y),Math.random()>.5&&(a="x"+a.toString(16)),h+="&#"+a+";";return h}var Se=function(){function H(y){this.tokens=[],this.tokens.links=Object.create(null),this.options=y||ne.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:ie.normal,inline:ee.normal};this.options.pedantic?(a.block=ie.pedantic,a.inline=ee.pedantic):this.options.gfm&&(a.block=ie.gfm,this.options.breaks?a.inline=ee.breaks:a.inline=ee.gfm),this.tokenizer.rules=a}H.lex=function(a,w){var F=new H(w);return F.lex(a)},H.lexInline=function(a,w){var F=new H(w);return F.inlineTokens(a)};var h=H.prototype;return h.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var w;w=this.inlineQueue.shift();)this.inlineTokens(w.src,w.tokens);return this.tokens},h.blockTokens=function(a,w){var F=this;w===void 0&&(w=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(U,Z,oe){return Z+"    ".repeat(oe.length)});for(var n,E,D,k;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(U){return(n=U.call({lexer:F},a,w))?(a=a.substring(n.raw.length),w.push(n),!0):!1}))){if(n=this.tokenizer.space(a)){a=a.substring(n.raw.length),n.raw.length===1&&w.length>0?w[w.length-1].raw+=`
`:w.push(n);continue}if(n=this.tokenizer.code(a)){a=a.substring(n.raw.length),E=w[w.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+n.raw,E.text+=`
`+n.text,this.inlineQueue[this.inlineQueue.length-1].src=E.text):w.push(n);continue}if(n=this.tokenizer.fences(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.heading(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.hr(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.blockquote(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.list(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.html(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.def(a)){a=a.substring(n.raw.length),E=w[w.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+n.raw,E.text+=`
`+n.raw,this.inlineQueue[this.inlineQueue.length-1].src=E.text):this.tokens.links[n.tag]||(this.tokens.links[n.tag]={href:n.href,title:n.title});continue}if(n=this.tokenizer.table(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.lheading(a)){a=a.substring(n.raw.length),w.push(n);continue}if(D=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var U=1/0,Z=a.slice(1),oe=void 0;F.options.extensions.startBlock.forEach(function(ve){oe=ve.call({lexer:this},Z),typeof oe=="number"&&oe>=0&&(U=Math.min(U,oe))}),U<1/0&&U>=0&&(D=a.substring(0,U+1))}(),this.state.top&&(n=this.tokenizer.paragraph(D))){E=w[w.length-1],k&&E.type==="paragraph"?(E.raw+=`
`+n.raw,E.text+=`
`+n.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):w.push(n),k=D.length!==a.length,a=a.substring(n.raw.length);continue}if(n=this.tokenizer.text(a)){a=a.substring(n.raw.length),E=w[w.length-1],E&&E.type==="text"?(E.raw+=`
`+n.raw,E.text+=`
`+n.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):w.push(n);continue}if(a){var R="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(R);break}else throw new Error(R)}}return this.state.top=!0,w},h.inline=function(a,w){return w===void 0&&(w=[]),this.inlineQueue.push({src:a,tokens:w}),w},h.inlineTokens=function(a,w){var F=this;w===void 0&&(w=[]);var n,E,D,k=a,R,U,Z;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(R=this.tokenizer.rules.inline.reflinkSearch.exec(k))!=null;)oe.includes(R[0].slice(R[0].lastIndexOf("[")+1,-1))&&(k=k.slice(0,R.index)+"["+M("a",R[0].length-2)+"]"+k.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(R=this.tokenizer.rules.inline.blockSkip.exec(k))!=null;)k=k.slice(0,R.index)+"["+M("a",R[0].length-2)+"]"+k.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(R=this.tokenizer.rules.inline.escapedEmSt.exec(k))!=null;)k=k.slice(0,R.index)+"++"+k.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(U||(Z=""),U=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(n=de.call({lexer:F},a,w))?(a=a.substring(n.raw.length),w.push(n),!0):!1}))){if(n=this.tokenizer.escape(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.tag(a)){a=a.substring(n.raw.length),E=w[w.length-1],E&&n.type==="text"&&E.type==="text"?(E.raw+=n.raw,E.text+=n.text):w.push(n);continue}if(n=this.tokenizer.link(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(n.raw.length),E=w[w.length-1],E&&n.type==="text"&&E.type==="text"?(E.raw+=n.raw,E.text+=n.text):w.push(n);continue}if(n=this.tokenizer.emStrong(a,k,Z)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.codespan(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.br(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.del(a)){a=a.substring(n.raw.length),w.push(n);continue}if(n=this.tokenizer.autolink(a,Ee)){a=a.substring(n.raw.length),w.push(n);continue}if(!this.state.inLink&&(n=this.tokenizer.url(a,Ee))){a=a.substring(n.raw.length),w.push(n);continue}if(D=a,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,ke=a.slice(1),Te=void 0;F.options.extensions.startInline.forEach(function(Me){Te=Me.call({lexer:this},ke),typeof Te=="number"&&Te>=0&&(de=Math.min(de,Te))}),de<1/0&&de>=0&&(D=a.substring(0,de+1))}(),n=this.tokenizer.inlineText(D,ce)){a=a.substring(n.raw.length),n.raw.slice(-1)!=="_"&&(Z=n.raw.slice(-1)),U=!0,E=w[w.length-1],E&&E.type==="text"?(E.raw+=n.raw,E.text+=n.text):w.push(n);continue}if(a){var ve="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return w},i(H,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),H}(),Pe=function(){function H(y){this.options=y||ne.defaults}var h=H.prototype;return h.code=function(a,w,F){var n=(w||"").match(/\S*/)[0];if(this.options.highlight){var E=this.options.highlight(a,n);E!=null&&E!==a&&(F=!0,a=E)}return a=a.replace(/\n$/,"")+`
`,n?'<pre><code class="'+this.options.langPrefix+e(n,!0)+'">'+(F?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(F?a:e(a,!0))+`</code></pre>
`},h.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},h.html=function(a){return a},h.heading=function(a,w,F,n){if(this.options.headerIds){var E=this.options.headerPrefix+n.slug(F);return"<h"+w+' id="'+E+'">'+a+"</h"+w+`>
`}return"<h"+w+">"+a+"</h"+w+`>
`},h.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},h.list=function(a,w,F){var n=w?"ol":"ul",E=w&&F!==1?' start="'+F+'"':"";return"<"+n+E+`>
`+a+"</"+n+`>
`},h.listitem=function(a){return"<li>"+a+`</li>
`},h.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},h.paragraph=function(a){return"<p>"+a+`</p>
`},h.table=function(a,w){return w&&(w="<tbody>"+w+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+w+`</table>
`},h.tablerow=function(a){return`<tr>
`+a+`</tr>
`},h.tablecell=function(a,w){var F=w.header?"th":"td",n=w.align?"<"+F+' align="'+w.align+'">':"<"+F+">";return n+a+("</"+F+`>
`)},h.strong=function(a){return"<strong>"+a+"</strong>"},h.em=function(a){return"<em>"+a+"</em>"},h.codespan=function(a){return"<code>"+a+"</code>"},h.br=function(){return this.options.xhtml?"<br/>":"<br>"},h.del=function(a){return"<del>"+a+"</del>"},h.link=function(a,w,F){if(a=p(this.options.sanitize,this.options.baseUrl,a),a===null)return F;var n='<a href="'+e(a)+'"';return w&&(n+=' title="'+w+'"'),n+=">"+F+"</a>",n},h.image=function(a,w,F){if(a=p(this.options.sanitize,this.options.baseUrl,a),a===null)return F;var n='<img src="'+a+'" alt="'+F+'"';return w&&(n+=' title="'+w+'"'),n+=this.options.xhtml?"/>":">",n},h.text=function(a){return a},H}(),le=function(){function H(){}var h=H.prototype;return h.strong=function(a){return a},h.em=function(a){return a},h.codespan=function(a){return a},h.del=function(a){return a},h.html=function(a){return a},h.text=function(a){return a},h.link=function(a,w,F){return""+F},h.image=function(a,w,F){return""+F},h.br=function(){return""},H}(),J=function(){function H(){this.seen={}}var h=H.prototype;return h.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},h.getNextSafeSlug=function(a,w){var F=a,n=0;if(this.seen.hasOwnProperty(F)){n=this.seen[a];do n++,F=a+"-"+n;while(this.seen.hasOwnProperty(F))}return w||(this.seen[a]=n,this.seen[F]=0),F},h.slug=function(a,w){w===void 0&&(w={});var F=this.serialize(a);return this.getNextSafeSlug(F,w.dryrun)},H}(),he=function(){function H(y){this.options=y||ne.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new J}H.parse=function(a,w){var F=new H(w);return F.parse(a)},H.parseInline=function(a,w){var F=new H(w);return F.parseInline(a)};var h=H.prototype;return h.parse=function(a,w){w===void 0&&(w=!0);var F="",n,E,D,k,R,U,Z,oe,ve,de,ke,Te,Me,Ce,Ne,Ve,Ye,Ue,Je,X=a.length;for(n=0;n<X;n++){if(de=a[n],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Je=this.options.extensions.renderers[de.type].call({parser:this},de),Je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){F+=Je||"";continue}switch(de.type){case"space":continue;case"hr":{F+=this.renderer.hr();continue}case"heading":{F+=this.renderer.heading(this.parseInline(de.tokens),de.depth,o(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{F+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(oe="",Z="",k=de.header.length,E=0;E<k;E++)Z+=this.renderer.tablecell(this.parseInline(de.header[E].tokens),{header:!0,align:de.align[E]});for(oe+=this.renderer.tablerow(Z),ve="",k=de.rows.length,E=0;E<k;E++){for(U=de.rows[E],Z="",R=U.length,D=0;D<R;D++)Z+=this.renderer.tablecell(this.parseInline(U[D].tokens),{header:!1,align:de.align[D]});ve+=this.renderer.tablerow(Z)}F+=this.renderer.table(oe,ve);continue}case"blockquote":{ve=this.parse(de.tokens),F+=this.renderer.blockquote(ve);continue}case"list":{for(ke=de.ordered,Te=de.start,Me=de.loose,k=de.items.length,ve="",E=0;E<k;E++)Ne=de.items[E],Ve=Ne.checked,Ye=Ne.task,Ce="",Ne.task&&(Ue=this.renderer.checkbox(Ve),Me?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=Ue+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=Ue+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:Ue}):Ce+=Ue),Ce+=this.parse(Ne.tokens,Me),ve+=this.renderer.listitem(Ce,Ye,Ve);F+=this.renderer.list(ve,ke,Te);continue}case"html":{F+=this.renderer.html(de.text);continue}case"paragraph":{F+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ve=de.tokens?this.parseInline(de.tokens):de.text;n+1<X&&a[n+1].type==="text";)de=a[++n],ve+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);F+=w?this.renderer.paragraph(ve):ve;continue}default:{var se='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return F},h.parseInline=function(a,w){w=w||this.renderer;var F="",n,E,D,k=a.length;for(n=0;n<k;n++){if(E=a[n],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[E.type]&&(D=this.options.extensions.renderers[E.type].call({parser:this},E),D!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(E.type))){F+=D||"";continue}switch(E.type){case"escape":{F+=w.text(E.text);break}case"html":{F+=w.html(E.text);break}case"link":{F+=w.link(E.href,E.title,this.parseInline(E.tokens,w));break}case"image":{F+=w.image(E.href,E.title,E.text);break}case"strong":{F+=w.strong(this.parseInline(E.tokens,w));break}case"em":{F+=w.em(this.parseInline(E.tokens,w));break}case"codespan":{F+=w.codespan(E.text);break}case"br":{F+=w.br();break}case"del":{F+=w.del(this.parseInline(E.tokens,w));break}case"text":{F+=w.text(E.text);break}default:{var R='Token with "'+E.type+'" type was not found.';if(this.options.silent){console.error(R);return}else throw new Error(R)}}}return F},H}();function re(H,h,y){if(typeof H>"u"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof h=="function"&&(y=h,h=null),h=v({},re.defaults,h||{}),W(h),y){var a=h.highlight,w;try{w=Se.lex(H,h)}catch(k){return y(k)}var F=function(R){var U;if(!R)try{h.walkTokens&&re.walkTokens(w,h.walkTokens),U=he.parse(w,h)}catch(Z){R=Z}return h.highlight=a,R?y(R):y(null,U)};if(!a||a.length<3||(delete h.highlight,!w.length))return F();var n=0;re.walkTokens(w,function(k){k.type==="code"&&(n++,setTimeout(function(){a(k.text,k.lang,function(R,U){if(R)return F(R);U!=null&&U!==k.text&&(k.text=U,k.escaped=!0),n--,n===0&&F()})},0))}),n===0&&F();return}function E(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,h.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}try{var D=Se.lex(H,h);if(h.walkTokens){if(h.async)return Promise.all(re.walkTokens(D,h.walkTokens)).then(function(){return he.parse(D,h)}).catch(E);re.walkTokens(D,h.walkTokens)}return he.parse(D,h)}catch(k){E(k)}}re.options=re.setOptions=function(H){return v(re.defaults,H),T(re.defaults),re},re.getDefaults=_,re.defaults=ne.defaults,re.use=function(){for(var H=arguments.length,h=new Array(H),y=0;y<H;y++)h[y]=arguments[y];var a=v.apply(void 0,[{}].concat(h)),w=re.defaults.extensions||{renderers:{},childTokens:{}},F;h.forEach(function(n){if(n.extensions&&(F=!0,n.extensions.forEach(function(D){if(!D.name)throw new Error("extension name required");if(D.renderer){var k=w.renderers?w.renderers[D.name]:null;k?w.renderers[D.name]=function(){for(var R=arguments.length,U=new Array(R),Z=0;Z<R;Z++)U[Z]=arguments[Z];var oe=D.renderer.apply(this,U);return oe===!1&&(oe=k.apply(this,U)),oe}:w.renderers[D.name]=D.renderer}if(D.tokenizer){if(!D.level||D.level!=="block"&&D.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");w[D.level]?w[D.level].unshift(D.tokenizer):w[D.level]=[D.tokenizer],D.start&&(D.level==="block"?w.startBlock?w.startBlock.push(D.start):w.startBlock=[D.start]:D.level==="inline"&&(w.startInline?w.startInline.push(D.start):w.startInline=[D.start]))}D.childTokens&&(w.childTokens[D.name]=D.childTokens)})),n.renderer&&function(){var D=re.defaults.renderer||new Pe,k=function(Z){var oe=D[Z];D[Z]=function(){for(var ve=arguments.length,de=new Array(ve),ke=0;ke<ve;ke++)de[ke]=arguments[ke];var Te=n.renderer[Z].apply(D,de);return Te===!1&&(Te=oe.apply(D,de)),Te}};for(var R in n.renderer)k(R);a.renderer=D}(),n.tokenizer&&function(){var D=re.defaults.tokenizer||new ae,k=function(Z){var oe=D[Z];D[Z]=function(){for(var ve=arguments.length,de=new Array(ve),ke=0;ke<ve;ke++)de[ke]=arguments[ke];var Te=n.tokenizer[Z].apply(D,de);return Te===!1&&(Te=oe.apply(D,de)),Te}};for(var R in n.tokenizer)k(R);a.tokenizer=D}(),n.walkTokens){var E=re.defaults.walkTokens;a.walkTokens=function(D){var k=[];return k.push(n.walkTokens.call(this,D)),E&&(k=k.concat(E.call(this,D))),k}}F&&(a.extensions=w),re.setOptions(a)})},re.walkTokens=function(H,h){for(var y=[],a=function(){var E=F.value;switch(y=y.concat(h.call(re,E)),E.type){case"table":{for(var D=z(E.header),k;!(k=D()).done;){var R=k.value;y=y.concat(re.walkTokens(R.tokens,h))}for(var U=z(E.rows),Z;!(Z=U()).done;)for(var oe=Z.value,ve=z(oe),de;!(de=ve()).done;){var ke=de.value;y=y.concat(re.walkTokens(ke.tokens,h))}break}case"list":{y=y.concat(re.walkTokens(E.items,h));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[E.type]?re.defaults.extensions.childTokens[E.type].forEach(function(Te){y=y.concat(re.walkTokens(E[Te],h))}):E.tokens&&(y=y.concat(re.walkTokens(E.tokens,h)))}},w=z(H),F;!(F=w()).done;)a();return y},re.parseInline=function(H,h){if(typeof H>"u"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");h=v({},re.defaults,h||{}),W(h);try{var y=Se.lexInline(H,h);return h.walkTokens&&re.walkTokens(y,h.walkTokens),he.parseInline(y,h)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,h.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},re.Parser=he,re.parser=he.parse,re.Renderer=Pe,re.TextRenderer=le,re.Lexer=Se,re.lexer=Se.lex,re.Tokenizer=ae,re.Slugger=J,re.parse=re;var ye=re.options,V=re.setOptions,Q=re.use,ge=re.walkTokens,De=re.parseInline,Ae=re,Ie=he.parse,Oe=Se.lex;ne.Lexer=Se,ne.Parser=he,ne.Renderer=Pe,ne.Slugger=J,ne.TextRenderer=le,ne.Tokenizer=ae,ne.getDefaults=_,ne.lexer=Oe,ne.marked=re,ne.options=ye,ne.parse=Ae,ne.parseInline=De,ne.parser=Ie,ne.setOptions=V,ne.use=Q,ne.walkTokens=ge,Object.defineProperty(ne,"__esModule",{value:!0})}),define(me[89],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=i;function i(s){const o=z(s);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const x=new Uint32Array(10);function z(s){if(N=0,_(s,B,4352),N>0||(_(s,c,4449),N>0)||(_(s,u,4520),N>0)||(_(s,e,12593),N))return x.subarray(0,N);if(s>=44032&&s<=55203){const o=s-44032,l=o%588,d=Math.floor(o/588),C=Math.floor(l/28),m=l%28-1;if(d<B.length?_(d,B,0):4352+d-12593<e.length&&_(4352+d,e,12593),C<c.length?_(C,c,0):4449+C-12593<e.length&&_(4449+C-12593,e,12593),m>=0&&(m<u.length?_(m,u,0):4520+m-12593<e.length&&_(4520+m-12593,e,12593)),N>0)return x.subarray(0,N)}}function _(s,o,l){s>=l&&s<l+o.length&&T(o[s-l])}function T(s){s!==0&&(x[N++]=s&255,s>>8&&(x[N++]=s>>8&255),s>>16&&(x[N++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var g;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(g||(g={}));var b;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(b||(b={}));const B=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),u=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[90],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class i{constructor(x,z=0,_=x.length,T=z-1){this.items=x,this.start=z,this.end=_,this.index=T}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=i}),define(me[91],pe([1,0,90]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class N{constructor(_=[],T=10){this._initialize(_),this._limit=T,this._onChange()}getHistory(){return this._elements}add(_){this._history.delete(_),this._history.add(_),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(_){return this._history.has(_)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const _=this._elements;this._navigator=new i.ArrayNavigator(_,0,_.length,_.length)}_reduceToLimit(){const _=this._elements;_.length>this._limit&&this._initialize(_.slice(_.length-this._limit))}_currentPosition(){const _=this._navigator.current();return _?this._elements.indexOf(_):-1}_initialize(_){this._history=new Set;for(const T of _)this._history.add(T)}get _elements(){const _=[];return this._history.forEach(T=>_.push(T)),_}}t.HistoryNavigator=N;class x{get size(){return this._size}constructor(_,T=10){if(this.capacity=T,_.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:_[0],previous:void 0,next:void 0},this.valueSet=new Set([_[0]]);for(let f=1;f<_.length;f++)this.add(_[f])}add(_){const T={value:_,previous:this.tail,next:void 0};for(this.tail.next=T,this.tail=T,this.cursor=this.tail,this._size++,this.valueSet.has(_)?this._deleteFromList(_):this.valueSet.add(_);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(_){if(this.tail.value===_)return _;const T=this.tail.value;return this.valueSet.delete(T),this.tail.value=_,this.valueSet.has(_)?this._deleteFromList(_):this.valueSet.add(_),T}prepend(_){if(this._size===this.capacity||this.valueSet.has(_))return;const T={value:_,previous:void 0,next:this.head};this.head.previous=T,this.head=T,this._size++,this.valueSet.add(_)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(_){return this.valueSet.has(_)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let _=this.head;for(;_;)yield _.value,_=_.next}_deleteFromList(_){let T=this.head;for(;T!==this.tail;)T.value===_&&(T===this.head?(this.head=this.head.next,this.head.previous=void 0):(T.previous.next=T.next,T.next.previous=T.previous),this._size--),T=T.next}}t.HistoryNavigator2=x}),define(me[40],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=i,t.rot=N;function i(T,f,g){return Math.min(Math.max(T,f),g)}function N(T,f){return(f+T%f)%f}class x{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=x;class z{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=z;class _{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const g=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=g,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=_}),define(me[26],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=z,t.getFunctionName=c;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return z(e,this)}}t.DebugNameData=i;const N=new Map,x=new WeakMap;function z(u,e){const s=x.get(u);if(s)return s;const o=_(u,e);if(o){let l=N.get(o)??0;l++,N.set(o,l);const d=l===1?o:`${o}#${l}`;return x.set(u,d),d}}function _(u,e){const s=x.get(u);if(s)return s;const o=e.owner?b(e.owner)+".":"";let l;const d=e.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(l=d(),l!==void 0)return o+l}else return o+d;const C=e.referenceFn;if(C!==void 0&&(l=c(C),l!==void 0))return o+l;if(e.owner!==void 0){const m=T(e.owner,u);if(m!==void 0)return o+m}}function T(u,e){for(const s in u)if(u[s]===e)return s}const f=new Map,g=new WeakMap;function b(u){const e=g.get(u);if(e)return e;const s=B(u);let o=f.get(s)??0;o++,f.set(s,o);const l=o===1?s:`${s}#${o}`;return g.set(u,l),l}function B(u){const e=u.constructor;return e?e.name:"Object"}function c(u){const e=u.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(me[27],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=N,t.getLogger=x;let i;function N(s){i=s}function x(){return i}class z{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return _([T(u("|  ",this.indentation)),o])}formatInfo(o){return o.hadValue?o.didChange?[T(" "),g(b(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),g(b(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),g(b(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,l){console.log(...this.textToConsoleArgs([f("observable value changed"),g(o.debugName,{color:"BlueViolet"}),...this.formatInfo(l)]))}formatChanges(o){if(o.size!==0)return g(" (changed deps: "+[...o].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const l=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(d,C)=>(this.changedObservablesSets.get(o).add(d),l.apply(o,[d,C]))}handleDerivedRecomputed(o,l){const d=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([f("derived recomputed"),g(o.debugName,{color:"BlueViolet"}),...this.formatInfo(l),this.formatChanges(d),{data:[{fn:o._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(o,l){console.log(...this.textToConsoleArgs([f("observable from event triggered"),g(o.debugName,{color:"BlueViolet"}),...this.formatInfo(l),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const l=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(d,C)=>(this.changedObservablesSets.get(o).add(d),l.apply(o,[d,C]))}handleAutorunTriggered(o){const l=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([f("autorun"),g(o.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:o._runFn}]}])),l.clear(),this.indentation++}handleAutorunFinished(o){this.indentation--}handleBeginTransaction(o){let l=o.getDebugName();l===void 0&&(l=""),console.log(...this.textToConsoleArgs([f("transaction"),g(l,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=z;function _(s){const o=new Array,l=[];let d="";function C(p){if("length"in p)for(const r of p)r&&C(r);else"text"in p?(d+=`%c${p.text}`,o.push(p.style),p.data&&l.push(...p.data)):"data"in p&&l.push(...p.data)}C(s);const m=[d,...o];return m.push(...l),m}function T(s){return g(s,{color:"black"})}function f(s){return g(e(`${s}: `,10),{color:"black",bold:!0})}function g(s,o={color:"black"}){function l(C){return Object.entries(C).reduce((m,[p,r])=>`${m}${p}:${r};`,"")}const d={color:o.color};return o.strikeThrough&&(d["text-decoration"]="line-through"),o.bold&&(d["font-weight"]="bold"),{text:s,style:l(d)}}function b(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?B(s,o):c(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function B(s,o){let l="[ ",d=!0;for(const C of s){if(d||(l+=", "),l.length-5>o){l+="...";break}d=!1,l+=`${b(C,o-l.length)}`}return l+=" ]",l}function c(s,o){let l="{ ",d=!0;for(const[C,m]of Object.entries(s)){if(d||(l+=", "),l.length-5>o){l+="...";break}d=!1,l+=`${C}: ${b(m,o-l.length)}`}return l+=" }",l}function u(s,o){let l="";for(let d=1;d<=o;d++)l+=s;return l}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(me[41],pe([1,0,37,2,26,27]),function(ne,t,i,N,x,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=_,t.autorunOpts=T,t.autorunHandleChanges=f,t.autorunWithStoreHandleChanges=g,t.autorunWithStore=b,t.autorunDelta=B;function _(e){return new u(new x.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function T(e,s){return new u(new x.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function f(e,s){return new u(new x.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function g(e,s){const o=new N.DisposableStore,l=f({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(d,C)=>{o.clear(),s(d,C,o)});return(0,N.toDisposable)(()=>{l.dispose(),o.dispose()})}function b(e){const s=new N.DisposableStore,o=T({owner:void 0,debugName:void 0,debugReferenceFn:e},l=>{s.clear(),e(l,s)});return(0,N.toDisposable)(()=>{o.dispose(),s.dispose()})}function B(e,s){let o;return T({debugReferenceFn:s},l=>{const d=e.read(l),C=o;o=d,s({lastValue:C,newValue:d})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class u{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,o,l,d){this._debugNameData=s,this._runFn=o,this.createChangeSummary=l,this._handleChange=d,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,z.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,N.trackDisposable)(this)}dispose(){this.disposed=!0;for(const s of this.dependencies)s.removeObserver(this);this.dependencies.clear(),(0,N.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const s=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=s,this.state=3;const o=this.disposed;try{if(!o){(0,z.getLogger)()?.handleAutorunTriggered(this);const l=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,l)}}finally{o||(0,z.getLogger)()?.handleAutorunFinished(this);for(const l of this.dependenciesToBeRemoved)l.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const s of this.dependencies)if(s.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(s){this.state===3&&this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(this.state=1)}handleChange(s,o){this.dependencies.has(s)&&!this.dependenciesToBeRemoved.has(s)&&(!this._handleChange||this._handleChange({changedObservable:s,change:o,didChange:d=>d===s},this.changeSummary))&&(this.state=2)}readObservable(s){if(this.disposed)return s.get();s.addObserver(this);const o=s.get();return this.dependencies.add(s),this.dependenciesToBeRemoved.delete(s),o}}t.AutorunObserver=u,function(e){e.Observer=u}(_||(t.autorun=_={}))}),define(me[33],pe([1,0,38,26,27]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=_,t._setKeepObserved=f,t._setDerivedOpts=b,t.transaction=u,t.globalTransaction=s,t.asyncTransaction=o,t.subtransaction=l,t.observableValue=C,t.observableValueOpts=m,t.disposableObservableValue=r;let z;function _(A){z=A}let T;function f(A){T=A}let g;function b(A){g=A}class B{get TChange(){return null}reportChanges(){this.get()}read(I){return I?I.readObservable(this):this.get()}map(I,P){const $=P===void 0?void 0:I,v=P===void 0?I:P;return g({owner:$,debugName:()=>{const O=(0,N.getFunctionName)(v);if(O!==void 0)return O;const L=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(L)return`${this.debugName}.${L[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:v},O=>v(this.read(O),O))}recomputeInitiallyAndOnChange(I,P){return I.add(z(this,P)),this}keepObserved(I){return I.add(T(this)),this}get debugValue(){return this.get()}}t.ConvenientObservable=B;class c extends B{constructor(){super(...arguments),this.observers=new Set}addObserver(I){const P=this.observers.size;this.observers.add(I),P===0&&this.onFirstObserverAdded()}removeObserver(I){this.observers.delete(I)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=c;function u(A,I){const P=new d(A,I);try{A(P)}finally{P.finish()}}let e;function s(A){if(e)A(e);else{const I=new d(A,void 0);e=I;try{A(I)}finally{I.finish(),e=void 0}}}async function o(A,I){const P=new d(A,I);try{await A(P)}finally{P.finish()}}function l(A,I,P){A?I(A):u(I,P)}class d{constructor(I,P){this._fn=I,this._getDebugName=P,this.updatingObservers=[],(0,x.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,N.getFunctionName)(this._fn)}updateObserver(I,P){this.updatingObservers.push({observer:I,observable:P}),I.beginUpdate(P)}finish(){const I=this.updatingObservers;for(let P=0;P<I.length;P++){const{observer:$,observable:v}=I[P];$.endUpdate(v)}this.updatingObservers=null,(0,x.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=d;function C(A,I){let P;return typeof A=="string"?P=new N.DebugNameData(void 0,A,void 0):P=new N.DebugNameData(A,void 0,void 0),new p(P,I,i.strictEquals)}function m(A,I){return new p(new N.DebugNameData(A.owner,A.debugName,void 0),I,A.equalsFn??i.strictEquals)}class p extends c{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(I,P,$){super(),this._debugNameData=I,this._equalityComparator=$,this._value=P}get(){return this._value}set(I,P,$){if(this._equalityComparator(this._value,I))return;let v;P||(P=v=new d(()=>{},()=>`Setting ${this.debugName}`));try{const O=this._value;this._setValue(I),(0,x.getLogger)()?.handleObservableChanged(this,{oldValue:O,newValue:I,change:$,didChange:!0,hadValue:!0});for(const q of this.observers)P.updateObserver(q,this),q.handleChange(this,$)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(I){this._value=I}}t.ObservableValue=p;function r(A,I){let P;return typeof A=="string"?P=new N.DebugNameData(void 0,A,void 0):P=new N.DebugNameData(A,void 0,void 0),new S(P,I,i.strictEquals)}class S extends p{_setValue(I){this._value!==I&&(this._value&&this._value.dispose(),this._value=I)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=S}),define(me[42],pe([1,0,37,38,2,33,26,27]),function(ne,t,i,N,x,z,_,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Derived=void 0,t.derived=f,t.derivedOpts=g,t.derivedHandleChanges=b,t.derivedWithStore=B,t.derivedDisposable=c;function f(s,o){return o!==void 0?new e(new _.DebugNameData(s,void 0,o),o,void 0,void 0,void 0,N.strictEquals):new e(new _.DebugNameData(void 0,void 0,s),s,void 0,void 0,void 0,N.strictEquals)}function g(s,o){return new e(new _.DebugNameData(s.owner,s.debugName,s.debugReferenceFn),o,void 0,void 0,s.onLastObserverRemoved,s.equalsFn??N.strictEquals)}(0,z._setDerivedOpts)(g);function b(s,o){return new e(new _.DebugNameData(s.owner,s.debugName,void 0),o,s.createEmptyChangeSummary,s.handleChange,void 0,s.equalityComparer??N.strictEquals)}function B(s,o){let l,d;o===void 0?(l=s,d=void 0):(d=s,l=o);const C=new x.DisposableStore;return new e(new _.DebugNameData(d,void 0,l),m=>(C.clear(),l(m,C)),void 0,void 0,()=>C.dispose(),N.strictEquals)}function c(s,o){let l,d;o===void 0?(l=s,d=void 0):(d=s,l=o);const C=new x.DisposableStore;return new e(new _.DebugNameData(d,void 0,l),m=>{C.clear();const p=l(m);return p&&C.add(p),p},void 0,void 0,()=>C.dispose(),N.strictEquals)}var u;(function(s){s[s.initial=0]="initial",s[s.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",s[s.stale=2]="stale",s[s.upToDate=3]="upToDate"})(u||(u={}));class e extends z.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(o,l,d,C,m=void 0,p){super(),this._debugNameData=o,this._computeFn=l,this.createChangeSummary=d,this._handleChange=C,this._handleLastObserverRemoved=m,this._equalityComparator=p,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,T.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const o of this.dependencies)o.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const o=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),o}else{do{if(this.state===1){for(const o of this.dependencies)if(o.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const o=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=o;const l=this.state!==0,d=this.value;this.state=3;const C=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,C)}finally{for(const p of this.dependenciesToBeRemoved)p.removeObserver(this);this.dependenciesToBeRemoved.clear()}const m=l&&!this._equalityComparator(d,this.value);if((0,T.getLogger)()?.handleDerivedRecomputed(this,{oldValue:d,newValue:this.value,change:void 0,didChange:m,hadValue:l}),m)for(const p of this.observers)p.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(o){this.updateCount++;const l=this.updateCount===1;if(this.state===3&&(this.state=1,!l))for(const d of this.observers)d.handlePossibleChange(this);if(l)for(const d of this.observers)d.beginUpdate(this)}endUpdate(o){if(this.updateCount--,this.updateCount===0){const l=[...this.observers];for(const d of l)d.endUpdate(this)}(0,i.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(o){if(this.state===3&&this.dependencies.has(o)&&!this.dependenciesToBeRemoved.has(o)){this.state=1;for(const l of this.observers)l.handlePossibleChange(this)}}handleChange(o,l){if(this.dependencies.has(o)&&!this.dependenciesToBeRemoved.has(o)){const d=this._handleChange?this._handleChange({changedObservable:o,change:l,didChange:m=>m===o},this.changeSummary):!0,C=this.state===3;if(d&&(this.state===1||C)&&(this.state=2,C))for(const m of this.observers)m.handlePossibleChange(this)}}readObservable(o){o.addObserver(this);const l=o.get();return this.dependencies.add(o),this.dependenciesToBeRemoved.delete(o),l}addObserver(o){const l=!this.observers.has(o)&&this.updateCount>0;super.addObserver(o),l&&o.beginUpdate(this)}removeObserver(o){const l=this.observers.has(o)&&this.updateCount>0;super.removeObserver(o),l&&o.endUpdate(this)}}t.Derived=e}),define(me[56],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(N){function x(f,g){if(f.start>=g.end||g.start>=f.end)return{start:0,end:0};const b=Math.max(f.start,g.start),B=Math.min(f.end,g.end);return B-b<=0?{start:0,end:0}:{start:b,end:B}}N.intersect=x;function z(f){return f.end-f.start<=0}N.isEmpty=z;function _(f,g){return!z(x(f,g))}N.intersects=_;function T(f,g){const b=[],B={start:f.start,end:Math.min(g.start,f.end)},c={start:Math.max(g.end,f.start),end:f.end};return z(B)||b.push(B),z(c)||b.push(c),b}N.relativeComplement=T})(i||(t.Range=i={}))}),define(me[92],pe([1,0,56]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=N,t.shift=x,t.consolidate=z;function N(f,g){const b=[];for(const B of g){if(f.start>=B.range.end)continue;if(f.end<B.range.start)break;const c=i.Range.intersect(f,B.range);i.Range.isEmpty(c)||b.push({range:c,size:B.size})}return b}function x({start:f,end:g},b){return{start:f+b,end:g+b}}function z(f){const g=[];let b=null;for(const B of f){const c=B.range.start,u=B.range.end,e=B.size;if(b&&e===b.size){b.range.end=u;continue}b={range:{start:c,end:u},size:e},g.push(b)}return g}function _(...f){return z(f.reduce((g,b)=>g.concat(b),[]))}class T{get paddingTop(){return this._paddingTop}set paddingTop(g){this._size=this._size+g-this._paddingTop,this._paddingTop=g}constructor(g){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=g??0,this._size=this._paddingTop}splice(g,b,B=[]){const c=B.length-b,u=N({start:0,end:g},this.groups),e=N({start:g+b,end:Number.POSITIVE_INFINITY},this.groups).map(o=>({range:x(o.range,c),size:o.size})),s=B.map((o,l)=>({range:{start:g+l,end:g+l+1},size:o.size}));this.groups=_(u,s,e),this._size=this._paddingTop+this.groups.reduce((o,l)=>o+l.size*(l.range.end-l.range.start),0)}get count(){const g=this.groups.length;return g?this.groups[g-1].range.end:0}get size(){return this._size}indexAt(g){if(g<0)return-1;if(g<this._paddingTop)return 0;let b=0,B=this._paddingTop;for(const c of this.groups){const u=c.range.end-c.range.start,e=B+u*c.size;if(g<e)return b+Math.floor((g-B)/c.size);b+=u,B=e}return b}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let b=0,B=0;for(const c of this.groups){const u=c.range.end-c.range.start,e=B+u;if(g<e)return this._paddingTop+b+(g-B)*c.size;b+=u*c.size,B=e}return-1}}t.RangeMap=T}),define(me[93],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(z){return new N(z)}constructor(z){this._now=i&&z===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=N}),define(me[3],pe([1,0,6,53,2,55,93]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=u;const T=!1,f=!1,g=!1;var b;(function(G){G.None=()=>x.Disposable.None;function K(E){if(g){const{onDidAddListener:D}=E,k=s.create();let R=0;E.onDidAddListener=()=>{++R===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),D?.()}}}function ae(E,D){return re(E,()=>{},0,void 0,!0,void 0,D)}G.defer=ae;function ie(E){return(D,k=null,R)=>{let U=!1,Z;return Z=E(oe=>{if(!U)return Z?Z.dispose():U=!0,D.call(k,oe)},null,R),U&&Z.dispose(),Z}}G.once=ie;function ee(E,D,k){return J((R,U=null,Z)=>E(oe=>R.call(U,D(oe)),null,Z),k)}G.map=ee;function ce(E,D,k){return J((R,U=null,Z)=>E(oe=>{D(oe),R.call(U,oe)},null,Z),k)}G.forEach=ce;function Ee(E,D,k){return J((R,U=null,Z)=>E(oe=>D(oe)&&R.call(U,oe),null,Z),k)}G.filter=Ee;function Se(E){return E}G.signal=Se;function Pe(...E){return(D,k=null,R)=>{const U=(0,x.combinedDisposable)(...E.map(Z=>Z(oe=>D.call(k,oe))));return he(U,R)}}G.any=Pe;function le(E,D,k,R){let U=k;return ee(E,Z=>(U=D(U,Z),U),R)}G.reduce=le;function J(E,D){let k;const R={onWillAddFirstListener(){k=E(U.fire,U)},onDidRemoveLastListener(){k?.dispose()}};D||K(R);const U=new p(R);return D?.add(U),U.event}function he(E,D){return D instanceof Array?D.push(E):D&&D.add(E),E}function re(E,D,k=100,R=!1,U=!1,Z,oe){let ve,de,ke,Te=0,Me;const Ce={leakWarningThreshold:Z,onWillAddFirstListener(){ve=E(Ve=>{Te++,de=D(de,Ve),R&&!ke&&(Ne.fire(de),de=void 0),Me=()=>{const Ye=de;de=void 0,ke=void 0,(!R||Te>1)&&Ne.fire(Ye),Te=0},typeof k=="number"?(clearTimeout(ke),ke=setTimeout(Me,k)):ke===void 0&&(ke=0,queueMicrotask(Me))})},onWillRemoveListener(){U&&Te>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,ve.dispose()}};oe||K(Ce);const Ne=new p(Ce);return oe?.add(Ne),Ne.event}G.debounce=re;function ye(E,D=0,k){return G.debounce(E,(R,U)=>R?(R.push(U),R):[U],D,void 0,!0,void 0,k)}G.accumulate=ye;function V(E,D=(R,U)=>R===U,k){let R=!0,U;return Ee(E,Z=>{const oe=R||!D(Z,U);return R=!1,U=Z,oe},k)}G.latch=V;function Q(E,D,k){return[G.filter(E,D,k),G.filter(E,R=>!D(R),k)]}G.split=Q;function ge(E,D=!1,k=[],R){let U=k.slice(),Z=E(de=>{U?U.push(de):ve.fire(de)});R&&R.add(Z);const oe=()=>{U?.forEach(de=>ve.fire(de)),U=null},ve=new p({onWillAddFirstListener(){Z||(Z=E(de=>ve.fire(de)),R&&R.add(Z))},onDidAddFirstListener(){U&&(D?setTimeout(oe):oe())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return R&&R.add(ve),ve.event}G.buffer=ge;function De(E,D){return(R,U,Z)=>{const oe=D(new Ie);return E(function(ve){const de=oe.evaluate(ve);de!==Ae&&R.call(U,de)},void 0,Z)}}G.chain=De;const Ae=Symbol("HaltChainable");class Ie{constructor(){this.steps=[]}map(D){return this.steps.push(D),this}forEach(D){return this.steps.push(k=>(D(k),k)),this}filter(D){return this.steps.push(k=>D(k)?k:Ae),this}reduce(D,k){let R=k;return this.steps.push(U=>(R=D(R,U),R)),this}latch(D=(k,R)=>k===R){let k=!0,R;return this.steps.push(U=>{const Z=k||!D(U,R);return k=!1,R=U,Z?U:Ae}),this}evaluate(D){for(const k of this.steps)if(D=k(D),D===Ae)break;return D}}function Oe(E,D,k=R=>R){const R=(...ve)=>oe.fire(k(...ve)),U=()=>E.on(D,R),Z=()=>E.removeListener(D,R),oe=new p({onWillAddFirstListener:U,onDidRemoveLastListener:Z});return oe.event}G.fromNodeEventEmitter=Oe;function H(E,D,k=R=>R){const R=(...ve)=>oe.fire(k(...ve)),U=()=>E.addEventListener(D,R),Z=()=>E.removeEventListener(D,R),oe=new p({onWillAddFirstListener:U,onDidRemoveLastListener:Z});return oe.event}G.fromDOMEventEmitter=H;function h(E){return new Promise(D=>ie(E)(D))}G.toPromise=h;function y(E){const D=new p;return E.then(k=>{D.fire(k)},()=>{D.fire(void 0)}).finally(()=>{D.dispose()}),D.event}G.fromPromise=y;function a(E,D,k){return D(k),E(R=>D(R))}G.runAndSubscribe=a;class w{constructor(D,k){this._observable=D,this._counter=0,this._hasChanged=!1;const R={onWillAddFirstListener:()=>{D.addObserver(this)},onDidRemoveLastListener:()=>{D.removeObserver(this)}};k||K(R),this.emitter=new p(R),k&&k.add(this.emitter)}beginUpdate(D){this._counter++}handlePossibleChange(D){}handleChange(D,k){this._hasChanged=!0}endUpdate(D){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function F(E,D){return new w(E,D).emitter.event}G.fromObservable=F;function n(E){return(D,k,R)=>{let U=0,Z=!1;const oe={beginUpdate(){U++},endUpdate(){U--,U===0&&(E.reportChanges(),Z&&(Z=!1,D.call(k)))},handlePossibleChange(){},handleChange(){Z=!0}};E.addObserver(oe),E.reportChanges();const ve={dispose(){E.removeObserver(oe)}};return R instanceof x.DisposableStore?R.add(ve):Array.isArray(R)&&R.push(ve),ve}}G.fromObservableLight=n})(b||(t.Event=b={}));class B{static{this.all=new Set}static{this._idPool=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${B._idPool++}`,B.all.add(this)}start(K){this._stopWatch=new _.StopWatch,this.listenerCount=K}stop(){if(this._stopWatch){const K=this._stopWatch.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=B;let c=-1;function u(G){const K=c;return c=G,{dispose(){c=K}}}class e{constructor(K,ae=Math.random().toString(18).slice(2,5)){this.threshold=K,this.name=ae,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(K,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this._stacks||(this._stacks=new Map);const ee=this._stacks.get(K.value)||0;if(this._stacks.set(K.value,ee+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=ie*.5;let ce,Ee=0;for(const[Se,Pe]of this._stacks)(!ce||Ee<Pe)&&(ce=Se,Ee=Pe);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${Ee}):`),console.warn(ce)}return()=>{const ce=this._stacks.get(K.value)||0;this._stacks.set(K.value,ce-1)}}}class s{static create(){return new s(new Error().stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let o=0;class l{constructor(K){this.value=K,this.id=o++}}const d=2,C=(G,K)=>{if(G instanceof l)K(G);else for(let ae=0;ae<G.length;ae++){const ie=G[ae];ie&&K(ie)}},m=T?new FinalizationRegistry(G=>{typeof G=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(G))}):void 0;class p{constructor(K){this._size=0,this._options=K,this._leakageMon=c>0||this._options?.leakWarningThreshold?new e(this._options?.leakWarningThreshold??c):void 0,this._perfMon=this._options?._profName?new B(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(f){const K=this._listeners;queueMicrotask(()=>{C(K,ae=>ae.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(K,ae,ie)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),x.Disposable.None;if(this._disposed)return x.Disposable.None;ae&&(K=K.bind(ae));const ee=new l(K);let ce,Ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ee.stack=s.create(),ce=this._leakageMon.check(ee.stack,this._size+1)),f&&(ee.stack=Ee??s.create()),this._listeners?this._listeners instanceof l?(this._deliveryQueue??=new S,this._listeners=[this._listeners,ee]):this._listeners.push(ee):(this._options?.onWillAddFirstListener?.(this),this._listeners=ee,this._options?.onDidAddFirstListener?.(this)),this._size++;const Se=(0,x.toDisposable)(()=>{m?.unregister(Se),ce?.(),this._removeListener(ee)});if(ie instanceof x.DisposableStore?ie.add(Se):Array.isArray(ie)&&ie.push(Se),m){const Pe=new Error().stack.split(`
`).slice(2).join(`
`).trim();m.register(Se,Pe,Se)}return Se},this._event}_removeListener(K){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const ae=this._listeners,ie=ae.indexOf(K);if(ie===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,ae[ie]=void 0;const ee=this._deliveryQueue.current===this;if(this._size*d<=ae.length){let ce=0;for(let Ee=0;Ee<ae.length;Ee++)ae[Ee]?ae[ce++]=ae[Ee]:ee&&(this._deliveryQueue.end--,ce<this._deliveryQueue.i&&this._deliveryQueue.i--);ae.length=ce}}_deliver(K,ae){if(!K)return;const ie=this._options?.onListenerError||i.onUnexpectedError;if(!ie){K.value(ae);return}try{K.value(ae)}catch(ee){ie(ee)}}_deliverQueue(K){const ae=K.current._listeners;for(;K.i<K.end;)this._deliver(ae[K.i++],K.value);K.reset()}fire(K){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof l)this._deliver(this._listeners,K);else{const ae=this._deliveryQueue;ae.enqueue(this,K,this._listeners.length),this._deliverQueue(ae)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=p;const r=()=>new S;t.createEventDeliveryQueue=r;class S{constructor(){this.i=-1,this.end=0}enqueue(K,ae,ie){this.i=0,this.end=ie,this.current=K,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class A extends p{async fireAsync(K,ae,ie){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new z.LinkedList),C(this._listeners,ee=>this._asyncDeliveryQueue.push([ee.value,K]));this._asyncDeliveryQueue.size>0&&!ae.isCancellationRequested;){const[ee,ce]=this._asyncDeliveryQueue.shift(),Ee=[],Se={...ce,token:ae,waitUntil:Pe=>{if(Object.isFrozen(Ee))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Pe=ie(Pe,ee)),Ee.push(Pe)}};try{ee(Se)}catch(Pe){(0,i.onUnexpectedError)(Pe);continue}Object.freeze(Ee),await Promise.allSettled(Ee).then(Pe=>{for(const le of Pe)le.status==="rejected"&&(0,i.onUnexpectedError)(le.reason)})}}}t.AsyncEmitter=A;class I extends p{get isPaused(){return this._isPaused!==0}constructor(K){super(K),this._isPaused=0,this._eventQueue=new z.LinkedList,this._mergeFn=K?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const K=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(K))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(K){this._size&&(this._isPaused!==0?this._eventQueue.push(K):super.fire(K))}}t.PauseableEmitter=I;class P extends I{constructor(K){super(K),this._delay=K.delay??100}fire(K){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(K)}}t.DebounceEmitter=P;class $ extends p{constructor(K){super(K),this._queuedEvents=[],this._mergeFn=K?.merge}fire(K){this.hasListeners()&&(this._queuedEvents.push(K),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(ae=>super.fire(ae)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=$;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(K){const ae={event:K,listener:null};this.events.push(ae),this.hasListeners&&this.hook(ae);const ie=()=>{this.hasListeners&&this.unhook(ae);const ee=this.events.indexOf(ae);this.events.splice(ee,1)};return(0,x.toDisposable)((0,N.createSingleCallFunction)(ie))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(K=>this.hook(K))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(K=>this.unhook(K))}hook(K){K.listener=K.event(ae=>this.emitter.fire(ae))}unhook(K){K.listener?.dispose(),K.listener=null}dispose(){this.emitter.dispose();for(const K of this.events)K.listener?.dispose();this.events=[]}}t.EventMultiplexer=v;class O{constructor(K,ae,ie,ee){this._store=new x.DisposableStore;const ce=this._store.add(new v),Ee=this._store.add(new x.DisposableMap);function Se(Pe){Ee.set(Pe,ce.add(ee(Pe)))}for(const Pe of K)Se(Pe);this._store.add(ae(Pe=>{Se(Pe)})),this._store.add(ie(Pe=>{Ee.deleteAndDispose(Pe)})),this.event=ce.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=O;class q{constructor(){this.buffers=[]}wrapEvent(K){return(ae,ie,ee)=>K(ce=>{const Ee=this.buffers[this.buffers.length-1];Ee?Ee.push(()=>ae.call(ie,ce)):ae.call(ie,ce)},void 0,ee)}bufferEvents(K){const ae=[];this.buffers.push(ae);const ie=K();return this.buffers.pop(),ae.forEach(ee=>ee()),ie}}t.EventBufferer=q;class L{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=x.Disposable.None,this.emitter=new p({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(K){this.inputEvent=K,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=K(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=L;class W{static const(K){return new M(K)}constructor(K){this._value=K,this._onDidChange=new p,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(K){K!==this._value&&(this._value=K,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=W;class M{constructor(K){this.value=K,this.onDidChange=b.None}}}),define(me[17],pe([1,0,22,3]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=z,t.setZoomLevel=_,t.getZoomLevel=T,t.getZoomFactor=f,t.setZoomFactor=g,t.setFullscreen=b,t.isFullscreen=B,t.isStandalone=e,t.isWCOEnabled=s;class x{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new N.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new N.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new x}getZoomLevel(l){return this.mapWindowIdToZoomLevel.get(this.getWindowId(l))??0}setZoomLevel(l,d){if(this.getZoomLevel(d)===l)return;const C=this.getWindowId(d);this.mapWindowIdToZoomLevel.set(C,l),this._onDidChangeZoomLevel.fire(C)}getZoomFactor(l){return this.mapWindowIdToZoomFactor.get(this.getWindowId(l))??1}setZoomFactor(l,d){this.mapWindowIdToZoomFactor.set(this.getWindowId(d),l)}setFullscreen(l,d){if(this.isFullscreen(d)===l)return;const C=this.getWindowId(d);this.mapWindowIdToFullScreen.set(C,l),this._onDidChangeFullscreen.fire(C)}isFullscreen(l){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(l))}getWindowId(l){return l.vscodeWindowId}}function z(o,l,d){typeof l=="string"&&(l=o.matchMedia(l)),l.addEventListener("change",d)}function _(o,l){x.INSTANCE.setZoomLevel(o,l)}function T(o){return x.INSTANCE.getZoomLevel(o)}t.onDidChangeZoomLevel=x.INSTANCE.onDidChangeZoomLevel;function f(o){return x.INSTANCE.getZoomFactor(o)}function g(o,l){x.INSTANCE.setZoomFactor(o,l)}function b(o,l){x.INSTANCE.setFullscreen(o,l)}function B(o){return x.INSTANCE.isFullscreen(o)}t.onDidChangeFullscreen=x.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.isFirefox=c.indexOf("Firefox")>=0,t.isWebKit=c.indexOf("AppleWebKit")>=0,t.isChrome=c.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&c.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=c.indexOf("Electron/")>=0,t.isAndroid=c.indexOf("Android")>=0;let u=!1;if(typeof i.mainWindow.matchMedia=="function"){const o=i.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.mainWindow.matchMedia("(display-mode: fullscreen)");u=o.matches,z(i.mainWindow,o,({matches:d})=>{u&&l.matches||(u=d)})}function e(){return u}function s(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],pe([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class N{get event(){return this.emitter.event}constructor(z,_,T){const f=g=>this.emitter.fire(g);this.emitter=new i.Emitter({onWillAddFirstListener:()=>z.addEventListener(_,f,T),onDidRemoveLastListener:()=>z.removeEventListener(_,f,T)})}dispose(){this.emitter.dispose()}}t.DomEmitter=N}),define(me[34],pe([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=T;const N=Object.freeze(function(f,g){const b=setTimeout(f.bind(g),0);return{dispose(){clearTimeout(b)}}});var x;(function(f){function g(b){return b===f.None||b===f.Cancelled||b instanceof z?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}f.isCancellationToken=g,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(x||(t.CancellationToken=x={}));class z{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?N:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new z),this._token}cancel(){this._token?this._token instanceof z&&this._token.cancel():this._token=x.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof z&&this._token.dispose():this._token=x.None}}t.CancellationTokenSource=_;function T(f){const g=new _;return f.add({dispose(){g.cancel()}}),g.token}}),define(me[94],pe([1,0,34]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=x;class N{constructor(f){this.task=f,this.result=null}get(){if(this.result)return this.result;const f=new i.CancellationTokenSource,g=this.task(f.token);return this.result={promise:g,dispose:()=>{this.result=null,f.cancel(),f.dispose()}},this.result}}t.Cache=N;function x(T){return T}class z{constructor(f,g){this.lastCache=void 0,this.lastArgKey=void 0,typeof f=="function"?(this._fn=f,this._computeKey=x):(this._fn=g,this._computeKey=f.getCacheKey)}get(f){const g=this._computeKey(f);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this._fn(f)),this.lastCache}}t.LRUCachedFunction=z;class _{get cachedValues(){return this._map}constructor(f,g){this._map=new Map,this._map2=new Map,typeof f=="function"?(this._fn=f,this._computeKey=x):(this._fn=g,this._computeKey=f.getCacheKey)}get(f){const g=this._computeKey(f);if(this._map2.has(g))return this._map2.get(g);const b=this._fn(f);return this._map.set(f,b),this._map2.set(g,b),b}}t.CachedFunction=_}),define(me[95],pe([1,0,41,33,42,34,26,38,6]),function(ne,t,i,N,x,z,_,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=u,t.derivedWithCancellationToken=e;class g{get cachedValue(){return this._value}constructor(o){this._computeValue=o,this._value=(0,N.observableValue)(this,void 0)}getValue(){let o=this._value.get();return o||(o=this._computeValue(),this._value.set(o,void 0)),o}}t.ObservableLazy=g;class b{constructor(o){this._value=(0,N.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=o.then(l=>((0,N.transaction)(d=>{this._value.set(new B(l,void 0),d)}),l),l=>{throw(0,N.transaction)(d=>{this._value.set(new B(void 0,l),d)}),l})}}t.ObservablePromise=b;class B{constructor(o,l){this.data=o,this.error=l}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=B;class c{constructor(o){this._computePromise=o,this._lazyValue=new g(()=>new b(this._computePromise())),this.cachedPromiseResult=(0,x.derived)(this,l=>this._lazyValue.cachedValue.read(l)?.promiseResult.read(l))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=c;function u(s,o,l,d){return o||(o=C=>C!=null),new Promise((C,m)=>{let p=!0,r=!1;const S=s.map(I=>({isFinished:o(I),error:l?l(I):!1,state:I})),A=(0,i.autorun)(I=>{const{isFinished:P,error:$,state:v}=S.read(I);(P||$)&&(p?r=!0:A.dispose(),$?m($===!0?v:$):C(v))});if(d){const I=d.onCancellationRequested(()=>{A.dispose(),I.dispose(),m(new f.CancellationError)});if(d.isCancellationRequested){A.dispose(),I.dispose(),m(new f.CancellationError);return}}p=!1,r&&A.dispose()})}function e(s,o){let l,d;o===void 0?(l=s,d=void 0):(d=s,l=o);let C;return new x.Derived(new _.DebugNameData(d,void 0,l),m=>(C&&C.dispose(!0),C=new z.CancellationTokenSource,l(m,C.token)),void 0,void 0,()=>C?.dispose(),T.strictEquals)}}),define(me[96],pe([1,0,3,2,41,33,26,42,27]),function(ne,t,i,N,x,z,_,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEventFromObservable=t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=g,t.observableFromPromise=B,t.observableFromEvent=c,t.observableSignalFromEvent=e,t.observableSignal=o,t.debouncedObservable=d,t.debouncedObservable2=C,t.wasEventTriggeredRecently=m,t.keepObserved=p,t.recomputeInitiallyAndOnChange=r,t.derivedObservableWithCache=A,t.derivedObservableWithWritableCache=I,t.mapObservableArrayCached=P,t.observableFromValueWithChangeEvent=O;function g(q){return new b(q)}class b extends z.ConvenientObservable{constructor(L){super(),this.value=L}get debugName(){return this.toString()}get(){return this.value}addObserver(L){}removeObserver(L){}toString(){return`Const: ${this.value}`}}function B(q){const L=(0,z.observableValue)("promiseValue",{});return q.then(W=>{L.set({value:W},void 0)}),L}function c(q,L){return new u(q,L)}class u extends z.BaseObservable{constructor(L,W){super(),this.event=L,this._getValue=W,this.hasValue=!1,this.handleEvent=M=>{const G=this._getValue(M),K=this.value,ae=!this.hasValue||K!==G;let ie=!1;ae&&(this.value=G,this.hasValue&&(ie=!0,(0,z.subtransaction)(u.globalTransaction,ee=>{(0,f.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:G,change:void 0,didChange:ae,hadValue:this.hasValue});for(const ce of this.observers)ee.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const ee=this.getDebugName();return"Event fired"+(ee?`: ${ee}`:"")})),this.hasValue=!0),ie||(0,f.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:G,change:void 0,didChange:ae,hadValue:this.hasValue})}}getDebugName(){return(0,_.getFunctionName)(this._getValue)}get debugName(){const L=this.getDebugName();return"From Event"+(L?`: ${L}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=u,function(q){q.Observer=u;function L(W,M){let G=!1;u.globalTransaction===void 0&&(u.globalTransaction=W,G=!0);try{M()}finally{G&&(u.globalTransaction=void 0)}}q.batchEventsGlobally=L}(c||(t.observableFromEvent=c={}));function e(q,L){return new s(q,L)}class s extends z.BaseObservable{constructor(L,W){super(),this.debugName=L,this.event=W,this.handleEvent=()=>{(0,z.transaction)(M=>{for(const G of this.observers)M.updateObserver(G,this),G.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function o(q){return typeof q=="string"?new l(q):new l(void 0,q)}class l extends z.BaseObservable{get debugName(){return new _.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}constructor(L,W){super(),this._debugName=L,this._owner=W}trigger(L,W){if(!L){(0,z.transaction)(M=>{this.trigger(M,W)},()=>`Trigger signal ${this.debugName}`);return}for(const M of this.observers)L.updateObserver(M,this),M.handleChange(this,W)}get(){}}function d(q,L,W){const M=(0,z.observableValue)("debounced",void 0);let G;return W.add((0,x.autorun)(K=>{const ae=q.read(K);G&&clearTimeout(G),G=setTimeout(()=>{(0,z.transaction)(ie=>{M.set(ae,ie)})},L)})),M}function C(q,L){let W=!1,M,G;return c(K=>{const ae=(0,x.autorun)(ie=>{const ee=q.read(ie);W?(G&&clearTimeout(G),G=setTimeout(()=>{M=ee,K()},L)):(W=!0,M=ee)});return{dispose(){ae.dispose(),W=!1,M=void 0}}},()=>W?M:q.get())}function m(q,L,W){const M=(0,z.observableValue)("triggeredRecently",!1);let G;return W.add(q(()=>{M.set(!0,void 0),G&&clearTimeout(G),G=setTimeout(()=>{M.set(!1,void 0)},L)})),M}function p(q){const L=new S(!1,void 0);return q.addObserver(L),(0,N.toDisposable)(()=>{q.removeObserver(L)})}(0,z._setKeepObserved)(p);function r(q,L){const W=new S(!0,L);return q.addObserver(W),L?L(q.get()):q.reportChanges(),(0,N.toDisposable)(()=>{q.removeObserver(W)})}(0,z._setRecomputeInitiallyAndOnChange)(r);class S{constructor(L,W){this._forceRecompute=L,this._handleValue=W,this._counter=0}beginUpdate(L){this._counter++}endUpdate(L){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(L.get()):L.reportChanges())}handlePossibleChange(L){}handleChange(L,W){}}t.KeepAliveObserver=S;function A(q,L){let W;return(0,T.derived)(q,G=>(W=L(G,W),W))}function I(q,L){let W;const M=o("derivedObservableWithWritableCache"),G=(0,T.derived)(q,K=>(M.read(K),W=L(K,W),W));return Object.assign(G,{clearCache:K=>{W=void 0,M.trigger(K)},setCache:(K,ae)=>{W=K,M.trigger(ae)}})}function P(q,L,W,M){let G=new $(W,M);return(0,T.derivedOpts)({debugReferenceFn:W,owner:q,onLastObserverRemoved:()=>{G.dispose(),G=new $(W)}},ae=>(G.setItems(L.read(ae)),G.getItems()))}class ${constructor(L,W){this._map=L,this._keySelector=W,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(L=>L.store.dispose()),this._cache.clear()}setItems(L){const W=[],M=new Set(this._cache.keys());for(const G of L){const K=this._keySelector?this._keySelector(G):G;let ae=this._cache.get(K);if(ae)M.delete(K);else{const ie=new N.DisposableStore;ae={out:this._map(G,ie),store:ie},this._cache.set(K,ae)}W.push(ae.out)}for(const G of M)this._cache.get(G).store.dispose(),this._cache.delete(G);this._items=W}getItems(){return this._items}}class v{constructor(L){this.observable=L}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.ValueWithChangeEventFromObservable=v;function O(q,L){return L instanceof v?L.observable:c(L.onDidChange,()=>L.value)}}),define(me[57],pe([1,0,33,42,41,96,95,27]),function(ne,t,i,N,x,z,_,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return N.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return N.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return N.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return N.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return x.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return x.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return x.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return x.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return x.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return x.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return z.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return z.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return z.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return z.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return z.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return z.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return z.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return z.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return z.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return z.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return z.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return _.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return _.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return _.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return _.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return _.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return _.derivedWithCancellationToken}}),!1&&(0,T.setLogger)(new T.ConsoleObservableLogger)}),define(me[58],pe([1,0,3,2]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var x;(function(u){u[u.Auto=1]="Auto",u[u.Hidden=2]="Hidden",u[u.Visible=3]="Visible"})(x||(t.ScrollbarVisibility=x={}));class z{constructor(e,s,o,l,d,C,m){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,o=o|0,l=l|0,d=d|0,C=C|0,m=m|0),this.rawScrollLeft=l,this.rawScrollTop=m,s<0&&(s=0),l+s>o&&(l=o-s),l<0&&(l=0),d<0&&(d=0),m+d>C&&(m=C-d),m<0&&(m=0),this.width=s,this.scrollWidth=o,this.scrollLeft=l,this.height=d,this.scrollHeight=C,this.scrollTop=m}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new z(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new z(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,d=this.scrollLeft!==e.scrollLeft,C=this.height!==e.height,m=this.scrollHeight!==e.scrollHeight,p=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:l,scrollLeftChanged:d,heightChanged:C,scrollHeightChanged:m,scrollTopChanged:p}}}t.ScrollState=z;class _ extends N.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new z(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,s){const o=this._state.withScrollDimensions(e,s);this._setState(o,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const s=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(e,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const o=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===o.scrollLeft&&this._smoothScrolling.to.scrollTop===o.scrollTop)return;let l;s?l=new b(this._smoothScrolling.from,o,this._smoothScrolling.startTime,this._smoothScrolling.duration):l=this._smoothScrolling.combine(this._state,o,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=l}else{const o=this._state.withScrollPosition(e);this._smoothScrolling=b.start(this._state,o,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),s=this._state.withScrollPosition(e);if(this._setState(s,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,s){const o=this._state;o.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(o,s)))}}t.Scrollable=_;class T{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.SmoothScrollingUpdate=T;function f(u,e){const s=e-u;return function(o){return u+s*c(o)}}function g(u,e,s){return function(o){return o<s?u(o/s):e((o-s)/(1-s))}}class b{constructor(e,s,o,l){this.from=e,this.to=s,this.duration=l,this.startTime=o,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,s,o){if(Math.abs(e-s)>2.5*o){let d,C;return e<s?(d=e+.75*o,C=s-.75*o):(d=e-.75*o,C=s+.75*o),g(f(e,d),f(C,s),.33)}return f(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.scrollLeft(s),l=this.scrollTop(s);return new T(o,l,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return b.start(e,s,o)}static start(e,s,o){o=o+10;const l=Date.now()-10;return new b(e,s,l,o)}}t.SmoothScrollingOperation=b;function B(u){return Math.pow(u,3)}function c(u){return 1-B(1-u)}}),define(me[97],pe([1,0,6,2]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=x,t.isReadableStream=z,t.isReadableBufferedStream=_,t.newWriteableStream=T,t.consumeReadable=g,t.peekReadable=b,t.consumeStream=B,t.listenStream=c,t.peekStream=u,t.toStream=e,t.emptyStream=s,t.toReadable=o,t.transform=l,t.prefixedReadable=d,t.prefixedStream=C;function x(m){const p=m;return p?typeof p.read=="function":!1}function z(m){const p=m;return p?[p.on,p.pause,p.resume,p.destroy].every(r=>typeof r=="function"):!1}function _(m){const p=m;return p?z(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}function T(m,p){return new f(m,p)}class f{constructor(p,r){this.reducer=p,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(r=>r(p))}emitError(p){this.listeners.error.length===0?(0,i.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(r=>r(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,r){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(p,r){if(this.state.destroyed)return;let S;switch(p){case"data":S=this.listeners.data;break;case"end":S=this.listeners.end;break;case"error":S=this.listeners.error;break}if(S){const A=S.indexOf(r);A>=0&&S.splice(A,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(S=>S())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(m,p){const r=[];let S;for(;(S=m.read())!==null;)r.push(S);return p(r)}function b(m,p,r){const S=[];let A;for(;(A=m.read())!==null&&S.length<r;)S.push(A);return A===null&&S.length>0?p(S):{read:()=>{if(S.length>0)return S.shift();if(typeof A<"u"){const I=A;return A=void 0,I}return m.read()}}}function B(m,p){return new Promise((r,S)=>{const A=[];c(m,{onData:I=>{p&&A.push(I)},onError:I=>{p?S(I):r(void 0)},onEnd:()=>{r(p?p(A):void 0)}})})}function c(m,p,r){m.on("error",S=>{r?.isCancellationRequested||p.onError(S)}),m.on("end",()=>{r?.isCancellationRequested||p.onEnd()}),m.on("data",S=>{r?.isCancellationRequested||p.onData(S)})}function u(m,p){return new Promise((r,S)=>{const A=new N.DisposableStore,I=[],P=O=>{if(I.push(O),I.length>p)return A.dispose(),m.pause(),r({stream:m,buffer:I,ended:!1})},$=O=>(A.dispose(),S(O)),v=()=>(A.dispose(),r({stream:m,buffer:I,ended:!0}));A.add((0,N.toDisposable)(()=>m.removeListener("error",$))),m.on("error",$),A.add((0,N.toDisposable)(()=>m.removeListener("end",v))),m.on("end",v),A.add((0,N.toDisposable)(()=>m.removeListener("data",P))),m.on("data",P)})}function e(m,p){const r=T(p);return r.end(m),r}function s(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}function o(m){let p=!1;return{read:()=>p?null:(p=!0,m)}}function l(m,p,r){const S=T(r);return c(m,{onData:A=>S.write(p.data(A)),onError:A=>S.error(p.error?p.error(A):A),onEnd:()=>S.end()}),S}function d(m,p,r){let S=!1;return{read:()=>{const A=p.read();return S?A:(S=!0,A!==null?r([m,A]):m)}}}function C(m,p,r){let S=!1;const A=T(r);return c(p,{onData:I=>S?A.write(I):(S=!0,A.write(r([m,I]))),onError:I=>A.error(I),onEnd:()=>{S||(S=!0,A.write(m)),A.end()}}),A}}),define(me[43],pe([1,0,23,97]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=g,t.readUInt16LE=b,t.writeUInt16LE=B,t.readUInt32BE=c,t.writeUInt32BE=u,t.readUInt32LE=e,t.writeUInt32LE=s,t.readUInt8=o,t.writeUInt8=l,t.readableToBuffer=d,t.bufferToReadable=C,t.streamToBuffer=m,t.bufferedStreamToBuffer=p,t.bufferToStream=r,t.streamToBufferReadableStream=S,t.newWriteableBufferStream=A,t.prefixedBufferReadable=I,t.prefixedBufferStream=P,t.decodeBase64=$,t.encodeBase64=q;const x=typeof Buffer<"u",z=new i.Lazy(()=>new Uint8Array(256));let _,T;class f{static alloc(W){return x?new f(Buffer.allocUnsafe(W)):new f(new Uint8Array(W))}static wrap(W){return x&&!Buffer.isBuffer(W)&&(W=Buffer.from(W.buffer,W.byteOffset,W.byteLength)),new f(W)}static fromString(W,M){return!(M?.dontUseNodeBuffer||!1)&&x?new f(Buffer.from(W)):(_||(_=new TextEncoder),new f(_.encode(W)))}static fromByteArray(W){const M=f.alloc(W.length);for(let G=0,K=W.length;G<K;G++)M.buffer[G]=W[G];return M}static concat(W,M){if(typeof M>"u"){M=0;for(let ae=0,ie=W.length;ae<ie;ae++)M+=W[ae].byteLength}const G=f.alloc(M);let K=0;for(let ae=0,ie=W.length;ae<ie;ae++){const ee=W[ae];G.set(ee,K),K+=ee.byteLength}return G}constructor(W){this.buffer=W,this.byteLength=this.buffer.byteLength}clone(){const W=f.alloc(this.byteLength);return W.set(this),W}toString(){return x?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(W,M){return new f(this.buffer.subarray(W,M))}set(W,M){if(W instanceof f)this.buffer.set(W.buffer,M);else if(W instanceof Uint8Array)this.buffer.set(W,M);else if(W instanceof ArrayBuffer)this.buffer.set(new Uint8Array(W),M);else if(ArrayBuffer.isView(W))this.buffer.set(new Uint8Array(W.buffer,W.byteOffset,W.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(W){return c(this.buffer,W)}writeUInt32BE(W,M){u(this.buffer,W,M)}readUInt32LE(W){return e(this.buffer,W)}writeUInt32LE(W,M){s(this.buffer,W,M)}readUInt8(W){return o(this.buffer,W)}writeUInt8(W,M){l(this.buffer,W,M)}indexOf(W,M=0){return g(this.buffer,W instanceof f?W.buffer:W,M)}}t.VSBuffer=f;function g(L,W,M=0){const G=W.byteLength,K=L.byteLength;if(G===0)return 0;if(G===1)return L.indexOf(W[0]);if(G>K-M)return-1;const ae=z.value;ae.fill(W.length);for(let Ee=0;Ee<W.length;Ee++)ae[W[Ee]]=W.length-Ee-1;let ie=M+W.length-1,ee=ie,ce=-1;for(;ie<K;)if(L[ie]===W[ee]){if(ee===0){ce=ie;break}ie--,ee--}else ie+=Math.max(W.length-ee,ae[L[ie]]),ee=W.length-1;return ce}function b(L,W){return L[W+0]<<0>>>0|L[W+1]<<8>>>0}function B(L,W,M){L[M+0]=W&255,W=W>>>8,L[M+1]=W&255}function c(L,W){return L[W]*2**24+L[W+1]*2**16+L[W+2]*2**8+L[W+3]}function u(L,W,M){L[M+3]=W,W=W>>>8,L[M+2]=W,W=W>>>8,L[M+1]=W,W=W>>>8,L[M]=W}function e(L,W){return L[W+0]<<0>>>0|L[W+1]<<8>>>0|L[W+2]<<16>>>0|L[W+3]<<24>>>0}function s(L,W,M){L[M+0]=W&255,W=W>>>8,L[M+1]=W&255,W=W>>>8,L[M+2]=W&255,W=W>>>8,L[M+3]=W&255}function o(L,W){return L[W]}function l(L,W,M){L[M]=W}function d(L){return N.consumeReadable(L,W=>f.concat(W))}function C(L){return N.toReadable(L)}function m(L){return N.consumeStream(L,W=>f.concat(W))}async function p(L){return L.ended?f.concat(L.buffer):f.concat([...L.buffer,await m(L.stream)])}function r(L){return N.toStream(L,W=>f.concat(W))}function S(L){return N.transform(L,{data:W=>typeof W=="string"?f.fromString(W):f.wrap(W)},W=>f.concat(W))}function A(L){return N.newWriteableStream(W=>f.concat(W),L)}function I(L,W){return N.prefixedReadable(L,W,M=>f.concat(M))}function P(L,W){return N.prefixedStream(L,W,M=>f.concat(M))}function $(L){let W=0,M=0,G=0;const K=new Uint8Array(Math.floor(L.length/4*3)),ae=ee=>{switch(M){case 3:K[G++]=W|ee,M=0;break;case 2:K[G++]=W|ee>>>2,W=ee<<6,M=3;break;case 1:K[G++]=W|ee>>>4,W=ee<<4,M=2;break;default:W=ee<<2,M=1}};for(let ee=0;ee<L.length;ee++){const ce=L.charCodeAt(ee);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ee]}`)}}const ie=G;for(;M>0;)ae(0);return f.wrap(K).slice(0,ie)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function q({buffer:L},W=!0,M=!1){const G=M?O:v;let K="";const ae=L.byteLength%3;let ie=0;for(;ie<L.byteLength-ae;ie+=3){const ee=L[ie+0],ce=L[ie+1],Ee=L[ie+2];K+=G[ee>>>2],K+=G[(ee<<4|ce>>>4)&63],K+=G[(ce<<2|Ee>>>6)&63],K+=G[Ee&63]}if(ae===1){const ee=L[ie+0];K+=G[ee>>>2],K+=G[ee<<4&63],W&&(K+="==")}else if(ae===2){const ee=L[ie+0],ce=L[ie+1];K+=G[ee>>>2],K+=G[(ee<<4|ce>>>4)&63],K+=G[ce<<2&63],W&&(K+="=")}return K}}),define(me[9],pe([1,0,94,23]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=x,t.format=_,t.format2=f,t.htmlAttributeEncodeValue=g,t.escape=b,t.escapeRegExpCharacters=B,t.count=c,t.truncate=u,t.truncateMiddle=e,t.trim=s,t.ltrim=o,t.rtrim=l,t.convertSimple2RegExpPattern=d,t.stripWildcards=C,t.createRegExp=m,t.regExpLeadsToEndlessLoop=p,t.splitLines=r,t.splitLinesIncludeSeparators=S,t.firstNonWhitespaceIndex=A,t.getLeadingWhitespace=I,t.lastNonWhitespaceIndex=P,t.replaceAsync=$,t.compare=v,t.compareSubstring=O,t.compareIgnoreCase=q,t.compareSubstringIgnoreCase=L,t.isAsciiDigit=W,t.isLowerAsciiLetter=M,t.isUpperAsciiLetter=G,t.equalsIgnoreCase=K,t.startsWithIgnoreCase=ae,t.commonPrefixLength=ie,t.commonSuffixLength=ee,t.isHighSurrogate=ce,t.isLowSurrogate=Ee,t.computeCodePoint=Se,t.getNextCodePoint=Pe,t.nextCharLength=re,t.prevCharLength=ye,t.getCharContainingOffset=V,t.charCount=Q,t.containsRTL=Ae,t.isBasicASCII=Oe,t.containsUnusualLineTerminators=H,t.isFullWidthCharacter=h,t.isEmojiImprecise=y,t.lcut=a,t.forAnsiStringParts=F,t.removeAnsiEscapeCodes=n,t.startsWithUTF8BOM=E,t.stripUTF8BOM=D,t.fuzzyContains=k,t.containsUppercaseCharacter=R,t.uppercaseFirstLetter=U,t.getNLines=Z,t.singleLetterHash=oe,t.getGraphemeBreakType=ve,t.getLeftDeleteOffset=Ce;function x(X){return!X||typeof X!="string"?!0:X.trim().length===0}const z=/{(\d+)}/g;function _(X,...se){return se.length===0?X:X.replace(z,function(be,we){const Le=parseInt(we,10);return isNaN(Le)||Le<0||Le>=se.length?be:se[Le]})}const T=/{([^}]+)}/g;function f(X,se){return Object.keys(se).length===0?X:X.replace(T,(be,we)=>se[we]??be)}function g(X){return X.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}function b(X){return X.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}function B(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(X,se){let be=0;const we=se.charCodeAt(0);for(let Le=X.length-1;Le>=0;Le--)X.charCodeAt(Le)===we&&be++;return be}function u(X,se,be="\u2026"){return X.length<=se?X:`${X.substr(0,se)}${be}`}function e(X,se,be="\u2026"){if(X.length<=se)return X;const we=Math.ceil(se/2)-be.length/2,Le=Math.floor(se/2)-be.length/2;return`${X.substr(0,we)}${be}${X.substr(X.length-Le)}`}function s(X,se=" "){const be=o(X,se);return l(be,se)}function o(X,se){if(!X||!se)return X;const be=se.length;if(be===0||X.length===0)return X;let we=0;for(;X.indexOf(se,we)===we;)we=we+be;return X.substring(we)}function l(X,se){if(!X||!se)return X;const be=se.length,we=X.length;if(be===0||we===0)return X;let Le=we,He=-1;for(;He=X.lastIndexOf(se,Le-1),!(He===-1||He+be!==Le);){if(He===0)return"";Le=He}return X.substring(0,Le)}function d(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function C(X){return X.replace(/\*/g,"")}function m(X,se,be={}){if(!X)throw new Error("Cannot create regex from empty string");se||(X=B(X)),be.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let we="";return be.global&&(we+="g"),be.matchCase||(we+="i"),be.multiline&&(we+="m"),be.unicode&&(we+="u"),new RegExp(X,we)}function p(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}function r(X){return X.split(/\r\n|\r|\n/)}function S(X){const se=[],be=X.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(be.length/2);we++)se.push(be[2*we]+(be[2*we+1]??""));return se}function A(X){for(let se=0,be=X.length;se<be;se++){const we=X.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}function I(X,se=0,be=X.length){for(let we=se;we<be;we++){const Le=X.charCodeAt(we);if(Le!==32&&Le!==9)return X.substring(se,we)}return X.substring(se,be)}function P(X,se=X.length-1){for(let be=se;be>=0;be--){const we=X.charCodeAt(be);if(we!==32&&we!==9)return be}return-1}function $(X,se,be){const we=[];let Le=0;for(const He of X.matchAll(se)){if(we.push(X.slice(Le,He.index)),He.index===void 0)throw new Error("match.index should be defined");Le=He.index+He[0].length,we.push(be(He[0],...He.slice(1),He.index,X,He.groups))}return we.push(X.slice(Le)),Promise.all(we).then(He=>He.join(""))}function v(X,se){return X<se?-1:X>se?1:0}function O(X,se,be=0,we=X.length,Le=0,He=se.length){for(;be<we&&Le<He;be++,Le++){const it=X.charCodeAt(be),nt=se.charCodeAt(Le);if(it<nt)return-1;if(it>nt)return 1}const $e=we-be,et=He-Le;return $e<et?-1:$e>et?1:0}function q(X,se){return L(X,se,0,X.length,0,se.length)}function L(X,se,be=0,we=X.length,Le=0,He=se.length){for(;be<we&&Le<He;be++,Le++){let it=X.charCodeAt(be),nt=se.charCodeAt(Le);if(it===nt)continue;if(it>=128||nt>=128)return O(X.toLowerCase(),se.toLowerCase(),be,we,Le,He);M(it)&&(it-=32),M(nt)&&(nt-=32);const Qe=it-nt;if(Qe!==0)return Qe}const $e=we-be,et=He-Le;return $e<et?-1:$e>et?1:0}function W(X){return X>=48&&X<=57}function M(X){return X>=97&&X<=122}function G(X){return X>=65&&X<=90}function K(X,se){return X.length===se.length&&L(X,se)===0}function ae(X,se){const be=se.length;return se.length>X.length?!1:L(X,se,0,be)===0}function ie(X,se){const be=Math.min(X.length,se.length);let we;for(we=0;we<be;we++)if(X.charCodeAt(we)!==se.charCodeAt(we))return we;return be}function ee(X,se){const be=Math.min(X.length,se.length);let we;const Le=X.length-1,He=se.length-1;for(we=0;we<be;we++)if(X.charCodeAt(Le-we)!==se.charCodeAt(He-we))return we;return be}function ce(X){return 55296<=X&&X<=56319}function Ee(X){return 56320<=X&&X<=57343}function Se(X,se){return(X-55296<<10)+(se-56320)+65536}function Pe(X,se,be){const we=X.charCodeAt(be);if(ce(we)&&be+1<se){const Le=X.charCodeAt(be+1);if(Ee(Le))return Se(we,Le)}return we}function le(X,se){const be=X.charCodeAt(se-1);if(Ee(be)&&se>1){const we=X.charCodeAt(se-2);if(ce(we))return Se(we,be)}return be}class J{get offset(){return this._offset}constructor(se,be=0){this._str=se,this._len=se.length,this._offset=be}setOffset(se){this._offset=se}prevCodePoint(){const se=le(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=Pe(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}t.CodePointIterator=J;class he{get offset(){return this._iterator.offset}constructor(se,be=0){this._iterator=new J(se,be)}nextGraphemeLength(){const se=Te.getInstance(),be=this._iterator,we=be.offset;let Le=se.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const He=be.offset,$e=se.getGraphemeBreakType(be.nextCodePoint());if(de(Le,$e)){be.setOffset(He);break}Le=$e}return be.offset-we}prevGraphemeLength(){const se=Te.getInstance(),be=this._iterator,we=be.offset;let Le=se.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const He=be.offset,$e=se.getGraphemeBreakType(be.prevCodePoint());if(de($e,Le)){be.setOffset(He);break}Le=$e}return we-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=he;function re(X,se){return new he(X,se).nextGraphemeLength()}function ye(X,se){return new he(X,se).prevGraphemeLength()}function V(X,se){se>0&&Ee(X.charCodeAt(se))&&se--;const be=se+re(X,se);return[be-ye(X,be),be]}function Q(X){const se=new he(X);let be=0;for(;!se.eol();)be++,se.nextGraphemeLength();return be}let ge;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ae(X){return ge||(ge=De()),ge.test(X)}const Ie=/^[\t\n\r\x20-\x7E]*$/;function Oe(X){return Ie.test(X)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(X){return t.UNUSUAL_LINE_TERMINATORS.test(X)}function h(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}function y(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}function a(X,se,be=""){const we=X.trimStart();if(we.length<se)return we;const Le=/\b/g;let He=0;for(;Le.test(we)&&!(we.length-Le.lastIndex<se);)He=Le.lastIndex,Le.lastIndex+=1;return He===0?we:be+we.substring(He).trimStart()}const w=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*F(X){let se=0;for(const be of X.matchAll(w))se!==be.index&&(yield{isCode:!1,str:X.substring(se,be.index)}),yield{isCode:!0,str:be[0]},se=be.index+be[0].length;se!==X.length&&(yield{isCode:!1,str:X.substring(se)})}function n(X){return X&&(X=X.replace(w,"")),X}t.UTF8_BOM_CHARACTER="\uFEFF";function E(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}function D(X){return E(X)?X.substr(1):X}function k(X,se){if(!X||!se||X.length<se.length)return!1;const be=se.length,we=X.toLowerCase();let Le=0,He=-1;for(;Le<be;){const $e=we.indexOf(se[Le],He+1);if($e<0)return!1;He=$e,Le++}return!0}function R(X,se=!1){return X?(se&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}function U(X){return X.charAt(0).toUpperCase()+X.slice(1)}function Z(X,se=1){if(se===0)return"";let be=-1;do be=X.indexOf(`
`,be+1),se--;while(se>0&&be>=0);return be===-1?X:(X[be-1]==="\r"&&be--,X.substr(0,be))}function oe(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}function ve(X){return Te.getInstance().getGraphemeBreakType(X)}function de(X,se){return X===0?se!==5&&se!==7:X===2&&se===3?!1:X===4||X===2||X===3||se===4||se===2||se===3?!0:!(X===8&&(se===8||se===9||se===11||se===12)||(X===11||X===9)&&(se===9||se===10)||(X===12||X===10)&&se===10||se===5||se===13||se===7||X===1||X===13&&se===14||X===6&&se===6)}var ke;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Te{static{this._INSTANCE=null}static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const be=this._data,we=be.length/3;let Le=1;for(;Le<=we;)if(se<be[3*Le])Le=2*Le;else if(se>be[3*Le+1])Le=2*Le+1;else return be[3*Le+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(X,se){if(X===0)return 0;const be=Ne(X,se);if(be!==void 0)return be;const we=new J(se,X);return we.prevCodePoint(),we.offset}function Ne(X,se){const be=new J(se,X);let we=be.prevCodePoint();for(;Ve(we)||we===65039||we===8419;){if(be.offset===0)return;we=be.prevCodePoint()}if(!y(we))return;let Le=be.offset;return Le>0&&be.prevCodePoint()===8205&&(Le=be.offset),Le}function Ve(X){return 127995<=X&&X<=127999}var Ye;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),t.noBreakWhitespace="\xA0";class Ue{static{this.ambiguousCharacterData=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},se=>{function be(Qe){const rt=new Map;for(let tt=0;tt<Qe.length;tt+=2)rt.set(Qe[tt],Qe[tt+1]);return rt}function we(Qe,rt){const tt=new Map(Qe);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Le(Qe,rt){if(!Qe)return rt;const tt=new Map;for(const[mt,gt]of Qe)rt.has(mt)&&tt.set(mt,gt);return tt}const He=this.ambiguousCharacterData.value;let $e=se.filter(Qe=>!Qe.startsWith("_")&&Qe in He);$e.length===0&&($e=["_default"]);let et;for(const Qe of $e){const rt=be(He[Qe]);et=Le(et,rt)}const it=be(He._common),nt=we(it,et);return new Ue(nt)})}static getInstance(se){return Ue.cache.get(Array.from(se))}static{this._locales=new N.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ue._locales.value}constructor(se){this.confusableDictionary=se}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Ue;class Je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Je.getRawData())),this._data}static isInvisibleCharacter(se){return Je.getData().has(se)}static get codePoints(){return Je.getData()}}t.InvisibleCharacters=Je}),define(me[44],pe([1,0,39,89,9]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=z,t.matchesContiguousSubString=T,t.matchesSubString=f,t.isUpper=B,t.matchesCamelCase=$,t.matchesWords=v,t.matchesFuzzy=G,t.matchesFuzzy2=K,t.anyScore=ae,t.createMatches=ie,t.isPatternInWord=Ae,t.fuzzyScore=h,t.fuzzyScoreGracefulAggressive=w,t.fuzzyScoreGraceful=F;function z(...D){return function(k,R){for(let U=0,Z=D.length;U<Z;U++){const oe=D[U](k,R);if(oe)return oe}return null}}t.matchesStrictPrefix=_.bind(void 0,!1),t.matchesPrefix=_.bind(void 0,!0);function _(D,k,R){if(!R||R.length<k.length)return null;let U;return D?U=x.startsWithIgnoreCase(R,k):U=R.indexOf(k)===0,U?k.length>0?[{start:0,end:k.length}]:[]:null}function T(D,k){const R=k.toLowerCase().indexOf(D.toLowerCase());return R===-1?null:[{start:R,end:R+D.length}]}function f(D,k){return g(D.toLowerCase(),k.toLowerCase(),0,0)}function g(D,k,R,U){if(R===D.length)return[];if(U===k.length)return null;if(D[R]===k[U]){let Z=null;return(Z=g(D,k,R+1,U+1))?m({start:U,end:U+1},Z):null}return g(D,k,R,U+1)}function b(D){return 97<=D&&D<=122}function B(D){return 65<=D&&D<=90}function c(D){return 48<=D&&D<=57}function u(D){return D===32||D===9||D===10||D===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>e.add(D.charCodeAt(0)));function s(D){return u(D)||e.has(D)}function o(D,k){return D===k||s(D)&&s(k)}const l=new Map;function d(D){if(l.has(D))return l.get(D);let k;const R=(0,N.getKoreanAltChars)(D);return R&&(k=R),l.set(D,k),k}function C(D){return b(D)||B(D)||c(D)}function m(D,k){return k.length===0?k=[D]:D.end===k[0].start?k[0].start=D.start:k.unshift(D),k}function p(D,k){for(let R=k;R<D.length;R++){const U=D.charCodeAt(R);if(B(U)||c(U)||R>0&&!C(D.charCodeAt(R-1)))return R}return D.length}function r(D,k,R,U){if(R===D.length)return[];if(U===k.length)return null;if(D[R]!==k[U].toLowerCase())return null;{let Z=null,oe=U+1;for(Z=r(D,k,R+1,U+1);!Z&&(oe=p(k,oe))<k.length;)Z=r(D,k,R+1,oe),oe++;return Z===null?null:m({start:U,end:U+1},Z)}}function S(D){let k=0,R=0,U=0,Z=0,oe=0;for(let Me=0;Me<D.length;Me++)oe=D.charCodeAt(Me),B(oe)&&k++,b(oe)&&R++,C(oe)&&U++,c(oe)&&Z++;const ve=k/D.length,de=R/D.length,ke=U/D.length,Te=Z/D.length;return{upperPercent:ve,lowerPercent:de,alphaPercent:ke,numericPercent:Te}}function A(D){const{upperPercent:k,lowerPercent:R}=D;return R===0&&k>.6}function I(D){const{upperPercent:k,lowerPercent:R,alphaPercent:U,numericPercent:Z}=D;return R>.2&&k<.8&&U>.6&&Z<.2}function P(D){let k=0,R=0,U=0,Z=0;for(let oe=0;oe<D.length;oe++)U=D.charCodeAt(oe),B(U)&&k++,b(U)&&R++,u(U)&&Z++;return(k===0||R===0)&&Z===0?D.length<=30:k<=5}function $(D,k){if(!k||(k=k.trim(),k.length===0)||!P(D))return null;k.length>60&&(k=k.substring(0,60));const R=S(k);if(!I(R)){if(!A(R))return null;k=k.toLowerCase()}let U=null,Z=0;for(D=D.toLowerCase();Z<k.length&&(U=r(D,k,0,Z))===null;)Z=p(k,Z+1);return U}function v(D,k,R=!1){if(!k||k.length===0)return null;let U=null,Z=0;for(D=D.toLowerCase(),k=k.toLowerCase();Z<k.length&&(U=O(D,k,0,Z,R),U===null);)Z=q(k,Z+1);return U}function O(D,k,R,U,Z){let oe=0;if(R===D.length)return[];if(U===k.length)return null;if(!o(D.charCodeAt(R),k.charCodeAt(U))){const ke=d(D.charCodeAt(R));if(!ke)return null;for(let Te=0;Te<ke.length;Te++)if(!o(ke[Te],k.charCodeAt(U+Te)))return null;oe+=ke.length-1}let ve=null,de=U+oe+1;if(ve=O(D,k,R+1,de,Z),!Z)for(;!ve&&(de=q(k,de))<k.length;)ve=O(D,k,R+1,de,Z),de++;if(!ve)return null;if(D.charCodeAt(R)!==k.charCodeAt(U)){const ke=d(D.charCodeAt(R));if(!ke)return ve;for(let Te=0;Te<ke.length;Te++)if(ke[Te]!==k.charCodeAt(U+Te))return ve}return m({start:U,end:U+oe+1},ve)}function q(D,k){for(let R=k;R<D.length;R++)if(s(D.charCodeAt(R))||R>0&&s(D.charCodeAt(R-1)))return R;return D.length}const L=z(t.matchesPrefix,$,T),W=z(t.matchesPrefix,$,f),M=new i.LRUCache(1e4);function G(D,k,R=!1){if(typeof D!="string"||typeof k!="string")return null;let U=M.get(D);U||(U=new RegExp(x.convertSimple2RegExpPattern(D),"i"),M.set(D,U));const Z=U.exec(k);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:R?W(D,k):L(D,k)}function K(D,k){const R=h(D,D.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return R?ie(R):null}function ae(D,k,R,U,Z,oe){const ve=Math.min(13,D.length);for(;R<ve;R++){const de=h(D,k,R,U,Z,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,oe]}function ie(D){if(typeof D>"u")return[];const k=[],R=D[1];for(let U=D.length-1;U>1;U--){const Z=D[U]+R,oe=k[k.length-1];oe&&oe.end===Z?oe.end=Z+1:k.push({start:Z,end:Z+1})}return k}const ee=128;function ce(){const D=[],k=[];for(let R=0;R<=ee;R++)k[R]=0;for(let R=0;R<=ee;R++)D.push(k.slice(0));return D}function Ee(D){const k=[];for(let R=0;R<=D;R++)k[R]=0;return k}const Se=Ee(2*ee),Pe=Ee(2*ee),le=ce(),J=ce(),he=ce(),re=!1;function ye(D,k,R,U,Z){function oe(de,ke,Te=" "){for(;de.length<ke;)de=Te+de;return de}let ve=` |   |${U.split("").map(de=>oe(de,3)).join("|")}
`;for(let de=0;de<=R;de++)de===0?ve+=" |":ve+=`${k[de-1]}|`,ve+=D[de].slice(0,Z+1).map(ke=>oe(ke.toString(),3)).join("|")+`
`;return ve}function V(D,k,R,U){D=D.substr(k),R=R.substr(U),console.log(ye(J,D,D.length,R,R.length)),console.log(ye(he,D,D.length,R,R.length)),console.log(ye(le,D,D.length,R,R.length))}function Q(D,k){if(k<0||k>=D.length)return!1;const R=D.codePointAt(k);switch(R){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!x.isEmojiImprecise(R)}}function ge(D,k){if(k<0||k>=D.length)return!1;switch(D.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function De(D,k,R){return k[D]!==R[D]}function Ae(D,k,R,U,Z,oe,ve=!1){for(;k<R&&Z<oe;)D[k]===U[Z]&&(ve&&(Se[k]=Z),k+=1),Z+=1;return k===R}var Ie;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Oe;(function(D){D.Default=[-100,0];function k(R){return!R||R.length===2&&R[0]===-100&&R[1]===0}D.isDefault=k})(Oe||(t.FuzzyScore=Oe={}));class H{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(k,R){this.firstMatchCanBeWeak=k,this.boostFullMatch=R}}t.FuzzyScoreOptions=H;function h(D,k,R,U,Z,oe,ve=H.default){const de=D.length>ee?ee:D.length,ke=U.length>ee?ee:U.length;if(R>=de||oe>=ke||de-R>ke-oe||!Ae(k,R,de,Z,oe,ke,!0))return;y(de,ke,R,oe,k,Z);let Te=1,Me=1,Ce=R,Ne=oe;const Ve=[!1];for(Te=1,Ce=R;Ce<de;Te++,Ce++){const se=Se[Ce],be=Pe[Ce],we=Ce+1<de?Pe[Ce+1]:ke;for(Me=se-oe+1,Ne=se;Ne<we;Me++,Ne++){let Le=Number.MIN_SAFE_INTEGER,He=!1;Ne<=be&&(Le=a(D,k,Ce,R,U,Z,Ne,ke,oe,le[Te-1][Me-1]===0,Ve));let $e=0;Le!==Number.MAX_SAFE_INTEGER&&(He=!0,$e=Le+J[Te-1][Me-1]);const et=Ne>se,it=et?J[Te][Me-1]+(le[Te][Me-1]>0?-5:0):0,nt=Ne>se+1&&le[Te][Me-1]>0,Qe=nt?J[Te][Me-2]+(le[Te][Me-2]>0?-5:0):0;if(nt&&(!et||Qe>=it)&&(!He||Qe>=$e))J[Te][Me]=Qe,he[Te][Me]=3,le[Te][Me]=0;else if(et&&(!He||it>=$e))J[Te][Me]=it,he[Te][Me]=2,le[Te][Me]=0;else if(He)J[Te][Me]=$e,he[Te][Me]=1,le[Te][Me]=le[Te-1][Me-1]+1;else throw new Error("not possible")}}if(re&&V(D,R,U,oe),!Ve[0]&&!ve.firstMatchCanBeWeak)return;Te--,Me--;const Ye=[J[Te][Me],oe];let Ue=0,Je=0;for(;Te>=1;){let se=Me;do{const be=he[Te][se];if(be===3)se=se-2;else if(be===2)se=se-1;else break}while(se>=1);Ue>1&&k[R+Te-1]===Z[oe+Me-1]&&!De(se+oe-1,U,Z)&&Ue+1>le[Te][se]&&(se=Me),se===Me?Ue++:Ue=1,Je||(Je=se),Te--,Me=se-1,Ye.push(Me)}ke===de&&ve.boostFullMatch&&(Ye[0]+=2);const X=Je-de;return Ye[0]-=X,Ye}function y(D,k,R,U,Z,oe){let ve=D-1,de=k-1;for(;ve>=R&&de>=U;)Z[ve]===oe[de]&&(Pe[ve]=de,ve--),de--}function a(D,k,R,U,Z,oe,ve,de,ke,Te,Me){if(k[R]!==oe[ve])return Number.MIN_SAFE_INTEGER;let Ce=1,Ne=!1;return ve===R-U?Ce=D[R]===Z[ve]?7:5:De(ve,Z,oe)&&(ve===0||!De(ve-1,Z,oe))?(Ce=D[R]===Z[ve]?7:5,Ne=!0):Q(oe,ve)&&(ve===0||!Q(oe,ve-1))?Ce=5:(Q(oe,ve-1)||ge(oe,ve-1))&&(Ce=5,Ne=!0),Ce>1&&R===U&&(Me[0]=!0),Ne||(Ne=De(ve,Z,oe)||Q(oe,ve-1)||ge(oe,ve-1)),R===U?ve>ke&&(Ce-=Ne?3:5):Te?Ce+=Ne?2:0:Ce+=Ne?0:1,ve+1===de&&(Ce-=Ne?3:5),Ce}function w(D,k,R,U,Z,oe,ve){return n(D,k,R,U,Z,oe,!0,ve)}function F(D,k,R,U,Z,oe,ve){return n(D,k,R,U,Z,oe,!1,ve)}function n(D,k,R,U,Z,oe,ve,de){let ke=h(D,k,R,U,Z,oe,de);if(ke&&!ve)return ke;if(D.length>=3){const Te=Math.min(7,D.length-1);for(let Me=R+1;Me<Te;Me++){const Ce=E(D,Me);if(Ce){const Ne=h(Ce,Ce.toLowerCase(),R,U,Z,oe,de);Ne&&(Ne[0]-=3,(!ke||Ne[0]>ke[0])&&(ke=Ne))}}}return ke}function E(D,k){if(k+1>=D.length)return;const R=D[k],U=D[k+1];if(R!==U)return D.slice(0,k)+U+R+D.slice(k+2)}}),define(me[59],pe([1,0,9]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=N,t.doHash=x,t.numberHash=z,t.stringHash=T,t.toHexString=s;function N(l){return x(l,0)}function x(l,d){switch(typeof l){case"object":return l===null?z(349,d):Array.isArray(l)?f(l,d):g(l,d);case"string":return T(l,d);case"boolean":return _(l,d);case"number":return z(l,d);case"undefined":return z(937,d);default:return z(617,d)}}function z(l,d){return(d<<5)-d+l|0}function _(l,d){return z(l?433:863,d)}function T(l,d){d=z(149417,d);for(let C=0,m=l.length;C<m;C++)d=z(l.charCodeAt(C),d);return d}function f(l,d){return d=z(104579,d),l.reduce((C,m)=>x(m,C),d)}function g(l,d){return d=z(181387,d),Object.keys(l).sort().reduce((C,m)=>(C=T(m,C),x(l[m],C)),d)}class b{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=x(d,this._value),this._value}}t.Hasher=b;var B;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function c(l,d,C=32){const m=C-d,p=~((1<<m)-1);return(l<<d|(p&l)>>>m)>>>0}function u(l,d=0,C=l.byteLength,m=0){for(let p=0;p<C;p++)l[d+p]=m}function e(l,d,C="0"){for(;l.length<d;)l=C+l;return l}function s(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(C=>C.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),d/4)}class o{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const C=d.length;if(C===0)return;const m=this._buff;let p=this._buffLen,r=this._leftoverHighSurrogate,S,A;for(r!==0?(S=r,A=-1,r=0):(S=d.charCodeAt(0),A=0);;){let I=S;if(i.isHighSurrogate(S))if(A+1<C){const P=d.charCodeAt(A+1);i.isLowSurrogate(P)?(A++,I=i.computeCodePoint(S,P)):I=65533}else{r=S;break}else i.isLowSurrogate(S)&&(I=65533);if(p=this._push(m,p,I),A++,A<C)S=d.charCodeAt(A);else break}this._buffLen=p,this._leftoverHighSurrogate=r}_push(d,C,m){return m<128?d[C++]=m:m<2048?(d[C++]=192|(m&1984)>>>6,d[C++]=128|(m&63)>>>0):m<65536?(d[C++]=224|(m&61440)>>>12,d[C++]=128|(m&4032)>>>6,d[C++]=128|(m&63)>>>0):(d[C++]=240|(m&1835008)>>>18,d[C++]=128|(m&258048)>>>12,d[C++]=128|(m&4032)>>>6,d[C++]=128|(m&63)>>>0),C>=64&&(this._step(),C-=64,this._totalLen+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),C}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=o._bigBlock32,C=this._buffDV;for(let v=0;v<64;v+=4)d.setUint32(v,C.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)d.setUint32(v,c(d.getUint32(v-12,!1)^d.getUint32(v-32,!1)^d.getUint32(v-56,!1)^d.getUint32(v-64,!1),1),!1);let m=this._h0,p=this._h1,r=this._h2,S=this._h3,A=this._h4,I,P,$;for(let v=0;v<80;v++)v<20?(I=p&r|~p&S,P=1518500249):v<40?(I=p^r^S,P=1859775393):v<60?(I=p&r|p&S|r&S,P=2400959708):(I=p^r^S,P=3395469782),$=c(m,5)+I+A+P+d.getUint32(v*4,!1)&4294967295,A=S,S=r,r=c(p,30),p=m,m=$;this._h0=this._h0+m&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+A&4294967295}}t.StringSHA1=o}),define(me[98],pe([1,0,85,59]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=z;class x{constructor(c){this.source=c}getElements(){const c=this.source,u=new Int32Array(c.length);for(let e=0,s=c.length;e<s;e++)u[e]=c.charCodeAt(e);return u}}t.StringDiffSequence=x;function z(B,c,u){return new b(new x(B),new x(c)).ComputeDiff(u).changes}class _{static Assert(c,u){if(!c)throw new Error(u)}}class T{static Copy(c,u,e,s,o){for(let l=0;l<o;l++)e[s+l]=c[u+l]}static Copy2(c,u,e,s,o){for(let l=0;l<o;l++)e[s+l]=c[u+l]}}var f;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class g{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(c,u){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,u),this.m_originalCount++}AddModifiedElement(c,u){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,u),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(c,u,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=c,this._modifiedSequence=u;const[s,o,l]=b._getElements(c),[d,C,m]=b._getElements(u);this._hasStrings=l&&m,this._originalStringElements=s,this._originalElementsOrHash=o,this._modifiedStringElements=d,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(c){return c.length>0&&typeof c[0]=="string"}static _getElements(c){const u=c.getElements();if(b._isStringArray(u)){const e=new Int32Array(u.length);for(let s=0,o=u.length;s<o;s++)e[s]=(0,N.stringHash)(u[s],0);return[u,e,!0]}return u instanceof Int32Array?[[],u,!1]:[[],new Int32Array(u),!1]}ElementsAreEqual(c,u){return this._originalElementsOrHash[c]!==this._modifiedElementsOrHash[u]?!1:this._hasStrings?this._originalStringElements[c]===this._modifiedStringElements[u]:!0}ElementsAreStrictEqual(c,u){if(!this.ElementsAreEqual(c,u))return!1;const e=b._getStrictElement(this._originalSequence,c),s=b._getStrictElement(this._modifiedSequence,u);return e===s}static _getStrictElement(c,u){return typeof c.getStrictElement=="function"?c.getStrictElement(u):null}OriginalElementsAreEqual(c,u){return this._originalElementsOrHash[c]!==this._originalElementsOrHash[u]?!1:this._hasStrings?this._originalStringElements[c]===this._originalStringElements[u]:!0}ModifiedElementsAreEqual(c,u){return this._modifiedElementsOrHash[c]!==this._modifiedElementsOrHash[u]?!1:this._hasStrings?this._modifiedStringElements[c]===this._modifiedStringElements[u]:!0}ComputeDiff(c){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,c)}_ComputeDiff(c,u,e,s,o){const l=[!1];let d=this.ComputeDiffRecursive(c,u,e,s,l);return o&&(d=this.PrettifyChanges(d)),{quitEarly:l[0],changes:d}}ComputeDiffRecursive(c,u,e,s,o){for(o[0]=!1;c<=u&&e<=s&&this.ElementsAreEqual(c,e);)c++,e++;for(;u>=c&&s>=e&&this.ElementsAreEqual(u,s);)u--,s--;if(c>u||e>s){let r;return e<=s?(_.Assert(c===u+1,"originalStart should only be one more than originalEnd"),r=[new i.DiffChange(c,0,e,s-e+1)]):c<=u?(_.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.DiffChange(c,u-c+1,e,0)]):(_.Assert(c===u+1,"originalStart should only be one more than originalEnd"),_.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const l=[0],d=[0],C=this.ComputeRecursionPoint(c,u,e,s,l,d,o),m=l[0],p=d[0];if(C!==null)return C;if(!o[0]){const r=this.ComputeDiffRecursive(c,m,e,p,o);let S=[];return o[0]?S=[new i.DiffChange(m+1,u-(m+1)+1,p+1,s-(p+1)+1)]:S=this.ComputeDiffRecursive(m+1,u,p+1,s,o),this.ConcatenateChanges(r,S)}return[new i.DiffChange(c,u-c+1,e,s-e+1)]}WALKTRACE(c,u,e,s,o,l,d,C,m,p,r,S,A,I,P,$,v,O){let q=null,L=null,W=new g,M=u,G=e,K=A[0]-$[0]-s,ae=-1073741824,ie=this.m_forwardHistory.length-1;do{const ee=K+c;ee===M||ee<G&&m[ee-1]<m[ee+1]?(r=m[ee+1],I=r-K-s,r<ae&&W.MarkNextChange(),ae=r,W.AddModifiedElement(r+1,I),K=ee+1-c):(r=m[ee-1]+1,I=r-K-s,r<ae&&W.MarkNextChange(),ae=r-1,W.AddOriginalElement(r,I+1),K=ee-1-c),ie>=0&&(m=this.m_forwardHistory[ie],c=m[0],M=1,G=m.length-1)}while(--ie>=-1);if(q=W.getReverseChanges(),O[0]){let ee=A[0]+1,ce=$[0]+1;if(q!==null&&q.length>0){const Ee=q[q.length-1];ee=Math.max(ee,Ee.getOriginalEnd()),ce=Math.max(ce,Ee.getModifiedEnd())}L=[new i.DiffChange(ee,S-ee+1,ce,P-ce+1)]}else{W=new g,M=l,G=d,K=A[0]-$[0]-C,ae=1073741824,ie=v?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ee=K+o;ee===M||ee<G&&p[ee-1]>=p[ee+1]?(r=p[ee+1]-1,I=r-K-C,r>ae&&W.MarkNextChange(),ae=r+1,W.AddOriginalElement(r+1,I+1),K=ee+1-o):(r=p[ee-1],I=r-K-C,r>ae&&W.MarkNextChange(),ae=r,W.AddModifiedElement(r+1,I+1),K=ee-1-o),ie>=0&&(p=this.m_reverseHistory[ie],o=p[0],M=1,G=p.length-1)}while(--ie>=-1);L=W.getChanges()}return this.ConcatenateChanges(q,L)}ComputeRecursionPoint(c,u,e,s,o,l,d){let C=0,m=0,p=0,r=0,S=0,A=0;c--,e--,o[0]=0,l[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const I=u-c+(s-e),P=I+1,$=new Int32Array(P),v=new Int32Array(P),O=s-e,q=u-c,L=c-e,W=u-s,G=(q-O)%2===0;$[O]=c,v[q]=u,d[0]=!1;for(let K=1;K<=I/2+1;K++){let ae=0,ie=0;p=this.ClipDiagonalBound(O-K,K,O,P),r=this.ClipDiagonalBound(O+K,K,O,P);for(let ce=p;ce<=r;ce+=2){ce===p||ce<r&&$[ce-1]<$[ce+1]?C=$[ce+1]:C=$[ce-1]+1,m=C-(ce-O)-L;const Ee=C;for(;C<u&&m<s&&this.ElementsAreEqual(C+1,m+1);)C++,m++;if($[ce]=C,C+m>ae+ie&&(ae=C,ie=m),!G&&Math.abs(ce-q)<=K-1&&C>=v[ce])return o[0]=C,l[0]=m,Ee<=v[ce]&&1447>0&&K<=1448?this.WALKTRACE(O,p,r,L,q,S,A,W,$,v,C,u,o,m,s,l,G,d):null}const ee=(ae-c+(ie-e)-K)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ae,ee))return d[0]=!0,o[0]=ae,l[0]=ie,ee>0&&1447>0&&K<=1448?this.WALKTRACE(O,p,r,L,q,S,A,W,$,v,C,u,o,m,s,l,G,d):(c++,e++,[new i.DiffChange(c,u-c+1,e,s-e+1)]);S=this.ClipDiagonalBound(q-K,K,q,P),A=this.ClipDiagonalBound(q+K,K,q,P);for(let ce=S;ce<=A;ce+=2){ce===S||ce<A&&v[ce-1]>=v[ce+1]?C=v[ce+1]-1:C=v[ce-1],m=C-(ce-q)-W;const Ee=C;for(;C>c&&m>e&&this.ElementsAreEqual(C,m);)C--,m--;if(v[ce]=C,G&&Math.abs(ce-O)<=K&&C<=$[ce])return o[0]=C,l[0]=m,Ee>=$[ce]&&1447>0&&K<=1448?this.WALKTRACE(O,p,r,L,q,S,A,W,$,v,C,u,o,m,s,l,G,d):null}if(K<=1447){let ce=new Int32Array(r-p+2);ce[0]=O-p+1,T.Copy2($,p,ce,1,r-p+1),this.m_forwardHistory.push(ce),ce=new Int32Array(A-S+2),ce[0]=q-S+1,T.Copy2(v,S,ce,1,A-S+1),this.m_reverseHistory.push(ce)}}return this.WALKTRACE(O,p,r,L,q,S,A,W,$,v,C,u,o,m,s,l,G,d)}PrettifyChanges(c){for(let u=0;u<c.length;u++){const e=c[u],s=u<c.length-1?c[u+1].originalStart:this._originalElementsOrHash.length,o=u<c.length-1?c[u+1].modifiedStart:this._modifiedElementsOrHash.length,l=e.originalLength>0,d=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<o&&(!l||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!d||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const C=[null];if(u<c.length-1&&this.ChangesOverlap(c[u],c[u+1],C)){c[u]=C[0],c.splice(u+1,1),u--;continue}}for(let u=c.length-1;u>=0;u--){const e=c[u];let s=0,o=0;if(u>0){const r=c[u-1];s=r.originalStart+r.originalLength,o=r.modifiedStart+r.modifiedLength}const l=e.originalLength>0,d=e.modifiedLength>0;let C=0,m=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const S=e.originalStart-r,A=e.modifiedStart-r;if(S<s||A<o||l&&!this.OriginalElementsAreEqual(S,S+e.originalLength)||d&&!this.ModifiedElementsAreEqual(A,A+e.modifiedLength))break;const P=(S===s&&A===o?5:0)+this._boundaryScore(S,e.originalLength,A,e.modifiedLength);P>m&&(m=P,C=r)}e.originalStart-=C,e.modifiedStart-=C;const p=[null];if(u>0&&this.ChangesOverlap(c[u-1],c[u],p)){c[u-1]=p[0],c.splice(u,1),u++;continue}}if(this._hasStrings)for(let u=1,e=c.length;u<e;u++){const s=c[u-1],o=c[u],l=o.originalStart-s.originalStart-s.originalLength,d=s.originalStart,C=o.originalStart+o.originalLength,m=C-d,p=s.modifiedStart,r=o.modifiedStart+o.modifiedLength,S=r-p;if(l<5&&m<20&&S<20){const A=this._findBetterContiguousSequence(d,m,p,S,l);if(A){const[I,P]=A;(I!==s.originalStart+s.originalLength||P!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=I-s.originalStart,s.modifiedLength=P-s.modifiedStart,o.originalStart=I+l,o.modifiedStart=P+l,o.originalLength=C-o.originalStart,o.modifiedLength=r-o.modifiedStart)}}}return c}_findBetterContiguousSequence(c,u,e,s,o){if(u<o||s<o)return null;const l=c+u-o+1,d=e+s-o+1;let C=0,m=0,p=0;for(let r=c;r<l;r++)for(let S=e;S<d;S++){const A=this._contiguousSequenceScore(r,S,o);A>0&&A>C&&(C=A,m=r,p=S)}return C>0?[m,p]:null}_contiguousSequenceScore(c,u,e){let s=0;for(let o=0;o<e;o++){if(!this.ElementsAreEqual(c+o,u+o))return 0;s+=this._originalStringElements[c+o].length}return s}_OriginalIsBoundary(c){return c<=0||c>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[c])}_OriginalRegionIsBoundary(c,u){if(this._OriginalIsBoundary(c)||this._OriginalIsBoundary(c-1))return!0;if(u>0){const e=c+u;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(c){return c<=0||c>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[c])}_ModifiedRegionIsBoundary(c,u){if(this._ModifiedIsBoundary(c)||this._ModifiedIsBoundary(c-1))return!0;if(u>0){const e=c+u;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(c,u,e,s){const o=this._OriginalRegionIsBoundary(c,u)?1:0,l=this._ModifiedRegionIsBoundary(e,s)?1:0;return o+l}ConcatenateChanges(c,u){const e=[];if(c.length===0||u.length===0)return u.length>0?u:c;if(this.ChangesOverlap(c[c.length-1],u[0],e)){const s=new Array(c.length+u.length-1);return T.Copy(c,0,s,0,c.length-1),s[c.length-1]=e[0],T.Copy(u,1,s,c.length,u.length-1),s}else{const s=new Array(c.length+u.length);return T.Copy(c,0,s,0,c.length),T.Copy(u,0,s,c.length,u.length),s}}ChangesOverlap(c,u,e){if(_.Assert(c.originalStart<=u.originalStart,"Left change is not less than or equal to right change"),_.Assert(c.modifiedStart<=u.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=u.originalStart||c.modifiedStart+c.modifiedLength>=u.modifiedStart){const s=c.originalStart;let o=c.originalLength;const l=c.modifiedStart;let d=c.modifiedLength;return c.originalStart+c.originalLength>=u.originalStart&&(o=u.originalStart+u.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=u.modifiedStart&&(d=u.modifiedStart+u.modifiedLength-c.modifiedStart),e[0]=new i.DiffChange(s,o,l,d),!0}else return e[0]=null,!1}ClipDiagonalBound(c,u,e,s){if(c>=0&&c<s)return c;const o=e,l=s-e-1,d=u%2===0;if(c<0){const C=o%2===0;return d===C?0:1}else{const C=l%2===0;return d===C?s-1:s-2}}}t.LcsDiff=b}),define(me[60],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(me[99],pe([1,0,8,9]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class x{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const e=u.charCodeAt(0),s=this._value.charCodeAt(this._pos);return e-s}value(){return this._value[this._pos]}}t.StringIterator=x;class z{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,N.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=z;class _{constructor(u=!0,e=!0){this._splitOnBackslash=u,this._caseSensitive=e}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let e=u.length-1;e>=0;e--,this._valueLen--){const s=this._value.charCodeAt(e);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,N.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=_;var T;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(T||(T={}));class f{constructor(u,e){this._ignorePathCasing=u,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,N.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,N.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,N.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,N.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=f;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(b||(b={}));class B{static forUris(u=()=>!1,e=()=>!1){return new B(new f(u,e))}static forPaths(u=!1){return new B(new _(void 0,!u))}static forStrings(){return new B(new x)}static forConfigKeys(){return new B(new z)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,e){if(e){const s=e.slice(0);(0,i.shuffle)(s);for(const o of s)this.set(o,u)}else{const s=u.slice(0);(0,i.shuffle)(s);for(const o of s)this.set(o[0],o[1])}}set(u,e){const s=this._iter.reset(u);let o;this._root||(this._root=new g,this._root.segment=s.value());const l=[];for(o=this._root;;){const C=s.cmp(o.segment);if(C>0)o.left||(o.left=new g,o.left.segment=s.value()),l.push([-1,o]),o=o.left;else if(C<0)o.right||(o.right=new g,o.right.segment=s.value()),l.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new g,o.mid.segment=s.value()),l.push([0,o]),o=o.mid;else break}const d=o.value;o.value=e,o.key=u;for(let C=l.length-1;C>=0;C--){const m=l[C][1];m.updateHeight();const p=m.balanceFactor();if(p<-1||p>1){const r=l[C][0],S=l[C+1][0];if(r===1&&S===1)l[C][1]=m.rotateLeft();else if(r===-1&&S===-1)l[C][1]=m.rotateRight();else if(r===1&&S===-1)m.right=l[C+1][1]=l[C+1][1].rotateRight(),l[C][1]=m.rotateLeft();else if(r===-1&&S===1)m.left=l[C+1][1]=l[C+1][1].rotateLeft(),l[C][1]=m.rotateRight();else throw new Error;if(C>0)switch(l[C-1][0]){case-1:l[C-1][1].left=l[C][1];break;case 1:l[C-1][1].right=l[C][1];break;case 0:l[C-1][1].mid=l[C][1];break}else this._root=l[0][1]}}return d}get(u){return this._getNode(u)?.value}_getNode(u){const e=this._iter.reset(u);let s=this._root;for(;s;){const o=e.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(u){const e=this._getNode(u);return!(e?.value===void 0&&e?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,e){const s=this._iter.reset(u),o=[];let l=this._root;for(;l;){const d=s.cmp(l.segment);if(d>0)o.push([-1,l]),l=l.left;else if(d<0)o.push([1,l]),l=l.right;else if(s.hasNext())s.next(),o.push([0,l]),l=l.mid;else break}if(l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this._min(l.right);if(d.key){const{key:C,value:m,segment:p}=d;this._delete(d.key,!1),l.key=C,l.value=m,l.segment=p}}else{const d=l.left??l.right;if(o.length>0){const[C,m]=o[o.length-1];switch(C){case-1:m.left=d;break;case 0:m.mid=d;break;case 1:m.right=d;break}}else this._root=d}for(let d=o.length-1;d>=0;d--){const C=o[d][1];C.updateHeight();const m=C.balanceFactor();if(m>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),o[d][1]=C.rotateLeft()):m<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),o[d][1]=C.rotateRight()),d>0)switch(o[d-1][0]){case-1:o[d-1][1].left=o[d][1];break;case 1:o[d-1][1].right=o[d][1];break;case 0:o[d-1][1].mid=o[d][1];break}else this._root=o[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const e=this._iter.reset(u);let s=this._root,o;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,e){const s=this._iter.reset(u);let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):e?o.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[e,s]of this)u(s,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const e=[];return this._dfsEntries(u,e),e[Symbol.iterator]()}_dfsEntries(u,e){u&&(u.left&&this._dfsEntries(u.left,e),u.value&&e.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,e),u.right&&this._dfsEntries(u.right,e))}_isBalanced(){const u=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:u(e.left)&&u(e.right)};return u(this._root)}}t.TernarySearchTree=B}),define(me[10],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=N,t.isObject=x,t.isTypedArray=z,t.isNumber=_,t.isIterable=T,t.isBoolean=f,t.isUndefined=g,t.isDefined=b,t.isUndefinedOrNull=B,t.assertType=c,t.assertIsDefined=u,t.assertAllDefined=e,t.isEmptyObject=o,t.isFunction=l,t.areFunctions=d,t.validateConstraints=C,t.validateConstraint=m;function i(p){return typeof p=="string"}function N(p){return Array.isArray(p)&&p.every(r=>i(r))}function x(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}function z(p){const r=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof r}function _(p){return typeof p=="number"&&!isNaN(p)}function T(p){return!!p&&typeof p[Symbol.iterator]=="function"}function f(p){return p===!0||p===!1}function g(p){return typeof p>"u"}function b(p){return!B(p)}function B(p){return g(p)||p===null}function c(p,r){if(!p)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function u(p){if(B(p))throw new Error("Assertion Failed: argument is undefined or null");return p}function e(...p){const r=[];for(let S=0;S<p.length;S++){const A=p[S];if(B(A))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);r.push(A)}return r}const s=Object.prototype.hasOwnProperty;function o(p){if(!x(p))return!1;for(const r in p)if(s.call(p,r))return!1;return!0}function l(p){return typeof p=="function"}function d(...p){return p.length>0&&p.every(l)}function C(p,r){const S=Math.min(p.length,r.length);for(let A=0;A<S;A++)m(p[A],r[A])}function m(p,r){if(i(r)){if(typeof p!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(l(r)){try{if(p instanceof r)return}catch{}if(!B(p)&&p.constructor===r||r.length===1&&r.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[45],pe([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=x,t.getCodiconFontCharacters=z;const N=Object.create(null);function x(_,T){if((0,i.isString)(T)){const f=N[T];if(f===void 0)throw new Error(`${_} references an unknown codicon: ${T}`);T=f}return N[_]=T,{id:_}}function z(){return N}}),define(me[100],pe([1,0,45]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467)}}),define(me[18],pe([1,0,45,100]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=x;function x(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...N.codiconsLibrary,...t.codiconsDerived}}),define(me[61],pe([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=N,t.deepFreeze=x,t.cloneAndChange=_,t.mixin=f,t.equals=g,t.safeStringify=b,t.distinct=B,t.getCaseInsensitive=c,t.filter=u,t.getAllPropertyNames=e,t.getAllMethodNames=s,t.createProxyObject=o;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([C,m])=>{d[C]=m&&typeof m=="object"?N(m):m}),d}function x(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const C=d.shift();Object.freeze(C);for(const m in C)if(z.call(C,m)){const p=C[m];typeof p=="object"&&!Object.isFrozen(p)&&!(0,i.isTypedArray)(p)&&d.push(p)}}return l}const z=Object.prototype.hasOwnProperty;function _(l,d){return T(l,d,new Set)}function T(l,d,C){if((0,i.isUndefinedOrNull)(l))return l;const m=d(l);if(typeof m<"u")return m;if(Array.isArray(l)){const p=[];for(const r of l)p.push(T(r,d,C));return p}if((0,i.isObject)(l)){if(C.has(l))throw new Error("Cannot clone recursive data-structure");C.add(l);const p={};for(const r in l)z.call(l,r)&&(p[r]=T(l[r],d,C));return C.delete(l),p}return l}function f(l,d,C=!0){return(0,i.isObject)(l)?((0,i.isObject)(d)&&Object.keys(d).forEach(m=>{m in l?C&&((0,i.isObject)(l[m])&&(0,i.isObject)(d[m])?f(l[m],d[m],C):l[m]=d[m]):l[m]=d[m]}),l):d}function g(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let C,m;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(C=0;C<l.length;C++)if(!g(l[C],d[C]))return!1}else{const p=[];for(m in l)p.push(m);p.sort();const r=[];for(m in d)r.push(m);if(r.sort(),!g(p,r))return!1;for(C=0;C<p.length;C++)if(!g(l[p[C]],d[p[C]]))return!1}return!0}function b(l){const d=new Set;return JSON.stringify(l,(C,m)=>{if((0,i.isObject)(m)||Array.isArray(m)){if(d.has(m))return"[Circular]";d.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function B(l,d){const C=Object.create(null);return!l||!d||Object.keys(d).forEach(p=>{const r=l[p],S=d[p];g(r,S)||(C[p]=S)}),C}function c(l,d){const C=d.toLowerCase(),m=Object.keys(l).find(p=>p.toLowerCase()===C);return m?l[m]:l[d]}function u(l,d){const C=Object.create(null);for(const[m,p]of Object.entries(l))d(m,p)&&(C[m]=p);return C}function e(l){let d=[];for(;Object.prototype!==l;)d=d.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return d}function s(l){const d=[];for(const C of e(l))typeof l[C]=="function"&&d.push(C);return d}function o(l,d){const C=p=>function(){const r=Array.prototype.slice.call(arguments,0);return d(p,r)},m={};for(const p of l)m[p]=C(p);return m}}),define(me[19],pe([1,0,18]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=x;var N;(function(_){function T(f){return f&&typeof f=="object"&&typeof f.id=="string"}_.isThemeColor=T})(N||(t.ThemeColor=N={}));function x(_){return{id:_}}var z;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function f(d){const C=T.exec(d.id);if(!C)return f(i.Codicon.error);const[,m,p]=C,r=["codicon","codicon-"+m];return p&&r.push("codicon-modifier-"+p.substring(1)),r}_.asClassNameArray=f;function g(d){return f(d).join(" ")}_.asClassName=g;function b(d){return"."+f(d).join(".")}_.asCSSSelector=b;function B(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||N.isThemeColor(d.color))}_.isThemeIcon=B;const c=new RegExp(`^\\$\\((${_.iconNameExpression}(?:${_.iconModifierExpression})?)\\)$`);function u(d){const C=c.exec(d);if(!C)return;const[,m]=C;return{id:m}}_.fromString=u;function e(d){return{id:d}}_.fromId=e;function s(d,C){let m=d.id;const p=m.lastIndexOf("~");return p!==-1&&(m=m.substring(0,p)),C&&(m=`${m}~${C}`),{id:m}}_.modify=s;function o(d){const C=d.id.lastIndexOf("~");if(C!==-1)return d.id.substring(C+1)}_.getModifier=o;function l(d,C){return d.id===C.id&&d.color?.id===C.color?.id}_.isEqual=l})(z||(t.ThemeIcon=z={}))}),define(me[62],pe([1,0,44,9,19]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=f,t.markdownEscapeEscapedIcons=b,t.stripIcons=c,t.getCodiconAriaLabel=u,t.parseLabelWithIcons=s,t.matchesFuzzyIconAware=o;const z="$(",_=new RegExp(`\\$\\(${x.ThemeIcon.iconNameExpression}(?:${x.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${_.source}`,"g");function f(l){return l.replace(T,(d,C)=>C?d:`\\${d}`)}const g=new RegExp(`\\\\${_.source}`,"g");function b(l){return l.replace(g,d=>`\\${d}`)}const B=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function c(l){return l.indexOf(z)===-1?l:l.replace(B,(d,C,m,p)=>m?d:C||p||"")}function u(l){return l?l.replace(/\$\((.*?)\)/g,(d,C)=>` ${C} `).trim():""}const e=new RegExp(`\\$\\(${x.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(l){e.lastIndex=0;let d="";const C=[];let m=0;for(;;){const p=e.lastIndex,r=e.exec(l),S=l.substring(p,r?.index);if(S.length>0){d+=S;for(let A=0;A<S.length;A++)C.push(m)}if(!r)break;m+=r[0].length}return{text:d,iconOffsets:C}}function o(l,d,C=!1){const{text:m,iconOffsets:p}=d;if(!p||p.length===0)return(0,i.matchesFuzzy)(l,m,C);const r=(0,N.ltrim)(m," "),S=m.length-r.length,A=(0,i.matchesFuzzy)(l,r,C);if(A)for(const I of A){const P=p[I.start+S]+S;I.start+=P,I.end+=P}return A}}),define(me[101],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[102],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class i{constructor(x,z){this.sender=x,this.onMessage=z}send(x){try{this.sender.send("vscode:message",x.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=i}),define(me[35],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const i=globalThis.vscode;t.ipcRenderer=i.ipcRenderer,t.ipcMessagePort=i.ipcMessagePort,t.webFrame=i.webFrame,t.process=i.process,t.context=i.context}),define(me[103],pe([1,0,101,35]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=z;let x=0;function z(T,f,g){const b=[],B=x++,c=`vscode:onContextMenu${B}`,u=(e,s,o)=>{b[s].click?.(o)};N.ipcRenderer.once(c,u),N.ipcRenderer.once(i.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===B&&(N.ipcRenderer.removeListener(c,u),g?.())}),N.ipcRenderer.send(i.CONTEXT_MENU_CHANNEL,B,T.map(e=>_(e,b)),c,f)}function _(T,f){const g={id:f.length,label:T.label,type:T.type,accelerator:T.accelerator,checked:T.checked,enabled:typeof T.enabled=="boolean"?T.enabled:!0,visible:typeof T.visible=="boolean"?T.visible:!0};return f.push(T),Array.isArray(T.submenu)&&(g.submenu=T.submenu.map(b=>_(b,f))),g}}),define(me[63],pe([7]),{}),define(me[104],pe([7]),{}),define(me[105],pe([7]),{}),define(me[106],pe([7]),{}),define(me[107],pe([1,0,105,106]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[108],pe([7]),{}),define(me[109],pe([7]),{}),define(me[110],pe([7]),{}),define(me[111],pe([7]),{}),define(me[112],pe([7]),{}),define(me[113],pe([7]),{}),define(me[114],pe([7]),{}),define(me[115],pe([7]),{}),define(me[116],pe([7]),{}),define(me[117],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[118],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[119],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[120],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[121],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[122],pe([13,12]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[123],pe([13,12]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(me[46],pe([1,0,3,2,123]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=b;class z extends N.Disposable{constructor(c,u="",e="",s=!0,o){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=c,this._label=u,this._cssClass=e,this._enabled=s,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}async run(c,u){this._actionCallback&&await this._actionCallback(c)}}t.Action=z;class _ extends N.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(c,u){if(!c.enabled)return;this._onWillRun.fire({action:c});let e;try{await this.runAction(c,u)}catch(s){e=s}this._onDidRun.fire({action:c,error:e})}async runAction(c,u){await c.run(u)}}t.ActionRunner=_;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let u=[];for(const e of c)e.length&&(u.length?u=[...u,new T,...e]:u=e);return u}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=T;class f{get actions(){return this._actions}constructor(c,u,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=u,this.class=s,this._actions=e}async run(){}}t.SubmenuAction=f;class g extends z{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,x.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=g;function b(B){return{id:B.id,label:B.label,class:B.class,enabled:B.enabled??!0,checked:B.checked,run:async(...c)=>B.run(...c),tooltip:B.label}}}),define(me[124],pe([13,12]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,124]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=S,t.isLittleEndian=O,t.isBigSurOrNewer=q,t.LANGUAGE_DEFAULT="en";let N=!1,x=!1,z=!1,_=!1,T=!1,f=!1,g=!1,b=!1,B=!1,c=!1,u,e=t.LANGUAGE_DEFAULT,s=t.LANGUAGE_DEFAULT,o,l;const d=globalThis;let C;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?C=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(C=process);const m=typeof C?.versions?.electron=="string",p=m&&C?.type==="renderer";if(typeof C=="object"){N=C.platform==="win32",x=C.platform==="darwin",z=C.platform==="linux",_=z&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,g=m,B=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const L=C.env.VSCODE_NLS_CONFIG;if(L)try{const W=JSON.parse(L),M=W.availableLanguages["*"];u=W.locale,s=W.osLocale,e=M||t.LANGUAGE_DEFAULT,o=W._translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!p?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,x=l.indexOf("Macintosh")>=0,b=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,z=l.indexOf("Linux")>=0,c=l?.indexOf("Mobi")>=0,f=!0,u=i.getConfiguredDefaultLocale(i.localize(0,null))||t.LANGUAGE_DEFAULT,e=u,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(r||(t.Platform=r={}));function S(L){switch(L){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let A=0;x?A=1:N?A=3:z&&(A=2),t.isWindows=N,t.isMacintosh=x,t.isLinux=z,t.isLinuxSnap=_,t.isNative=T,t.isElectron=g,t.isWeb=f,t.isWebWorker=f&&typeof d.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?d.origin:void 0,t.isIOS=b,t.isMobile=c,t.isCI=B,t.platform=A,t.userAgent=l,t.language=e;var I;(function(L){function W(){return t.language}L.value=W;function M(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}L.isDefaultVariant=M;function G(){return t.language==="en"}L.isDefault=G})(I||(t.Language=I={})),t.locale=u,t.platformLocale=s,t.translationsConfigFile=o,t.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const L=[];d.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let G=0,K=L.length;G<K;G++){const ae=L[G];if(ae.id===M.data.vscodeScheduleAsyncWork){L.splice(G,1),ae.callback();return}}});let W=0;return M=>{const G=++W;L.push({id:G,callback:M}),d.postMessage({vscodeScheduleAsyncWork:G},"*")}}return L=>setTimeout(L)})();var P;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(P||(t.OperatingSystem=P={})),t.OS=x||b?2:N?1:3;let $=!0,v=!1;function O(){if(!v){v=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,$=new Uint16Array(L.buffer)[0]===513}return $}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function q(L){return parseFloat(L)>=20}}),define(me[125],pe([1,0,17,22,5]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var z;(function(_){_[_.Always=0]="Always",_[_.FullScreen=1]="FullScreen",_[_.None=2]="None"})(z||(t.KeyboardSupport=z={})),t.BrowserFeatures={clipboard:{writeText:x.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:x.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:x.isNative||i.isStandalone()?0:navigator.keyboard||i.isSafari?1:2,touch:"ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0,pointerEvents:N.mainWindow.PointerEvent&&("ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0)}}),define(me[15],pe([1,0,17,54,87,5]),function(ne,t,i,N,x,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=B,t.printStandardKeyboardEvent=c;function _(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return 7;if(i.isFirefox)switch(s){case 59:return 85;case 60:if(z.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(z.isMacintosh)return 57;break}else if(i.isWebKit){if(z.isMacintosh&&s===93)return 57;if(!z.isMacintosh&&s===92)return 57}return N.EVENT_KEY_CODE_MAP[s]||0}const T=z.isMacintosh?256:2048,f=512,g=1024,b=z.isMacintosh?2048:256;function B(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}class u{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=_(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=T),this.altKey&&(o|=f),this.shiftKey&&(o|=g),this.metaKey&&(o|=b),o|=s,o}_computeKeyCodeChord(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new x.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=u}),define(me[20],pe([1,0,17,79,5]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class z{constructor(g,b){this.timestamp=Date.now(),this.browserEvent=b,this.leftButton=b.button===0,this.middleButton=b.button===1,this.rightButton=b.button===2,this.buttons=b.buttons,this.target=b.target,this.detail=b.detail||1,b.type==="dblclick"&&(this.detail=2),this.ctrlKey=b.ctrlKey,this.shiftKey=b.shiftKey,this.altKey=b.altKey,this.metaKey=b.metaKey,typeof b.pageX=="number"?(this.posx=b.pageX,this.posy=b.pageY):(this.posx=b.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=b.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const B=N.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(g,b.view);this.posx-=B.left,this.posy-=B.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=z;class _ extends z{constructor(g,b){super(g,b),this.dataTransfer=b.dataTransfer}}t.DragMouseEvent=_;class T{constructor(g,b=0,B=0){this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=B,this.deltaX=b;let c=!1;if(i.isChrome){const u=navigator.userAgent.match(/Chrome\/(\d+)/);c=(u?parseInt(u[1]):123)<=122}if(g){const u=g,e=g,s=g.view?.devicePixelRatio||1;if(typeof u.wheelDeltaY<"u")c?this.deltaY=u.wheelDeltaY/(120*s):this.deltaY=u.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!x.isMacintosh?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof u.wheelDeltaX<"u")i.isSafari&&x.isWindows?this.deltaX=-(u.wheelDeltaX/120):c?this.deltaX=u.wheelDeltaX/(120*s):this.deltaX=u.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.isFirefox&&!x.isMacintosh?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(c?this.deltaY=g.wheelDelta/(120*s):this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=T}),define(me[126],pe([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let N;const x=globalThis.vscode;if(typeof x<"u"&&typeof x.process<"u"){const z=x.process;N={get platform(){return z.platform},get arch(){return z.arch},get env(){return z.env},cwd(){return z.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.platform=N.platform,t.arch=N.arch}),define(me[25],pe([1,0,126]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const N=65,x=97,z=90,_=122,T=46,f=47,g=92,b=58,B=63;class c extends Error{constructor(S,A,I){let P;typeof A=="string"&&A.indexOf("not ")===0?(P="must not be",A=A.replace(/^not /,"")):P="must be";const $=S.indexOf(".")!==-1?"property":"argument";let v=`The "${S}" ${$} ${P} of type ${A}`;v+=`. Received type ${typeof I}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function u(r,S){if(r===null||typeof r!="object")throw new c(S,"Object",r)}function e(r,S){if(typeof r!="string")throw new c(S,"string",r)}const s=i.platform==="win32";function o(r){return r===f||r===g}function l(r){return r===f}function d(r){return r>=N&&r<=z||r>=x&&r<=_}function C(r,S,A,I){let P="",$=0,v=-1,O=0,q=0;for(let L=0;L<=r.length;++L){if(L<r.length)q=r.charCodeAt(L);else{if(I(q))break;q=f}if(I(q)){if(!(v===L-1||O===1))if(O===2){if(P.length<2||$!==2||P.charCodeAt(P.length-1)!==T||P.charCodeAt(P.length-2)!==T){if(P.length>2){const W=P.lastIndexOf(A);W===-1?(P="",$=0):(P=P.slice(0,W),$=P.length-1-P.lastIndexOf(A)),v=L,O=0;continue}else if(P.length!==0){P="",$=0,v=L,O=0;continue}}S&&(P+=P.length>0?`${A}..`:"..",$=2)}else P.length>0?P+=`${A}${r.slice(v+1,L)}`:P=r.slice(v+1,L),$=L-v-1;v=L,O=0}else q===T&&O!==-1?++O:O=-1}return P}function m(r,S){u(S,"pathObject");const A=S.dir||S.root,I=S.base||`${S.name||""}${S.ext||""}`;return A?A===S.root?`${A}${I}`:`${A}${r}${I}`:I}t.win32={resolve(...r){let S="",A="",I=!1;for(let P=r.length-1;P>=-1;P--){let $;if(P>=0){if($=r[P],e($,"path"),$.length===0)continue}else S.length===0?$=i.cwd():($=i.env[`=${S}`]||i.cwd(),($===void 0||$.slice(0,2).toLowerCase()!==S.toLowerCase()&&$.charCodeAt(2)===g)&&($=`${S}\\`));const v=$.length;let O=0,q="",L=!1;const W=$.charCodeAt(0);if(v===1)o(W)&&(O=1,L=!0);else if(o(W))if(L=!0,o($.charCodeAt(1))){let M=2,G=M;for(;M<v&&!o($.charCodeAt(M));)M++;if(M<v&&M!==G){const K=$.slice(G,M);for(G=M;M<v&&o($.charCodeAt(M));)M++;if(M<v&&M!==G){for(G=M;M<v&&!o($.charCodeAt(M));)M++;(M===v||M!==G)&&(q=`\\\\${K}\\${$.slice(G,M)}`,O=M)}}}else O=1;else d(W)&&$.charCodeAt(1)===b&&(q=$.slice(0,2),O=2,v>2&&o($.charCodeAt(2))&&(L=!0,O=3));if(q.length>0)if(S.length>0){if(q.toLowerCase()!==S.toLowerCase())continue}else S=q;if(I){if(S.length>0)break}else if(A=`${$.slice(O)}\\${A}`,I=L,L&&S.length>0)break}return A=C(A,!I,"\\",o),I?`${S}\\${A}`:`${S}${A}`||"."},normalize(r){e(r,"path");const S=r.length;if(S===0)return".";let A=0,I,P=!1;const $=r.charCodeAt(0);if(S===1)return l($)?"\\":r;if(o($))if(P=!0,o(r.charCodeAt(1))){let O=2,q=O;for(;O<S&&!o(r.charCodeAt(O));)O++;if(O<S&&O!==q){const L=r.slice(q,O);for(q=O;O<S&&o(r.charCodeAt(O));)O++;if(O<S&&O!==q){for(q=O;O<S&&!o(r.charCodeAt(O));)O++;if(O===S)return`\\\\${L}\\${r.slice(q)}\\`;O!==q&&(I=`\\\\${L}\\${r.slice(q,O)}`,A=O)}}}else A=1;else d($)&&r.charCodeAt(1)===b&&(I=r.slice(0,2),A=2,S>2&&o(r.charCodeAt(2))&&(P=!0,A=3));let v=A<S?C(r.slice(A),!P,"\\",o):"";return v.length===0&&!P&&(v="."),v.length>0&&o(r.charCodeAt(S-1))&&(v+="\\"),I===void 0?P?`\\${v}`:v:P?`${I}\\${v}`:`${I}${v}`},isAbsolute(r){e(r,"path");const S=r.length;if(S===0)return!1;const A=r.charCodeAt(0);return o(A)||S>2&&d(A)&&r.charCodeAt(1)===b&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let S,A;for(let $=0;$<r.length;++$){const v=r[$];e(v,"path"),v.length>0&&(S===void 0?S=A=v:S+=`\\${v}`)}if(S===void 0)return".";let I=!0,P=0;if(typeof A=="string"&&o(A.charCodeAt(0))){++P;const $=A.length;$>1&&o(A.charCodeAt(1))&&(++P,$>2&&(o(A.charCodeAt(2))?++P:I=!1))}if(I){for(;P<S.length&&o(S.charCodeAt(P));)P++;P>=2&&(S=`\\${S.slice(P)}`)}return t.win32.normalize(S)},relative(r,S){if(e(r,"from"),e(S,"to"),r===S)return"";const A=t.win32.resolve(r),I=t.win32.resolve(S);if(A===I||(r=A.toLowerCase(),S=I.toLowerCase(),r===S))return"";let P=0;for(;P<r.length&&r.charCodeAt(P)===g;)P++;let $=r.length;for(;$-1>P&&r.charCodeAt($-1)===g;)$--;const v=$-P;let O=0;for(;O<S.length&&S.charCodeAt(O)===g;)O++;let q=S.length;for(;q-1>O&&S.charCodeAt(q-1)===g;)q--;const L=q-O,W=v<L?v:L;let M=-1,G=0;for(;G<W;G++){const ae=r.charCodeAt(P+G);if(ae!==S.charCodeAt(O+G))break;ae===g&&(M=G)}if(G!==W){if(M===-1)return I}else{if(L>W){if(S.charCodeAt(O+G)===g)return I.slice(O+G+1);if(G===2)return I.slice(O+G)}v>W&&(r.charCodeAt(P+G)===g?M=G:G===2&&(M=3)),M===-1&&(M=0)}let K="";for(G=P+M+1;G<=$;++G)(G===$||r.charCodeAt(G)===g)&&(K+=K.length===0?"..":"\\..");return O+=M,K.length>0?`${K}${I.slice(O,q)}`:(I.charCodeAt(O)===g&&++O,I.slice(O,q))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const S=t.win32.resolve(r);if(S.length<=2)return r;if(S.charCodeAt(0)===g){if(S.charCodeAt(1)===g){const A=S.charCodeAt(2);if(A!==B&&A!==T)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(d(S.charCodeAt(0))&&S.charCodeAt(1)===b&&S.charCodeAt(2)===g)return`\\\\?\\${S}`;return r},dirname(r){e(r,"path");const S=r.length;if(S===0)return".";let A=-1,I=0;const P=r.charCodeAt(0);if(S===1)return o(P)?r:".";if(o(P)){if(A=I=1,o(r.charCodeAt(1))){let O=2,q=O;for(;O<S&&!o(r.charCodeAt(O));)O++;if(O<S&&O!==q){for(q=O;O<S&&o(r.charCodeAt(O));)O++;if(O<S&&O!==q){for(q=O;O<S&&!o(r.charCodeAt(O));)O++;if(O===S)return r;O!==q&&(A=I=O+1)}}}}else d(P)&&r.charCodeAt(1)===b&&(A=S>2&&o(r.charCodeAt(2))?3:2,I=A);let $=-1,v=!0;for(let O=S-1;O>=I;--O)if(o(r.charCodeAt(O))){if(!v){$=O;break}}else v=!1;if($===-1){if(A===-1)return".";$=A}return r.slice(0,$)},basename(r,S){S!==void 0&&e(S,"ext"),e(r,"path");let A=0,I=-1,P=!0,$;if(r.length>=2&&d(r.charCodeAt(0))&&r.charCodeAt(1)===b&&(A=2),S!==void 0&&S.length>0&&S.length<=r.length){if(S===r)return"";let v=S.length-1,O=-1;for($=r.length-1;$>=A;--$){const q=r.charCodeAt($);if(o(q)){if(!P){A=$+1;break}}else O===-1&&(P=!1,O=$+1),v>=0&&(q===S.charCodeAt(v)?--v===-1&&(I=$):(v=-1,I=O))}return A===I?I=O:I===-1&&(I=r.length),r.slice(A,I)}for($=r.length-1;$>=A;--$)if(o(r.charCodeAt($))){if(!P){A=$+1;break}}else I===-1&&(P=!1,I=$+1);return I===-1?"":r.slice(A,I)},extname(r){e(r,"path");let S=0,A=-1,I=0,P=-1,$=!0,v=0;r.length>=2&&r.charCodeAt(1)===b&&d(r.charCodeAt(0))&&(S=I=2);for(let O=r.length-1;O>=S;--O){const q=r.charCodeAt(O);if(o(q)){if(!$){I=O+1;break}continue}P===-1&&($=!1,P=O+1),q===T?A===-1?A=O:v!==1&&(v=1):A!==-1&&(v=-1)}return A===-1||P===-1||v===0||v===1&&A===P-1&&A===I+1?"":r.slice(A,P)},format:m.bind(null,"\\"),parse(r){e(r,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return S;const A=r.length;let I=0,P=r.charCodeAt(0);if(A===1)return o(P)?(S.root=S.dir=r,S):(S.base=S.name=r,S);if(o(P)){if(I=1,o(r.charCodeAt(1))){let M=2,G=M;for(;M<A&&!o(r.charCodeAt(M));)M++;if(M<A&&M!==G){for(G=M;M<A&&o(r.charCodeAt(M));)M++;if(M<A&&M!==G){for(G=M;M<A&&!o(r.charCodeAt(M));)M++;M===A?I=M:M!==G&&(I=M+1)}}}}else if(d(P)&&r.charCodeAt(1)===b){if(A<=2)return S.root=S.dir=r,S;if(I=2,o(r.charCodeAt(2))){if(A===3)return S.root=S.dir=r,S;I=3}}I>0&&(S.root=r.slice(0,I));let $=-1,v=I,O=-1,q=!0,L=r.length-1,W=0;for(;L>=I;--L){if(P=r.charCodeAt(L),o(P)){if(!q){v=L+1;break}continue}O===-1&&(q=!1,O=L+1),P===T?$===-1?$=L:W!==1&&(W=1):$!==-1&&(W=-1)}return O!==-1&&($===-1||W===0||W===1&&$===O-1&&$===v+1?S.base=S.name=r.slice(v,O):(S.name=r.slice(v,$),S.base=r.slice(v,O),S.ext=r.slice($,O))),v>0&&v!==I?S.dir=r.slice(0,v-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(s){const r=/\\/g;return()=>{const S=i.cwd().replace(r,"/");return S.slice(S.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...r){let S="",A=!1;for(let I=r.length-1;I>=-1&&!A;I--){const P=I>=0?r[I]:p();e(P,"path"),P.length!==0&&(S=`${P}/${S}`,A=P.charCodeAt(0)===f)}return S=C(S,!A,"/",l),A?`/${S}`:S.length>0?S:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const S=r.charCodeAt(0)===f,A=r.charCodeAt(r.length-1)===f;return r=C(r,!S,"/",l),r.length===0?S?"/":A?"./":".":(A&&(r+="/"),S?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===f},join(...r){if(r.length===0)return".";let S;for(let A=0;A<r.length;++A){const I=r[A];e(I,"path"),I.length>0&&(S===void 0?S=I:S+=`/${I}`)}return S===void 0?".":t.posix.normalize(S)},relative(r,S){if(e(r,"from"),e(S,"to"),r===S||(r=t.posix.resolve(r),S=t.posix.resolve(S),r===S))return"";const A=1,I=r.length,P=I-A,$=1,v=S.length-$,O=P<v?P:v;let q=-1,L=0;for(;L<O;L++){const M=r.charCodeAt(A+L);if(M!==S.charCodeAt($+L))break;M===f&&(q=L)}if(L===O)if(v>O){if(S.charCodeAt($+L)===f)return S.slice($+L+1);if(L===0)return S.slice($+L)}else P>O&&(r.charCodeAt(A+L)===f?q=L:L===0&&(q=0));let W="";for(L=A+q+1;L<=I;++L)(L===I||r.charCodeAt(L)===f)&&(W+=W.length===0?"..":"/..");return`${W}${S.slice($+q)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const S=r.charCodeAt(0)===f;let A=-1,I=!0;for(let P=r.length-1;P>=1;--P)if(r.charCodeAt(P)===f){if(!I){A=P;break}}else I=!1;return A===-1?S?"/":".":S&&A===1?"//":r.slice(0,A)},basename(r,S){S!==void 0&&e(S,"ext"),e(r,"path");let A=0,I=-1,P=!0,$;if(S!==void 0&&S.length>0&&S.length<=r.length){if(S===r)return"";let v=S.length-1,O=-1;for($=r.length-1;$>=0;--$){const q=r.charCodeAt($);if(q===f){if(!P){A=$+1;break}}else O===-1&&(P=!1,O=$+1),v>=0&&(q===S.charCodeAt(v)?--v===-1&&(I=$):(v=-1,I=O))}return A===I?I=O:I===-1&&(I=r.length),r.slice(A,I)}for($=r.length-1;$>=0;--$)if(r.charCodeAt($)===f){if(!P){A=$+1;break}}else I===-1&&(P=!1,I=$+1);return I===-1?"":r.slice(A,I)},extname(r){e(r,"path");let S=-1,A=0,I=-1,P=!0,$=0;for(let v=r.length-1;v>=0;--v){const O=r.charCodeAt(v);if(O===f){if(!P){A=v+1;break}continue}I===-1&&(P=!1,I=v+1),O===T?S===-1?S=v:$!==1&&($=1):S!==-1&&($=-1)}return S===-1||I===-1||$===0||$===1&&S===I-1&&S===A+1?"":r.slice(S,I)},format:m.bind(null,"/"),parse(r){e(r,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return S;const A=r.charCodeAt(0)===f;let I;A?(S.root="/",I=1):I=0;let P=-1,$=0,v=-1,O=!0,q=r.length-1,L=0;for(;q>=I;--q){const W=r.charCodeAt(q);if(W===f){if(!O){$=q+1;break}continue}v===-1&&(O=!1,v=q+1),W===T?P===-1?P=q:L!==1&&(L=1):P!==-1&&(L=-1)}if(v!==-1){const W=$===0&&A?1:$;P===-1||L===0||L===1&&P===v-1&&P===$+1?S.base=S.name=r.slice(W,v):(S.name=r.slice(W,P),S.base=r.slice(W,v),S.ext=r.slice(P,v))}return $>0?S.dir=r.slice(0,$-1):A&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(me[127],pe([1,0,25,5,9,10]),function(ne,t,i,N,x,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=_,t.toSlashes=T,t.toPosixPath=f,t.getRoot=g,t.isUNC=b,t.isValidBasename=e,t.isEqual=s,t.isEqualOrParent=o,t.isWindowsDriveLetter=l,t.sanitizeFilePath=d,t.removeTrailingPathSeparator=C,t.isRootOrDriveLetter=m,t.hasDriveLetter=p,t.getDriveLetter=r,t.indexOfPath=S,t.parseLineAndColumnAware=A,t.randomPath=$;function _(v){return v===47||v===92}function T(v){return v.replace(/[\\/]/g,i.posix.sep)}function f(v){return v.indexOf("/")===-1&&(v=T(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function g(v,O=i.posix.sep){if(!v)return"";const q=v.length,L=v.charCodeAt(0);if(_(L)){if(_(v.charCodeAt(1))&&!_(v.charCodeAt(2))){let M=3;const G=M;for(;M<q&&!_(v.charCodeAt(M));M++);if(G!==M&&!_(v.charCodeAt(M+1))){for(M+=1;M<q;M++)if(_(v.charCodeAt(M)))return v.slice(0,M+1).replace(/[\\/]/g,O)}}return O}else if(l(L)&&v.charCodeAt(1)===58)return _(v.charCodeAt(2))?v.slice(0,2)+O:v.slice(0,2);let W=v.indexOf("://");if(W!==-1){for(W+=3;W<q;W++)if(_(v.charCodeAt(W)))return v.slice(0,W+1)}return""}function b(v){if(!N.isWindows||!v||v.length<5)return!1;let O=v.charCodeAt(0);if(O!==92||(O=v.charCodeAt(1),O!==92))return!1;let q=2;const L=q;for(;q<v.length&&(O=v.charCodeAt(q),O!==92);q++);return!(L===q||(O=v.charCodeAt(q+1),isNaN(O)||O===92))}const B=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,O=N.isWindows){const q=O?B:c;return!(!v||v.length===0||/^\s+$/.test(v)||(q.lastIndex=0,q.test(v))||O&&u.test(v)||v==="."||v===".."||O&&v[v.length-1]==="."||O&&v.length!==v.trim().length||v.length>255)}function s(v,O,q){const L=v===O;return!q||L?L:!v||!O?!1:(0,x.equalsIgnoreCase)(v,O)}function o(v,O,q,L=i.sep){if(v===O)return!0;if(!v||!O||O.length>v.length)return!1;if(q){if(!(0,x.startsWithIgnoreCase)(v,O))return!1;if(O.length===v.length)return!0;let M=O.length;return O.charAt(O.length-1)===L&&M--,v.charAt(M)===L}return O.charAt(O.length-1)!==L&&(O+=L),v.indexOf(O)===0}function l(v){return v>=65&&v<=90||v>=97&&v<=122}function d(v,O){return N.isWindows&&v.endsWith(":")&&(v+=i.sep),(0,i.isAbsolute)(v)||(v=(0,i.join)(O,v)),v=(0,i.normalize)(v),C(v)}function C(v){return N.isWindows?(v=(0,x.rtrim)(v,i.sep),v.endsWith(":")&&(v+=i.sep)):(v=(0,x.rtrim)(v,i.sep),v||(v=i.sep)),v}function m(v){const O=(0,i.normalize)(v);return N.isWindows?v.length>3?!1:p(O)&&(v.length===2||O.charCodeAt(2)===92):O===i.posix.sep}function p(v,O=N.isWindows){return O?l(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function r(v,O=N.isWindows){return p(v,O)?v[0]:void 0}function S(v,O,q){return O.length>v.length?-1:v===O?0:(q&&(v=v.toLowerCase(),O=O.toLowerCase()),v.indexOf(O))}function A(v){const O=v.split(":");let q,L,W;for(const M of O){const G=Number(M);(0,z.isNumber)(G)?L===void 0?L=G:W===void 0&&(W=G):q=q?[q,M].join(":"):M}if(!q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:q,line:L!==void 0?L:void 0,column:W!==void 0?W:L!==void 0?1:void 0}}const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(v,O,q=8){let L="";for(let M=0;M<q;M++){let G;M===0&&N.isWindows&&!O&&(q===3||q===4)?G=P:G=I,L+=G.charAt(Math.floor(Math.random()*G.length))}let W;return O?W=`${O}-${L}`:W=L,v?(0,i.join)(v,W):W}}),define(me[128],pe([1,0,25]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=z,t.getMediaMime=_,t.getExtensionForMimeType=T,t.normalizeMimeType=g,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},x={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(b){const B=(0,i.extname)(b),c=N[B.toLowerCase()];return c!==void 0?c:_(b)}function _(b){const B=(0,i.extname)(b);return x[B.toLowerCase()]}function T(b){for(const B in x)if(x[B]===b)return B}const f=/^(.+)\/(.+?)(;.+)?$/;function g(b,B){const c=f.exec(b);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:B?void 0:b}}),define(me[16],pe([1,0,25,5]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=e,t.uriToFsPath=m;const x=/^\w[\w\d+.-]*$/,z=/^\//,_=/^\/\//;function T(I,P){if(!I.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${I.authority}", path: "${I.path}", query: "${I.query}", fragment: "${I.fragment}"}`);if(I.scheme&&!x.test(I.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(I.path){if(I.authority){if(!z.test(I.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(I.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(I,P){return!I&&!P?"file":I}function g(I,P){switch(I){case"https":case"http":case"file":P?P[0]!==B&&(P=B+P):P=B;break}return P}const b="",B="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(P){return P instanceof u?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,$,v,O,q,L=!1){typeof P=="object"?(this.scheme=P.scheme||b,this.authority=P.authority||b,this.path=P.path||b,this.query=P.query||b,this.fragment=P.fragment||b):(this.scheme=f(P,L),this.authority=$||b,this.path=g(this.scheme,v||b),this.query=O||b,this.fragment=q||b,T(this,L))}get fsPath(){return m(this,!1)}with(P){if(!P)return this;let{scheme:$,authority:v,path:O,query:q,fragment:L}=P;return $===void 0?$=this.scheme:$===null&&($=b),v===void 0?v=this.authority:v===null&&(v=b),O===void 0?O=this.path:O===null&&(O=b),q===void 0?q=this.query:q===null&&(q=b),L===void 0?L=this.fragment:L===null&&(L=b),$===this.scheme&&v===this.authority&&O===this.path&&q===this.query&&L===this.fragment?this:new o($,v,O,q,L)}static parse(P,$=!1){const v=c.exec(P);return v?new o(v[2]||b,A(v[4]||b),A(v[5]||b),A(v[7]||b),A(v[9]||b),$):new o(b,b,b,b,b)}static file(P){let $=b;if(N.isWindows&&(P=P.replace(/\\/g,B)),P[0]===B&&P[1]===B){const v=P.indexOf(B,2);v===-1?($=P.substring(2),P=B):($=P.substring(2,v),P=P.substring(v)||B)}return new o("file",$,P,b,b)}static from(P,$){return new o(P.scheme,P.authority,P.path,P.query,P.fragment,$)}static joinPath(P,...$){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return N.isWindows&&P.scheme==="file"?v=u.file(i.win32.join(m(P,!0),...$)).path:v=i.posix.join(P.path,...$),P.with({path:v})}toString(P=!1){return p(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof u)return P;{const $=new o(P);return $._formatted=P.external??null,$._fsPath=P._sep===s?P.fsPath??null:null,$}}else return P}}t.URI=u;function e(I){return!I||typeof I!="object"?!1:typeof I.scheme=="string"&&(typeof I.authority=="string"||typeof I.authority>"u")&&(typeof I.path=="string"||typeof I.path>"u")&&(typeof I.query=="string"||typeof I.query>"u")&&(typeof I.fragment=="string"||typeof I.fragment>"u")}const s=N.isWindows?1:void 0;class o extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(P=!1){return P?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const P={$mid:1};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=s),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(I,P,$){let v,O=-1;for(let q=0;q<I.length;q++){const L=I.charCodeAt(q);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||P&&L===47||$&&L===91||$&&L===93||$&&L===58)O!==-1&&(v+=encodeURIComponent(I.substring(O,q)),O=-1),v!==void 0&&(v+=I.charAt(q));else{v===void 0&&(v=I.substr(0,q));const W=l[L];W!==void 0?(O!==-1&&(v+=encodeURIComponent(I.substring(O,q)),O=-1),v+=W):O===-1&&(O=q)}}return O!==-1&&(v+=encodeURIComponent(I.substring(O))),v!==void 0?v:I}function C(I){let P;for(let $=0;$<I.length;$++){const v=I.charCodeAt($);v===35||v===63?(P===void 0&&(P=I.substr(0,$)),P+=l[v]):P!==void 0&&(P+=I[$])}return P!==void 0?P:I}function m(I,P){let $;return I.authority&&I.path.length>1&&I.scheme==="file"?$=`//${I.authority}${I.path}`:I.path.charCodeAt(0)===47&&(I.path.charCodeAt(1)>=65&&I.path.charCodeAt(1)<=90||I.path.charCodeAt(1)>=97&&I.path.charCodeAt(1)<=122)&&I.path.charCodeAt(2)===58?P?$=I.path.substr(1):$=I.path[1].toLowerCase()+I.path.substr(2):$=I.path,N.isWindows&&($=$.replace(/\//g,"\\")),$}function p(I,P){const $=P?C:d;let v="",{scheme:O,authority:q,path:L,query:W,fragment:M}=I;if(O&&(v+=O,v+=":"),(q||O==="file")&&(v+=B,v+=B),q){let G=q.indexOf("@");if(G!==-1){const K=q.substr(0,G);q=q.substr(G+1),G=K.lastIndexOf(":"),G===-1?v+=$(K,!1,!1):(v+=$(K.substr(0,G),!1,!1),v+=":",v+=$(K.substr(G+1),!1,!0)),v+="@"}q=q.toLowerCase(),G=q.lastIndexOf(":"),G===-1?v+=$(q,!1,!0):(v+=$(q.substr(0,G),!1,!0),v+=q.substr(G))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const G=L.charCodeAt(1);G>=65&&G<=90&&(L=`/${String.fromCharCode(G+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const G=L.charCodeAt(0);G>=65&&G<=90&&(L=`${String.fromCharCode(G+32)}:${L.substr(2)}`)}v+=$(L,!0,!1)}return W&&(v+="?",v+=$(W,!1,!1)),M&&(v+="#",v+=P?M:d(M,!1,!1)),v}function r(I){try{return decodeURIComponent(I)}catch{return I.length>3?I.substr(0,3)+r(I.substr(3)):I}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(I){return I.match(S)?I.replace(S,P=>r(P)):I}}),define(me[64],pe([1,0,43,16]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=x,t.parse=z,t.revive=T;function x(f){return JSON.stringify(f,_)}function z(f){let g=JSON.parse(f);return g=T(g),g}function _(f,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function T(f,g=0){if(!f||g>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return N.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof i.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let b=0;b<f.length;++b)f[b]=T(f[b],g+1);else for(const b in f)Object.hasOwnProperty.call(f,b)&&(f[b]=T(f[b],g+1))}return f}}),define(me[36],pe([1,0,6,5,9,16,25]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=f,t.matchesSomeScheme=g,t.getServerRootPath=B;var T;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(T||(t.Schemas=T={}));function f(e,s){return z.URI.isUri(e)?(0,x.equalsIgnoreCase)(e.scheme,s):(0,x.startsWithIgnoreCase)(e,s+":")}function g(e,...s){return s.some(o=>f(e,o))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s,o){this._serverRootPath=B(s,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return _.posix.join(this._serverRootPath,T.vscodeRemoteResource)}set(s,o,l){this._hosts[s]=o,this._ports[s]=l}setConnectionToken(s,o){this._connectionTokens[s]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(p){return i.onUnexpectedError(p),s}const o=s.authority;let l=this._hosts[o];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const d=this._ports[o],C=this._connectionTokens[o];let m=`path=${encodeURIComponent(s.path)}`;return typeof C=="string"&&(m+=`&${t.connectionTokenQueryName}=${encodeURIComponent(C)}`),z.URI.from({scheme:N.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${l}:${d}`,path:this._remoteResourcesPath,query:m})}}t.RemoteAuthorities=new b;function B(e,s){return _.posix.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class c{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(s){const o=this.toUri(s,ne);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===T.vscodeRemote?t.RemoteAuthorities.rewrite(s):s.scheme===T.file&&(N.isNative||N.webWorkerOrigin===`${T.vscodeFileResource}://${c.FALLBACK_AUTHORITY}`)?s.with({scheme:T.vscodeFileResource,authority:s.authority||c.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const o=this.toUri(s,ne);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===T.vscodeFileResource?s.with({scheme:T.file,authority:s.authority!==c.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,o){return z.URI.isUri(s)?s:z.URI.parse(o.toUrl(s))}}t.FileAccess=new c;var u;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function l(C){let m;typeof C=="string"?m=new URL(C).searchParams:C instanceof URL?m=C.searchParams:z.URI.isUri(C)&&(m=new URL(C.toString(!0)).searchParams);const p=m?.get(o);if(p)return s.get(p)}e.getHeadersFromQuery=l;function d(C,m,p){if(!globalThis.crossOriginIsolated)return;const r=m&&p?"3":p?"2":"1";C instanceof URLSearchParams?C.set(o,r):C[o]=r}e.addSearchParam=d})(u||(t.COI=u={}))}),define(me[47],pe([1,0,127,36,25,5,9,16]),function(ne,t,i,N,x,z,_,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=f,t.distinctParents=b,t.toLocalResource=c;function f(u){return(0,T.uriToFsPath)(u,!0)}class g{constructor(e){this._ignorePathCasing=e}compare(e,s,o=!1){return e===s?0:(0,_.compare)(this.getComparisonKey(e,o),this.getComparisonKey(s,o))}isEqual(e,s,o=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,o)===this.getComparisonKey(s,o)}getComparisonKey(e,s=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,s,o=!1){if(e.scheme===s.scheme){if(e.scheme===N.Schemas.file)return i.isEqualOrParent(f(e),f(s),this._ignorePathCasing(e))&&e.query===s.query&&(o||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return i.isEqualOrParent(e.path,s.path,this._ignorePathCasing(e),"/")&&e.query===s.query&&(o||e.fragment===s.fragment)}return!1}joinPath(e,...s){return T.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return x.posix.basename(e.path)}extname(e){return x.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===N.Schemas.file?s=T.URI.file(x.dirname(f(e))).path:(s=x.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===N.Schemas.file?s=T.URI.file(x.normalize(f(e))).path:s=x.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===N.Schemas.file){const d=x.relative(f(e),f(s));return z.isWindows?i.toSlashes(d):d}let o=e.path||"/";const l=s.path||"/";if(this._ignorePathCasing(e)){let d=0;for(const C=Math.min(o.length,l.length);d<C&&!(o.charCodeAt(d)!==l.charCodeAt(d)&&o.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);o=l.substr(0,d)+o.substr(d)}return x.posix.relative(o,l)}resolvePath(e,s){if(e.scheme===N.Schemas.file){const o=T.URI.file(x.resolve(f(e),s));return e.with({authority:o.authority,path:o.path})}return s=i.toPosixPath(s),e.with({path:x.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,_.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=x.sep){if(e.scheme===N.Schemas.file){const o=f(e);return o.length>i.getRoot(o).length&&o[o.length-1]===s}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=x.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=x.sep){let o=!1;if(e.scheme===N.Schemas.file){const l=f(e);o=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===s}else{s="/";const l=e.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=g,t.extUri=new g(()=>!1),t.extUriBiasedIgnorePathCase=new g(u=>u.scheme===N.Schemas.file?!z.isLinux:!0),t.extUriIgnorePathCase=new g(u=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function b(u,e){const s=[];for(let o=0;o<u.length;o++){const l=e(u[o]);u.some((d,C)=>C===o?!1:(0,t.isEqualOrParent)(l,e(d)))||s.push(u[o])}return s}var B;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function e(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(C=>{const[m,p]=C.split(":");m&&p&&o.set(m,p)});const d=s.path.substring(0,s.path.indexOf(";"));return d&&o.set(u.META_DATA_MIME,d),o}u.parseMetaData=e})(B||(t.DataUri=B={}));function c(u,e,s){if(e){let o=u.path;return o&&o[0]!==x.posix.sep&&(o=x.posix.sep+o),u.with({scheme:s,authority:e,path:o})}return u.with({scheme:s})}}),define(me[11],pe([1,0,34,6,3,2,47,5,60,23]),function(ne,t,i,N,x,z,_,T,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=b,t.createCancelablePromise=B,t.raceCancellation=c,t.raceCancellationError=u,t.raceCancellablePromises=e,t.raceTimeout=s,t.asPromise=o,t.promiseWithResolvers=l,t.timeout=$,t.disposableTimeout=v,t.sequence=O,t.first=q,t.firstParallel=L,t.retry=J,t.createCancelableAsyncIterable=H;function b(y){return!!y&&typeof y.then=="function"}function B(y){const a=new i.CancellationTokenSource,w=y(a.token),F=new Promise((n,E)=>{const D=a.token.onCancellationRequested(()=>{D.dispose(),E(new N.CancellationError)});Promise.resolve(w).then(k=>{D.dispose(),a.dispose(),n(k)},k=>{D.dispose(),a.dispose(),E(k)})});return new class{cancel(){a.cancel(),a.dispose()}then(n,E){return F.then(n,E)}catch(n){return this.then(void 0,n)}finally(n){return F.finally(n)}}}function c(y,a,w){return new Promise((F,n)=>{const E=a.onCancellationRequested(()=>{E.dispose(),F(w)});y.then(F,n).finally(()=>E.dispose())})}function u(y,a){return new Promise((w,F)=>{const n=a.onCancellationRequested(()=>{n.dispose(),F(new N.CancellationError)});y.then(w,F).finally(()=>n.dispose())})}async function e(y){let a=-1;const w=y.map((F,n)=>F.then(E=>(a=n,E)));try{return await Promise.race(w)}finally{y.forEach((F,n)=>{n!==a&&F.cancel()})}}function s(y,a,w){let F;const n=setTimeout(()=>{F?.(void 0),w?.()},a);return Promise.race([y.finally(()=>clearTimeout(n)),new Promise(E=>F=E)])}function o(y){return new Promise((a,w)=>{const F=y();b(F)?F.then(a,w):a(F)})}function l(){let y,a;return{promise:new Promise((F,n)=>{y=F,a=n}),resolve:y,reject:a}}class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const w=()=>{if(this.queuedPromise=null,this.isDisposed)return;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(w,w).then(F)})}return new Promise((w,F)=>{this.queuedPromise.then(w,F)})}return this.activePromise=a(),new Promise((w,F)=>{this.activePromise.then(n=>{this.activePromise=null,w(n)},n=>{this.activePromise=null,F(n)})})}dispose(){this.isDisposed=!0}}t.Throttler=d;class C{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}t.Sequencer=C;class m{constructor(){this.promiseMap=new Map}queue(a,w){const n=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.promiseMap.get(a)===n&&this.promiseMap.delete(a)});return this.promiseMap.set(a,n),n}}t.SequencerByKey=m;const p=(y,a)=>{let w=!0;const F=setTimeout(()=>{w=!1,a()},y);return{isTriggered:()=>w,dispose:()=>{clearTimeout(F),w=!1}}},r=y=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,y())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class S{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,w=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((n,E)=>{this.doResolve=n,this.doReject=E}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const n=this.task;return this.task=null,n()}}));const F=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=w===f.MicrotaskDelay?r(F):p(w,F),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new N.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=S;class A{constructor(a){this.delayer=new S(a),this.throttler=new d}trigger(a,w){return this.delayer.trigger(()=>this.throttler.queue(a),w)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=A;class I{constructor(){this._isOpen=!1,this._promise=new Promise((a,w)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=I;class P extends I{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=P;function $(y,a){return a?new Promise((w,F)=>{const n=setTimeout(()=>{E.dispose(),w()},y),E=a.onCancellationRequested(()=>{clearTimeout(n),E.dispose(),F(new N.CancellationError)})}):B(w=>$(y,w))}function v(y,a=0,w){const F=setTimeout(()=>{y(),w&&n.dispose()},a),n=(0,z.toDisposable)(()=>{clearTimeout(F),w?.deleteAndLeak(n)});return w?.add(n),n}function O(y){const a=[];let w=0;const F=y.length;function n(){return w<F?y[w++]():null}function E(D){D!=null&&a.push(D);const k=n();return k?k.then(E):Promise.resolve(a)}return Promise.resolve(null).then(E)}function q(y,a=F=>!!F,w=null){let F=0;const n=y.length,E=()=>{if(F>=n)return Promise.resolve(w);const D=y[F++];return Promise.resolve(D()).then(R=>a(R)?Promise.resolve(R):E())};return E()}function L(y,a=F=>!!F,w=null){if(y.length===0)return Promise.resolve(w);let F=y.length;const n=()=>{F=-1;for(const E of y)E.cancel?.()};return new Promise((E,D)=>{for(const k of y)k.then(R=>{--F>=0&&a(R)?(n(),E(R)):F===0&&E(w)}).catch(R=>{--F>=0&&(n(),D(R))})})}class W{constructor(a){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new x.Emitter}whenIdle(){return this.size>0?x.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((w,F)=>{this.outstandingPromises.push({factory:a,c:w,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const w=a.factory();w.then(a.c,a.e),w.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=W;class M extends W{constructor(){super(1)}}t.Queue=M;class G{constructor(){this.sequentializer=new he,this.tasks=0}queue(a){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,a())):this.sequentializer.run(this.tasks++,a())}}t.LimitedQueue=G;class K{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const a=new V;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueSize(a,w=_.extUri){const F=w.getComparisonKey(a);return this.queues.get(F)?.size??0}queueFor(a,w,F=_.extUri){const n=F.getComparisonKey(a);let E=this.queues.get(n);if(!E){E=new M;const D=this.drainListenerCount++,k=x.Event.once(E.onDrained)(()=>{E?.dispose(),this.queues.delete(n),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(D),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new z.DisposableMap),this.drainListeners.set(D,k),this.queues.set(n,E)}return E.queue(w)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=K;class ae{constructor(a,w){this._token=-1,typeof a=="function"&&typeof w=="number"&&this.setIfNotSet(a,w)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,w){this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},w)}setIfNotSet(a,w){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},w))}}t.TimeoutTimer=ae;class ie{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(a,w,F=globalThis){this.cancel();const n=F.setInterval(()=>{a()},w);this.disposable=(0,z.toDisposable)(()=>{F.clearInterval(n),this.disposable=void 0})}dispose(){this.cancel()}}t.IntervalTimer=ie;class ee{constructor(a,w){this.timeoutToken=-1,this.runner=a,this.timeout=w,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ee;class ce{constructor(a,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=w,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ce;class Ee extends ee{constructor(a,w){super(a,w),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=Ee;class Se extends z.Disposable{constructor(a,w){super(),this.options=a,this.handler=w,this.pendingWork=[],this.throttler=this._register(new z.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const w of a)this.pendingWork.push(w);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ee(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=Se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(y,a)=>{(0,T.setTimeout0)(()=>{if(w)return;const F=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:t._runWhenIdle=(y,a,w)=>{const F=y.requestIdleCallback(a,typeof w=="number"?{timeout:w}:void 0);let n=!1;return{dispose(){n||(n=!0,y.cancelIdleCallback(F))}}},t.runWhenGlobalIdle=y=>(0,t._runWhenIdle)(globalThis,y)}();class Pe{constructor(a,w){this._didRun=!1,this._executor=()=>{try{this._value=w()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(a,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Pe;class le extends Pe{constructor(a){super(globalThis,a)}}t.GlobalIdleValue=le;async function J(y,a,w){let F;for(let n=0;n<w;n++)try{return await y()}catch(E){F=E,await $(a)}throw F}class he{isRunning(a){return typeof a=="number"?this._running?.taskId===a:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(a,w,F){return this._running={taskId:a,cancel:()=>F?.(),promise:w},w.then(()=>this.doneRunning(a),()=>this.doneRunning(a)),w}doneRunning(a){this._running&&a===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const a=this._queued;this._queued=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this._queued)this._queued.run=a;else{const{promise:w,resolve:F,reject:n}=l();this._queued={run:a,promise:w,promiseResolve:F,promiseReject:n}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=he;class re{constructor(a,w=()=>Date.now()){this.interval=a,this.nowFn=w,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}t.IntervalCounter=re;var ye;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(ye||(ye={}));class V{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((a,w)=>{this.completeCallback=a,this.errorCallback=w})}complete(a){return new Promise(w=>{this.completeCallback(a),this.outcome={outcome:0,value:a},w()})}error(a){return new Promise(w=>{this.errorCallback(a),this.outcome={outcome:1,value:a},w()})}cancel(){return this.error(new N.CancellationError)}}t.DeferredPromise=V;var Q;(function(y){async function a(F){let n;const E=await Promise.all(F.map(D=>D.then(k=>k,k=>{n||(n=k)})));if(typeof n<"u")throw n;return E}y.settled=a;function w(F){return new Promise(async(n,E)=>{try{await F(n,E)}catch(D){E(D)}})}y.withAsyncBody=w})(Q||(t.Promises=Q={}));class ge{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(a){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=a.then(w=>(this._value=w,this._isResolved=!0,w),w=>{throw this._error=w,this._isResolved=!0,w})}requireValue(){if(!this._isResolved)throw new N.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=ge;class De{constructor(a){this._compute=a,this._promise=new g.Lazy(()=>new ge(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=De;var Ae;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(Ae||(Ae={}));class Ie{static fromArray(a){return new Ie(w=>{w.emitMany(a)})}static fromPromise(a){return new Ie(async w=>{w.emitMany(await a)})}static fromPromises(a){return new Ie(async w=>{await Promise.all(a.map(async F=>w.emitOne(await F)))})}static merge(a){return new Ie(async w=>{await Promise.all(a.map(async F=>{for await(const n of F)w.emitOne(n)}))})}static{this.EMPTY=Ie.fromArray([])}constructor(a,w){this._state=0,this._results=[],this._error=null,this._onReturn=w,this._onStateChanged=new x.Emitter,queueMicrotask(async()=>{const F={emitOne:n=>this.emitOne(n),emitMany:n=>this.emitMany(n),reject:n=>this.reject(n)};try{await Promise.resolve(a(F)),this.resolve()}catch(n){this.reject(n)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===1)return{done:!0,value:void 0};await x.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(a,w){return new Ie(async F=>{for await(const n of a)F.emitOne(w(n))})}map(a){return Ie.map(this,a)}static filter(a,w){return new Ie(async F=>{for await(const n of a)w(n)&&F.emitOne(n)})}filter(a){return Ie.filter(this,a)}static coalesce(a){return Ie.filter(a,w=>!!w)}coalesce(){return Ie.coalesce(this)}static async toPromise(a){const w=[];for await(const F of a)w.push(F);return w}toPromise(){return Ie.toPromise(this)}emitOne(a){this._state===0&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===0&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(a){this._state===0&&(this._state=2,this._error=a,this._onStateChanged.fire())}}t.AsyncIterableObject=Ie;class Oe extends Ie{constructor(a,w){super(w),this._source=a}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=Oe;function H(y){const a=new i.CancellationTokenSource,w=y(a.token);return new Oe(a,async F=>{const n=a.token.onCancellationRequested(()=>{n.dispose(),a.dispose(),F.reject(new N.CancellationError)});try{for await(const E of w){if(a.token.isCancellationRequested)return;F.emitOne(E)}n.dispose(),a.dispose()}catch(E){n.dispose(),a.dispose(),F.reject(E)}})}class h{constructor(a){this._deferred=new V,this._asyncIterable=new Ie(n=>{if(w){n.reject(w);return}return F&&n.emitMany(F),this._errorFn=E=>n.reject(E),this._emitFn=E=>n.emitOne(E),this._deferred.p},a);let w,F;this._emitFn=n=>{F||(F=[]),F.push(n)},this._errorFn=n=>{w||(w=n)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(a){this._errorFn(a),this._deferred.complete()}emitOne(a){this._emitFn(a)}}t.AsyncIterableSource=h}),define(me[4],pe([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=l,t.addDisposableListener=C,t.addDisposableGenericMouseDownListener=I,t.addDisposableGenericMouseMoveListener=P,t.addDisposableGenericMouseUpListener=$,t.runWhenWindowIdle=v,t.disposableWindowInterval=q,t.measure=M,t.modify=G,t.addDisposableThrottledListener=ee,t.getComputedStyle=ce,t.getClientArea=Ee,t.getTopLeftOffset=le,t.size=J,t.position=he,t.getDomNodePagePosition=re,t.getDomNodeZoomLevel=ye,t.getTotalWidth=V,t.getContentWidth=Q,t.getTotalScrollWidth=ge,t.getContentHeight=De,t.getTotalHeight=Ae,t.getLargestChildWidth=Oe,t.isAncestor=H,t.setParentFlowTo=y,t.isAncestorUsingFlowTo=w,t.findParentWithClass=F,t.hasParentWithClass=n,t.isShadowRoot=E,t.isInShadowDOM=D,t.getShadowRoot=k,t.getActiveElement=R,t.isActiveElement=U,t.isAncestorOfActiveElement=Z,t.isActiveDocument=oe,t.getActiveDocument=ve,t.getActiveWindow=de,t.isGlobalStylesheet=Te,t.createStyleSheet2=Me,t.createStyleSheet=Ne,t.cloneGlobalStylesheets=Ve,t.createMetaElement=Ue,t.createLinkElement=Je,t.createCSSRule=Le,t.removeCSSRulesContainingSelector=He,t.isMouseEvent=et,t.isKeyboardEvent=it,t.isPointerEvent=nt,t.isDragEvent=Qe,t.isEventLike=rt,t.saveParentsScrollTop=tt,t.restoreParentsScrollTop=mt,t.trackFocus=_t,t.after=At,t.append=Tt,t.prepend=xe,t.reset=ue,t.$=st,t.join=lt,t.setVisibility=Xe,t.show=ht,t.hide=bt,t.removeTabIndexAndUpdateFocus=Yt,t.finalHandler=Ci,t.domContentLoaded=_i,t.computeScreenAwareSize=Ai,t.windowOpenNoOpener=Ti,t.windowOpenPopup=Ii,t.windowOpenWithSuccess=Ni,t.animate=Fi,t.asCSSUrl=Li,t.asCSSPropertyValue=ki,t.asCssValueWithDefault=Qt,t.triggerDownload=Pi,t.triggerUpload=Oi,t.detectFullscreen=Ri,t.hookDomPurifyHrefAndSrcSanitizer=Jt,t.safeInnerHtml=xi,t.multibyteAwareBtoa=Hi,t.getCookieValue=zi,t.h=qi,t.copyAttributes=ti,t.trackAttributes=ji,o=function(){const j=new Map;(0,s.ensureCodeWindow)(s.mainWindow,1);const Y={window:s.mainWindow,disposables:new b.DisposableStore};j.set(s.mainWindow.vscodeWindowId,Y);const te=new f.Emitter,fe=new f.Emitter,_e=new f.Emitter;function We(Be,qe){return(typeof Be=="number"?j.get(Be):void 0)??(qe?Y:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:_e.event,onDidUnregisterWindow:fe.event,registerWindow(Be){if(j.has(Be.vscodeWindowId))return b.Disposable.None;const qe=new b.DisposableStore,Ke={window:Be,disposables:qe.add(new b.DisposableStore)};return j.set(Be.vscodeWindowId,Ke),qe.add((0,b.toDisposable)(()=>{j.delete(Be.vscodeWindowId),fe.fire(Be)})),qe.add(C(Be,t.EventType.BEFORE_UNLOAD,()=>{_e.fire(Be)})),te.fire(Ke),qe},getWindows(){return j.values()},getWindowsCount(){return j.size},getWindowId(Be){return Be.vscodeWindowId},hasWindow(Be){return j.has(Be)},getWindowById:We,getWindow(Be){const qe=Be;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Be;return Ke?.view?Ke.view.window:s.mainWindow},getDocument(Be){const qe=Be;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function l(j){for(;j.firstChild;)j.firstChild.remove()}class d{constructor(Y,te,fe,_e){this._node=Y,this._type=te,this._handler=fe,this._options=_e||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function C(j,Y,te,fe){return new d(j,Y,te,fe)}function m(j,Y){return function(te){return Y(new z.StandardMouseEvent(j,te))}}function p(j){return function(Y){return j(new x.StandardKeyboardEvent(Y))}}const r=function(Y,te,fe,_e){let We=fe;return te==="click"||te==="mousedown"?We=m((0,t.getWindow)(Y),fe):(te==="keydown"||te==="keypress"||te==="keyup")&&(We=p(fe)),C(Y,te,We,_e)};t.addStandardDisposableListener=r;const S=function(Y,te,fe){const _e=m((0,t.getWindow)(Y),te);return I(Y,_e,fe)};t.addStandardDisposableGenericMouseDownListener=S;const A=function(Y,te,fe){const _e=m((0,t.getWindow)(Y),te);return $(Y,_e,fe)};t.addStandardDisposableGenericMouseUpListener=A;function I(j,Y,te){return C(j,c.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,te)}function P(j,Y,te){return C(j,c.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,te)}function $(j,Y,te){return C(j,c.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,te)}function v(j,Y,te){return(0,_._runWhenIdle)(j,Y,te)}class O extends _.AbstractIdleValue{constructor(Y,te){super(Y,te)}}t.WindowIdleValue=O;function q(j,Y,te,fe){let _e=0;const We=j.setInterval(()=>{_e++,(typeof fe=="number"&&_e>=fe||Y()===!0)&&Be.dispose()},te),Be=(0,b.toDisposable)(()=>{j.clearInterval(We)});return Be}class L extends _.IntervalTimer{constructor(Y){super(),this.defaultTarget=Y&&(0,t.getWindow)(Y)}cancelAndSet(Y,te,fe){return super.cancelAndSet(Y,te,fe??this.defaultTarget)}}t.WindowIntervalTimer=L;class W{constructor(Y,te=0){this._runner=Y,this.priority=te,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Y){(0,T.onUnexpectedError)(Y)}}static sort(Y,te){return te.priority-Y.priority}}(function(){const j=new Map,Y=new Map,te=new Map,fe=new Map,_e=We=>{te.set(We,!1);const Be=j.get(We)??[];for(Y.set(We,Be),j.set(We,[]),fe.set(We,!0);Be.length>0;)Be.sort(W.sort),Be.shift().execute();fe.set(We,!1)};t.scheduleAtNextAnimationFrame=(We,Be,qe=0)=>{const Ke=(0,t.getWindowId)(We),Ge=new W(Be,qe);let at=j.get(Ke);return at||(at=[],j.set(Ke,at)),at.push(Ge),te.get(Ke)||(te.set(Ke,!0),We.requestAnimationFrame(()=>_e(Ke))),Ge},t.runAtThisOrScheduleAtNextAnimationFrame=(We,Be,qe)=>{const Ke=(0,t.getWindowId)(We);if(fe.get(Ke)){const Ge=new W(Be,qe);let at=Y.get(Ke);return at||(at=[],Y.set(Ke,at)),at.push(Ge),Ge}else return(0,t.scheduleAtNextAnimationFrame)(We,Be,qe)}})();function M(j,Y){return(0,t.scheduleAtNextAnimationFrame)(j,Y,1e4)}function G(j,Y){return(0,t.scheduleAtNextAnimationFrame)(j,Y,-1e4)}const K=8,ae=function(j,Y){return Y};class ie extends b.Disposable{constructor(Y,te,fe,_e=ae,We=K){super();let Be=null,qe=0;const Ke=this._register(new _.TimeoutTimer),Ge=()=>{qe=new Date().getTime(),fe(Be),Be=null};this._register(C(Y,te,at=>{Be=_e(Be,at);const Nt=new Date().getTime()-qe;Nt>=We?(Ke.cancel(),Ge()):Ke.setIfNotSet(Ge,We-Nt)}))}}function ee(j,Y,te,fe,_e){return new ie(j,Y,te,fe,_e)}function ce(j){return(0,t.getWindow)(j).getComputedStyle(j,null)}function Ee(j,Y){const te=(0,t.getWindow)(j),fe=te.document;if(j!==fe.body)return new Pe(j.clientWidth,j.clientHeight);if(c.isIOS&&te?.visualViewport)return new Pe(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Pe(te.innerWidth,te.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Pe(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Pe(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(Y)return Ee(Y);throw new Error("Unable to figure out browser width and height")}class Se{static convertToPixels(Y,te){return parseFloat(te)||0}static getDimension(Y,te,fe){const _e=ce(Y),We=_e?_e.getPropertyValue(te):"0";return Se.convertToPixels(Y,We)}static getBorderLeftWidth(Y){return Se.getDimension(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return Se.getDimension(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return Se.getDimension(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return Se.getDimension(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return Se.getDimension(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return Se.getDimension(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return Se.getDimension(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return Se.getDimension(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return Se.getDimension(Y,"margin-left","marginLeft")}static getMarginTop(Y){return Se.getDimension(Y,"margin-top","marginTop")}static getMarginRight(Y){return Se.getDimension(Y,"margin-right","marginRight")}static getMarginBottom(Y){return Se.getDimension(Y,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(Y,te){this.width=Y,this.height=te}with(Y=this.width,te=this.height){return Y!==this.width||te!==this.height?new Pe(Y,te):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof Pe?Y:new Pe(Y.width,Y.height)}static equals(Y,te){return Y===te?!0:!Y||!te?!1:Y.width===te.width&&Y.height===te.height}}t.Dimension=Pe;function le(j){let Y=j.offsetParent,te=j.offsetTop,fe=j.offsetLeft;for(;(j=j.parentNode)!==null&&j!==j.ownerDocument.body&&j!==j.ownerDocument.documentElement;){te-=j.scrollTop;const _e=E(j)?null:ce(j);_e&&(fe-=_e.direction!=="rtl"?j.scrollLeft:-j.scrollLeft),j===Y&&(fe+=Se.getBorderLeftWidth(j),te+=Se.getBorderTopWidth(j),te+=j.offsetTop,fe+=j.offsetLeft,Y=j.offsetParent)}return{left:fe,top:te}}function J(j,Y,te){typeof Y=="number"&&(j.style.width=`${Y}px`),typeof te=="number"&&(j.style.height=`${te}px`)}function he(j,Y,te,fe,_e,We="absolute"){typeof Y=="number"&&(j.style.top=`${Y}px`),typeof te=="number"&&(j.style.right=`${te}px`),typeof fe=="number"&&(j.style.bottom=`${fe}px`),typeof _e=="number"&&(j.style.left=`${_e}px`),j.style.position=We}function re(j){const Y=j.getBoundingClientRect(),te=(0,t.getWindow)(j);return{left:Y.left+te.scrollX,top:Y.top+te.scrollY,width:Y.width,height:Y.height}}function ye(j){let Y=j,te=1;do{const fe=ce(Y).zoom;fe!=null&&fe!=="1"&&(te*=fe),Y=Y.parentElement}while(Y!==null&&Y!==Y.ownerDocument.documentElement);return te}function V(j){const Y=Se.getMarginLeft(j)+Se.getMarginRight(j);return j.offsetWidth+Y}function Q(j){const Y=Se.getBorderLeftWidth(j)+Se.getBorderRightWidth(j),te=Se.getPaddingLeft(j)+Se.getPaddingRight(j);return j.offsetWidth-Y-te}function ge(j){const Y=Se.getMarginLeft(j)+Se.getMarginRight(j);return j.scrollWidth+Y}function De(j){const Y=Se.getBorderTopWidth(j)+Se.getBorderBottomWidth(j),te=Se.getPaddingTop(j)+Se.getPaddingBottom(j);return j.offsetHeight-Y-te}function Ae(j){const Y=Se.getMarginTop(j)+Se.getMarginBottom(j);return j.offsetHeight+Y}function Ie(j,Y){if(j===null)return 0;const te=le(j),fe=le(Y);return te.left-fe.left}function Oe(j,Y){const te=Y.map(_e=>Math.max(ge(_e),V(_e))+Ie(_e,j)||0);return Math.max(...te)}function H(j,Y){return!!Y?.contains(j)}const h="parentFlowToElementId";function y(j,Y){j.dataset[h]=Y.id}function a(j){const Y=j.dataset[h];return typeof Y=="string"?j.ownerDocument.getElementById(Y):null}function w(j,Y){let te=j;for(;te;){if(te===Y)return!0;if(te instanceof HTMLElement){const fe=a(te);if(fe){te=fe;continue}}te=te.parentNode}return!1}function F(j,Y,te){for(;j&&j.nodeType===j.ELEMENT_NODE;){if(j.classList.contains(Y))return j;if(te){if(typeof te=="string"){if(j.classList.contains(te))return null}else if(j===te)return null}j=j.parentNode}return null}function n(j,Y,te){return!!F(j,Y,te)}function E(j){return j&&!!j.host&&!!j.mode}function D(j){return!!k(j)}function k(j){for(;j.parentNode;){if(j===j.ownerDocument?.body)return null;j=j.parentNode}return E(j)?j:null}function R(){let j=ve().activeElement;for(;j?.shadowRoot;)j=j.shadowRoot.activeElement;return j}function U(j){return R()===j}function Z(j){return H(R(),j)}function oe(j){return j.ownerDocument===ve()}function ve(){return(0,t.getWindowsCount)()<=1?s.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:Y})=>Y.document).find(Y=>Y.hasFocus())??s.mainWindow.document}function de(){return ve().defaultView?.window??s.mainWindow}const ke=new Map;function Te(j){return ke.has(j)}function Me(){return new Ce}class Ce{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(Y){Y!==this._currentCssStyle&&(this._currentCssStyle=Y,this._styleSheet?this._styleSheet.innerText=Y:this._styleSheet=Ne(s.mainWindow.document.head,te=>te.innerText=Y))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function Ne(j=s.mainWindow.document.head,Y,te){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",Y?.(fe),j.appendChild(fe),te&&te.add((0,b.toDisposable)(()=>j.removeChild(fe))),j===s.mainWindow.document.head){const _e=new Set;ke.set(fe,_e);for(const{window:We,disposables:Be}of(0,t.getWindows)()){if(We===s.mainWindow)continue;const qe=Be.add(Ye(fe,_e,We));te?.add(qe)}}return fe}function Ve(j){const Y=new b.DisposableStore;for(const[te,fe]of ke)Y.add(Ye(te,fe,j));return Y}function Ye(j,Y,te){const fe=new b.DisposableStore,_e=j.cloneNode(!0);te.document.head.appendChild(_e),fe.add((0,b.toDisposable)(()=>te.document.head.removeChild(_e)));for(const We of we(j))_e.sheet?.insertRule(We.cssText,_e.sheet?.cssRules.length);return fe.add(t.sharedMutationObserver.observe(j,fe,{childList:!0})(()=>{_e.textContent=j.textContent})),Y.add(_e),fe.add((0,b.toDisposable)(()=>Y.delete(_e))),fe}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe(j,Y,te){let fe=this.mutationObservers.get(j);fe||(fe=new Map,this.mutationObservers.set(j,fe));const _e=(0,e.hash)(te);let We=fe.get(_e);if(We)We.users+=1;else{const Be=new f.Emitter,qe=new MutationObserver(Ge=>Be.fire(Ge));qe.observe(j,te);const Ke=We={users:1,observer:qe,onDidMutate:Be.event};Y.add((0,b.toDisposable)(()=>{Ke.users-=1,Ke.users===0&&(Be.dispose(),qe.disconnect(),fe?.delete(_e),fe?.size===0&&this.mutationObservers.delete(j))})),fe.set(_e,We)}return We.onDidMutate}};function Ue(j=s.mainWindow.document.head){return X("meta",j)}function Je(j=s.mainWindow.document.head){return X("link",j)}function X(j,Y=s.mainWindow.document.head){const te=document.createElement(j);return Y.appendChild(te),te}let se=null;function be(){return se||(se=Ne()),se}function we(j){return j?.sheet?.rules?j.sheet.rules:j?.sheet?.cssRules?j.sheet.cssRules:[]}function Le(j,Y,te=be()){if(!(!te||!Y)){te.sheet?.insertRule(`${j} {${Y}}`,0);for(const fe of ke.get(te)??[])Le(j,Y,fe)}}function He(j,Y=be()){if(!Y)return;const te=we(Y),fe=[];for(let _e=0;_e<te.length;_e++){const We=te[_e];$e(We)&&We.selectorText.indexOf(j)!==-1&&fe.push(_e)}for(let _e=fe.length-1;_e>=0;_e--)Y.sheet?.deleteRule(fe[_e]);for(const _e of ke.get(Y)??[])He(j,_e)}function $e(j){return typeof j.selectorText=="string"}function et(j){return j instanceof MouseEvent||j instanceof(0,t.getWindow)(j).MouseEvent}function it(j){return j instanceof KeyboardEvent||j instanceof(0,t.getWindow)(j).KeyboardEvent}function nt(j){return j instanceof PointerEvent||j instanceof(0,t.getWindow)(j).PointerEvent}function Qe(j){return j instanceof DragEvent||j instanceof(0,t.getWindow)(j).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"};function rt(j){const Y=j;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.EventHelper={stop:(j,Y)=>(j.preventDefault(),Y&&j.stopPropagation(),j)};function tt(j){const Y=[];for(let te=0;j&&j.nodeType===j.ELEMENT_NODE;te++)Y[te]=j.scrollTop,j=j.parentNode;return Y}function mt(j,Y){for(let te=0;j&&j.nodeType===j.ELEMENT_NODE;te++)j.scrollTop!==Y[te]&&(j.scrollTop=Y[te]),j=j.parentNode}class gt extends b.Disposable{static hasFocusWithin(Y){if(Y instanceof HTMLElement){const te=k(Y),fe=te?te.activeElement:Y.ownerDocument.activeElement;return H(fe,Y)}else{const te=Y;return H(te.document.activeElement,te.document)}}constructor(Y){super(),this._onDidFocus=this._register(new f.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new f.Emitter),this.onDidBlur=this._onDidBlur.event;let te=gt.hasFocusWithin(Y),fe=!1;const _e=()=>{fe=!1,te||(te=!0,this._onDidFocus.fire())},We=()=>{te&&(fe=!0,(Y instanceof HTMLElement?(0,t.getWindow)(Y):Y).setTimeout(()=>{fe&&(fe=!1,te=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{gt.hasFocusWithin(Y)!==te&&(te?We():_e())},this._register(C(Y,t.EventType.FOCUS,_e,!0)),this._register(C(Y,t.EventType.BLUR,We,!0)),Y instanceof HTMLElement&&(this._register(C(Y,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(C(Y,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function _t(j){return new gt(j)}function At(j,Y){return j.after(Y),Y}function Tt(j,...Y){if(j.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}function xe(j,Y){return j.insertBefore(Y,j.firstChild),Y}function ue(j,...Y){j.innerText="",Tt(j,...Y)}const Fe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Re;(function(j){j.HTML="http://www.w3.org/1999/xhtml",j.SVG="http://www.w3.org/2000/svg"})(Re||(t.Namespace=Re={}));function je(j,Y,te,...fe){const _e=Fe.exec(Y);if(!_e)throw new Error("Bad use of emmet");const We=_e[1]||"div";let Be;return j!==Re.HTML?Be=document.createElementNS(j,We):Be=document.createElement(We),_e[3]&&(Be.id=_e[3]),_e[4]&&(Be.className=_e[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Be[qe]=Ke:qe==="selected"?Ke&&Be.setAttribute(qe,"true"):Be.setAttribute(qe,Ke))}),Be.append(...fe),Be}function st(j,Y,...te){return je(Re.HTML,j,Y,...te)}st.SVG=function(j,Y,...te){return je(Re.SVG,j,Y,...te)};function lt(j,Y){const te=[];return j.forEach((fe,_e)=>{_e>0&&(Y instanceof Node?te.push(Y.cloneNode()):te.push(document.createTextNode(Y))),te.push(fe)}),te}function Xe(j,...Y){j?ht(...Y):bt(...Y)}function ht(...j){for(const Y of j)Y.style.display="",Y.removeAttribute("aria-hidden")}function bt(...j){for(const Y of j)Y.style.display="none",Y.setAttribute("aria-hidden","true")}function It(j,Y){for(;j&&j.nodeType===j.ELEMENT_NODE;){if(j instanceof HTMLElement&&j.hasAttribute(Y))return j;j=j.parentNode}return null}function Yt(j){!j||!j.hasAttribute("tabIndex")||(j.ownerDocument.activeElement===j&&It(j.parentElement,"tabIndex")?.focus(),j.removeAttribute("tabindex"))}function Ci(j){return Y=>{Y.preventDefault(),Y.stopPropagation(),j(Y)}}function _i(j){return new Promise(Y=>{if(j.document.readyState==="complete"||j.document&&j.document.body!==null)Y(void 0);else{const fe=()=>{j.window.removeEventListener("DOMContentLoaded",fe,!1),Y()};j.window.addEventListener("DOMContentLoaded",fe,!1)}})}function Ai(j,Y){const te=j.devicePixelRatio*Y;return Math.max(1,Math.floor(te))/j.devicePixelRatio}function Ti(j){s.mainWindow.open(j,"_blank","noopener")}const Xt=780,Zt=640;function Ii(j){const Y=Math.floor(s.mainWindow.screenLeft+s.mainWindow.innerWidth/2-Xt/2),te=Math.floor(s.mainWindow.screenTop+s.mainWindow.innerHeight/2-Zt/2);s.mainWindow.open(j,"_blank",`width=${Xt},height=${Zt},top=${te},left=${Y}`)}function Ni(j,Y=!0){const te=s.mainWindow.open();return te?(Y&&(te.opener=null),te.location.href=j,!0):!1}function Fi(j,Y){const te=()=>{Y(),fe=(0,t.scheduleAtNextAnimationFrame)(j,te)};let fe=(0,t.scheduleAtNextAnimationFrame)(j,te);return(0,b.toDisposable)(()=>fe.dispose())}B.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(s.mainWindow.location.href)?"https":"http");function Li(j){return j?`url('${B.FileAccess.uriToBrowserUri(j).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function ki(j){return`'${j.replace(/'/g,"%27")}'`}function Qt(j,Y){if(j!==void 0){const te=j.match(/^\s*var\((.+)\)$/);if(te){const fe=te[1].split(",",2);return fe.length===2&&(Y=Qt(fe[1].trim(),Y)),`var(${fe[0]}, ${Y})`}return j}return Y}function Pi(j,Y){let te;if(u.URI.isUri(j))te=j.toString(!0);else{const We=new Blob([j]);te=URL.createObjectURL(We),setTimeout(()=>URL.revokeObjectURL(te))}const fe=de(),_e=document.createElement("a");fe.document.body.appendChild(_e),_e.download=Y,_e.href=te,_e.click(),setTimeout(()=>fe.document.body.removeChild(_e))}function Oi(){return new Promise(j=>{const Y=de(),te=document.createElement("input");Y.document.body.appendChild(te),te.type="file",te.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(te,"input"))(()=>{j(te.files??void 0)}),te.click(),setTimeout(()=>Y.document.body.removeChild(te))})}var yt;(function(j){j[j.DOCUMENT=1]="DOCUMENT",j[j.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Ri(j){return j.document.fullscreenElement||j.document.webkitFullscreenElement||j.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:j.innerHeight===j.screen.height?{mode:yt.BROWSER,guess:!1}:(c.isMacintosh||c.isLinux)&&j.outerHeight===j.screen.height&&j.outerWidth===j.screen.width?{mode:yt.BROWSER,guess:!0}:null}function Jt(j,Y=!1){const te=document.createElement("a");return g.addHook("afterSanitizeAttributes",fe=>{for(const _e of["href","src"])if(fe.hasAttribute(_e)){const We=fe.getAttribute(_e);if(_e==="href"&&We.startsWith("#"))continue;if(te.href=We,!j.includes(te.protocol.replace(/:$/,""))){if(Y&&_e==="src"&&te.href.startsWith("data:"))continue;fe.removeAttribute(_e)}}}),(0,b.toDisposable)(()=>{g.removeHook("afterSanitizeAttributes")})}const Mi=[B.Schemas.http,B.Schemas.https,B.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Bi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function xi(j,Y){const te=Jt(Mi);try{const fe=g.sanitize(Y,Bi);j.innerHTML=fe}finally{te.dispose()}}function Wi(j){const Y=new Uint16Array(j.length);for(let _e=0;_e<Y.length;_e++)Y[_e]=j.charCodeAt(_e);let te="";const fe=new Uint8Array(Y.buffer);for(let _e=0;_e<fe.length;_e++)te+=String.fromCharCode(fe[_e]);return te}function Hi(j){return btoa(Wi(j))}class vt extends f.Emitter{constructor(){super(),this._subscriptions=new b.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(f.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Y,disposables:te})=>this.registerListeners(Y,te),{window:s.mainWindow,disposables:this._subscriptions}))}registerListeners(Y,te){te.add(C(Y,"keydown",fe=>{if(fe.defaultPrevented)return;const _e=new x.StandardKeyboardEvent(fe);if(!(_e.keyCode===6&&fe.repeat)){if(fe.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(fe.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(fe.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(fe.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(_e.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=fe.altKey,this._keyStatus.ctrlKey=fe.ctrlKey,this._keyStatus.metaKey=fe.metaKey,this._keyStatus.shiftKey=fe.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=fe,this.fire(this._keyStatus))}},!0)),te.add(C(Y,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!fe.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!fe.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!fe.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=fe.altKey,this._keyStatus.ctrlKey=fe.ctrlKey,this._keyStatus.metaKey=fe.metaKey,this._keyStatus.shiftKey=fe.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=fe,this.fire(this._keyStatus)))},!0)),te.add(C(Y.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),te.add(C(Y.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),te.add(C(Y.document.body,"mousemove",fe=>{fe.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),te.add(C(Y,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return vt.instance||(vt.instance=new vt),vt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=vt;function zi(j){const Y=document.cookie.match("(^|[^;]+)\\s*"+j+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}class Vi extends b.Disposable{constructor(Y,te){super(),this.element=Y,this.callbacks=te,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(C(this.element,t.EventType.DRAG_START,Y=>{this.callbacks.onDragStart?.(Y)})),this.callbacks.onDrag&&this._register(C(this.element,t.EventType.DRAG,Y=>{this.callbacks.onDrag?.(Y)})),this._register(C(this.element,t.EventType.DRAG_ENTER,Y=>{this.counter++,this.dragStartTime=Y.timeStamp,this.callbacks.onDragEnter?.(Y)})),this._register(C(this.element,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.callbacks.onDragOver?.(Y,Y.timeStamp-this.dragStartTime)})),this._register(C(this.element,t.EventType.DRAG_LEAVE,Y=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(Y))})),this._register(C(this.element,t.EventType.DRAG_END,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(Y)})),this._register(C(this.element,t.EventType.DROP,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(Y)}))}}t.DragAndDropObserver=Vi;const $i=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(j,...Y){let te,fe;Array.isArray(Y[0])?(te={},fe=Y[0]):(te=Y[0]||{},fe=Y[1]);const _e=$i.exec(j);if(!_e||!_e.groups)throw new Error("Bad use of h");const We=_e.groups.tag||"div",Be=document.createElement(We);_e.groups.id&&(Be.id=_e.groups.id);const qe=[];if(_e.groups.class)for(const Ge of _e.groups.class.split("."))Ge!==""&&qe.push(Ge);if(te.className!==void 0)for(const Ge of te.className.split("."))Ge!==""&&qe.push(Ge);qe.length>0&&(Be.className=qe.join(" "));const Ke={};if(_e.groups.name&&(Ke[_e.groups.name]=Be),fe)for(const Ge of fe)Ge instanceof HTMLElement?Be.appendChild(Ge):typeof Ge=="string"?Be.append(Ge):"root"in Ge&&(Object.assign(Ke,Ge),Be.appendChild(Ge.root));for(const[Ge,at]of Object.entries(te))if(Ge!=="className")if(Ge==="style")for(const[Nt,Bt]of Object.entries(at))Be.style.setProperty(ei(Nt),typeof Bt=="number"?Bt+"px":""+Bt);else Ge==="tabIndex"?Be.tabIndex=at:Be.setAttribute(ei(Ge),at.toString());return Ke.root=Be,Ke}function ei(j){return j.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(j,Y,te){for(const{name:fe,value:_e}of j.attributes)(!te||te.includes(fe))&&Y.setAttribute(fe,_e)}function Ki(j,Y,te){const fe=j.getAttribute(te);fe?Y.setAttribute(te,fe):Y.removeAttribute(te)}function ji(j,Y,te){ti(j,Y,te);const fe=new b.DisposableStore;return fe.add(t.sharedMutationObserver.observe(j,fe,{attributes:!0,attributeFilter:te})(_e=>{for(const We of _e)We.type==="attributes"&&We.attributeName&&Ki(j,Y,We.attributeName)})),fe}}),define(me[65],pe([1,0,4,2,128]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=_;class z extends N.Disposable{constructor(f,g){super(),this._register((0,i.addDisposableListener)(f,"dragover",b=>{b.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{g(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(b=>{this._register((0,i.addDisposableListener)(f,b,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=z,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:x.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function _(T,f,g,b,B){const c=document.createElement("div");if(c.className=g,c.textContent=f,B&&(c.style.color=B),b&&(c.style.background=b),T.dataTransfer){const u=(0,i.getWindow)(T).document;u.body.appendChild(c),T.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>u.body.removeChild(c),0)}}}),define(me[66],pe([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=N,t.renderFormattedText=x,t.createElement=z;function N(c,u={}){const e=z(u);return e.textContent=c,e}function x(c,u={}){const e=z(u);return f(e,g(c,!!u.renderCodeSegments),u.actionHandler,u.renderCodeSegments),e}function z(c){const u=c.inline?"span":"div",e=document.createElement(u);return c.className&&(e.className=c.className),e}class _{constructor(u){this.source=u,this.index=0}eos(){return this.index>=this.source.length}next(){const u=this.peek();return this.advance(),u}peek(){return this.source[this.index]}advance(){this.index++}}var T;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(T||(T={}));function f(c,u,e,s){let o;if(u.type===2)o=document.createTextNode(u.content||"");else if(u.type===3)o=document.createElement("b");else if(u.type===4)o=document.createElement("i");else if(u.type===7&&s)o=document.createElement("code");else if(u.type===5&&e){const l=document.createElement("a");e.disposables.add(i.addStandardDisposableListener(l,"click",d=>{e.callback(String(u.index),d)})),o=l}else u.type===8?o=document.createElement("br"):u.type===1&&(o=c);o&&c!==o&&c.appendChild(o),o&&Array.isArray(u.children)&&u.children.forEach(l=>{f(o,l,e,s)})}function g(c,u){const e={type:1,children:[]};let s=0,o=e;const l=[],d=new _(c);for(;!d.eos();){let C=d.next();const m=C==="\\"&&B(d.peek(),u)!==0;if(m&&(C=d.next()),!m&&b(C,u)&&C===d.peek()){d.advance(),o.type===2&&(o=l.pop());const p=B(C,u);if(o.type===p||o.type===5&&p===6)o=l.pop();else{const r={type:p,children:[]};p===5&&(r.index=s,s++),o.children.push(r),l.push(o),o=r}}else if(C===`
`)o.type===2&&(o=l.pop()),o.children.push({type:8});else if(o.type!==2){const p={type:2,content:C};o.children.push(p),l.push(o),o=p}else o.content+=C}return o.type===2&&(o=l.pop()),l.length,e}function b(c,u){return B(c,u)!==0}function B(c,u){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return u?7:0;default:return 0}}}),define(me[67],pe([1,0,4,2]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class x{constructor(){this._hooks=new N.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(_,T){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const f=this._onStopCallback;this._onStopCallback=null,_&&f&&f(T)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(_,T,f,g,b){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=g,this._onStopCallback=b;let B=_;try{_.setPointerCapture(T),this._hooks.add((0,N.toDisposable)(()=>{try{_.releasePointerCapture(T)}catch{}}))}catch{B=i.getWindow(_)}this._hooks.add(i.addDisposableListener(B,i.EventType.POINTER_MOVE,c=>{if(c.buttons!==f){this.stopMonitoring(!0);return}c.preventDefault(),this._pointerMoveCallback(c)})),this._hooks.add(i.addDisposableListener(B,i.EventType.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=x});var Ze=this&&this.__decorate||function(ne,t,i,N){var x=arguments.length,z=x<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,i):N,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(ne,t,i,N);else for(var T=ne.length-1;T>=0;T--)(_=ne[T])&&(z=(x<3?_(z):x>3?_(t,i,z):_(t,i))||z);return x>3&&z&&Object.defineProperty(t,i,z),z};define(me[28],pe([1,0,4,22,8,31,3,2,55]),function(ne,t,i,N,x,z,_,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var g;(function(B){B.Tap="-monaco-gesturetap",B.Change="-monaco-gesturechange",B.Start="-monaco-gesturestart",B.End="-monaco-gesturesend",B.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class b extends T.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new f.LinkedList,this.ignoreTargets=new f.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(_.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:u})=>{u.add(i.addDisposableListener(c.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),u.add(i.addDisposableListener(c.document,"touchend",e=>this.onTouchEnd(c,e))),u.add(i.addDisposableListener(c.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:N.mainWindow,disposables:this._store}))}static addTarget(c){if(!b.isTouchDevice())return T.Disposable.None;b.INSTANCE||(b.INSTANCE=(0,T.markAsSingleton)(new b));const u=b.INSTANCE.targets.push(c);return(0,T.toDisposable)(u)}static ignoreTarget(c){if(!b.isTouchDevice())return T.Disposable.None;b.INSTANCE||(b.INSTANCE=(0,T.markAsSingleton)(new b));const u=b.INSTANCE.ignoreTargets.push(c);return(0,T.toDisposable)(u)}static isTouchDevice(){return"ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(c){const u=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,s=c.targetTouches.length;e<s;e++){const o=c.targetTouches.item(e);this.activeTouches[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:u,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[u],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const l=this.newGestureEvent(g.Start,o.target);l.pageX=o.pageX,l.pageY=o.pageY,this.dispatchEvent(l)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}onTouchEnd(c,u){const e=Date.now(),s=Object.keys(this.activeTouches).length;for(let o=0,l=u.changedTouches.length;o<l;o++){const d=u.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(d.identifier))){console.warn("move of an UNKNOWN touch",d);continue}const C=this.activeTouches[d.identifier],m=Date.now()-C.initialTimeStamp;if(m<b.HOLD_DELAY&&Math.abs(C.initialPageX-x.tail(C.rollingPageX))<30&&Math.abs(C.initialPageY-x.tail(C.rollingPageY))<30){const p=this.newGestureEvent(g.Tap,C.initialTarget);p.pageX=x.tail(C.rollingPageX),p.pageY=x.tail(C.rollingPageY),this.dispatchEvent(p)}else if(m>=b.HOLD_DELAY&&Math.abs(C.initialPageX-x.tail(C.rollingPageX))<30&&Math.abs(C.initialPageY-x.tail(C.rollingPageY))<30){const p=this.newGestureEvent(g.Contextmenu,C.initialTarget);p.pageX=x.tail(C.rollingPageX),p.pageY=x.tail(C.rollingPageY),this.dispatchEvent(p)}else if(s===1){const p=x.tail(C.rollingPageX),r=x.tail(C.rollingPageY),S=x.tail(C.rollingTimestamps)-C.rollingTimestamps[0],A=p-C.rollingPageX[0],I=r-C.rollingPageY[0],P=[...this.targets].filter($=>C.initialTarget instanceof Node&&$.contains(C.initialTarget));this.inertia(c,P,e,Math.abs(A)/S,A>0?1:-1,p,Math.abs(I)/S,I>0?1:-1,r)}this.dispatchEvent(this.newGestureEvent(g.End,C.initialTarget)),delete this.activeTouches[d.identifier]}this.dispatched&&(u.preventDefault(),u.stopPropagation(),this.dispatched=!1)}newGestureEvent(c,u){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=u,e.tapCount=0,e}dispatchEvent(c){if(c.type===g.Tap){const u=new Date().getTime();let e=0;u-this._lastSetTapCountTime>b.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=u,c.tapCount=e}else(c.type===g.Change||c.type===g.Contextmenu)&&(this._lastSetTapCountTime=0);if(c.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(c.initialTarget))return;const u=[];for(const e of this.targets)if(e.contains(c.initialTarget)){let s=0,o=c.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;u.push([s,e])}u.sort((e,s)=>e[0]-s[0]);for(const[e,s]of u)s.dispatchEvent(c),this.dispatched=!0}}inertia(c,u,e,s,o,l,d,C,m){this.handle=i.scheduleAtNextAnimationFrame(c,()=>{const p=Date.now(),r=p-e;let S=0,A=0,I=!0;s+=b.SCROLL_FRICTION*r,d+=b.SCROLL_FRICTION*r,s>0&&(I=!1,S=o*s*r),d>0&&(I=!1,A=C*d*r);const P=this.newGestureEvent(g.Change);P.translationX=S,P.translationY=A,u.forEach($=>$.dispatchEvent(P)),I||this.inertia(c,u,p,s,o,l+S,d,C,m+A)})}onTouchMove(c){const u=Date.now();for(let e=0,s=c.changedTouches.length;e<s;e++){const o=c.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const l=this.activeTouches[o.identifier],d=this.newGestureEvent(g.Change,l.initialTarget);d.translationX=o.pageX-x.tail(l.rollingPageX),d.translationY=o.pageY-x.tail(l.rollingPageY),d.pageX=o.pageX,d.pageY=o.pageY,this.dispatchEvent(d),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(o.pageX),l.rollingPageY.push(o.pageY),l.rollingTimestamps.push(u)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}}t.Gesture=b,Ze([z.memoize],b,"isTouchDevice",null)}),define(me[68],pe([1,0,4,104]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=g,t.alert=b,t.status=B;const N=2e4;let x,z,_,T,f;function g(u){x=document.createElement("div"),x.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),x.appendChild(o),o};z=e(),_=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),x.appendChild(o),o};T=s(),f=s(),u.appendChild(x)}function b(u){x&&(z.textContent!==u?(i.clearNode(_),c(z,u)):(i.clearNode(z),c(_,u)))}function B(u){x&&(T.textContent!==u?(i.clearNode(f),c(T,u)):(i.clearNode(T),c(f,u)))}function c(u,e){i.clearNode(u),e.length>N&&(e=e.substr(0,N)),u.textContent=e,u.style.visibility="hidden",u.style.visibility="visible"}}),define(me[130],pe([1,0,4,19]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=z,t.renderIcon=_;const x=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function z(T){const f=new Array;let g,b=0,B=0;for(;(g=x.exec(T))!==null;){B=g.index||0,b<B&&f.push(T.substring(b,B)),b=(g.index||0)+g[0].length;const[,c,u]=g;f.push(c?`$(${u})`:_({id:u}))}return b<T.length&&f.push(T.substring(b)),f}function _(T){const f=i.$("span");return f.classList.add(...N.ThemeIcon.asClassNameArray(T)),f}}),define(me[131],pe([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function N(z){try{z.parentElement?.removeChild(z)}catch{}}class x{constructor(_){this.renderers=_,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(_){let T=this.getTemplateCache(_).pop(),f=!1;if(T)f=this.transactionNodesPendingRemoval.has(T.domNode),f&&this.transactionNodesPendingRemoval.delete(T.domNode);else{const g=(0,i.$)(".monaco-list-row"),B=this.getRenderer(_).renderTemplate(g);T={domNode:g,templateId:_,templateData:B}}return{row:T,isReusingConnectedDomNode:f}}release(_){_&&this.releaseRow(_)}transact(_){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{_()}finally{for(const T of this.transactionNodesPendingRemoval)this.doRemoveNode(T);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(_){const{domNode:T,templateId:f}=_;T&&(this.inTransaction?this.transactionNodesPendingRemoval.add(T):this.doRemoveNode(T)),this.getTemplateCache(f).push(_)}doRemoveNode(_){_.classList.remove("scrolling"),N(_)}getTemplateCache(_){let T=this.cache.get(_);return T||(T=[],this.cache.set(_,T)),T}dispose(){this.cache.forEach((_,T)=>{for(const f of _)this.getRenderer(T).disposeTemplate(f.templateData),f.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(_){const T=this.renderers.get(_);if(!T)throw new Error(`No renderer found for ${_}`);return T}}t.RowCache=x}),define(me[132],pe([1,0,11,2]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class x extends N.Disposable{constructor(_,T,f){super(),this._visibility=_,this._visibleClassName=T,this._invisibleClassName=f,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new i.TimeoutTimer)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this._updateShouldBeVisible())}setShouldBeVisible(_){this._rawShouldBeVisible=_,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const _=this._applyVisibilitySetting();this._shouldBeVisible!==_&&(this._shouldBeVisible=_,this.ensureVisibility())}setIsNeeded(_){this._isNeeded!==_&&(this._isNeeded=_,this.ensureVisibility())}setDomNode(_){this._domNode=_,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(_){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(_?" fade":"")))}}t.ScrollbarVisibilityController=x}),define(me[133],pe([1,0,4,28,8,3,2,5]),function(ne,t,i,N,x,z,_,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class f extends _.Disposable{constructor(b,B,c,u){super(),this.selected=0,this.selectBoxOptions=u||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new z.Emitter),this.styles=c,this.registerListeners(),this.setOptions(b,B)}registerListeners(){this._register(N.Gesture.addTarget(this.selectElement)),[N.EventType.Tap].forEach(b=>{this._register(i.addDisposableListener(this.selectElement,b,B=>{this.selectElement.focus()}))}),this._register(i.addStandardDisposableListener(this.selectElement,"click",b=>{i.EventHelper.stop(b,!0)})),this._register(i.addStandardDisposableListener(this.selectElement,"change",b=>{this.selectElement.title=b.target.value,this._onDidSelect.fire({index:b.target.selectedIndex,selected:b.target.value})})),this._register(i.addStandardDisposableListener(this.selectElement,"keydown",b=>{let B=!1;T.isMacintosh?(b.keyCode===18||b.keyCode===16||b.keyCode===10)&&(B=!0):(b.keyCode===18&&b.altKey||b.keyCode===10||b.keyCode===3)&&(B=!0),B&&b.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(b,B){(!this.options||!x.equals(this.options,b))&&(this.options=b,this.selectElement.options.length=0,this.options.forEach((c,u)=>{this.selectElement.add(this.createOption(c.text,u,c.isDisabled))})),B!==void 0&&this.select(B)}select(b){this.options.length===0?this.selected=0:b>=0&&b<this.options.length?this.selected=b:b>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(b){this.selectBoxOptions.ariaLabel=b,this.selectElement.setAttribute("aria-label",b)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(b){this.selectElement.tabIndex=b?0:-1}render(b){b.classList.add("select-container"),b.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(b){this.styles=b,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(b,B,c){const u=document.createElement("option");return u.value=b,u.text=b,u.disabled=!!c,u}}t.SelectBoxNative=f}),define(me[69],pe([1,0,30,8,11,60,98,3,32]),function(ne,t,i,N,x,z,_,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=g,t.getVisibleState=b;function g(u){return typeof u=="object"&&"visibility"in u&&"data"in u}function b(u){switch(u){case!0:return 1;case!1:return 0;default:return u}}function B(u){return typeof u.collapsible=="boolean"}class c{constructor(e,s,o,l={}){this.user=e,this.list=s,this.rootRef=[],this.eventBufferer=new T.EventBufferer,this._onDidChangeCollapseState=new T.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new T.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new T.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new x.Delayer(z.MicrotaskDelay),this.collapseByDefault=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.allowNonCollapsibleParents=l.allowNonCollapsibleParents??!1,this.filter=l.filter,this.autoExpandSingleChildren=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.root={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,o=f.Iterable.empty(),l={}){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");l.diffIdentityProvider?this.spliceSmart(l.diffIdentityProvider,e,s,o,l):this.spliceSimple(e,s,o,l)}spliceSmart(e,s,o,l=f.Iterable.empty(),d,C=d.diffDepth??0){const{parentNode:m}=this.getParentNodeWithListIndex(s);if(!m.lastDiffIds)return this.spliceSimple(s,o,l,d);const p=[...l],r=s[s.length-1],S=new _.LcsDiff({getElements:()=>m.lastDiffIds},{getElements:()=>[...m.children.slice(0,r),...p,...m.children.slice(r+o)].map(v=>e.getId(v.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return m.lastDiffIds=void 0,this.spliceSimple(s,o,p,d);const A=s.slice(0,-1),I=(v,O,q)=>{if(C>0)for(let L=0;L<q;L++)v--,O--,this.spliceSmart(e,[...A,v,0],Number.MAX_SAFE_INTEGER,p[O].children,d,C-1)};let P=Math.min(m.children.length,r+o),$=p.length;for(const v of S.changes.sort((O,q)=>q.originalStart-O.originalStart))I(P,$,P-(v.originalStart+v.originalLength)),P=v.originalStart,$=v.modifiedStart-r,this.spliceSimple([...A,P],v.originalLength,f.Iterable.slice(p,$,$+v.modifiedLength),d);I(P,$,P)}spliceSimple(e,s,o=f.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:d,diffIdentityProvider:C}){const{parentNode:m,listIndex:p,revealed:r,visible:S}=this.getParentNodeWithListIndex(e),A=[],I=f.Iterable.map(o,G=>this.createTreeNode(G,m,m.visible?1:0,r,A,l)),P=e[e.length-1];let $=0;for(let G=P;G>=0&&G<m.children.length;G--){const K=m.children[G];if(K.visible){$=K.visibleChildIndex;break}}const v=[];let O=0,q=0;for(const G of I)v.push(G),q+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=$+O++);const L=(0,N.splice)(m.children,P,s,v);C?m.lastDiffIds?(0,N.splice)(m.lastDiffIds,P,s,v.map(G=>C.getId(G.element).toString())):m.lastDiffIds=m.children.map(G=>C.getId(G.element).toString()):m.lastDiffIds=void 0;let W=0;for(const G of L)G.visible&&W++;if(W!==0)for(let G=P+v.length;G<m.children.length;G++){const K=m.children[G];K.visible&&(K.visibleChildIndex-=W)}if(m.visibleChildrenCount+=O-W,r&&S){const G=L.reduce((K,ae)=>K+(ae.visible?ae.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(m,q-G),this.list.splice(p,G,A)}if(L.length>0&&d){const G=K=>{d(K),K.children.forEach(G)};L.forEach(G)}this._onDidSplice.fire({insertedNodes:v,deletedNodes:L});let M=m;for(;M;){if(M.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}M=M.parent}}rerender(e){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:o,revealed:l}=this.getTreeNodeWithListIndex(e);s.visible&&l&&this.list.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.TreeError(this.user,"Invalid tree location");const{listIndex:o}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(o,s)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:l}=this.getTreeNodeWithListIndex(e);return o&&l?s:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,s){const o=this.getTreeNode(e);typeof s>"u"&&(s=!o.collapsible);const l={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,l))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,s,o){const l=this.getTreeNode(e);typeof s>"u"&&(s=!l.collapsed);const d={collapsed:s,recursive:o||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,d))}_setCollapseState(e,s){const{node:o,listIndex:l,revealed:d}=this.getTreeNodeWithListIndex(e),C=this._setListNodeCollapseState(o,l,d,s);if(o!==this.root&&this.autoExpandSingleChildren&&C&&!B(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let m=-1;for(let p=0;p<o.children.length;p++)if(o.children[p].visible)if(m>-1){m=-1;break}else m=p;m>-1&&this._setCollapseState([...e,m],s)}return C}_setListNodeCollapseState(e,s,o,l){const d=this._setNodeCollapseState(e,l,!1);if(!o||!e.visible||!d)return d;const C=e.renderNodeCount,m=this.updateNodeAfterCollapseChange(e),p=C-(s===-1?0:1);return this.list.splice(s+1,p,m.slice(1)),d}_setNodeCollapseState(e,s,o){let l;if(e===this.root?l=!1:(B(s)?(l=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(l=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):l=!1,l&&this._onDidChangeCollapseState.fire({node:e,deep:o})),!B(s)&&s.recursive)for(const d of e.children)l=this._setNodeCollapseState(d,s,!0)||l;return l}expandTo(e){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,s),this.refilterDelayer.cancel()}createTreeNode(e,s,o,l,d,C){const m={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},p=this._filterNode(m,o);m.visibility=p,l&&d.push(m);const r=e.children||f.Iterable.empty(),S=l&&p!==0&&!m.collapsed;let A=0,I=1;for(const P of r){const $=this.createTreeNode(P,m,p,S,d,C);m.children.push($),I+=$.renderNodeCount,$.visible&&($.visibleChildIndex=A++)}return this.allowNonCollapsibleParents||(m.collapsible=m.collapsible||m.children.length>0),m.visibleChildrenCount=A,m.visible=p===2?A>0:p===1,m.visible?m.collapsed||(m.renderNodeCount=I):(m.renderNodeCount=0,l&&d.pop()),C?.(m),m}updateNodeAfterCollapseChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterCollapseChange(e,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterCollapseChange(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(o,s);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const s=e.renderNodeCount,o=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,o),this._updateAncestorsRenderNodeCount(e.parent,o.length-s),o}_updateNodeAfterFilterChange(e,s,o,l=!0){let d;if(e!==this.root){if(d=this._filterNode(e,s),d===0)return e.visible=!1,e.renderNodeCount=0,!1;l&&o.push(e)}const C=o.length;e.renderNodeCount=e===this.root?0:1;let m=!1;if(!e.collapsed||d!==0){let p=0;for(const r of e.children)m=this._updateNodeAfterFilterChange(r,d,o,l&&!e.collapsed)||m,r.visible&&(r.visibleChildIndex=p++);e.visibleChildrenCount=p}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=d===2?m:d===1,e.visibility=d),e.visible?e.collapsed||(e.renderNodeCount+=o.length-C):(e.renderNodeCount=0,l&&o.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,s){const o=this.filter?this.filter.filter(e.element,s):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):g(o)?(e.filterData=o.data,b(o.visibility)):(e.filterData=void 0,b(o))}hasTreeNode(e,s=this.root){if(!e||e.length===0)return!0;const[o,...l]=e;return o<0||o>s.children.length?!1:this.hasTreeNode(l,s.children[o])}getTreeNode(e,s=this.root){if(!e||e.length===0)return s;const[o,...l]=e;if(o<0||o>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");return this.getTreeNode(l,s.children[o])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:l,visible:d}=this.getParentNodeWithListIndex(e),C=e[e.length-1];if(C<0||C>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");const m=s.children[C];return{node:m,listIndex:o,revealed:l,visible:d&&m.visible}}getParentNodeWithListIndex(e,s=this.root,o=0,l=!0,d=!0){const[C,...m]=e;if(C<0||C>s.children.length)throw new i.TreeError(this.user,"Invalid tree location");for(let p=0;p<C;p++)o+=s.children[p].renderNodeCount;return l=l&&!s.collapsed,d=d&&s.visible,m.length===0?{parentNode:s,listIndex:o,revealed:l,visible:d}:this.getParentNodeWithListIndex(m,s.children[C],o+1,l,d)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.tail2)(e)[0]}getFirstElementChild(e){const s=this.getTreeNode(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.getTreeNode(e);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=c}),define(me[134],pe([1,0,69,30,32]),function(ne,t,i,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class z{get size(){return this.nodes.size}constructor(T,f,g={}){this.user=T,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new i.IndexTreeModel(T,f,null,g),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,g.sorter&&(this.sorter={compare(b,B){return g.sorter.compare(b.element,B.element)}}),this.identityProvider=g.identityProvider}setChildren(T,f=x.Iterable.empty(),g={}){const b=this.getElementLocation(T);this._setChildren(b,this.preserveCollapseState(f),g)}_setChildren(T,f=x.Iterable.empty(),g){const b=new Set,B=new Set,c=e=>{if(e.element===null)return;const s=e;if(b.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();B.add(o),this.nodesByIdentity.set(o,s)}g.onDidCreateNode?.(s)},u=e=>{if(e.element===null)return;const s=e;if(b.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const o=this.identityProvider.getId(s.element).toString();B.has(o)||this.nodesByIdentity.delete(o)}g.onDidDeleteNode?.(s)};this.model.splice([...T,0],Number.MAX_VALUE,f,{...g,onDidCreateNode:c,onDidDeleteNode:u})}preserveCollapseState(T=x.Iterable.empty()){return this.sorter&&(T=[...T].sort(this.sorter.compare.bind(this.sorter))),x.Iterable.map(T,f=>{let g=this.nodes.get(f.element);if(!g&&this.identityProvider){const c=this.identityProvider.getId(f.element).toString();g=this.nodesByIdentity.get(c)}if(!g){let c;return typeof f.collapsed>"u"?c=void 0:f.collapsed===N.ObjectTreeElementCollapseState.Collapsed||f.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:f.collapsed===N.ObjectTreeElementCollapseState.Expanded||f.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!f.collapsed,{...f,children:this.preserveCollapseState(f.children),collapsed:c}}const b=typeof f.collapsible=="boolean"?f.collapsible:g.collapsible;let B;return typeof f.collapsed>"u"||f.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||f.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?B=g.collapsed:f.collapsed===N.ObjectTreeElementCollapseState.Collapsed?B=!0:f.collapsed===N.ObjectTreeElementCollapseState.Expanded?B=!1:B=!!f.collapsed,{...f,collapsible:b,collapsed:B,children:this.preserveCollapseState(f.children)}})}rerender(T){const f=this.getElementLocation(T);this.model.rerender(f)}updateElementHeight(T,f){const g=this.getElementLocation(T);this.model.updateElementHeight(g,f)}resort(T=null,f=!0){if(!this.sorter)return;const g=this.getElementLocation(T),b=this.model.getNode(g);this._setChildren(g,this.resortChildren(b,f),{})}resortChildren(T,f,g=!0){let b=[...T.children];return(f||g)&&(b=b.sort(this.sorter.compare.bind(this.sorter))),x.Iterable.map(b,B=>({element:B.element,collapsible:B.collapsible,collapsed:B.collapsed,children:this.resortChildren(B,f,!1)}))}getFirstElementChild(T=null){const f=this.getElementLocation(T);return this.model.getFirstElementChild(f)}getLastElementAncestor(T=null){const f=this.getElementLocation(T);return this.model.getLastElementAncestor(f)}has(T){return this.nodes.has(T)}getListIndex(T){const f=this.getElementLocation(T);return this.model.getListIndex(f)}getListRenderCount(T){const f=this.getElementLocation(T);return this.model.getListRenderCount(f)}isCollapsible(T){const f=this.getElementLocation(T);return this.model.isCollapsible(f)}setCollapsible(T,f){const g=this.getElementLocation(T);return this.model.setCollapsible(g,f)}isCollapsed(T){const f=this.getElementLocation(T);return this.model.isCollapsed(f)}setCollapsed(T,f,g){const b=this.getElementLocation(T);return this.model.setCollapsed(b,f,g)}expandTo(T){const f=this.getElementLocation(T);this.model.expandTo(f)}refilter(){this.model.refilter()}getNode(T=null){if(T===null)return this.model.getNode(this.model.rootRef);const f=this.nodes.get(T);if(!f)throw new N.TreeError(this.user,`Tree element not found: ${T}`);return f}getNodeLocation(T){return T.element}getParentNodeLocation(T){if(T===null)throw new N.TreeError(this.user,"Invalid getParentNodeLocation call");const f=this.nodes.get(T);if(!f)throw new N.TreeError(this.user,`Tree element not found: ${T}`);const g=this.model.getNodeLocation(f),b=this.model.getParentNodeLocation(g);return this.model.getNode(b).element}getElementLocation(T){if(T===null)return[];const f=this.nodes.get(T);if(!f)throw new N.TreeError(this.user,`Tree element not found: ${T}`);return this.model.getNodeLocation(f)}}t.ObjectTreeModel=z}),define(me[21],pe([1,0,4,15,20,28,2]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class T extends _.Disposable{onclick(g,b){this._register(i.addDisposableListener(g,i.EventType.CLICK,B=>b(new x.StandardMouseEvent(i.getWindow(g),B))))}onmousedown(g,b){this._register(i.addDisposableListener(g,i.EventType.MOUSE_DOWN,B=>b(new x.StandardMouseEvent(i.getWindow(g),B))))}onmouseover(g,b){this._register(i.addDisposableListener(g,i.EventType.MOUSE_OVER,B=>b(new x.StandardMouseEvent(i.getWindow(g),B))))}onmouseleave(g,b){this._register(i.addDisposableListener(g,i.EventType.MOUSE_LEAVE,B=>b(new x.StandardMouseEvent(i.getWindow(g),B))))}onkeydown(g,b){this._register(i.addDisposableListener(g,i.EventType.KEY_DOWN,B=>b(new N.StandardKeyboardEvent(B))))}onkeyup(g,b){this._register(i.addDisposableListener(g,i.EventType.KEY_UP,B=>b(new N.StandardKeyboardEvent(B))))}oninput(g,b){this._register(i.addDisposableListener(g,i.EventType.INPUT,b))}onblur(g,b){this._register(i.addDisposableListener(g,i.EventType.BLUR,b))}onfocus(g,b){this._register(i.addDisposableListener(g,i.EventType.FOCUS,b))}onchange(g,b){this._register(i.addDisposableListener(g,i.EventType.CHANGE,b))}ignoreGesture(g){return z.Gesture.ignoreTarget(g)}}t.Widget=T}),define(me[48],pe([1,0,67,21,11,19,4]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class T extends N.Widget{constructor(g){super(),this._onActivate=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this._pointerMoveMonitor=this._register(new i.GlobalPointerMoveMonitor),this._register(_.addStandardDisposableListener(this.bgDomNode,_.EventType.POINTER_DOWN,b=>this._arrowPointerDown(b))),this._register(_.addStandardDisposableListener(this.domNode,_.EventType.POINTER_DOWN,b=>this._arrowPointerDown(b))),this._pointerdownRepeatTimer=this._register(new _.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new x.TimeoutTimer)}_arrowPointerDown(g){if(!g.target||!(g.target instanceof Element))return;const b=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,_.getWindow(g))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(b,200),this._pointerMoveMonitor.startMonitoring(g.target,g.pointerId,g.buttons,B=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),g.preventDefault()}}t.ScrollbarArrow=T}),define(me[70],pe([1,0,4,51,67,48,132,21,5]),function(ne,t,i,N,x,z,_,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const g=140;class b extends T.Widget{constructor(c){super(),this._lazyRender=c.lazyRender,this._host=c.host,this._scrollable=c.scrollable,this._scrollByPage=c.scrollByPage,this._scrollbarState=c.scrollbarState,this._visibilityController=this._register(new _.ScrollbarVisibilityController(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new x.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,N.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(i.addDisposableListener(this.domNode.domNode,i.EventType.POINTER_DOWN,u=>this._domNodePointerDown(u)))}_createArrow(c){const u=this._register(new z.ScrollbarArrow(c));this.domNode.domNode.appendChild(u.bgDomNode),this.domNode.domNode.appendChild(u.domNode)}_createSlider(c,u,e,s){this.slider=(0,N.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(u),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(i.addDisposableListener(this.slider.domNode,i.EventType.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))})),this.onclick(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}_onElementSize(c){return this._scrollbarState.setVisibleSize(c)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(c){return this._scrollbarState.setScrollSize(c)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(c){return this._scrollbarState.setScrollPosition(c)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(c){c.target===this.domNode.domNode&&this._onPointerDown(c)}delegatePointerDown(c){const u=this.domNode.domNode.getClientRects()[0].top,e=u+this._scrollbarState.getSliderPosition(),s=u+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),o=this._sliderPointerPosition(c);e<=o&&o<=s?c.button===0&&(c.preventDefault(),this._sliderPointerDown(c)):this._onPointerDown(c)}_onPointerDown(c){let u,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")u=c.offsetX,e=c.offsetY;else{const o=i.getDomNodePagePosition(this.domNode.domNode);u=c.pageX-o.left,e=c.pageY-o.top}const s=this._pointerDownRelativePosition(u,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),c.button===0&&(c.preventDefault(),this._sliderPointerDown(c))}_sliderPointerDown(c){if(!c.target||!(c.target instanceof Element))return;const u=this._sliderPointerPosition(c),e=this._sliderOrthogonalPointerPosition(c),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(c.target,c.pointerId,c.buttons,o=>{const l=this._sliderOrthogonalPointerPosition(o),d=Math.abs(l-e);if(f.isWindows&&d>g){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const m=this._sliderPointerPosition(o)-u;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(m))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(c){const u={};this.writeScrollPosition(u,c),this._scrollable.setScrollPositionNow(u)}updateScrollbarSize(c){this._updateScrollbarSize(c),this._scrollbarState.setScrollbarSize(c),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=b}),define(me[135],pe([1,0,20,70,48,52,18]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class T extends N.AbstractScrollbar{constructor(g,b,B){const c=g.getScrollDimensions(),u=g.getCurrentScrollPosition();if(super({lazyRender:b.lazyRender,host:B,scrollbarState:new z.ScrollbarState(b.horizontalHasArrows?b.arrowSize:0,b.horizontal===2?0:b.horizontalScrollbarSize,b.vertical===2?0:b.verticalScrollbarSize,c.width,c.scrollWidth,u.scrollLeft),visibility:b.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:b.scrollByPage}),b.horizontalHasArrows){const e=(b.arrowSize-x.ARROW_IMG_SIZE)/2,s=(b.horizontalScrollbarSize-x.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((b.horizontalScrollbarSize-b.horizontalSliderSize)/2),0,void 0,b.horizontalSliderSize)}_updateSlider(g,b){this.slider.setWidth(g),this.slider.setLeft(b)}_renderDomNode(g,b){this.domNode.setWidth(g),this.domNode.setHeight(b),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this._shouldRender=this._onElementScrollSize(g.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(g.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(g.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(g,b){return g}_sliderPointerPosition(g){return g.pageX}_sliderOrthogonalPointerPosition(g){return g.pageY}_updateScrollbarSize(g){this.slider.setHeight(g)}writeScrollPosition(g,b){g.scrollLeft=b}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this._visibilityController.setVisibility(g.horizontal),this._scrollByPage=g.scrollByPage}}t.HorizontalScrollbar=T}),define(me[136],pe([1,0,20,70,48,52,18]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class T extends N.AbstractScrollbar{constructor(g,b,B){const c=g.getScrollDimensions(),u=g.getCurrentScrollPosition();if(super({lazyRender:b.lazyRender,host:B,scrollbarState:new z.ScrollbarState(b.verticalHasArrows?b.arrowSize:0,b.vertical===2?0:b.verticalScrollbarSize,0,c.height,c.scrollHeight,u.scrollTop),visibility:b.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:b.scrollByPage}),b.verticalHasArrows){const e=(b.arrowSize-x.ARROW_IMG_SIZE)/2,s=(b.verticalScrollbarSize-x.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((b.verticalScrollbarSize-b.verticalSliderSize)/2),b.verticalSliderSize,void 0)}_updateSlider(g,b){this.slider.setHeight(g),this.slider.setTop(b)}_renderDomNode(g,b){this.domNode.setWidth(b),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this._shouldRender=this._onElementScrollSize(g.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(g.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(g.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(g,b){return b}_sliderPointerPosition(g){return g.pageY}_sliderOrthogonalPointerPosition(g){return g.pageX}_updateScrollbarSize(g){this.slider.setWidth(g)}writeScrollPosition(g,b){g.scrollTop=b}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(g.vertical),this._scrollByPage=g.scrollByPage}}t.VerticalScrollbar=T}),define(me[71],pe([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,o=!0;class l{constructor(I,P,$){this.timestamp=I,this.deltaX=P,this.deltaY=$,this.score=0}}class d{static{this.INSTANCE=new d}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let I=1,P=0,$=1,v=this._rear;do{const O=v===this._front?I:Math.pow(2,-$);if(I-=O,P+=this._memory[v].score*O,v===this._front)break;v=(this._capacity+v-1)%this._capacity,$++}while(!0);return P<=.5}acceptStandardWheelEvent(I){if(i.isChrome){const P=N.getWindow(I.browserEvent),$=(0,i.getZoomFactor)(P);this.accept(Date.now(),I.deltaX*$,I.deltaY*$)}else this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,P,$){let v=null;const O=new l(I,P,$);this._front===-1&&this._rear===-1?(this._memory[0]=O,this._front=0,this._rear=0):(v=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=O),O.score=this._computeScore(O,v)}_computeScore(I,P){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let $=.5;if((!this._isAlmostInt(I.deltaX)||!this._isAlmostInt(I.deltaY))&&($+=.25),P){const v=Math.abs(I.deltaX),O=Math.abs(I.deltaY),q=Math.abs(P.deltaX),L=Math.abs(P.deltaY),W=Math.max(Math.min(v,q),1),M=Math.max(Math.min(O,L),1),G=Math.max(v,q),K=Math.max(O,L);G%W===0&&K%M===0&&($-=.5)}return Math.min(Math.max($,0),1)}_isAlmostInt(I){return Math.abs(Math.round(I)-I)<.01}}t.MouseWheelClassifier=d;class C extends f.Widget{get options(){return this._options}constructor(I,P,$){super(),this._onScroll=this._register(new b.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new b.Emitter),this.onWillScroll=this._onWillScroll.event,I.style.overflow="hidden",this._options=S(P),this._scrollable=$,this._register(this._scrollable.onScroll(O=>{this._onWillScroll.fire(O),this._onDidScroll(O),this._onScroll.fire(O)}));const v={onMouseWheel:O=>this._onMouseWheel(O),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new T.VerticalScrollbar(this._scrollable,this._options,v)),this._horizontalScrollbar=this._register(new _.HorizontalScrollbar(this._scrollable,this._options,v)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(I),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,O=>this._onMouseOver(O)),this.onmouseleave(this._listenOnDomNode,O=>this._onMouseLeave(O)),this._hideTimeout=this._register(new g.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,B.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this._verticalScrollbar.delegatePointerDown(I)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(I){this._scrollable.setScrollDimensions(I,!1)}updateClassName(I){this._options.className=I,c.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this._options.handleMouseWheel=I.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this._options.horizontal=I.horizontal),typeof I.vertical<"u"&&(this._options.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this._options.scrollByPage=I.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(I){this._revealOnScroll=I}delegateScrollFromMouseWheelEvent(I){this._onMouseWheel(new z.StandardWheelEvent(I))}_setListeningToMouseWheel(I){if(this._mouseWheelToDispose.length>0!==I&&(this._mouseWheelToDispose=(0,B.dispose)(this._mouseWheelToDispose),I)){const $=v=>{this._onMouseWheel(new z.StandardWheelEvent(v))};this._mouseWheelToDispose.push(N.addDisposableListener(this._listenOnDomNode,N.EventType.MOUSE_WHEEL,$,{passive:!1}))}}_onMouseWheel(I){if(I.browserEvent?.defaultPrevented)return;const P=d.INSTANCE;o&&P.acceptStandardWheelEvent(I);let $=!1;if(I.deltaY||I.deltaX){let O=I.deltaY*this._options.mouseWheelScrollSensitivity,q=I.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&q+O===0?q=O=0:Math.abs(O)>=Math.abs(q)?q=0:O=0),this._options.flipAxes&&([O,q]=[q,O]);const L=!c.isMacintosh&&I.browserEvent&&I.browserEvent.shiftKey;(this._options.scrollYToX||L)&&!q&&(q=O,O=0),I.browserEvent&&I.browserEvent.altKey&&(q=q*this._options.fastScrollSensitivity,O=O*this._options.fastScrollSensitivity);const W=this._scrollable.getFutureScrollPosition();let M={};if(O){const G=s*O,K=W.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this._verticalScrollbar.writeScrollPosition(M,K)}if(q){const G=s*q,K=W.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this._horizontalScrollbar.writeScrollPosition(M,K)}M=this._scrollable.validateScrollPosition(M),(W.scrollLeft!==M.scrollLeft||W.scrollTop!==M.scrollTop)&&(o&&this._options.mouseWheelSmoothScroll&&P.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(M):this._scrollable.setScrollPositionNow(M),$=!0)}let v=$;!v&&this._options.alwaysConsumeMouseWheel&&(v=!0),!v&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(v=!0),v&&(I.preventDefault(),I.stopPropagation())}_onDidScroll(I){this._shouldRender=this._horizontalScrollbar.onDidScroll(I)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(I)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const I=this._scrollable.getCurrentScrollPosition(),P=I.scrollTop>0,$=I.scrollLeft>0,v=$?" left":"",O=P?" top":"",q=$||P?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${v}`),this._topShadowDomNode.setClassName(`shadow${O}`),this._topLeftShadowDomNode.setClassName(`shadow${q}${O}${v}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(I){this._mouseIsOver=!1,this._hide()}_onMouseOver(I){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=C;class m extends C{constructor(I,P){P=P||{},P.mouseWheelSmoothScroll=!1;const $=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>N.scheduleAtNextAnimationFrame(N.getWindow(I),v)});super(I,P,$),this._register($)}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=m;class p extends C{constructor(I,P,$){super(I,P,$)}setScrollPosition(I){I.reuseAnimation?this._scrollable.setScrollPositionSmooth(I,I.reuseAnimation):this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=p;class r extends C{constructor(I,P){P=P||{},P.mouseWheelSmoothScroll=!1;const $=new u.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>N.scheduleAtNextAnimationFrame(N.getWindow(I),v)});super(I,P,$),this._register($),this._element=I,this._register(this.onScroll(v=>{v.scrollTopChanged&&(this._element.scrollTop=v.scrollTop),v.scrollLeftChanged&&(this._element.scrollLeft=v.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this._scrollable.setScrollPositionNow(I)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=r;function S(A){const I={lazyRender:typeof A.lazyRender<"u"?A.lazyRender:!1,className:typeof A.className<"u"?A.className:"",useShadows:typeof A.useShadows<"u"?A.useShadows:!0,handleMouseWheel:typeof A.handleMouseWheel<"u"?A.handleMouseWheel:!0,flipAxes:typeof A.flipAxes<"u"?A.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof A.consumeMouseWheelIfScrollbarIsNeeded<"u"?A.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof A.alwaysConsumeMouseWheel<"u"?A.alwaysConsumeMouseWheel:!1,scrollYToX:typeof A.scrollYToX<"u"?A.scrollYToX:!1,mouseWheelScrollSensitivity:typeof A.mouseWheelScrollSensitivity<"u"?A.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof A.fastScrollSensitivity<"u"?A.fastScrollSensitivity:5,scrollPredominantAxis:typeof A.scrollPredominantAxis<"u"?A.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof A.mouseWheelSmoothScroll<"u"?A.mouseWheelSmoothScroll:!0,arrowSize:typeof A.arrowSize<"u"?A.arrowSize:11,listenOnDomNode:typeof A.listenOnDomNode<"u"?A.listenOnDomNode:null,horizontal:typeof A.horizontal<"u"?A.horizontal:1,horizontalScrollbarSize:typeof A.horizontalScrollbarSize<"u"?A.horizontalScrollbarSize:10,horizontalSliderSize:typeof A.horizontalSliderSize<"u"?A.horizontalSliderSize:0,horizontalHasArrows:typeof A.horizontalHasArrows<"u"?A.horizontalHasArrows:!1,vertical:typeof A.vertical<"u"?A.vertical:1,verticalScrollbarSize:typeof A.verticalScrollbarSize<"u"?A.verticalScrollbarSize:10,verticalHasArrows:typeof A.verticalHasArrows<"u"?A.verticalHasArrows:!1,verticalSliderSize:typeof A.verticalSliderSize<"u"?A.verticalSliderSize:0,scrollByPage:typeof A.scrollByPage<"u"?A.scrollByPage:!1};return I.horizontalSliderSize=typeof A.horizontalSliderSize<"u"?A.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof A.verticalSliderSize<"u"?A.verticalSliderSize:I.verticalScrollbarSize,c.isMacintosh&&(I.className+=" mac"),I}}),define(me[72],pe([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const d={CurrentDragAndDropData:void 0};var C;(function($){$[$.TOP=0]="TOP",$[$.CENTER_TOP=1]="CENTER_TOP",$[$.CENTER_BOTTOM=2]="CENTER_BOTTOM",$[$.BOTTOM=3]="BOTTOM"})(C||(t.ListViewTargetSector=C={}));const m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements($){return[$]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class p{get context(){return this._context}set context(v){this._context=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=p;class r{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=r;class S{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let O=0;O<v.files.length;O++){const q=v.files.item(O);q&&(q.size||q.type)&&this.files.push(q)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function A($,v){return Array.isArray($)&&Array.isArray(v)?(0,T.equals)($,v):$===v}class I{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(O,q,L)=>L,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(O,q)=>q+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=O=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=O=>{}}}class P{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(v){if(v!==this._horizontalScrolling){if(v&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=v,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const O of this.items)this.measureItemWidth(O);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,N.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(v,O,q,L=m){if(this.virtualDelegate=O,this.domId=`list_id_${++P.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new f.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=B.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=B.Disposable.None,this.onDragLeaveTimeout=B.Disposable.None,this.disposables=new B.DisposableStore,this._onDidChangeContentHeight=new b.Emitter,this._onDidChangeContentWidth=new b.Emitter,this.onDidChangeContentHeight=b.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=b.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,L.horizontalScrolling&&L.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(L.paddingTop??0);for(const M of q)this.renderers.set(M.templateId,M);this.cache=this.disposables.add(new s.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof L.mouseSupport=="boolean"?L.mouseSupport:!0),this._horizontalScrolling=L.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof L.paddingBottom>"u"?0:L.paddingBottom,this.accessibilityProvider=new I(L.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(L.transformOptimization??m.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(z.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:L.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,N.scheduleAtNextAnimationFrame)((0,N.getWindow)(this.domNode),M)})),this.scrollableElement=this.disposables.add(new _.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:L.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:L.verticalScrollMode??m.verticalScrollMode,useShadows:L.useShadows??m.useShadows,mouseWheelScrollSensitivity:L.mouseWheelScrollSensitivity,fastScrollSensitivity:L.fastScrollSensitivity,scrollByPage:L.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),v.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,N.addDisposableListener)(this.rowsContainer,z.EventType.Change,M=>this.onTouchChange(M))),this.disposables.add((0,N.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragover",M=>this.onDragOver(this.toDragEvent(M)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"drop",M=>this.onDrop(this.toDragEvent(M)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragleave",M=>this.onDragLeave(this.toDragEvent(M)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragend",M=>this.onDragEnd(M))),this.setRowLineHeight=L.setRowLineHeight??m.setRowLineHeight,this.setRowHeight=L.setRowHeight??m.setRowHeight,this.supportDynamicHeights=L.supportDynamicHeights??m.supportDynamicHeights,this.dnd=L.dnd??this.disposables.add(m.dnd),this.layout(L.initialSize?.height,L.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.paddingBottom=v.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.horizontalScrolling=v.horizontalScrolling);let O;if(v.scrollByPage!==void 0&&(O={...O??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:v.fastScrollSensitivity}),O&&this.scrollableElement.updateOptions(O),v.paddingTop!==void 0&&v.paddingTop!==this.rangeMap.paddingTop){const q=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),L=v.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=v.paddingTop,this.render(q,Math.max(0,this.lastRenderTop+L),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(v){this.scrollableElement.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.scrollableElement.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,O,q){if(v<0||v>=this.items.length)return;const L=this.items[v].size;if(typeof O>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[v].lastDynamicHeightWidth=void 0,O=L+this.probeDynamicHeight(v)}if(L===O)return;const W=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let M=0;v<W.start||q!==null&&q>v&&q<W.end?M=O-L:M=0,this.rangeMap.splice(v,1,[{size:O}]),this.items[v].size=O,this.render(W,Math.max(0,this.lastRenderTop+M),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(v){return new e.RangeMap(v)}splice(v,O,q=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(v,O,q)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(v,O,q=[]){const L=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),W={start:v,end:v+O},M=c.Range.intersect(L,W),G=new Map;for(let V=M.end-1;V>=M.start;V--){const Q=this.items[V];if(Q.dragStartDisposable.dispose(),Q.checkedDisposable.dispose(),Q.row){let ge=G.get(Q.templateId);ge||(ge=[],G.set(Q.templateId,ge));const De=this.renderers.get(Q.templateId);De&&De.disposeElement&&De.disposeElement(Q.element,V,Q.row.templateData,Q.size),ge.unshift(Q.row)}Q.row=null,Q.stale=!0}const K={start:v+O,end:this.items.length},ae=c.Range.intersect(K,L),ie=c.Range.relativeComplement(K,L),ee=q.map(V=>({id:String(this.itemId++),element:V,templateId:this.virtualDelegate.getTemplateId(V),size:this.virtualDelegate.getHeight(V),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:B.Disposable.None,checkedDisposable:B.Disposable.None,stale:!1}));let ce;v===0&&O>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,ee),ce=this.items,this.items=ee):(this.rangeMap.splice(v,O,ee),ce=this.items.splice(v,O,...ee));const Ee=q.length-O,Se=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Pe=(0,e.shift)(ae,Ee),le=c.Range.intersect(Se,Pe);for(let V=le.start;V<le.end;V++)this.updateItemInDOM(this.items[V],V);const J=c.Range.relativeComplement(Pe,Se);for(const V of J)for(let Q=V.start;Q<V.end;Q++)this.removeItemFromDOM(Q);const he=ie.map(V=>(0,e.shift)(V,Ee)),ye=[{start:v,end:v+q.length},...he].map(V=>c.Range.intersect(Se,V)).reverse();for(const V of ye)for(let Q=V.end-1;Q>=V.start;Q--){const ge=this.items[Q],Ae=G.get(ge.templateId)?.pop();this.insertItemInDOM(Q,Ae)}for(const V of G.values())for(const Q of V)this.cache.release(Q);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ce.map(V=>V.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,N.scheduleAtNextAnimationFrame)((0,N.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let v=0;for(const O of this.items)typeof O.width<"u"&&(v=Math.max(v,O.width));this.scrollWidth=v,this.scrollableElement.setScrollDimensions({scrollWidth:v===0?0:v+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(v){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const O=this.items[v];this.measureItemWidth(O),typeof O.width<"u"&&O.width>this.scrollWidth&&(this.scrollWidth=O.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const v of this.items)v.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,O=this.rangeMap.positionAt(v),q=this.rangeMap.positionAt(v+1);return q!==-1&&(q-O)/2+O<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(v){return this.items[v].element}indexOf(v){return this.items.findIndex(O=>O.element===v)}domElement(v){const O=this.items[v].row;return O&&O.domNode}elementHeight(v){return this.items[v].size}elementTop(v){return this.rangeMap.positionAt(v)}indexAt(v){return this.rangeMap.indexAt(v)}indexAfter(v){return this.rangeMap.indexAfter(v)}layout(v,O){const q={height:typeof v=="number"?v:(0,N.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,q.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(q),typeof O<"u"&&(this.renderWidth=O,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof O=="number"?O:(0,N.getContentWidth)(this.domNode)})}render(v,O,q,L,W,M=!1){const G=this.getRenderRange(O,q),K=c.Range.relativeComplement(G,v).reverse(),ae=c.Range.relativeComplement(v,G);if(M){const ie=c.Range.intersect(v,G);for(let ee=ie.start;ee<ie.end;ee++)this.updateItemInDOM(this.items[ee],ee)}this.cache.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.removeItemFromDOM(ee);for(const ie of K)for(let ee=ie.end-1;ee>=ie.start;ee--)this.insertItemInDOM(ee)}),L!==void 0&&(this.rowsContainer.style.left=`-${L}px`),this.rowsContainer.style.top=`-${O}px`,this.horizontalScrolling&&W!==void 0&&(this.rowsContainer.style.width=`${Math.max(W,this.renderWidth)}px`),this.lastRenderTop=O,this.lastRenderHeight=q}insertItemInDOM(v,O){const q=this.items[v];if(!q.row)if(O)q.row=O,q.stale=!0;else{const K=this.cache.alloc(q.templateId);q.row=K.row,q.stale||=K.isReusingConnectedDomNode}const L=this.accessibilityProvider.getRole(q.element)||"listitem";q.row.domNode.setAttribute("role",L);const W=this.accessibilityProvider.isChecked(q.element);if(typeof W=="boolean")q.row.domNode.setAttribute("aria-checked",String(!!W));else if(W){const K=ae=>q.row.domNode.setAttribute("aria-checked",String(!!ae));K(W.value),q.checkedDisposable=W.onDidChange(()=>K(W.value))}if(q.stale||!q.row.domNode.parentElement){const K=this.items.at(v+1)?.row?.domNode??null;(q.row.domNode.parentElement!==this.rowsContainer||q.row.domNode.nextElementSibling!==K)&&this.rowsContainer.insertBefore(q.row.domNode,K),q.stale=!1}this.updateItemInDOM(q,v);const M=this.renderers.get(q.templateId);if(!M)throw new Error(`No renderer found for template id ${q.templateId}`);M?.renderElement(q.element,v,q.row.templateData,q.size);const G=this.dnd.getDragURI(q.element);q.dragStartDisposable.dispose(),q.row.domNode.draggable=!!G,G&&(q.dragStartDisposable=(0,N.addDisposableListener)(q.row.domNode,"dragstart",K=>this.onDragStart(q.element,G,K))),this.horizontalScrolling&&(this.measureItemWidth(q),this.eventuallyUpdateScrollWidth())}measureItemWidth(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,N.getContentWidth)(v.row.domNode);const O=(0,N.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);O.paddingLeft&&(v.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(v.width+=parseFloat(O.paddingRight)),v.row.domNode.style.width=""}updateItemInDOM(v,O){v.row.domNode.style.top=`${this.elementTop(O)}px`,this.setRowHeight&&(v.row.domNode.style.height=`${v.size}px`),this.setRowLineHeight&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${O}`),v.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(v.element,O,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(v.element,O))),v.row.domNode.setAttribute("id",this.getElementDomId(O)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}removeItemFromDOM(v){const O=this.items[v];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const q=this.renderers.get(O.templateId);q&&q.disposeElement&&q.disposeElement(O.element,v,O.row.templateData,O.size),this.cache.release(O.row),O.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(v,O){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:v,reuseAnimation:O})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(v){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"click")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseDblClick(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"dblclick")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseMiddleClick(){return b.Event.filter(b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"auxclick")).event,v=>this.toMouseEvent(v),this.disposables),v=>v.browserEvent.button===1,this.disposables)}get onMouseUp(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseup")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseDown(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mousedown")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseOver(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseover")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseMove(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mousemove")).event,v=>this.toMouseEvent(v),this.disposables)}get onMouseOut(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseout")).event,v=>this.toMouseEvent(v),this.disposables)}get onContextMenu(){return b.Event.any(b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"contextmenu")).event,v=>this.toMouseEvent(v),this.disposables),b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,z.EventType.Contextmenu)).event,v=>this.toGestureEvent(v),this.disposables))}get onTouchStart(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"touchstart")).event,v=>this.toTouchEvent(v),this.disposables)}get onTap(){return b.Event.map(this.disposables.add(new x.DomEmitter(this.rowsContainer,z.EventType.Tap)).event,v=>this.toGestureEvent(v),this.disposables)}toMouseEvent(v){const O=this.getItemIndexFromEventTarget(v.target||null),q=typeof O>"u"?void 0:this.items[O],L=q&&q.element;return{browserEvent:v,index:O,element:L}}toTouchEvent(v){const O=this.getItemIndexFromEventTarget(v.target||null),q=typeof O>"u"?void 0:this.items[O],L=q&&q.element;return{browserEvent:v,index:O,element:L}}toGestureEvent(v){const O=this.getItemIndexFromEventTarget(v.initialTarget||null),q=typeof O>"u"?void 0:this.items[O],L=q&&q.element;return{browserEvent:v,index:O,element:L}}toDragEvent(v){const O=this.getItemIndexFromEventTarget(v.target||null),q=typeof O>"u"?void 0:this.items[O],L=q&&q.element,W=this.getTargetSector(v,O);return{browserEvent:v,index:O,element:L,sector:W}}onScroll(v){try{const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(O,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.supportDynamicHeights&&this._rerender(v.scrollTop,v.height,v.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",v),O}}onTouchChange(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}onDragStart(v,O,q){if(!q.dataTransfer)return;const L=this.dnd.getDragElements(v);if(q.dataTransfer.effectAllowed="copyMove",q.dataTransfer.setData(i.DataTransfers.TEXT,O),q.dataTransfer.setDragImage){let W;this.dnd.getDragLabel&&(W=this.dnd.getDragLabel(L,q)),typeof W>"u"&&(W=String(L.length));const M=(0,N.$)(".monaco-drag-image");M.textContent=W;const K=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);K.appendChild(M),q.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>K.removeChild(M),0)}this.domNode.classList.add("dragging"),this.currentDragData=new p(L),d.CurrentDragAndDropData=new r(L),this.dnd.onDragStart?.(this.currentDragData,q)}onDragOver(v){if(v.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),d.CurrentDragAndDropData&&d.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(d.CurrentDragAndDropData)this.currentDragData=d.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.currentDragData=new S}const O=this.dnd.onDragOver(this.currentDragData,v.element,v.index,v.sector,v.browserEvent);if(this.canDrop=typeof O=="boolean"?O:O.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let q;typeof O!="boolean"&&O.feedback?q=O.feedback:typeof v.index>"u"?q=[-1]:q=[v.index],q=(0,T.distinct)(q).filter(W=>W>=-1&&W<this.length).sort((W,M)=>W-M),q=q[0]===-1?[-1]:q;let L=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(A(this.currentDragFeedback,q)&&this.currentDragFeedbackPosition===L)return!0;if(this.currentDragFeedback=q,this.currentDragFeedbackPosition=L,this.currentDragFeedbackDisposable.dispose(),q[0]===-1)this.domNode.classList.add(L),this.rowsContainer.classList.add(L),this.currentDragFeedbackDisposable=(0,B.toDisposable)(()=>{this.domNode.classList.remove(L),this.rowsContainer.classList.remove(L)});else{if(q.length>1&&L!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");L==="drop-target-after"&&q[0]<this.length-1&&(q[0]+=1,L="drop-target-before");for(const W of q){const M=this.items[W];M.dropTarget=!0,M.row?.domNode.classList.add(L)}this.currentDragFeedbackDisposable=(0,B.toDisposable)(()=>{for(const W of q){const M=this.items[W];M.dropTarget=!1,M.row?.domNode.classList.remove(L)}})}return!0}onDragLeave(v){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,f.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,v.element,v.index,v.browserEvent)}onDrop(v){if(!this.canDrop)return;const O=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,d.CurrentDragAndDropData=void 0,!(!O||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),O.update(v.browserEvent.dataTransfer),this.dnd.drop(O,v.element,v.index,v.sector,v.browserEvent))}onDragEnd(v){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,d.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(v)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=B.Disposable.None}setupDragAndDropScrollTopAnimation(v){if(!this.dragOverAnimationDisposable){const O=(0,N.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,N.animate)((0,N.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,O))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,f.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=v.pageY}animateDragAndDropScrollTop(v){if(this.dragOverMouseY===void 0)return;const O=this.dragOverMouseY-v,q=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>q&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-q))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(v,O){if(O===void 0)return;const q=v.offsetY/this.items[O].size,L=Math.floor(q/.25);return(0,l.clamp)(L,0,3)}getItemIndexFromEventTarget(v){const O=this.scrollableElement.getDomNode();let q=v;for(;q instanceof HTMLElement&&q!==this.rowsContainer&&O.contains(q);){const L=q.getAttribute("data-index");if(L){const W=Number(L);if(!isNaN(W))return W}q=q.parentElement}}getRenderRange(v,O){return{start:this.rangeMap.indexAt(v),end:this.rangeMap.indexAfter(v+O-1)}}_rerender(v,O,q){const L=this.getRenderRange(v,O);let W,M;v===this.elementTop(L.start)?(W=L.start,M=0):L.end-L.start>1&&(W=L.start+1,M=this.elementTop(W)-v);let G=0;for(;;){const K=this.getRenderRange(v,O);let ae=!1;for(let ie=K.start;ie<K.end;ie++){const ee=this.probeDynamicHeight(ie);ee!==0&&this.rangeMap.splice(ie,1,[this.items[ie]]),G+=ee,ae=ae||ee!==0}if(!ae){G!==0&&this.eventuallyUpdateScrollDimensions();const ie=c.Range.relativeComplement(L,K);for(const ce of ie)for(let Ee=ce.start;Ee<ce.end;Ee++)this.items[Ee].row&&this.removeItemFromDOM(Ee);const ee=c.Range.relativeComplement(K,L).reverse();for(const ce of ee)for(let Ee=ce.end-1;Ee>=ce.start;Ee--)this.insertItemInDOM(Ee);for(let ce=K.start;ce<K.end;ce++)this.items[ce].row&&this.updateItemInDOM(this.items[ce],ce);if(typeof W=="number"){const ce=this.scrollable.getFutureScrollPosition().scrollTop-v,Ee=this.elementTop(W)-M+ce;this.setScrollTop(Ee,q)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(v){const O=this.items[v];if(this.virtualDelegate.getDynamicHeight){const M=this.virtualDelegate.getDynamicHeight(O.element);if(M!==null){const G=O.size;return O.size=M,O.lastDynamicHeightWidth=this.renderWidth,M-G}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(O.element))return 0;const q=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.size===0&&!(0,N.isAncestor)(O.row.domNode,(0,N.getWindow)(O.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),O.lastDynamicHeightWidth=this.renderWidth,O.size-q;const{row:L}=this.cache.alloc(O.templateId);L.domNode.style.height="",this.rowsContainer.appendChild(L.domNode);const W=this.renderers.get(O.templateId);if(!W)throw new o.BugIndicatingError("Missing renderer for templateId: "+O.templateId);return W.renderElement(O.element,v,L.templateData,void 0),O.size=L.domNode.offsetHeight,W.disposeElement?.(O.element,v,L.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(L.domNode),this.cache.release(L),O.size-q}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.items)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const O=this.renderers.get(v.row.templateId);O&&(O.disposeElement?.(v.element,-1,v.row.templateData,void 0),O.disposeTemplate(v.row.templateData))}this.items=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=P,Ze([g.memoize],P.prototype,"onMouseClick",null),Ze([g.memoize],P.prototype,"onMouseDblClick",null),Ze([g.memoize],P.prototype,"onMouseMiddleClick",null),Ze([g.memoize],P.prototype,"onMouseUp",null),Ze([g.memoize],P.prototype,"onMouseDown",null),Ze([g.memoize],P.prototype,"onMouseOver",null),Ze([g.memoize],P.prototype,"onMouseMove",null),Ze([g.memoize],P.prototype,"onMouseOut",null),Ze([g.memoize],P.prototype,"onContextMenu",null),Ze([g.memoize],P.prototype,"onTouchStart",null),Ze([g.memoize],P.prototype,"onTap",null)}),define(me[49],pe([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s,o,l,d,C,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=P,t.isMonacoEditor=v,t.isMonacoCustomToggle=O,t.isActionItem=q,t.isMonacoTwistie=L,t.isStickyScrollElement=W,t.isStickyScrollContainer=M,t.isButton=G,t.isSelectionSingleChangeEvent=Ee,t.isSelectionRangeChangeEvent=Se;class r{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,y,a){const w=this.renderedElements.findIndex(F=>F.templateData===a);if(w>=0){const F=this.renderedElements[w];this.trait.unrender(a),F.index=y}else{const F={index:y,templateData:a};this.renderedElements.push(F)}this.trait.renderIndex(y,a)}splice(h,y,a){const w=[];for(const F of this.renderedElements)F.index<h?w.push(F):F.index>=h+y&&w.push({index:F.index+a-y,templateData:F.templateData});this.renderedElements=w}renderIndexes(h){for(const{index:y,templateData:a}of this.renderedElements)h.indexOf(y)>-1&&this.trait.renderIndex(y,a)}disposeTemplate(h){const y=this.renderedElements.findIndex(a=>a.templateData===h);y<0||this.renderedElements.splice(y,1)}}class S{get name(){return this._trait}get renderer(){return new r(this)}constructor(h){this._trait=h,this.indexes=[],this.sortedIndexes=[],this._onChange=new c.Emitter,this.onChange=this._onChange.event}splice(h,y,a){const w=a.length-y,F=h+y,n=[];let E=0;for(;E<this.sortedIndexes.length&&this.sortedIndexes[E]<h;)n.push(this.sortedIndexes[E++]);for(let D=0;D<a.length;D++)a[D]&&n.push(D+h);for(;E<this.sortedIndexes.length&&this.sortedIndexes[E]>=F;)n.push(this.sortedIndexes[E++]+w);this.renderer.splice(h,y,a.length),this._set(n,n)}renderIndex(h,y){y.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,y){return this._set(h,[...h].sort(ge),y)}_set(h,y,a){const w=this.indexes,F=this.sortedIndexes;this.indexes=h,this.sortedIndexes=y;const n=V(F,h);return this.renderer.renderIndexes(n),this._onChange.fire({indexes:h,browserEvent:a}),w}get(){return this.indexes}contains(h){return(0,f.binarySearch)(this.sortedIndexes,h,ge)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ze([B.memoize],S.prototype,"renderer",null);class A extends S{constructor(h){super("selected"),this.setAriaSelected=h}renderIndex(h,y){super.renderIndex(h,y),this.setAriaSelected&&(this.contains(h)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class I{constructor(h,y,a){this.trait=h,this.view=y,this.identityProvider=a}splice(h,y,a){if(!this.identityProvider)return this.trait.splice(h,y,new Array(a.length).fill(!1));const w=this.trait.get().map(E=>this.identityProvider.getId(this.view.element(E)).toString());if(w.length===0)return this.trait.splice(h,y,new Array(a.length).fill(!1));const F=new Set(w),n=a.map(E=>F.has(this.identityProvider.getId(E).toString()));this.trait.splice(h,y,n)}}function P(H){return H.tagName==="INPUT"||H.tagName==="TEXTAREA"}function $(H,h){return H.classList.contains(h)?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:$(H.parentElement,h)}function v(H){return $(H,"monaco-editor")}function O(H){return $(H,"monaco-custom-toggle")}function q(H){return $(H,"action-item")}function L(H){return $(H,"monaco-tl-twistie")}function W(H){return $(H,"monaco-tree-sticky-row")}function M(H){return H.classList.contains("monaco-tree-sticky-container")}function G(H){return H.tagName==="A"&&H.classList.contains("monaco-button")||H.tagName==="DIV"&&H.classList.contains("monaco-button-dropdown")?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:G(H.parentElement)}class K{get onKeyDown(){return c.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,h=>h.filter(y=>!P(y.target)).map(y=>new x.StandardKeyboardEvent(y)))}constructor(h,y,a){this.list=h,this.view=y,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.multipleSelectionSupport=a.multipleSelectionSupport,this.disposables.add(this.onKeyDown(w=>{switch(w.keyCode){case 3:return this.onEnter(w);case 16:return this.onUpArrow(w);case 18:return this.onDownArrow(w);case 11:return this.onPageUpArrow(w);case 12:return this.onPageDownArrow(w);case 9:return this.onEscape(w);case 31:this.multipleSelectionSupport&&(o.isMacintosh?w.metaKey:w.ctrlKey)&&this.onCtrlA(w)}}))}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=h.multipleSelectionSupport)}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const y=this.list.getFocus()[0];this.list.setAnchor(y),this.list.reveal(y),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const y=this.list.getFocus()[0];this.list.setAnchor(y),this.list.reveal(y),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const y=this.list.getFocus()[0];this.list.setAnchor(y),this.list.reveal(y),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const y=this.list.getFocus()[0];this.list.setAnchor(y),this.list.reveal(y),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,f.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ze([B.memoize],K.prototype,"onKeyDown",null);var ae;(function(H){H[H.Automatic=0]="Automatic",H[H.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(H){H[H.Idle=0]="Idle",H[H.Typing=1]="Typing"})(ie||(ie={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(H){return H.ctrlKey||H.metaKey||H.altKey?!1:H.keyCode>=31&&H.keyCode<=56||H.keyCode>=21&&H.keyCode<=30||H.keyCode>=98&&H.keyCode<=107||H.keyCode>=85&&H.keyCode<=95}};class ee{constructor(h,y,a,w,F){this.list=h,this.view=y,this.keyboardNavigationLabelProvider=a,this.keyboardNavigationEventFilter=w,this.delegate=F,this.enabled=!1,this.state=ie.Idle,this.mode=ae.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??ae.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let h=!1;const y=c.Event.chain(this.enabledDisposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,F=>F.filter(n=>!P(n.target)).filter(()=>this.mode===ae.Automatic||this.triggered).map(n=>new x.StandardKeyboardEvent(n)).filter(n=>h||this.keyboardNavigationEventFilter(n)).filter(n=>this.delegate.mightProducePrintableCharacter(n)).forEach(n=>i.EventHelper.stop(n,!0)).map(n=>n.browserEvent.key)),a=c.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);c.Event.reduce(c.Event.any(y,a),(F,n)=>n===null?null:(F||"")+n,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),a(this.onClear,this,this.enabledDisposables),y(()=>h=!0,void 0,this.enabledDisposables),a(()=>h=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const y=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));typeof y=="string"?(0,_.alert)(y):y&&(0,_.alert)(y.get())}this.previouslyFocused=-1}onInput(h){if(!h){this.state=ie.Idle,this.triggered=!1;return}const y=this.list.getFocus(),a=y.length>0?y[0]:0,w=this.state===ie.Idle?1:0;this.state=ie.Typing;for(let F=0;F<this.list.length;F++){const n=(a+F+w)%this.list.length,E=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(n)),D=E&&E.toString();if(this.list.options.typeNavigationEnabled){if(typeof D<"u"){if((0,u.matchesPrefix)(h,D)){this.previouslyFocused=a,this.list.setFocus([n]),this.list.reveal(n);return}const k=(0,u.matchesFuzzy2)(h,D);if(k&&k[0].end-k[0].start>1&&k.length===1){this.previouslyFocused=a,this.list.setFocus([n]),this.list.reveal(n);return}}}else if(typeof D>"u"||(0,u.matchesPrefix)(h,D)){this.previouslyFocused=a,this.list.setFocus([n]),this.list.reveal(n);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ce{constructor(h,y){this.list=h,this.view=y,this.disposables=new e.DisposableStore;const a=c.Event.chain(this.disposables.add(new N.DomEmitter(y.domNode,"keydown")).event,F=>F.filter(n=>!P(n.target)).map(n=>new x.StandardKeyboardEvent(n)));c.Event.chain(a,F=>F.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const y=this.list.getFocus();if(y.length===0)return;const a=this.view.domElement(y[0]);if(!a)return;const w=a.querySelector("[tabIndex]");if(!w||!(w instanceof HTMLElement)||w.tabIndex===-1)return;const F=(0,i.getWindow)(w).getComputedStyle(w);F.visibility==="hidden"||F.display==="none"||(h.preventDefault(),h.stopPropagation(),w.focus())}dispose(){this.disposables.dispose()}}function Ee(H){return o.isMacintosh?H.browserEvent.metaKey:H.browserEvent.ctrlKey}function Se(H){return H.browserEvent.shiftKey}function Pe(H){return(0,i.isMouseEvent)(H)&&H.button===2}const le={isSelectionSingleChangeEvent:Ee,isSelectionRangeChangeEvent:Se};class J{constructor(h){this.list=h,this.disposables=new e.DisposableStore,this._onPointer=new c.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||le),this.mouseSupport=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(z.Gesture.addTarget(h.getHTMLElement()))),c.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||le))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){v(h.browserEvent.target)||(0,i.getActiveElement)()!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(P(h.browserEvent.target)||v(h.browserEvent.target))return;const y=typeof h.index>"u"?[]:[h.index];this.list.setFocus(y,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||P(h.browserEvent.target)||v(h.browserEvent.target)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const y=h.index;if(typeof y>"u"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([y],h.browserEvent),this.list.setAnchor(y),Pe(h.browserEvent)||this.list.setSelection([y],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(P(h.browserEvent.target)||v(h.browserEvent.target)||this.isSelectionChangeEvent(h)||h.browserEvent.isHandledByList)return;h.browserEvent.isHandledByList=!0;const y=this.list.getFocus();this.list.setSelection(y,h.browserEvent)}changeSelection(h){const y=h.index;let a=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof a>"u"&&(a=this.list.getFocus()[0]??y,this.list.setAnchor(a));const w=Math.min(a,y),F=Math.max(a,y),n=(0,f.range)(w,F+1),E=this.list.getSelection(),D=ye(V(E,[a]),a);if(D.length===0)return;const k=V(n,Q(E,D));this.list.setSelection(k,h.browserEvent),this.list.setFocus([y],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const w=this.list.getSelection(),F=w.filter(n=>n!==y);this.list.setFocus([y]),this.list.setAnchor(y),w.length===F.length?this.list.setSelection([...F,y],h.browserEvent):this.list.setSelection(F,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=J;class he{constructor(h,y){this.styleElement=h,this.selectorSuffix=y}style(h){const y=this.selectorSuffix&&`.${this.selectorSuffix}`,a=[];h.listBackground&&a.push(`.monaco-list${y} .monaco-list-rows { background: ${h.listBackground}; }`),h.listFocusBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&a.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(a.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&a.push(`.monaco-list${y} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`);const w=(0,i.asCssValueWithDefault)(h.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(h.listSelectionOutline,h.listFocusOutline??""));w&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${w}; outline-offset: -1px;}`),h.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.asCssValueWithDefault)(h.listSelectionOutline,h.listInactiveFocusOutline??"");F&&a.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),h.listSelectionOutline&&a.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listInactiveFocusOutline&&a.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&a.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropOverBackground&&a.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${h.listDropOverBackground} !important; color: inherit !important; }
			`),h.listDropBetweenBackground&&(a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${h.listDropBetweenBackground};
			}`)),h.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),h.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=a.join(`
`)}}t.DefaultStyleController=he,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:b.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:b.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:b.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ye(H,h){const y=H.indexOf(h);if(y===-1)return[];const a=[];let w=y-1;for(;w>=0&&H[w]===h-(y-w);)a.push(H[w--]);for(a.reverse(),w=y;w<H.length&&H[w]===h+(w-y);)a.push(H[w++]);return a}function V(H,h){const y=[];let a=0,w=0;for(;a<H.length||w<h.length;)if(a>=H.length)y.push(h[w++]);else if(w>=h.length)y.push(H[a++]);else if(H[a]===h[w]){y.push(H[a]),a++,w++;continue}else H[a]<h[w]?y.push(H[a++]):y.push(h[w++]);return y}function Q(H,h){const y=[];let a=0,w=0;for(;a<H.length||w<h.length;)if(a>=H.length)y.push(h[w++]);else if(w>=h.length)y.push(H[a++]);else if(H[a]===h[w]){a++,w++;continue}else H[a]<h[w]?y.push(H[a++]):w++;return y}const ge=(H,h)=>H-h;class De{constructor(h,y){this._templateId=h,this.renderers=y}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(y=>y.renderTemplate(h))}renderElement(h,y,a,w){let F=0;for(const n of this.renderers)n.renderElement(h,y,a[F++],w)}disposeElement(h,y,a,w){let F=0;for(const n of this.renderers)n.disposeElement?.(h,y,a[F],w),F+=1}disposeTemplate(h){let y=0;for(const a of this.renderers)a.disposeTemplate(h[y++])}}class Ae{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return{container:h,disposables:new e.DisposableStore}}renderElement(h,y,a){const w=this.accessibilityProvider.getAriaLabel(h),F=w&&typeof w!="string"?w:(0,p.constObservable)(w);a.disposables.add((0,p.autorun)(E=>{this.setAriaLabel(E.readObservable(F),a.container)}));const n=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof n=="number"?a.container.setAttribute("aria-level",`${n}`):a.container.removeAttribute("aria-level")}setAriaLabel(h,y){h?y.setAttribute("aria-label",h):y.removeAttribute("aria-label")}disposeElement(h,y,a,w){a.disposables.clear()}disposeTemplate(h){h.disposables.dispose()}}class Ie{constructor(h,y){this.list=h,this.dnd=y}getDragElements(h){const y=this.list.getSelectedElements();return y.indexOf(h)>-1?y:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,y){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,y)}onDragStart(h,y){this.dnd.onDragStart?.(h,y)}onDragOver(h,y,a,w,F){return this.dnd.onDragOver(h,y,a,w,F)}onDragLeave(h,y,a,w){this.dnd.onDragLeave?.(h,y,a,w)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,y,a,w,F){this.dnd.drop(h,y,a,w,F)}dispose(){this.dnd.dispose()}}class Oe{get onDidChangeFocus(){return c.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return c.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const y=c.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,F=>F.map(n=>new x.StandardKeyboardEvent(n)).filter(n=>h=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.EventHelper.stop(n,!0)).filter(()=>!1)),a=c.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keyup")).event,F=>F.forEach(()=>h=!1).map(n=>new x.StandardKeyboardEvent(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.EventHelper.stop(n,!0)).map(({browserEvent:n})=>{const E=this.getFocus(),D=E.length?E[0]:void 0,k=typeof D<"u"?this.view.element(D):void 0,R=typeof D<"u"?this.view.domElement(D):this.view.domNode;return{index:D,element:k,anchor:R,browserEvent:n}})),w=c.Event.chain(this.view.onContextMenu,F=>F.filter(n=>!h).map(({element:n,index:E,browserEvent:D})=>({element:n,index:E,anchor:new m.StandardMouseEvent((0,i.getWindow)(this.view.domNode),D),browserEvent:D})));return c.Event.any(y,a,w)}get onKeyDown(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.disposables.add(new N.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.disposables.add(new N.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(h,y,a,w,F=re){this.user=h,this._options=F,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new c.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new c.Emitter,this.onDidDispose=this._onDidDispose.event;const n=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new A(n!=="listbox");const E=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=F.accessibilityProvider,this.accessibilityProvider&&(E.push(new Ae(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),w=w.map(k=>new De(k.templateId,[...E,k]));const D={...F,dnd:F.dnd&&new Ie(this,F.dnd)};if(this.view=this.createListView(y,a,w,D),this.view.domNode.setAttribute("role",n),F.styleController)this.styleController=F.styleController(this.view.domId);else{const k=(0,i.createStyleSheet)(this.view.domNode);this.styleController=new he(k,this.view.domId)}if(this.spliceable=new T.CombinedSpliceable([new I(this.focus,this.view,F.identityProvider),new I(this.selection,this.view,F.identityProvider),new I(this.anchor,this.view,F.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ce(this,this.view)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.keyboardController=new K(this,this.view,F),this.disposables.add(this.keyboardController)),F.keyboardNavigationLabelProvider){const k=F.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new ee(this,this.view,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),k),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(F),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(h,y,a,w){return new C.ListView(h,y,a,w)}createMouseController(h){return new J(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,y,a=[]){if(h<0||h>this.view.length)throw new d.ListError(this.user,`Invalid start index: ${h}`);if(y<0)throw new d.ListError(this.user,`Invalid delete count: ${y}`);y===0&&a.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,y,a))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,y){this.view.updateElementHeight(h,y,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}indexAt(h){return this.view.indexAt(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,y){this.view.layout(h,y)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(h,y){for(const a of h)if(a<0||a>=this.length)throw new d.ListError(this.user,`Invalid index ${a}`);this.selection.set(h,y)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h>"u"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new d.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,f.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,y){for(const a of h)if(a<0||a>=this.length)throw new d.ListError(this.user,`Invalid index ${a}`);this.focus.set(h,y)}focusNext(h=1,y=!1,a,w){if(this.length===0)return;const F=this.focus.get(),n=this.findNextIndex(F.length>0?F[0]+h:0,y,w);n>-1&&this.setFocus([n],a)}focusPrevious(h=1,y=!1,a,w){if(this.length===0)return;const F=this.focus.get(),n=this.findPreviousIndex(F.length>0?F[0]-h:0,y,w);n>-1&&this.setFocus([n],a)}async focusNextPage(h,y){let a=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);a=a===0?0:a-1;const w=this.getFocus()[0];if(w!==a&&(w===void 0||a>w)){const F=this.findPreviousIndex(a,!1,y);F>-1&&w!==F?this.setFocus([F],h):this.setFocus([a],h)}else{const F=this.view.getScrollTop();let n=F+this.view.renderHeight;a>w&&(n-=this.view.elementHeight(a)),this.view.setScrollTop(n),this.view.getScrollTop()!==F&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusNextPage(h,y))}}async focusPreviousPage(h,y,a=()=>0){let w;const F=a(),n=this.view.getScrollTop()+F;n===0?w=this.view.indexAt(n):w=this.view.indexAfter(n-1);const E=this.getFocus()[0];if(E!==w&&(E===void 0||E>=w)){const D=this.findNextIndex(w,!1,y);D>-1&&E!==D?this.setFocus([D],h):this.setFocus([w],h)}else{const D=n;this.view.setScrollTop(n-this.view.renderHeight-F),this.view.getScrollTop()+a()!==D&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusPreviousPage(h,y,a))}}focusLast(h,y){if(this.length===0)return;const a=this.findPreviousIndex(this.length-1,!1,y);a>-1&&this.setFocus([a],h)}focusFirst(h,y){this.focusNth(0,h,y)}focusNth(h,y,a){if(this.length===0)return;const w=this.findNextIndex(h,!1,a);w>-1&&this.setFocus([w],y)}findNextIndex(h,y=!1,a){for(let w=0;w<this.length;w++){if(h>=this.length&&!y)return-1;if(h=h%this.length,!a||a(this.element(h)))return h;h++}return-1}findPreviousIndex(h,y=!1,a){for(let w=0;w<this.length;w++){if(h<0&&!y)return-1;if(h=(this.length+h%this.length)%this.length,!a||a(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,y,a=0){if(h<0||h>=this.length)throw new d.ListError(this.user,`Invalid index ${h}`);const w=this.view.getScrollTop(),F=this.view.elementTop(h),n=this.view.elementHeight(h);if((0,l.isNumber)(y)){const E=n-this.view.renderHeight+a;this.view.setScrollTop(E*(0,s.clamp)(y,0,1)+F-a)}else{const E=F+n,D=w+this.view.renderHeight;F<w+a&&E>=D||(F<w+a||E>=D&&n>=this.view.renderHeight?this.view.setScrollTop(F-a):E>=D&&this.view.setScrollTop(E-this.view.renderHeight))}}getRelativeTop(h,y=0){if(h<0||h>=this.length)throw new d.ListError(this.user,`Invalid index ${h}`);const a=this.view.getScrollTop(),w=this.view.elementTop(h),F=this.view.elementHeight(h);if(w<a+y||w+F>a+this.view.renderHeight)return null;const n=F-this.view.renderHeight+y;return Math.abs((a+y-w)/n)}isDOMFocused(){return(0,i.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(h){return this.view.getElementDomId(h)}getElementTop(h){return this.view.elementTop(h)}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:y}){return{indexes:h,elements:h.map(a=>this.view.element(a)),browserEvent:y}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let y;this.accessibilityProvider?.getActiveDescendantId&&(y=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",y||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=Oe,Ze([B.memoize],Oe.prototype,"onDidChangeFocus",null),Ze([B.memoize],Oe.prototype,"onDidChangeSelection",null),Ze([B.memoize],Oe.prototype,"onContextMenu",null),Ze([B.memoize],Oe.prototype,"onKeyDown",null),Ze([B.memoize],Oe.prototype,"onKeyUp",null),Ze([B.memoize],Oe.prototype,"onKeyPress",null),Ze([B.memoize],Oe.prototype,"onDidFocus",null),Ze([B.memoize],Oe.prototype,"onDidBlur",null)}),define(me[137],pe([1,0,6,62,47,9,16]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=g,t.isMarkdownString=b,t.markdownStringEqual=B,t.escapeMarkdownSyntaxTokens=c,t.appendEscapedMarkdownCodeBlockFence=u,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=s,t.parseHrefAndDimensions=o;var T;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(T||(t.MarkdownStringTextNewlineStyle=T={}));class f{constructor(d="",C=!1){if(this.value=d,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof C=="boolean"?(this.isTrusted=C,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=C.isTrusted??void 0,this.supportThemeIcons=C.supportThemeIcons??!1,this.supportHtml=C.supportHtml??!1)}appendText(d,C=0){return this.value+=c(this.supportThemeIcons?(0,N.escapeIcons)(d):d).replace(/([ \t]+)/g,(m,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,C===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,C){return this.value+=`
${u(C,d)}
`,this}appendLink(d,C,m){return this.value+="[",this.value+=this._escape(C,"]"),this.value+="](",this.value+=this._escape(String(d),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(d,C){const m=new RegExp((0,z.escapeRegExpCharacters)(C),"g");return d.replace(m,(p,r)=>d.charAt(r-1)!=="\\"?`\\${p}`:p)}}t.MarkdownString=f;function g(l){return b(l)?!l.value:Array.isArray(l)?l.every(g):!0}function b(l){return l instanceof f?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function B(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons&&l.supportHtml===d.supportHtml&&(l.baseUri===d.baseUri||!!l.baseUri&&!!d.baseUri&&(0,x.isEqual)(_.URI.from(l.baseUri),_.URI.from(d.baseUri)))}function c(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function u(l,d){const C=l.match(/^`+/gm)?.reduce((p,r)=>p.length>r.length?p:r).length??0,m=C>=3?C+1:3;return[`${"`".repeat(m)}${d}`,l,`${"`".repeat(m)}`].join(`
`)}function e(l){return l.replace(/"/g,"&quot;")}function s(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(l){const d=[],C=l.split("|").map(p=>p.trim());l=C[0];const m=C[1];if(m){const p=/height=(\d+)/.exec(m),r=/width=(\d+)/.exec(m),S=p?p[1]:"",A=r?r[1]:"",I=isFinite(parseInt(A)),P=isFinite(parseInt(S));I&&d.push(`width="${A}"`),P&&d.push(`height="${S}"`)}return{href:l,dimensions:d}}}),define(me[138],pe([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s,o,l,d,C,m,p,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=A,t.renderStringAsPlaintext=O,t.renderMarkdownAsPlaintext=q,t.fillInIncompleteTokens=ae;const S=Object.freeze({image:(V,Q,ge)=>{let De=[],Ae=[];return V&&({href:V,dimensions:De}=(0,B.parseHrefAndDimensions)(V),Ae.push(`src="${(0,B.escapeDoubleQuotes)(V)}"`)),ge&&Ae.push(`alt="${(0,B.escapeDoubleQuotes)(ge)}"`),Q&&Ae.push(`title="${(0,B.escapeDoubleQuotes)(Q)}"`),De.length&&(Ae=Ae.concat(De)),"<img "+Ae.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,Q,ge)=>typeof V!="string"?"":(V===ge&&(ge=(0,B.removeMarkdownEscapes)(ge)),Q=typeof Q=="string"?(0,B.escapeDoubleQuotes)((0,B.removeMarkdownEscapes)(Q)):"",V=(0,B.removeMarkdownEscapes)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${Q||V}" draggable="false">${ge}</a>`)});function A(V,Q={},ge={}){const De=new s.DisposableStore;let Ae=!1;const Ie=(0,z.createElement)(Q),Oe=function(D){let k;try{k=(0,l.parse)(decodeURIComponent(D))}catch{}return k?(k=(0,C.cloneAndChange)(k,R=>{if(V.uris&&V.uris[R])return r.URI.revive(V.uris[R])}),encodeURIComponent(JSON.stringify(k))):D},H=function(D,k){const R=V.uris&&V.uris[D];let U=r.URI.revive(R);return k?D.startsWith(d.Schemas.data+":")?D:(U||(U=r.URI.parse(D)),d.FileAccess.uriToBrowserUri(U).toString(!0)):!U||r.URI.parse(D).toString()===U.toString()?D:(U.query&&(U=U.with({query:Oe(U.query)})),U.toString())},h=new o.marked.Renderer;h.image=S.image,h.link=S.link,h.paragraph=S.paragraph;const y=[],a=[];if(Q.codeBlockRendererSync?h.code=(D,k)=>{const R=u.defaultGenerator.nextId(),U=Q.codeBlockRendererSync(I(k),D);return a.push([R,U]),`<div class="code" data-code="${R}">${(0,p.escape)(D)}</div>`}:Q.codeBlockRenderer&&(h.code=(D,k)=>{const R=u.defaultGenerator.nextId(),U=Q.codeBlockRenderer(I(k),D);return y.push(U.then(Z=>[R,Z])),`<div class="code" data-code="${R}">${(0,p.escape)(D)}</div>`}),Q.actionHandler){const D=function(U){let Z=U.target;if(!(Z.tagName!=="A"&&(Z=Z.parentElement,!Z||Z.tagName!=="A")))try{let oe=Z.dataset.href;oe&&(V.baseUri&&(oe=P(r.URI.from(V.baseUri),oe)),Q.actionHandler.callback(oe,U))}catch(oe){(0,g.onUnexpectedError)(oe)}finally{U.preventDefault()}},k=Q.actionHandler.disposables.add(new x.DomEmitter(Ie,"click")),R=Q.actionHandler.disposables.add(new x.DomEmitter(Ie,"auxclick"));Q.actionHandler.disposables.add(b.Event.any(k.event,R.event)(U=>{const Z=new T.StandardMouseEvent(i.getWindow(Ie),U);!Z.leftButton&&!Z.middleButton||D(Z)})),Q.actionHandler.disposables.add(i.addDisposableListener(Ie,"keydown",U=>{const Z=new _.StandardKeyboardEvent(U);!Z.equals(10)&&!Z.equals(3)||D(Z)}))}V.supportHtml||(ge.sanitizer=D=>(V.isTrusted?D.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?D:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=h;let w=V.value??"";w.length>1e5&&(w=`${w.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(w=(0,c.markdownEscapeEscapedIcons)(w));let F;if(Q.fillInIncompleteTokens){const D={...o.marked.defaults,...ge},k=o.marked.lexer(w,D),R=ae(k);F=o.marked.parser(R,D)}else F=o.marked.parse(w,ge);V.supportThemeIcons&&(F=(0,f.renderLabelWithIcons)(F).map(k=>typeof k=="string"?k:k.outerHTML).join(""));const E=new DOMParser().parseFromString($(V,F),"text/html");if(E.body.querySelectorAll("img, audio, video, source").forEach(D=>{const k=D.getAttribute("src");if(k){let R=k;try{V.baseUri&&(R=P(r.URI.from(V.baseUri),R))}catch{}if(D.setAttribute("src",H(R,!0)),Q.disallowRemoteImages){const U=r.URI.parse(R).scheme;U!==d.Schemas.file&&U!==d.Schemas.data&&D.replaceWith(i.$("",void 0,D.outerHTML))}}}),E.body.querySelectorAll("a").forEach(D=>{const k=D.getAttribute("href");if(D.setAttribute("href",""),!k||/^data:|javascript:/i.test(k)||/^command:/i.test(k)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(k))D.replaceWith(...D.childNodes);else{let R=H(k,!1);V.baseUri&&(R=P(r.URI.from(V.baseUri),k)),D.dataset.href=R}}),Ie.innerHTML=$(V,E.body.innerHTML),y.length>0)Promise.all(y).then(D=>{if(Ae)return;const k=new Map(D),R=Ie.querySelectorAll("div[data-code]");for(const U of R){const Z=k.get(U.dataset.code??"");Z&&i.reset(U,Z)}Q.asyncRenderCallback?.()});else if(a.length>0){const D=new Map(a),k=Ie.querySelectorAll("div[data-code]");for(const R of k){const U=D.get(R.dataset.code??"");U&&i.reset(R,U)}}if(Q.asyncRenderCallback)for(const D of Ie.getElementsByTagName("img")){const k=De.add(i.addDisposableListener(D,"load",()=>{k.dispose(),Q.asyncRenderCallback()}))}return{element:Ie,dispose:()=>{Ae=!0,De.dispose()}}}function I(V){if(!V)return"";const Q=V.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:V}function P(V,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:V.path.endsWith("/")?(0,m.resolvePath)(V,Q).toString():(0,m.resolvePath)((0,m.dirname)(V),Q).toString()}function $(V,Q){const{config:ge,allowedSchemes:De}=v(V);N.addHook("uponSanitizeAttribute",(Ie,Oe)=>{if(Oe.attrName==="style"||Oe.attrName==="class"){if(Ie.tagName==="SPAN"){if(Oe.attrName==="style"){Oe.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Oe.attrValue);return}else if(Oe.attrName==="class"){Oe.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Oe.attrValue);return}}Oe.keepAttr=!1;return}else if(Ie.tagName==="INPUT"&&Ie.attributes.getNamedItem("type")?.value==="checkbox"){if(Oe.attrName==="type"&&Oe.attrValue==="checkbox"||Oe.attrName==="disabled"||Oe.attrName==="checked"){Oe.keepAttr=!0;return}Oe.keepAttr=!1}}),N.addHook("uponSanitizeElement",(Ie,Oe)=>{Oe.tagName==="input"&&(Ie.attributes.getNamedItem("type")?.value==="checkbox"?Ie.setAttribute("disabled",""):Ie.parentElement?.removeChild(Ie))});const Ae=i.hookDomPurifyHrefAndSrcSanitizer(De);try{return N.sanitize(Q,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),Ae.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function v(V){const Q=[d.Schemas.http,d.Schemas.https,d.Schemas.mailto,d.Schemas.data,d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemote,d.Schemas.vscodeRemoteResource];return V.isTrusted&&Q.push(d.Schemas.command),{config:{ALLOWED_TAGS:[...i.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function O(V){return typeof V=="string"?V:q(V)}function q(V){let Q=V.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ge=o.marked.parse(Q,{renderer:W.value}).replace(/&(#\d+|[a-zA-Z]+);/g,De=>L.get(De)??De);return $({isTrusted:!1},ge).toString()}const L=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),W=new e.Lazy(()=>{const V=new o.marked.Renderer;return V.code=Q=>Q,V.blockquote=Q=>Q,V.html=Q=>"",V.heading=(Q,ge,De)=>Q+`
`,V.hr=()=>"",V.list=(Q,ge)=>Q,V.listitem=Q=>Q+`
`,V.paragraph=Q=>Q+`
`,V.table=(Q,ge)=>Q+ge+`
`,V.tablerow=Q=>Q,V.tablecell=(Q,ge)=>Q+" ",V.strong=Q=>Q,V.em=Q=>Q,V.codespan=Q=>Q,V.br=()=>`
`,V.del=Q=>Q,V.image=(Q,ge,De)=>"",V.text=Q=>Q,V.link=(Q,ge,De)=>De,V});function M(V){let Q="";return V.forEach(ge=>{Q+=ge.raw}),Q}function G(V){for(let Q=0;Q<V.tokens.length;Q++){const ge=V.tokens[Q];if(ge.type==="text"){const De=ge.raw.split(`
`),Ae=De[De.length-1];if(Ae.includes("`"))return ee(V);if(Ae.includes("**"))return J(V);if(Ae.match(/\*\w/))return ce(V);if(Ae.match(/(^|\s)__\w/))return he(V);if(Ae.match(/(^|\s)_\w/))return Ee(V);if(Ae.match(/(^|\s)\[.*\]\(\w*/)){const Ie=V.tokens.slice(Q+1);return Ie[0]?.type==="link"&&Ie[1]?.type==="text"&&Ie[1].raw.match(/^ *"[^"]*$/)?Pe(V):Se(V)}else{if(K(Ae))return Se(V);if(Ae.match(/(^|\s)\[\w/)&&!V.tokens.slice(Q+1).some(Ie=>K(Ie.raw)))return le(V)}}}}function K(V){return!!V.match(/^[^\[]*\]\([^\)]*$/)}function ae(V){let Q,ge;for(Q=0;Q<V.length;Q++){const De=V[Q];let Ae;if(De.type==="paragraph"&&(Ae=De.raw.match(/(\n|^)(````*)/))){const Ie=Ae[2];ge=ie(V.slice(Q),Ie);break}if(De.type==="paragraph"&&De.raw.match(/(\n|^)\|/)){ge=ye(V.slice(Q));break}if(Q===V.length-1&&De.type==="paragraph"){const Ie=G(De);if(Ie){ge=[Ie];break}}}if(ge){const De=[...V.slice(0,Q),...ge];return De.links=V.links,De}return V}function ie(V,Q){const ge=M(V);return o.marked.lexer(ge+`
${Q}`)}function ee(V){return re(V,"`")}function ce(V){return re(V,"*")}function Ee(V){return re(V,"_")}function Se(V){return re(V,")")}function Pe(V){return re(V,'")')}function le(V){return re(V,"](about:blank)")}function J(V){return re(V,"**")}function he(V){return re(V,"__")}function re(V,Q){const ge=M(Array.isArray(V)?V:[V]);return o.marked.lexer(ge+Q)[0]}function ye(V){const Q=M(V),ge=Q.split(`
`);let De,Ae=!1;for(let Ie=0;Ie<ge.length;Ie++){const Oe=ge[Ie].trim();if(typeof De>"u"&&Oe.match(/^\s*\|/)){const H=Oe.match(/(\|[^\|]+)(?=\||$)/g);H&&(De=H.length)}else if(typeof De=="number")if(Oe.match(/^\s*\|/)){if(Ie!==ge.length-1)return;Ae=!0}else return}if(typeof De=="number"&&De>0){const Ie=Ae?ge.slice(0,-1).join(`
`):Q,Oe=!!Ie.match(/\|\s*$/),H=Ie+(Oe?"":"|")+`
|${" --- |".repeat(De)}`;return o.marked.lexer(H)}}}),define(me[139],pe([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=i.$,o="selectOption.entry.template";class l{get templateId(){return o}renderTemplate(m){const p=Object.create(null);return p.root=m,p.text=i.append(m,s(".option-text")),p.detail=i.append(m,s(".option-detail")),p.decoratorRight=i.append(m,s(".option-decorator-right")),p}renderElement(m,p,r){const S=r,A=m.text,I=m.detail,P=m.decoratorRight,$=m.isDisabled;S.text.textContent=A,S.detail.textContent=I||"",S.decoratorRight.innerText=P||"",$?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(m){}}class d extends c.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(m,p,r,S,A){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=S,this.selectBoxOptions=A||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=d.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new b.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(r),this.selected=p||0,m&&this.setOptions(m,p),this.initStyleSheet()}setTitle(m){!this._hover&&m?this._hover=this._register((0,_.getBaseLayerHoverDelegate)().setupUpdatableHover((0,T.getDefaultHoverDelegate)("mouse"),this.selectElement,m)):this._hover&&this._hover.update(m)}getHeight(){return 22}getTemplateId(){return o}constructSelectDropDown(m){this.contextViewProvider=m,this.selectDropDownContainer=i.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=i.append(this.selectDropDownContainer,s(".select-box-details-pane"));const p=i.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),r=i.append(p,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",i.append(r,this.widthControlElement),this._dropDownPosition=0,this.styleElement=i.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.DRAG_START,S=>{i.EventHelper.stop(S,!0)}))}registerListeners(){this._register(i.addStandardDisposableListener(this.selectElement,"change",p=>{this.selected=p.target.selectedIndex,this._onDidSelect.fire({index:p.target.selectedIndex,selected:p.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(i.addDisposableListener(this.selectElement,i.EventType.CLICK,p=>{i.EventHelper.stop(p),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.MOUSE_DOWN,p=>{i.EventHelper.stop(p)}));let m;this._register(i.addDisposableListener(this.selectElement,"touchstart",p=>{m=this._isVisible})),this._register(i.addDisposableListener(this.selectElement,"touchend",p=>{i.EventHelper.stop(p),m?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(i.addDisposableListener(this.selectElement,i.EventType.KEY_DOWN,p=>{const r=new x.StandardKeyboardEvent(p);let S=!1;u.isMacintosh?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(S=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(S=!0),S&&(this.showSelectDropDown(),i.EventHelper.stop(p,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(m,p){g.equals(this.options,m)||(this.options=m,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((r,S)=>{this.selectElement.add(this.createOption(r.text,S,r.isDisabled)),typeof r.description=="string"&&(this._hasDetails=!0)})),p!==void 0&&(this.select(p),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(m){m>=0&&m<this.options.length?this.selected=m:m>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(m){this.selectBoxOptions.ariaLabel=m,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(m){this.selectElement.tabIndex=m?0:-1}render(m){this.container=m,m.classList.add("select-container"),m.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const m=[];this.styles.listFocusBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(m.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=m.join(`
`)}styleSelectElement(){const m=this.styles.selectBackground??"",p=this.styles.selectForeground??"",r=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=m,this.selectElement.style.color=p,this.selectElement.style.borderColor=r}styleList(){const m=this.styles.selectBackground??"",p=i.asCssValueWithDefault(this.styles.selectListBackground,m);this.selectDropDownListContainer.style.backgroundColor=p,this.selectionDetailsPane.style.backgroundColor=p;const r=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=r,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(m,p,r){const S=document.createElement("option");return S.value=m,S.text=m,S.disabled=!!r,S}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:m=>this.renderSelectDropDown(m,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:m=>this.renderSelectDropDown(m),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(m){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),m&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(m,p){return m.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(p),{dispose:()=>{try{m.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let m=0;return this.options.forEach((p,r)=>{this.updateDetail(r),this.selectionDetailsPane.offsetHeight>m&&(m=this.selectionDetailsPane.offsetHeight)}),m}layoutSelectDropDown(m){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const p=i.getWindow(this.selectElement),r=i.getDomNodePagePosition(this.selectElement),S=i.getWindow(this.selectElement).getComputedStyle(this.selectElement),A=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),I=p.innerHeight-r.top-r.height-(this.selectBoxOptions.minBottomMargin||0),P=r.top-d.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,$=this.selectElement.offsetWidth,v=this.setWidthControlElement(this.widthControlElement),O=Math.max(v,Math.round($)).toString()+"px";this.selectDropDownContainer.style.width=O,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let q=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const L=this._hasDetails?this._cachedMaxDetailsHeight:0,W=q+A+L,M=Math.floor((I-A-L)/this.getHeight()),G=Math.floor((P-A-L)/this.getHeight());if(m)return r.top+r.height>p.innerHeight-22||r.top<d.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||M<1&&G<1?!1:(M<d.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&G>M&&this.options.length>M?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(r.top+r.height>p.innerHeight-22||r.top<d.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&M<1||this._dropDownPosition===1&&G<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&M+G<1)return this.hideSelectDropDown(!0),!1;W>I&&(q=M*this.getHeight())}else W>P&&(q=G*this.getHeight());return this.selectList.layout(q),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=q+A+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=q+A+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=O,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(m){let p=0;if(m){let r=0,S=0;this.options.forEach((A,I)=>{const P=A.detail?A.detail.length:0,$=A.decoratorRight?A.decoratorRight.length:0,v=A.text.length+P+$;v>S&&(r=I,S=v)}),m.textContent=this.options[r].text+(this.options[r].decoratorRight?this.options[r].decoratorRight+" ":""),p=i.getTotalWidth(m)}return p}createSelectList(m){if(this.selectList)return;this.selectDropDownListContainer=i.append(m,s(".select-box-dropdown-list-container")),this.listRenderer=new l,this.selectList=new f.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let A=S.text;return S.detail&&(A+=`. ${S.detail}`),S.decoratorRight&&(A+=`. ${S.decoratorRight}`),S.description&&(A+=`. ${S.description}`),A},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>u.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const p=this._register(new N.DomEmitter(this.selectDropDownListContainer,"keydown")),r=b.Event.chain(p.event,S=>S.filter(()=>this.selectList.length>0).map(A=>new x.StandardKeyboardEvent(A)));this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===3))(this.onEnter,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===2))(this.onEnter,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===9))(this.onEscape,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===16))(this.onUpArrow,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===18))(this.onDownArrow,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===12))(this.onPageDown,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===11))(this.onPageUp,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===14))(this.onHome,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode===13))(this.onEnd,this)),this._register(b.Event.chain(r,S=>S.filter(A=>A.keyCode>=21&&A.keyCode<=56||A.keyCode>=85&&A.keyCode<=113))(this.onCharacter,this)),this._register(i.addDisposableListener(this.selectList.getHTMLElement(),i.EventType.POINTER_UP,S=>this.onPointerUp(S))),this._register(this.selectList.onMouseOver(S=>typeof S.index<"u"&&this.selectList.setFocus([S.index]))),this._register(this.selectList.onDidChangeFocus(S=>this.onListFocus(S))),this._register(i.addDisposableListener(this.selectDropDownContainer,i.EventType.FOCUS_OUT,S=>{!this._isVisible||i.isAncestor(S.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(m){if(!this.selectList.length)return;i.EventHelper.stop(m);const p=m.target;if(!p||p.classList.contains("slider"))return;const r=p.closest(".monaco-list-row");if(!r)return;const S=Number(r.getAttribute("data-index")),A=r.classList.contains("option-disabled");S>=0&&S<this.options.length&&!A&&(this.selected=S,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(m,p){const r=A=>{for(let I=0;I<A.childNodes.length;I++){const P=A.childNodes.item(I);(P.tagName&&P.tagName.toLowerCase())==="img"?A.removeChild(P):r(P)}},S=(0,z.renderMarkdown)({value:m,supportThemeIcons:!0},{actionHandler:p});return S.element.classList.add("select-box-description-markdown"),r(S.element),S.element}onListFocus(m){!this._isVisible||!this._hasDetails||this.updateDetail(m.indexes[0])}updateDetail(m){this.selectionDetailsPane.innerText="";const p=this.options[m],r=p?.description??"",S=p?.descriptionIsMarkdown??!1;if(r){if(S){const A=p.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(r,A))}else this.selectionDetailsPane.innerText=r;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(m){i.EventHelper.stop(m),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(m){i.EventHelper.stop(m),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(m){if(this.selected<this.options.length-1){i.EventHelper.stop(m,!0);const p=this.options[this.selected+1].isDisabled;if(p&&this.options.length>this.selected+2)this.selected+=2;else{if(p)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(m){this.selected>0&&(i.EventHelper.stop(m,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(m){i.EventHelper.stop(m),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(m){i.EventHelper.stop(m),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(m){i.EventHelper.stop(m),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(m){i.EventHelper.stop(m),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(m){const p=B.KeyCodeUtils.toString(m.keyCode);let r=-1;for(let S=0;S<this.options.length-1;S++)if(r=(S+this.selected+1)%this.options.length,this.options[r].text.charAt(0).toUpperCase()===p&&!this.options[r].isDisabled){this.select(r),this.selectList.setFocus([r]),this.selectList.reveal(this.selectList.getFocus()[0]),i.EventHelper.stop(m);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=d}),define(me[140],pe([1,0,49,139,133,21,5,112]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...i.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class T extends z.Widget{constructor(g,b,B,c,u){super(),_.isMacintosh&&!u?.useCustomDrawn?this.selectBoxDelegate=new x.SelectBoxNative(g,b,c,u):this.selectBoxDelegate=new N.SelectBoxList(g,b,B,c,u),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(g,b){this.selectBoxDelegate.setOptions(g,b)}select(g){this.selectBoxDelegate.select(g)}setAriaLabel(g){this.selectBoxDelegate.setAriaLabel(g)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(g){this.selectBoxDelegate.setFocusable(g)}render(g){this.selectBoxDelegate.render(g)}}t.SelectBox=T}),define(me[73],pe([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class e extends g.Disposable{get action(){return this._action}constructor(d,C,m={}){super(),this.options=m,this._context=d||this,this._action=C,C instanceof f.Action&&this._register(C.onDidChange(p=>{this.element&&this.handleActionChangeEvent(p)}))}handleActionChangeEvent(d){d.enabled!==void 0&&this.updateEnabled(),d.checked!==void 0&&this.updateChecked(),d.class!==void 0&&this.updateClass(),d.label!==void 0&&(this.updateLabel(),this.updateTooltip()),d.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new f.ActionRunner)),this._actionRunner}set actionRunner(d){this._actionRunner=d}isEnabled(){return this._action.enabled}setActionContext(d){this._context=d}render(d){const C=this.element=d;this._register(z.Gesture.addTarget(d));const m=this.options&&this.options.draggable;m&&(d.draggable=!0,i.isFirefox&&this._register((0,x.addDisposableListener)(d,x.EventType.DRAG_START,p=>p.dataTransfer?.setData(N.DataTransfers.TEXT,this._action.label)))),this._register((0,x.addDisposableListener)(C,z.EventType.Tap,p=>this.onClick(p,!0))),this._register((0,x.addDisposableListener)(C,x.EventType.MOUSE_DOWN,p=>{m||x.EventHelper.stop(p,!0),this._action.enabled&&p.button===0&&C.classList.add("active")})),b.isMacintosh&&this._register((0,x.addDisposableListener)(C,x.EventType.CONTEXT_MENU,p=>{p.button===0&&p.ctrlKey===!0&&this.onClick(p)})),this._register((0,x.addDisposableListener)(C,x.EventType.CLICK,p=>{x.EventHelper.stop(p,!0),this.options&&this.options.isMenu||this.onClick(p)})),this._register((0,x.addDisposableListener)(C,x.EventType.DBLCLICK,p=>{x.EventHelper.stop(p,!0)})),[x.EventType.MOUSE_UP,x.EventType.MOUSE_OUT].forEach(p=>{this._register((0,x.addDisposableListener)(C,p,r=>{x.EventHelper.stop(r),C.classList.remove("active")}))})}onClick(d,C=!1){x.EventHelper.stop(d,!0);const m=B.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?d:{preserveFocus:C}:this._context;this.actionRunner.run(this._action,m)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(d){this.element&&(this.element.tabIndex=d?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const d=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=d;else if(!this.customHover&&d!==""){const C=this.options.hoverDelegate??(0,_.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,u.getBaseLayerHoverDelegate)().setupUpdatableHover(C,this.element,d))}else this.customHover&&this.customHover.update(d)}updateAriaLabel(){if(this.element){const d=this.getTooltip()??"";this.element.setAttribute("aria-label",d)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class s extends e{constructor(d,C,m){super(d,C,m),this.options=m,this.options.icon=m.icon!==void 0?m.icon:!1,this.options.label=m.label!==void 0?m.label:!0,this.cssClass=""}render(d){super.render(d),B.assertType(this.element);const C=document.createElement("a");if(C.classList.add("action-label"),C.setAttribute("role",this.getDefaultAriaRole()),this.label=C,this.element.appendChild(C),this.options.label&&this.options.keybinding){const m=document.createElement("span");m.classList.add("keybinding"),m.textContent=this.options.keybinding,this.element.appendChild(m)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===f.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(d){this.label&&(this.label.tabIndex=d?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let d=null;return this.action.tooltip?d=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(d=this.action.label,this.options.keybinding&&(d=c.localize(0,null,d,this.options.keybinding))),d??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const d=this.getTooltip()??"";this.label.setAttribute("aria-label",d)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.removeAttribute("aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=s;class o extends e{constructor(d,C,m,p,r,S,A){super(d,C),this.selectBox=new T.SelectBox(m,p,r,S,A),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(d,C){this.selectBox.setOptions(d,C)}select(d){this.selectBox.select(d)}registerListeners(){this._register(this.selectBox.onDidSelect(d=>this.runAction(d.selected,d.index)))}runAction(d,C){this.actionRunner.run(this._action,this.getActionContext(d,C))}getActionContext(d,C){return d}setFocusable(d){this.selectBox.setFocusable(d)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(d){this.selectBox.render(d)}}t.SelectActionViewItem=o}),define(me[74],pe([1,0,4,15,73,14,46,3,2,10,63]),function(ne,t,i,N,x,z,_,T,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=c;var b;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(b||(t.ActionsOrientation=b={}));class B extends f.Disposable{constructor(e,s={}){super(),this._actionRunnerDisposables=this._register(new f.DisposableStore),this.viewItemDisposables=this._register(new f.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new T.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new T.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new T.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new T.Emitter),this.onWillRun=this._onWillRun.event,this.options=s,this._context=s.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this._hoverDelegate=s.hoverDelegate??this._register((0,z.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new _.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(d=>this._onDidRun.fire(d))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(d=>this._onWillRun.fire(d))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let o,l;switch(this._orientation){case 0:o=[15],l=[17];break;case 1:o=[16],l=[18],this.domNode.className+=" vertical";break}this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_DOWN,d=>{const C=new N.StandardKeyboardEvent(d);let m=!0;const p=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;o&&(C.equals(o[0])||C.equals(o[1]))?m=this.focusPrevious():l&&(C.equals(l[0])||C.equals(l[1]))?m=this.focusNext():C.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():C.equals(14)?m=this.focusFirst():C.equals(13)?m=this.focusLast():C.equals(2)&&p instanceof x.BaseActionViewItem&&p.trapsArrowNavigation?m=this.focusNext():this.isTriggerKeyEvent(C)?this._triggerKeys.keyDown?this.doTrigger(C):this.triggerKeyDown=!0:m=!1,m&&(C.preventDefault(),C.stopPropagation())})),this._register(i.addDisposableListener(this.domNode,i.EventType.KEY_UP,d=>{const C=new N.StandardKeyboardEvent(d);this.isTriggerKeyEvent(C)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(C)),C.preventDefault(),C.stopPropagation()):(C.equals(2)||C.equals(1026)||C.equals(16)||C.equals(18)||C.equals(15)||C.equals(17))&&this.updateFocusedItem()})),this.focusTracker=this._register(i.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(i.getActiveElement()===this.domNode||!i.isAncestor(i.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),e.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(e){e?this.actionsList.setAttribute("aria-label",e):this.actionsList.removeAttribute("aria-label")}setFocusable(e){if(this.focusable=e,this.focusable){const s=this.viewItems.find(o=>o instanceof x.BaseActionViewItem&&o.isEnabled());s instanceof x.BaseActionViewItem&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof x.BaseActionViewItem&&s.setFocusable(!1)})}isTriggerKeyEvent(e){let s=!1;return this._triggerKeys.keys.forEach(o=>{s=s||e.equals(o)}),s}updateFocusedItem(){for(let e=0;e<this.actionsList.children.length;e++){const s=this.actionsList.children[e];if(i.isAncestor(i.getActiveElement(),s)){this.focusedItem=e,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(e){this._context=e,this.viewItems.forEach(s=>s.setActionContext(e))}get actionRunner(){return this._actionRunner}set actionRunner(e){this._actionRunner=e,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(s=>this._onDidRun.fire(s))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(s=>this._onWillRun.fire(s))),this.viewItems.forEach(s=>s.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(s=>s.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.actionsList;){if(!e.parentElement)return;e=e.parentElement}for(let s=0;s<this.actionsList.childNodes.length;s++)if(this.actionsList.childNodes[s]===e)return this.viewItems[s].action}}push(e,s={}){const o=Array.isArray(e)?e:[e];let l=g.isNumber(s.index)?s.index:null;o.forEach(d=>{const C=document.createElement("li");C.className="action-item",C.setAttribute("role","presentation");let m;const p={hoverDelegate:this._hoverDelegate,...s};this.options.actionViewItemProvider&&(m=this.options.actionViewItemProvider(d,p)),m||(m=new x.ActionViewItem(this.context,d,p)),this.options.allowContextMenu||this.viewItemDisposables.set(m,i.addDisposableListener(C,i.EventType.CONTEXT_MENU,r=>{i.EventHelper.stop(r,!0)})),m.actionRunner=this._actionRunner,m.setActionContext(this.context),m.render(C),this.focusable&&m instanceof x.BaseActionViewItem&&this.viewItems.length===0&&m.setFocusable(!0),l===null||l<0||l>=this.actionsList.children.length?(this.actionsList.appendChild(C),this.viewItems.push(m)):(this.actionsList.insertBefore(C,this.actionsList.children[l]),this.viewItems.splice(l,0,m),l++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(e){if(e>=0&&e<this.actionsList.children.length){const s=this.actionsList.children.item(e);if(s)return s.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.actionsList.children.length){const s=this.actionsList.children.item(e);if(s)return s.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[e]),this.viewItemDisposables.deleteAndDispose(this.viewItems[e]),(0,f.dispose)(this.viewItems.splice(e,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,f.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),i.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let s=!1,o;if(e===void 0?s=!0:typeof e=="number"?o=e:typeof e=="boolean"&&(s=e),s&&typeof this.focusedItem>"u"){const l=this.viewItems.findIndex(d=>d.isEnabled());this.focusedItem=l===-1?void 0:l,this.updateFocus(void 0,void 0,!0)}else o!==void 0&&(this.focusedItem=o),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(e){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.focusedItem;let o;do{if(!e&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=s,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,o=this.viewItems[this.focusedItem]}while(this.focusedItem!==s&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===_.Separator.ID));return this.updateFocus(),!0}focusPrevious(e){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const s=this.focusedItem;let o;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!e&&this.options.preventLoopNavigation)return this.focusedItem=s,!1;this.focusedItem=this.viewItems.length-1}o=this.viewItems[this.focusedItem]}while(this.focusedItem!==s&&(this.options.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===_.Separator.ID));return this.updateFocus(!0),!0}updateFocus(e,s,o=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:s}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const l=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(l){let d=!0;g.isFunction(l.focus)||(d=!1),this.options.focusOnlyEnabledItems&&g.isFunction(l.isEnabled)&&!l.isEnabled()&&(d=!1),l.action.id===_.Separator.ID&&(d=!1),d?(o||this.previouslyFocusedItem!==this.focusedItem)&&(l.focus(e),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:s}),this.previouslyFocusedItem=void 0),d&&l.showHover?.()}}doTrigger(e){if(typeof this.focusedItem>"u")return;const s=this.viewItems[this.focusedItem];if(s instanceof x.BaseActionViewItem){const o=s._context===null||s._context===void 0?e:s._context;this.run(s._action,o)}}async run(e,s){await this._actionRunner.run(e,s)}dispose(){this._context=void 0,this.viewItems=(0,f.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=B;function c(u){if(!u.length)return u;let e=-1;for(let o=0;o<u.length;o++)if(u[o].id!==_.Separator.ID){e=o;break}if(e===-1)return[];u=u.slice(e);for(let o=u.length-1;o>=0&&u[o].id===_.Separator.ID;o--)u.splice(o,1);let s=!1;for(let o=u.length-1;o>=0;o--){const l=u[o].id===_.Separator.ID;l&&!s?u.splice(o,1):l?l&&(s=!1):s=!0}return u}}),define(me[75],pe([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const s=i.$;var o;(function(C){C[C.INFO=1]="INFO",C[C.WARNING=2]="WARNING",C[C.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends b.Widget{constructor(m,p,r){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new B.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new B.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=p,this.options=r,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=i.append(m,s(".monaco-inputbox.idle"));const S=this.options.flexibleHeight?"textarea":"input",A=i.append(this.element,s(".ibwrapper"));if(this.input=i.append(A,s(S+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=i.append(A,s("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new g.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),i.append(m,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll($=>this.input.scrollTop=$.scrollTop));const I=this._register(new N.DomEmitter(m.ownerDocument,"selectionchange")),P=B.Event.filter(I.event,()=>m.ownerDocument.getSelection()?.anchorNode===A);this._register(P(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new z.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(m){this.placeholder=m,this.input.setAttribute("placeholder",m)}setTooltip(m){this.tooltip=m,this.hover?this.hover.update(m):this.hover=this._register((0,T.getBaseLayerHoverDelegate)().setupUpdatableHover((0,f.getDefaultHoverDelegate)("mouse"),this.input,m))}setAriaLabel(m){this.ariaLabel=m,m?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(m){this.input.value!==m&&(this.input.value=m,this.onValueChange())}get step(){return this.input.step}set step(m){this.input.step=m}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:i.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return i.isActiveElement(this.input)}select(m=null){this.input.select(),m&&(this.input.setSelectionRange(m.start,m.end),m.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const m=this.input.selectionStart;if(m===null)return null;const p=this.input.selectionEnd??m;return{start:m,end:p}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(m){m?this.enable():this.disable()}get width(){return i.getTotalWidth(this.input)}set width(m){if(this.options.flexibleHeight&&this.options.flexibleWidth){let p=0;if(this.mirror){const r=parseFloat(this.mirror.style.paddingLeft||"")||0,S=parseFloat(this.mirror.style.paddingRight||"")||0;p=r+S}this.input.style.width=m-p+"px"}else this.input.style.width=m+"px";this.mirror&&(this.mirror.style.width=m+"px")}set paddingRight(m){this.input.style.width=`calc(100% - ${m}px)`,this.mirror&&(this.mirror.style.paddingRight=m+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const m=this.cachedContentHeight,p=this.cachedHeight,r=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:m,height:p}),this.scrollableElement.setScrollPosition({scrollTop:r})}showMessage(m,p){if(this.state==="open"&&(0,u.equals)(this.message,m))return;this.message=m,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(m.type));const r=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${i.asCssValueWithDefault(r.border,"transparent")}`,this.message.content&&(this.hasFocus()||p)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let m=null;return this.validation&&(m=this.validation(this.value),m?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(m)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),m?.type}stylesForType(m){const p=this.options.inputBoxStyles;switch(m){case 1:return{border:p.inputValidationInfoBorder,background:p.inputValidationInfoBackground,foreground:p.inputValidationInfoForeground};case 2:return{border:p.inputValidationWarningBorder,background:p.inputValidationWarningBackground,foreground:p.inputValidationWarningForeground};default:return{border:p.inputValidationErrorBorder,background:p.inputValidationErrorBackground,foreground:p.inputValidationErrorForeground}}}classForType(m){switch(m){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let m;const p=()=>m.style.width=i.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.message)return null;m=i.append(S,s(".monaco-inputbox-container")),p();const A={inline:!0,className:"monaco-inputbox-message"},I=this.message.formatContent?(0,x.renderFormattedText)(this.message.content,A):(0,x.renderText)(this.message.content,A);I.classList.add(this.classForType(this.message.type));const P=this.stylesForType(this.message.type);return I.style.backgroundColor=P.background??"",I.style.color=P.foreground??"",I.style.border=P.border?`1px solid ${P.border}`:"",i.append(m,I),null},onHide:()=>{this.state="closed"},layout:p});let r;this.message.type===3?r=e.localize(0,null,this.message.content):this.message.type===2?r=e.localize(1,null,this.message.content):r=e.localize(2,null,this.message.content),_.alert(r),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const m=this.value,r=m.charCodeAt(m.length-1)===10?" ":"";(m+r).replace(/\u000c/g,"")?this.mirror.textContent=m+r:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const m=this.options.inputBoxStyles,p=m.inputBackground??"",r=m.inputForeground??"",S=m.inputBorder??"";this.element.style.backgroundColor=p,this.element.style.color=r,this.input.style.backgroundColor="inherit",this.input.style.color=r,this.element.style.border=`1px solid ${i.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.mirror)return;const m=this.cachedContentHeight;this.cachedContentHeight=i.getTotalHeight(this.mirror),m!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(m){const p=this.inputElement,r=p.selectionStart,S=p.selectionEnd,A=p.value;r!==null&&S!==null&&(this.value=A.substr(0,r)+m+A.substr(S),p.setSelectionRange(r+1,r+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=l;class d extends l{constructor(m,p,r){const S=e.localize(3,null,"\u21C5"),A=e.localize(4,null,"\u21C5");super(m,p,r),this._onDidFocus=this._register(new B.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new B.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new c.HistoryNavigator(r.history,100);const I=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.placeholder.endsWith(S)&&!this.placeholder.endsWith(A)&&this.history.getHistory().length){const P=this.placeholder.endsWith(")")?S:A,$=this.placeholder+P;r.showPlaceholderOnFocus&&!i.isActiveElement(this.input)?this.placeholder=$:this.setPlaceHolder($)}};this.observer=new MutationObserver((P,$)=>{P.forEach(v=>{v.target.textContent||I()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>I()),this.onblur(this.input,()=>{const P=$=>{if(this.placeholder.endsWith($)){const v=this.placeholder.slice(0,this.placeholder.length-$.length);return r.showPlaceholderOnFocus?this.placeholder=v:this.setPlaceHolder(v),!0}else return!1};P(A)||P(S)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(m){this.value&&(m||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(m){const p=this.getHistory();this.clearHistory(),m.forEach(r=>{this.history.add(r)}),p.forEach(r=>{this.history.add(r)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let m=this.getNextValue();m&&(m=m===this.value?this.getNextValue():m),this.value=m??"",_.status(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let m=this.getPreviousValue();m&&(m=m===this.value?this.getPreviousValue():m),m&&(this.value=m,_.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(m){super.setPlaceHolder(m),this.setTooltip(m)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let m=this.history.current();return m||(m=this.history.last(),this.history.next()),m}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=d}),define(me[76],pe([1,0,73,21,18,19,3,4,14,29,114]),function(ne,t,i,N,x,z,_,T,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class b extends i.BaseActionViewItem{constructor(s,o,l){super(s,o,l),this.toggle=this._register(new B({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(s){this.element=s,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(s){this.toggle.domNode.tabIndex=s?0:-1}}t.ToggleActionViewItem=b;class B extends N.Widget{constructor(s){super(),this._onChange=this._register(new _.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=s,this._checked=this._opts.isChecked;const o=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,o.push(...z.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&o.push(...this._opts.actionClassName.split(" ")),this._checked&&o.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,g.getBaseLayerHoverDelegate)().setupUpdatableHover(s.hoverDelegate??(0,f.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...o),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,l=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),l.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),l.preventDefault(),l.stopPropagation();return}this._onKeyDown.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(s){this._checked=s,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(s){this._icon&&this.domNode.classList.remove(...z.ThemeIcon.asClassNameArray(this._icon)),this._icon=s,this._icon&&this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this._hover.update(s),this.domNode.setAttribute("aria-label",s)}set visible(s){this.domNode.style.display=s?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.Toggle=B;class c extends N.Widget{constructor(s,o,l){super(),this.title=s,this.isChecked=o,this._onChange=this._register(new _.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new B({title:this.title,isChecked:this.isChecked,icon:x.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=l,this.applyStyles(),this._register(this.checkbox.onChange(d=>{this.applyStyles(),this._onChange.fire(d)}))}get checked(){return this.checkbox.checked}set checked(s){this.checkbox.checked=s,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,T.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=c;class u extends i.BaseActionViewItem{constructor(s,o,l){super(s,o,l),this.toggle=this._register(new c(this._action.label,!!this._action.checked,l.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const o=this.element.appendChild((0,T.$)("span.checkbox-label",void 0,this._action.label));this._register((0,T.addDisposableListener)(o,T.EventType.CLICK,l=>{this.toggle.checked=!this.toggle.checked,l.stopPropagation(),l.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(s){this.toggle.domNode.tabIndex=s?0:-1}}t.CheckboxActionViewItem=u}),define(me[141],pe([1,0,14,76,18,119]),function(ne,t,i,N,x,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const _=z.localize(0,null),T=z.localize(1,null),f=z.localize(2,null);class g extends N.Toggle{constructor(u){super({icon:x.Codicon.caseSensitive,title:_+u.appendTitle,isChecked:u.isChecked,hoverDelegate:u.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.CaseSensitiveToggle=g;class b extends N.Toggle{constructor(u){super({icon:x.Codicon.wholeWord,title:T+u.appendTitle,isChecked:u.isChecked,hoverDelegate:u.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.WholeWordsToggle=b;class B extends N.Toggle{constructor(u){super({icon:x.Codicon.regex,title:f+u.appendTitle,isChecked:u.isChecked,hoverDelegate:u.hoverDelegate??(0,i.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.RegexToggle=B}),define(me[142],pe([1,0,4,141,75,21,3,118,2,14,108]),function(ne,t,i,N,x,z,_,T,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const b=T.localize(0,null);class B extends z.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(u,e,s){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new f.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new _.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new _.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new _.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new _.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new _.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new _.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=s.placeholder||"",this.validation=s.validation,this.label=s.label||b,this.showCommonFindToggles=!!s.showCommonFindToggles;const o=s.appendCaseSensitiveLabel||"",l=s.appendWholeWordsLabel||"",d=s.appendRegexLabel||"",C=s.history||[],m=!!s.flexibleHeight,p=!!s.flexibleWidth,r=s.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new x.HistoryInputBox(this.domNode,e,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:C,showHistoryHint:s.showHistoryHint,flexibleHeight:m,flexibleWidth:p,flexibleMaxHeight:r,inputBoxStyles:s.inputBoxStyles}));const S=this._register((0,g.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new N.RegexToggle({appendTitle:d,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this._register(this.regex.onChange(I=>{this._onDidOptionChange.fire(I),!I&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(I=>{this._onRegexKeyDown.fire(I)})),this.wholeWords=this._register(new N.WholeWordsToggle({appendTitle:l,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this._register(this.wholeWords.onChange(I=>{this._onDidOptionChange.fire(I),!I&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new N.CaseSensitiveToggle({appendTitle:o,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this._register(this.caseSensitive.onChange(I=>{this._onDidOptionChange.fire(I),!I&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(I=>{this._onCaseSensitiveKeyDown.fire(I)}));const A=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,I=>{if(I.equals(15)||I.equals(17)||I.equals(9)){const P=A.indexOf(this.domNode.ownerDocument.activeElement);if(P>=0){let $=-1;I.equals(17)?$=(P+1)%A.length:I.equals(15)&&(P===0?$=A.length-1:$=P-1),I.equals(9)?(A[P].blur(),this.inputBox.focus()):$>=0&&A[$].focus(),i.EventHelper.stop(I,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(s?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),u?.appendChild(this.domNode),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionstart",A=>{this.imeSessionInProgress=!0})),this._register(i.addDisposableListener(this.inputBox.inputElement,"compositionend",A=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,A=>this._onKeyDown.fire(A)),this.onkeyup(this.inputBox.inputElement,A=>this._onKeyUp.fire(A)),this.oninput(this.inputBox.inputElement,A=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,A=>this._onMouseDown.fire(A))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(u){this.inputBox.layout(),this.updateInputBoxPadding(u.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const u of this.additionalToggles)u.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const u of this.additionalToggles)u.disable()}setFocusInputOnOptionClick(u){this.fixFocusOnOptionClickEnabled=u}setEnabled(u){u?this.enable():this.disable()}setAdditionalToggles(u){for(const e of this.additionalToggles)e.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new f.DisposableStore;for(const e of u??[])this.additionalTogglesDisposables.value.add(e),this.controls.appendChild(e.domNode),this.additionalTogglesDisposables.value.add(e.onChange(s=>{this._onDidOptionChange.fire(s),!s&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(e);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(u=!1){u?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((e,s)=>e+s.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(u){this.inputBox.value!==u&&(this.inputBox.value=u)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(u){this.caseSensitive&&(this.caseSensitive.checked=u)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(u){this.wholeWords&&(this.wholeWords.checked=u)}getRegex(){return this.regex?.checked??!1}setRegex(u){this.regex&&(this.regex.checked=u,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(u){this.inputBox.showMessage(u)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=B}),define(me[143],pe([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s,o,l,d,C,m,p,r,S,A,I,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class $ extends f.ElementsDragAndDropData{set context(n){this.data.context=n}get context(){return this.data.context}constructor(n){super(n.elements.map(E=>E.element)),this.data=n}}function v(F){return F instanceof f.ElementsDragAndDropData?new $(F):F}class O{constructor(n,E){this.modelProvider=n,this.dnd=E,this.autoExpandDisposable=p.Disposable.None,this.disposables=new p.DisposableStore}getDragURI(n){return this.dnd.getDragURI(n.element)}getDragLabel(n,E){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(n.map(D=>D.element),E)}onDragStart(n,E){this.dnd.onDragStart?.(v(n),E)}onDragOver(n,E,D,k,R,U=!0){const Z=this.dnd.onDragOver(v(n),E&&E.element,D,k,R),oe=this.autoExpandNode!==E;if(oe&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=E),typeof E>"u")return Z;if(oe&&typeof Z!="boolean"&&Z.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Me=this.modelProvider(),Ce=Me.getNodeLocation(E);Me.isCollapsed(Ce)&&Me.setCollapsed(Ce,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!U){const Me=typeof Z=="boolean"?Z:Z.accept,Ce=typeof Z=="boolean"?void 0:Z.effect;return{accept:Me,effect:Ce,feedback:[D]}}return Z}if(Z.bubble===1){const Me=this.modelProvider(),Ce=Me.getNodeLocation(E),Ne=Me.getParentNodeLocation(Ce),Ve=Me.getNode(Ne),Ye=Ne&&Me.getListIndex(Ne);return this.onDragOver(n,Ve,Ye,k,R,!1)}const ve=this.modelProvider(),de=ve.getNodeLocation(E),ke=ve.getListIndex(de),Te=ve.getListRenderCount(de);return{...Z,feedback:(0,e.range)(ke,ke+Te)}}drop(n,E,D,k,R){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(v(n),E&&E.element,D,k,R)}onDragEnd(n){this.dnd.onDragEnd?.(n)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function q(F,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(E){return n.identityProvider.getId(E.element)}},dnd:n.dnd&&new O(F,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return n.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return n.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(E){const D=F(),k=D.getNodeLocation(E),R=D.getParentNodeLocation(k);return D.getNode(R).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?E=>n.accessibilityProvider.isChecked(E.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?E=>n.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return n.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?E=>n.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(E=>n.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class L{constructor(n){this.delegate=n}getHeight(n){return this.delegate.getHeight(n.element)}getTemplateId(n){return this.delegate.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(n.element)}setDynamicHeight(n,E){this.delegate.setDynamicHeight?.(n.element,E)}}t.ComposedTreeDelegate=L;class W{static lift(n){return n instanceof W?n:new W(n)}static empty(n=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const E of n.expanded)this.expanded[E]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=W;var M;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(M||(t.RenderIndentGuides=M={}));class G{get elements(){return this._elements}constructor(n,E=[]){this._elements=E,this.disposables=new p.DisposableStore,this.onDidChange=C.Event.forEach(n,D=>this._elements=D,this.disposables)}dispose(){this.disposables.dispose()}}class K{static{this.DefaultIndent=8}constructor(n,E,D,k,R,U={}){this.renderer=n,this.modelProvider=E,this.activeNodes=k,this.renderedIndentGuides=R,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=K.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=p.Disposable.None,this.disposables=new p.DisposableStore,this.templateId=n.templateId,this.updateOptions(U),C.Event.map(D,Z=>Z.node)(this.onDidChangeNodeTwistieState,this,this.disposables),n.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(n={}){if(typeof n.indent<"u"){const E=(0,r.clamp)(n.indent,0,40);if(E!==this.indent){this.indent=E;for(const[D,k]of this.renderedNodes)this.renderTreeElement(D,k)}}if(typeof n.renderIndentGuides<"u"){const E=n.renderIndentGuides!==M.None;if(E!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=E;for(const[D,k]of this.renderedNodes)this._renderIndentGuides(D,k);if(this.indentGuidesDisposable.dispose(),E){const D=new p.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,D),this.indentGuidesDisposable=D,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const E=(0,i.append)(n,(0,i.$)(".monaco-tl-row")),D=(0,i.append)(E,(0,i.$)(".monaco-tl-indent")),k=(0,i.append)(E,(0,i.$)(".monaco-tl-twistie")),R=(0,i.append)(E,(0,i.$)(".monaco-tl-contents")),U=this.renderer.renderTemplate(R);return{container:n,indent:D,twistie:k,indentGuidesDisposable:p.Disposable.None,templateData:U}}renderElement(n,E,D,k){this.renderedNodes.set(n,D),this.renderedElements.set(n.element,n),this.renderTreeElement(n,D),this.renderer.renderElement(n,E,D.templateData,k)}disposeElement(n,E,D,k){D.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(n,E,D.templateData,k),typeof k=="number"&&(this.renderedNodes.delete(n),this.renderedElements.delete(n.element))}disposeTemplate(n){this.renderer.disposeTemplate(n.templateData)}onDidChangeTwistieState(n){const E=this.renderedElements.get(n);E&&this.onDidChangeNodeTwistieState(E)}onDidChangeNodeTwistieState(n){const E=this.renderedNodes.get(n);E&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(n,E))}renderTreeElement(n,E){const D=K.DefaultIndent+(n.depth-1)*this.indent;E.twistie.style.paddingLeft=`${D}px`,E.indent.style.width=`${D+this.indent-16}px`,n.collapsible?E.container.setAttribute("aria-expanded",String(!n.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...l.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded));let k=!1;this.renderer.renderTwistie&&(k=this.renderer.renderTwistie(n.element,E.twistie)),n.collapsible&&(!this.hideTwistiesOfChildlessElements||n.visibleChildrenCount>0)?(k||E.twistie.classList.add(...l.ThemeIcon.asClassNameArray(o.Codicon.treeItemExpanded)),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",n.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(n,E)}_renderIndentGuides(n,E){if((0,i.clearNode)(E.indent),E.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const D=new p.DisposableStore,k=this.modelProvider();for(;;){const R=k.getNodeLocation(n),U=k.getParentNodeLocation(R);if(!U)break;const Z=k.getNode(U),oe=(0,i.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(Z)&&oe.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(oe):E.indent.insertBefore(oe,E.indent.firstElementChild),this.renderedIndentGuides.add(Z,oe),D.add((0,p.toDisposable)(()=>this.renderedIndentGuides.delete(Z,oe))),n=Z}E.indentGuidesDisposable=D}_onDidChangeActiveNodes(n){if(!this.shouldRenderIndentGuides)return;const E=new Set,D=this.modelProvider();n.forEach(k=>{const R=D.getNodeLocation(k);try{const U=D.getParentNodeLocation(R);k.collapsible&&k.children.length>0&&!k.collapsed?E.add(k):U&&E.add(D.getNode(U))}catch{}}),this.activeIndentNodes.forEach(k=>{E.has(k)||this.renderedIndentGuides.forEach(k,R=>R.classList.remove("active"))}),E.forEach(k=>{this.activeIndentNodes.has(k)||this.renderedIndentGuides.forEach(k,R=>R.classList.add("active"))}),this.activeIndentNodes=E}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,p.dispose)(this.disposables)}}t.TreeRenderer=K;class ae{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(n){this._pattern=n,this._lowercasePattern=n.toLowerCase()}constructor(n,E,D){this.tree=n,this.keyboardNavigationLabelProvider=E,this._filter=D,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new p.DisposableStore,n.onWillRefilter(this.reset,this,this.disposables)}filter(n,E){let D=1;if(this._filter){const U=this._filter.filter(n,E);if(typeof U=="boolean"?D=U?1:0:(0,B.isFilterResult)(U)?D=(0,B.getVisibleState)(U.visibility):D=U,D===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:m.FuzzyScore.Default,visibility:D};const k=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(n),R=Array.isArray(k)?k:[k];for(const U of R){const Z=U&&U.toString();if(typeof Z>"u")return{data:m.FuzzyScore.Default,visibility:D};let oe;if(this.tree.findMatchType===Se.Contiguous){const ve=Z.toLowerCase().indexOf(this._lowercasePattern);if(ve>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let de=this._lowercasePattern.length;de>0;de--)oe.push(ve+de-1)}}else oe=(0,m.fuzzyScore)(this._pattern,this._lowercasePattern,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this._matchCount++,R.length===1?{data:oe,visibility:D}:{data:{label:Z,score:oe},visibility:D}}return this.tree.findMode===Ee.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(n):2:{data:m.FuzzyScore.Default,visibility:D}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,p.dispose)(this.disposables)}}class ie extends b.Toggle{constructor(n){super({icon:o.Codicon.listFilter,title:(0,A.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.ModeToggle=ie;class ee extends b.Toggle{constructor(n){super({icon:o.Codicon.searchFuzzy,title:(0,A.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.FuzzyToggle=ee;const ce={inputBoxStyles:T.unthemedInboxStyles,toggleStyles:b.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Ee;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Ee||(t.TreeFindMode=Ee={}));var Se;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Se||(t.TreeFindMatchType=Se={}));class Pe extends p.Disposable{set mode(n){this.modeToggle.checked=n===Ee.Filter,this.findInput.inputBox.setPlaceHolder(n===Ee.Filter?(0,A.localize)(2,null):(0,A.localize)(3,null))}set matchType(n){this.matchTypeToggle.checked=n===Se.Fuzzy}get value(){return this.findInput.inputBox.value}set value(n){this.findInput.inputBox.value=n}constructor(n,E,D,k,R,U){super(),this.tree=E,this.elements=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new C.Emitter,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.elements.root),this._register((0,p.toDisposable)(()=>n.removeChild(this.elements.root)));const Z=U?.styles??ce;Z.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const oe=this._register((0,I.createInstantHoverDelegate)());this.modeToggle=this._register(new ie({...Z.toggleStyles,isChecked:k===Ee.Filter,hoverDelegate:oe})),this.matchTypeToggle=this._register(new ee({...Z.toggleStyles,isChecked:R===Se.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=C.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?Ee.Filter:Ee.Highlight,this._store),this.onDidChangeMatchType=C.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Se.Fuzzy:Se.Contiguous,this._store),this.findInput=this._register(new _.FindInput(this.elements.findInput,D,{label:(0,A.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:U?.history})),this.actionbar=this._register(new z.ActionBar(this.elements.actionbar)),this.mode=k;const ve=this._register(new N.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),de=C.Event.chain(ve.event,Ce=>Ce.map(Ne=>new x.StandardKeyboardEvent(Ne)));this._register(de(Ce=>{if(Ce.equals(3)){Ce.preventDefault(),Ce.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(Ce.equals(18)){Ce.preventDefault(),Ce.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(Ce.equals(16)){Ce.preventDefault(),Ce.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const ke=this._register(new u.Action("close",(0,A.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(ke,{icon:!0,label:!1});const Te=this._register(new N.DomEmitter(this.elements.grab,"mousedown"));this._register(Te.event(Ce=>{const Ne=new p.DisposableStore,Ve=Ne.add(new N.DomEmitter((0,i.getWindow)(Ce),"mousemove")),Ye=Ne.add(new N.DomEmitter((0,i.getWindow)(Ce),"mouseup")),Ue=this.right,Je=Ce.pageX,X=this.top,se=Ce.pageY;this.elements.grab.classList.add("grabbing");const be=this.elements.root.style.transition;this.elements.root.style.transition="unset";const we=Le=>{const He=Le.pageX-Je;this.right=Ue-He;const $e=Le.pageY-se;this.top=X+$e,this.layout()};Ne.add(Ve.event(we)),Ne.add(Ye.event(Le=>{we(Le),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=be,Ne.dispose()}))}));const Me=C.Event.chain(this._register(new N.DomEmitter(this.elements.grab,"keydown")).event,Ce=>Ce.map(Ne=>new x.StandardKeyboardEvent(Ne)));this._register(Me(Ce=>{let Ne,Ve;if(Ce.keyCode===15?Ne=Number.POSITIVE_INFINITY:Ce.keyCode===17?Ne=0:Ce.keyCode===10&&(Ne=this.right===0?Number.POSITIVE_INFINITY:0),Ce.keyCode===16?Ve=0:Ce.keyCode===18&&(Ve=Number.POSITIVE_INFINITY),Ne!==void 0&&(Ce.preventDefault(),Ce.stopPropagation(),this.right=Ne,this.layout()),Ve!==void 0){Ce.preventDefault(),Ce.stopPropagation(),this.top=Ve;const Ye=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(n=this.width){this.width=n,this.right=(0,r.clamp)(this.right,0,Math.max(0,n-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,r.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(n){this.findInput.showMessage(n)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class le{get pattern(){return this._pattern}get mode(){return this._mode}set mode(n){n!==this._mode&&(this._mode=n,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(n))}get matchType(){return this._matchType}set matchType(n){n!==this._matchType&&(this._matchType=n,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(n))}constructor(n,E,D,k,R,U={}){this.tree=n,this.view=D,this.filter=k,this.contextViewProvider=R,this.options=U,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new C.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new C.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new C.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new C.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new p.DisposableStore,this.disposables=new p.DisposableStore,this._mode=n.options.defaultFindMode??Ee.Highlight,this._matchType=n.options.defaultFindMatchType??Se.Fuzzy,E.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new Pe(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(n=>this.mode=n,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(n=>this.matchType=n,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(n){this._pattern=n,this._onDidChangePattern.fire(n),this.filter.pattern=n,this.tree.refilter(),n&&this.tree.focusNext(0,!0,void 0,D=>!m.FuzzyScore.isDefault(D.filterData));const E=this.tree.getFocus();if(E.length>0){const D=E[0];this.tree.getRelativeTop(D)===null&&this.tree.reveal(D,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const n=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&n?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,A.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(n){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!m.FuzzyScore.isDefault(n.filterData)}layout(n){this.width=n,this.widget?.layout(n)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function J(F,n){return F.position===n.position&&he(F,n)}function he(F,n){return F.node.element===n.node.element&&F.startIndex===n.startIndex&&F.height===n.height&&F.endIndex===n.endIndex}class re{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,e.equals)(this.stickyNodes,n.stickyNodes,J)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const E=this.stickyNodes[this.count-2];return E.position+E.height!==n.position}animationStateChanged(n){if(!(0,e.equals)(this.stickyNodes,n.stickyNodes,he)||this.count===0)return!1;const E=this.stickyNodes[this.count-1],D=n.stickyNodes[n.count-1];return E.position!==D.position}}class ye{constrainStickyScrollNodes(n,E,D){for(let k=0;k<n.length;k++){const R=n[k];if(R.position+R.height>D||k>=E)return n.slice(0,k)}return n}}class V extends p.Disposable{constructor(n,E,D,k,R,U={}){super(),this.tree=n,this.model=E,this.view=D,this.treeDelegate=R,this.maxWidgetViewRatio=.4;const Z=this.validateStickySettings(U);this.stickyScrollMaxItemCount=Z.stickyScrollMaxItemCount,this.stickyScrollDelegate=U.stickyScrollDelegate??new ye,this._widget=this._register(new Q(D.getScrollableElement(),D,n,k,R,U.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(D.onDidScroll(()=>this.update())),this._register(D.onDidChangeContentHeight(()=>this.update())),this._register(n.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(n){return this._widget.getNode(n)}getNodeAtHeight(n){let E;if(n===0?E=this.view.firstVisibleIndex:E=this.view.indexAt(n+this.view.scrollTop),!(E<0||E>=this.view.length))return this.view.element(E)}update(){const n=this.getNodeAtHeight(0);if(!n||this.tree.scrollTop===0){this._widget.setState(void 0);return}const E=this.findStickyState(n);this._widget.setState(E)}findStickyState(n){const E=[];let D=n,k=0,R=this.getNextStickyNode(D,void 0,k);for(;R&&(E.push(R),k+=R.height,!(E.length<=this.stickyScrollMaxItemCount&&(D=this.getNextVisibleNode(R),!D)));)R=this.getNextStickyNode(D,R.node,k);const U=this.constrainStickyNodes(E);return U.length?new re(U):void 0}getNextVisibleNode(n){return this.getNodeAtHeight(n.position+n.height)}getNextStickyNode(n,E,D){const k=this.getAncestorUnderPrevious(n,E);if(k&&!(k===n&&(!this.nodeIsUncollapsedParent(n)||this.nodeTopAlignsWithStickyNodesBottom(n,D))))return this.createStickyScrollNode(k,D)}nodeTopAlignsWithStickyNodesBottom(n,E){const D=this.getNodeIndex(n),k=this.view.getElementTop(D),R=E;return this.view.scrollTop===k-R}createStickyScrollNode(n,E){const D=this.treeDelegate.getHeight(n),{startIndex:k,endIndex:R}=this.getNodeRange(n),U=this.calculateStickyNodePosition(R,E,D);return{node:n,position:U,height:D,startIndex:k,endIndex:R}}getAncestorUnderPrevious(n,E=void 0){let D=n,k=this.getParentNode(D);for(;k;){if(k===E)return D;D=k,k=this.getParentNode(D)}if(E===void 0)return D}calculateStickyNodePosition(n,E,D){let k=this.view.getRelativeTop(n);if(k===null&&this.view.firstVisibleIndex===n&&n+1<this.view.length){const ve=this.treeDelegate.getHeight(this.view.element(n)),de=this.view.getRelativeTop(n+1);k=de?de-ve/this.view.renderHeight:null}if(k===null)return E;const R=this.view.element(n),U=this.treeDelegate.getHeight(R),oe=k*this.view.renderHeight+U;return E+D>oe&&E<=oe?oe-D:E}constrainStickyNodes(n){if(n.length===0)return[];const E=this.view.renderHeight*this.maxWidgetViewRatio,D=n[n.length-1];if(n.length<=this.stickyScrollMaxItemCount&&D.position+D.height<=E)return n;const k=this.stickyScrollDelegate.constrainStickyScrollNodes(n,this.stickyScrollMaxItemCount,E);if(!k.length)return[];const R=k[k.length-1];if(k.length>this.stickyScrollMaxItemCount||R.position+R.height>E)throw new Error("stickyScrollDelegate violates constraints");return k}getParentNode(n){const E=this.model.getNodeLocation(n),D=this.model.getParentNodeLocation(E);return D?this.model.getNode(D):void 0}nodeIsUncollapsedParent(n){const E=this.model.getNodeLocation(n);return this.model.getListRenderCount(E)>1}getNodeIndex(n){const E=this.model.getNodeLocation(n);return this.model.getListIndex(E)}getNodeRange(n){const E=this.model.getNodeLocation(n),D=this.model.getListIndex(E);if(D<0)throw new Error("Node not found in tree");const k=this.model.getListRenderCount(E),R=D+k-1;return{startIndex:D,endIndex:R}}nodePositionTopBelowWidget(n){const E=[];let D=this.getParentNode(n);for(;D;)E.push(D),D=this.getParentNode(D);let k=0;for(let R=0;R<E.length&&R<this.stickyScrollMaxItemCount;R++)k+=this.treeDelegate.getHeight(E[R]);return k}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const E=this.validateStickySettings(n);this.stickyScrollMaxItemCount!==E.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=E.stickyScrollMaxItemCount,this.update())}validateStickySettings(n){let E=7;return typeof n.stickyScrollMaxItemCount=="number"&&(E=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:E}}}class Q{constructor(n,E,D,k,R,U){this.view=E,this.tree=D,this.treeRenderers=k,this.treeDelegate=R,this.accessibilityProvider=U,this._previousElements=[],this._previousStateDisposables=new p.DisposableStore,this._rootDomNode=(0,i.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this._rootDomNode);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(Z),this.stickyScrollFocus=new ge(this._rootDomNode,E),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const n=this._previousState.stickyNodes[this._previousState.count-1];return n.position+n.height}get count(){return this._previousState?.count??0}getNode(n){return this._previousState?.stickyNodes.find(E=>E.node===n)}setState(n){const E=!!this._previousState&&this._previousState.count>0,D=!!n&&n.count>0;if(!E&&!D||E&&D&&this._previousState.equal(n))return;if(E!==D&&this.setVisible(D),!D){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const k=n.stickyNodes[n.count-1];if(this._previousState&&n.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${k.position}px`;else{this._previousStateDisposables.clear();const R=Array(n.count);for(let U=n.count-1;U>=0;U--){const Z=n.stickyNodes[U],{element:oe,disposable:ve}=this.createElement(Z,U,n.count);R[U]=oe,this._rootDomNode.appendChild(oe),this._previousStateDisposables.add(ve)}this.stickyScrollFocus.updateElements(R,n),this._previousElements=R}this._previousState=n,this._rootDomNode.style.height=`${k.position+k.height}px`}createElement(n,E,D){const k=n.startIndex,R=document.createElement("div");R.style.top=`${n.position}px`,this.tree.options.setRowHeight!==!1&&(R.style.height=`${n.height}px`),this.tree.options.setRowLineHeight!==!1&&(R.style.lineHeight=`${n.height}px`),R.classList.add("monaco-tree-sticky-row"),R.classList.add("monaco-list-row"),R.setAttribute("data-index",`${k}`),R.setAttribute("data-parity",k%2===0?"even":"odd"),R.setAttribute("id",this.view.getElementID(k));const U=this.setAccessibilityAttributes(R,n.node.element,E,D),Z=this.treeDelegate.getTemplateId(n.node),oe=this.treeRenderers.find(Te=>Te.templateId===Z);if(!oe)throw new Error(`No renderer found for template id ${Z}`);let ve=n.node;ve===this.tree.getNode(this.tree.getNodeLocation(n.node))&&(ve=new Proxy(n.node,{}));const de=oe.renderTemplate(R);oe.renderElement(ve,n.startIndex,de,n.height);const ke=(0,p.toDisposable)(()=>{U.dispose(),oe.disposeElement(ve,n.startIndex,de,n.height),oe.disposeTemplate(de),R.remove()});return{element:R,disposable:ke}}setAccessibilityAttributes(n,E,D,k){if(!this.accessibilityProvider)return p.Disposable.None;this.accessibilityProvider.getSetSize&&n.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(E,D,k))),this.accessibilityProvider.getPosInSet&&n.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(E,D))),this.accessibilityProvider.getRole&&n.setAttribute("role",this.accessibilityProvider.getRole(E)??"treeitem");const R=this.accessibilityProvider.getAriaLabel(E),U=R&&typeof R!="string"?R:(0,P.constObservable)(R),Z=(0,P.autorun)(ve=>{const de=ve.readObservable(U);de?n.setAttribute("aria-label",de):n.removeAttribute("aria-label")});typeof R=="string"||R&&n.setAttribute("aria-label",R.get());const oe=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(E);return typeof oe=="number"&&n.setAttribute("aria-level",`${oe}`),n.setAttribute("aria-selected",String(!1)),Z}setVisible(n){this._rootDomNode.classList.toggle("empty",!n),n||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class ge extends p.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(n){n!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(n),this._domHasFocus=n)}constructor(n,E){super(),this.container=n,this.view=E,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new C.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new C.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this.container.addEventListener("focus",()=>this.onFocus()),this.container.addEventListener("blur",()=>this.onBlur()),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(D=>this.onKeyDown(D))),this._register(this.view.onMouseDown(D=>this.onMouseDown(D))),this._register(this.view.onContextMenu(D=>this.handleContextMenu(D)))}handleContextMenu(n){const E=n.browserEvent.target;if(!(0,g.isStickyScrollContainer)(E)&&!(0,g.isStickyScrollElement)(E)){this.focusedLast()&&this.view.domFocus();return}if(!(0,i.isKeyboardEvent)(n.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const U=this.state.stickyNodes.findIndex(Z=>Z.node.element===n.element?.element);if(U===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(U);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const k=this.state.stickyNodes[this.focusedIndex].node.element,R=this.elements[this.focusedIndex];this._onContextMenu.fire({element:k,anchor:R,browserEvent:n.browserEvent,isStickyScroll:!0})}onKeyDown(n){if(this.domHasFocus&&this.state){if(n.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const E=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([E]),this.scrollNodeUnderWidget(E,this.state)}else this.setFocusedElement(this.focusedIndex+1);n.preventDefault(),n.stopPropagation()}}}onMouseDown(n){const E=n.browserEvent.target;!(0,g.isStickyScrollContainer)(E)&&!(0,g.isStickyScrollElement)(E)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,E){if(E&&E.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(E&&E.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const D=this.focusedIndex;if(this.removeFocus(),this.elements=n,this.state=E,E){const k=(0,r.clamp)(D,0,E.count-1);this.setFocus(k)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=E?0:-1}setFocusedElement(n){const E=this.state;if(!E)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(n),!(n<E.count-1)&&E.lastNodePartiallyVisible()){const D=E.stickyNodes[n];this.scrollNodeUnderWidget(D.endIndex+1,E)}}scrollNodeUnderWidget(n,E){const D=E.stickyNodes[E.count-1],k=E.count>1?E.stickyNodes[E.count-2]:void 0,R=this.view.getElementTop(n),U=k?k.position+k.height+D.height:D.height;this.view.scrollTop=R-U}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.state&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&n>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const E=this.focusedIndex;E>=0&&this.toggleElementFocus(this.elements[E],!1),n>=0&&this.toggleElementFocus(this.elements[n],!0),this.focusedIndex=n}toggleElementFocus(n,E){this.toggleElementActiveFocus(n,E&&this.domHasFocus),this.toggleElementPassiveFocus(n,E)}toggleCurrentElementActiveFocus(n){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],n)}toggleElementActiveFocus(n,E){n.classList.toggle("focused",E)}toggleElementPassiveFocus(n,E){n.classList.toggle("passive-focused",E)}toggleStickyScrollFocused(n){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function De(F){let n=c.TreeMouseEventTarget.Unknown;return(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=c.TreeMouseEventTarget.Twistie:(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=c.TreeMouseEventTarget.Element:(0,i.hasParentWithClass)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=c.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:n}}function Ae(F){const n=(0,g.isStickyScrollContainer)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:n}}function Ie(F,n){n(F),F.children.forEach(E=>Ie(E,n))}class Oe{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(n,E){this.getFirstViewElementWithTrait=n,this.identityProvider=E,this.nodes=[],this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event}set(n,E){!E?.__forceEvent&&(0,e.equals)(this.nodes,n)||this._set(n,!1,E)}_set(n,E,D){if(this.nodes=[...n],this.elements=void 0,this._nodeSet=void 0,!E){const k=this;this._onDidChange.fire({get elements(){return k.get()},browserEvent:D})}}get(){return this.elements||(this.elements=this.nodes.map(n=>n.element)),[...this.elements]}getNodes(){return this.nodes}has(n){return this.nodeSet.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:E}){if(!this.identityProvider){const oe=this.createNodeSet(),ve=de=>oe.delete(de);E.forEach(de=>Ie(de,ve)),this.set([...oe.values()]);return}const D=new Set,k=oe=>D.add(this.identityProvider.getId(oe.element).toString());E.forEach(oe=>Ie(oe,k));const R=new Map,U=oe=>R.set(this.identityProvider.getId(oe.element).toString(),oe);n.forEach(oe=>Ie(oe,U));const Z=[];for(const oe of this.nodes){const ve=this.identityProvider.getId(oe.element).toString();if(!D.has(ve))Z.push(oe);else{const ke=R.get(ve);ke&&ke.visible&&Z.push(ke)}}if(this.nodes.length>0&&Z.length===0){const oe=this.getFirstViewElementWithTrait();oe&&Z.push(oe)}this._set(Z,!0)}createNodeSet(){const n=new Set;for(const E of this.nodes)n.add(E);return n}}class H extends g.MouseController{constructor(n,E,D){super(n),this.tree=E,this.stickyScrollProvider=D}onViewPointer(n){if((0,g.isButton)(n.browserEvent.target)||(0,g.isInputElement)(n.browserEvent.target)||(0,g.isMonacoEditor)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const E=n.element;if(!E)return super.onViewPointer(n);if(this.isSelectionRangeChangeEvent(n)||this.isSelectionSingleChangeEvent(n))return super.onViewPointer(n);const D=n.browserEvent.target,k=D.classList.contains("monaco-tl-twistie")||D.classList.contains("monaco-icon-label")&&D.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,R=(0,g.isStickyScrollElement)(n.browserEvent.target);let U=!1;if(R?U=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?U=this.tree.expandOnlyOnTwistieClick(E.element):U=!!this.tree.expandOnlyOnTwistieClick,R)this.handleStickyScrollMouseEvent(n,E);else{if(U&&!k&&n.browserEvent.detail!==2)return super.onViewPointer(n);if(!this.tree.expandOnDoubleClick&&n.browserEvent.detail===2)return super.onViewPointer(n)}if(E.collapsible&&(!R||k)){const Z=this.tree.getNodeLocation(E),oe=n.browserEvent.altKey;if(this.tree.setFocus([Z]),this.tree.toggleCollapsed(Z,oe),k){n.browserEvent.isHandledByList=!0;return}}R||super.onViewPointer(n)}handleStickyScrollMouseEvent(n,E){if((0,g.isMonacoCustomToggle)(n.browserEvent.target)||(0,g.isActionItem)(n.browserEvent.target))return;const D=this.stickyScrollProvider();if(!D)throw new Error("Sticky scroll controller not found");const k=this.list.indexOf(E),R=this.list.getElementTop(k),U=D.nodePositionTopBelowWidget(E);this.tree.scrollTop=R-U,this.list.domFocus(),this.list.setFocus([k]),this.list.setSelection([k])}onDoubleClick(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||n.browserEvent.isHandledByList||super.onDoubleClick(n)}onMouseDown(n){const E=n.browserEvent.target;if(!(0,g.isStickyScrollContainer)(E)&&!(0,g.isStickyScrollElement)(E)){super.onMouseDown(n);return}}onContextMenu(n){const E=n.browserEvent.target;if(!(0,g.isStickyScrollContainer)(E)&&!(0,g.isStickyScrollElement)(E)){super.onContextMenu(n);return}}}class h extends g.List{constructor(n,E,D,k,R,U,Z,oe){super(n,E,D,k,oe),this.focusTrait=R,this.selectionTrait=U,this.anchorTrait=Z}createMouseController(n){return new H(this,n.tree,n.stickyScrollProvider)}splice(n,E,D=[]){if(super.splice(n,E,D),D.length===0)return;const k=[],R=[];let U;D.forEach((Z,oe)=>{this.focusTrait.has(Z)&&k.push(n+oe),this.selectionTrait.has(Z)&&R.push(n+oe),this.anchorTrait.has(Z)&&(U=n+oe)}),k.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...k])),R.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...R])),typeof U=="number"&&super.setAnchor(U)}setFocus(n,E,D=!1){super.setFocus(n,E),D||this.focusTrait.set(n.map(k=>this.element(k)),E)}setSelection(n,E,D=!1){super.setSelection(n,E),D||this.selectionTrait.set(n.map(k=>this.element(k)),E)}setAnchor(n,E=!1){super.setAnchor(n),E||(typeof n>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(n)]))}}var y;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(y||(t.AbstractTreePart=y={}));class a{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return C.Event.map(this.view.onMouseClick,De)}get onMouseDblClick(){return C.Event.filter(C.Event.map(this.view.onMouseDblClick,De),n=>n.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return C.Event.map(this.view.onMouseOver,De)}get onMouseOut(){return C.Event.map(this.view.onMouseOut,De)}get onContextMenu(){return C.Event.any(C.Event.filter(C.Event.map(this.view.onContextMenu,Ae),n=>!n.isStickyScroll),this.stickyScrollController?.onContextMenu??C.Event.None)}get onTap(){return C.Event.map(this.view.onTap,De)}get onPointer(){return C.Event.map(this.view.onPointer,De)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return C.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??Ee.Highlight}set findMode(n){this.findController&&(this.findController.mode=n)}get findMatchType(){return this.findController?.matchType??Se.Fuzzy}set findMatchType(n){this.findController&&(this.findController.matchType=n)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:C.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(n,E,D,k,R={}){this._user=n,this._options=R,this.eventBufferer=new C.EventBufferer,this.onDidChangeFindOpenState=C.Event.None,this.onDidChangeStickyScrollFocused=C.Event.None,this.disposables=new p.DisposableStore,this._onWillRefilter=new C.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new C.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new L(D);const U=new C.Relay,Z=new C.Relay,oe=this.disposables.add(new G(Z.event)),ve=new d.SetMap;this.renderers=k.map(Ce=>new K(Ce,()=>this.model,U.event,oe,ve,R));for(const Ce of this.renderers)this.disposables.add(Ce);let de;R.keyboardNavigationLabelProvider&&(de=new ae(this,R.keyboardNavigationLabelProvider,R.filter),R={...R,filter:de},this.disposables.add(de)),this.focus=new Oe(()=>this.view.getFocusedElements()[0],R.identityProvider),this.selection=new Oe(()=>this.view.getSelectedElements()[0],R.identityProvider),this.anchor=new Oe(()=>this.view.getAnchorElement(),R.identityProvider),this.view=new h(n,E,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...q(()=>this.model,R),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(n,this.view,R),U.input=this.model.onDidChangeCollapseState;const ke=C.Event.forEach(this.model.onDidSplice,Ce=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(Ce),this.selection.onDidModelSplice(Ce)})},this.disposables);ke(()=>null,null,this.disposables);const Te=this.disposables.add(new C.Emitter),Me=this.disposables.add(new s.Delayer(0));if(this.disposables.add(C.Event.any(ke,this.focus.onDidChange,this.selection.onDidChange)(()=>{Me.trigger(()=>{const Ce=new Set;for(const Ne of this.focus.getNodes())Ce.add(Ne);for(const Ne of this.selection.getNodes())Ce.add(Ne);Te.fire([...Ce.values()])})})),Z.input=Te.event,R.keyboardSupport!==!1){const Ce=C.Event.chain(this.view.onKeyDown,Ne=>Ne.filter(Ve=>!(0,g.isInputElement)(Ve.target)).map(Ve=>new x.StandardKeyboardEvent(Ve)));C.Event.chain(Ce,Ne=>Ne.filter(Ve=>Ve.keyCode===15))(this.onLeftArrow,this,this.disposables),C.Event.chain(Ce,Ne=>Ne.filter(Ve=>Ve.keyCode===17))(this.onRightArrow,this,this.disposables),C.Event.chain(Ce,Ne=>Ne.filter(Ve=>Ve.keyCode===10))(this.onSpace,this,this.disposables)}if((R.findWidgetEnabled??!0)&&R.keyboardNavigationLabelProvider&&R.contextViewProvider){const Ce=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new le(this,this.model,this.view,de,R.contextViewProvider,Ce),this.focusNavigationFilter=Ne=>this.findController.shouldAllowFocus(Ne),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=C.Event.None,this.onDidChangeFindMatchType=C.Event.None;R.enableStickyScroll&&(this.stickyScrollController=new V(this,this.model,this.view,this.renderers,this.treeDelegate,R),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,i.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===M.Always)}updateOptions(n={}){this._options={...this._options,...n};for(const E of this.renderers)E.updateOptions(n);this.view.updateOptions(this._options),this.findController?.updateOptions(n),this.updateStickyScroll(n),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===M.Always)}get options(){return this._options}updateStickyScroll(n){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new V(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=C.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(n)}updateWidth(n){const E=this.model.getListIndex(n);E!==-1&&this.view.updateWidth(E)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(n){this.view.scrollTop=n}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(n){this.view.scrollLeft=n}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let n=this.view.firstVisibleIndex;return this.stickyScrollController&&(n+=this.stickyScrollController.count),n<0||n>=this.view.length?void 0:this.view.element(n).element}get lastVisibleElement(){const n=this.view.lastVisibleIndex;return this.view.element(n).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(n){this.view.ariaLabel=n}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,i.isActiveElement)(this.getHTMLElement())}layout(n,E){this.view.layout(n,E),(0,S.isNumber)(E)&&this.findController?.layout(E)}style(n){const E=`.${this.view.domId}`,D=[];n.treeIndentGuidesStroke&&(D.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),D.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`));const k=n.treeStickyScrollBackground??n.listBackground;k&&(D.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${k}; }`),D.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${k}; }`)),n.treeStickyScrollBorder&&D.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${n.treeStickyScrollBorder}; }`),n.treeStickyScrollShadow&&D.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${n.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),n.listFocusForeground&&(D.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),D.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const R=(0,i.asCssValueWithDefault)(n.listFocusAndSelectionOutline,(0,i.asCssValueWithDefault)(n.listSelectionOutline,n.listFocusOutline??""));R&&(D.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${R}; outline-offset: -1px;}`),D.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(D.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),D.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),D.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),D.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),D.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=D.join(`
`),this.view.style(n)}getParentElement(n){const E=this.model.getParentNodeLocation(n);return this.model.getNode(E).element}getFirstElementChild(n){return this.model.getFirstElementChild(n)}getNode(n){return this.model.getNode(n)}getNodeLocation(n){return this.model.getNodeLocation(n)}collapse(n,E=!1){return this.model.setCollapsed(n,!0,E)}expand(n,E=!1){return this.model.setCollapsed(n,!1,E)}toggleCollapsed(n,E=!1){return this.model.setCollapsed(n,void 0,E)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(n){return this.model.isCollapsible(n)}setCollapsible(n,E){return this.model.setCollapsible(n,E)}isCollapsed(n){return this.model.isCollapsed(n)}expandTo(n){this.model.expandTo(n)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(n){if(typeof n>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const E=this.model.getNode(n);this.anchor.set([E]);const D=this.model.getListIndex(n);D>-1&&this.view.setAnchor(D,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(n,E){this.eventBufferer.bufferEvents(()=>{const D=n.map(R=>this.model.getNode(R));this.selection.set(D,E);const k=n.map(R=>this.model.getListIndex(R)).filter(R=>R>-1);this.view.setSelection(k,E,!0)})}getSelection(){return this.selection.get()}setFocus(n,E){this.eventBufferer.bufferEvents(()=>{const D=n.map(R=>this.model.getNode(R));this.focus.set(D,E);const k=n.map(R=>this.model.getListIndex(R)).filter(R=>R>-1);this.view.setFocus(k,E,!0)})}focusNext(n=1,E=!1,D,k=(0,i.isKeyboardEvent)(D)&&D.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(n,E,D,k)}focusPrevious(n=1,E=!1,D,k=(0,i.isKeyboardEvent)(D)&&D.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(n,E,D,k)}focusNextPage(n,E=(0,i.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(n,E)}focusPreviousPage(n,E=(0,i.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(n,E,()=>this.stickyScrollController?.height??0)}focusLast(n,E=(0,i.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(n,E)}focusFirst(n,E=(0,i.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(n,E)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const n=this.stickyScrollController?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?1:0}reveal(n,E){this.model.expandTo(n);const D=this.model.getListIndex(n);if(D!==-1)if(!this.stickyScrollController)this.view.reveal(D,E);else{const k=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(n));this.view.reveal(D,E,k)}}getRelativeTop(n){const E=this.model.getListIndex(n);if(E===-1)return null;const D=this.stickyScrollController?.getNode(this.getNode(n));return this.view.getRelativeTop(E,D?.position??this.stickyScrollController?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new c.TreeError(this._user,"Can't get tree view state without an identity provider");const E=U=>n.getId(U).toString(),D=W.empty(this.scrollTop);for(const U of this.getFocus())D.focus.add(E(U));for(const U of this.getSelection())D.selection.add(E(U));const k=this.model.getNode(),R=[k];for(;R.length>0;){const U=R.shift();U!==k&&U.collapsible&&(D.expanded[E(U.element)]=U.collapsed?0:1),R.push(...U.children)}return D}onLeftArrow(n){n.preventDefault(),n.stopPropagation();const E=this.view.getFocusedElements();if(E.length===0)return;const D=E[0],k=this.model.getNodeLocation(D);if(!this.model.setCollapsed(k,!0)){const U=this.model.getParentNodeLocation(k);if(!U)return;const Z=this.model.getListIndex(U);this.view.reveal(Z),this.view.setFocus([Z])}}onRightArrow(n){n.preventDefault(),n.stopPropagation();const E=this.view.getFocusedElements();if(E.length===0)return;const D=E[0],k=this.model.getNodeLocation(D);if(!this.model.setCollapsed(k,!1)){if(!D.children.some(oe=>oe.visible))return;const[U]=this.view.getFocus(),Z=U+1;this.view.reveal(Z),this.view.setFocus([Z])}}onSpace(n){n.preventDefault(),n.stopPropagation();const E=this.view.getFocusedElements();if(E.length===0)return;const D=E[0],k=this.model.getNodeLocation(D),R=n.browserEvent.altKey;this.model.setCollapsed(k,void 0,R)}navigate(n){return new w(this.view,this.model,n)}dispose(){(0,p.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=a;class w{constructor(n,E,D){this.view=n,this.model=E,D?this.index=this.model.getListIndex(D):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[144],pe([1,0,143,134,30,32]),function(ne,t,i,N,x,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class _ extends i.AbstractTree{constructor(f,g,b,B,c,u={}){super(f,g,b,B,u),this.user=f,this.dataSource=c,this.nodesByIdentity=new Map,this.identityProvider=u.identityProvider}getInput(){return this.input}setInput(f,g){if(g&&!this.identityProvider)throw new x.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=f,!f){this.nodesByIdentity.clear(),this.model.setChildren(null,z.Iterable.empty());return}if(!g){this._refresh(f);return}const b=[],B=[],c=e=>{const s=this.identityProvider.getId(e).toString();return!g.expanded[s]},u=e=>{const s=this.identityProvider.getId(e.element).toString();g.focus.has(s)&&b.push(e.element),g.selection.has(s)&&B.push(e.element)};this._refresh(f,c,u),this.setFocus(b),this.setSelection(B),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(f=this.input){if(typeof this.input>"u")throw new x.TreeError(this.user,"Tree input not set");let g;this.identityProvider&&(g=b=>{const B=this.identityProvider.getId(b).toString(),c=this.nodesByIdentity.get(B);if(c)return c.collapsed}),this._refresh(f,g)}resort(f=this.input,g=!0){this.model.resort(f===this.input?null:f,g)}refresh(f){if(f===void 0){this.view.rerender();return}this.model.rerender(f)}_refresh(f,g,b){let B;if(this.identityProvider){const c=new Set,u=b;b=e=>{const s=this.identityProvider.getId(e.element).toString();c.add(s),this.nodesByIdentity.set(s,e),u?.(e)},B=e=>{const s=this.identityProvider.getId(e.element).toString();c.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(f===this.input?null:f,this.iterate(f,g).elements,{onDidCreateNode:b,onDidDeleteNode:B})}iterate(f,g){const b=[...this.dataSource.getChildren(f)];return{elements:z.Iterable.map(b,c=>{const{elements:u,size:e}=this.iterate(c,g),s=this.dataSource.hasChildren?this.dataSource.hasChildren(c):void 0,o=e===0?void 0:g&&g(c);return{element:c,children:u,collapsible:s,collapsed:o}}),size:b.length}}createModel(f,g,b){return new N.ObjectTreeModel(f,g,b)}}t.DataTree=_}),define(me[77],pe([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=$,t.deserialize=v,t.getDelayedChannel=G,t.getNextTickChannel=K;var u;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(u||(u={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function o(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(l||(l={}));function d(le){let J=0;for(let he=0;;he+=7){const re=le.read(1);if(J|=(re.buffer[0]&127)<<he,!(re.buffer[0]&128))return J}}const C=A(0);function m(le,J){if(J===0){le.write(C);return}let he=0;for(let ye=J;ye!==0;ye=ye>>>7)he++;const re=x.VSBuffer.alloc(he);for(let ye=0;J!==0;ye++)re.buffer[ye]=J&127,J=J>>>7,J>0&&(re.buffer[ye]|=128);le.write(re)}class p{constructor(J){this.buffer=J,this.pos=0}read(J){const he=this.buffer.slice(this.pos,this.pos+J);return this.pos+=he.byteLength,he}}t.BufferReader=p;class r{constructor(){this.buffers=[]}get buffer(){return x.VSBuffer.concat(this.buffers)}write(J){this.buffers.push(J)}}t.BufferWriter=r;var S;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(S||(S={}));function A(le){const J=x.VSBuffer.alloc(1);return J.writeUInt8(le,0),J}const I={Undefined:A(S.Undefined),String:A(S.String),Buffer:A(S.Buffer),VSBuffer:A(S.VSBuffer),Array:A(S.Array),Object:A(S.Object),Uint:A(S.Int)},P=typeof Buffer<"u";function $(le,J){if(typeof J>"u")le.write(I.Undefined);else if(typeof J=="string"){const he=x.VSBuffer.fromString(J);le.write(I.String),m(le,he.byteLength),le.write(he)}else if(P&&Buffer.isBuffer(J)){const he=x.VSBuffer.wrap(J);le.write(I.Buffer),m(le,he.byteLength),le.write(he)}else if(J instanceof x.VSBuffer)le.write(I.VSBuffer),m(le,J.byteLength),le.write(J);else if(Array.isArray(J)){le.write(I.Array),m(le,J.length);for(const he of J)$(le,he)}else if(typeof J=="number"&&(J|0)===J)le.write(I.Uint),m(le,J);else{const he=x.VSBuffer.fromString(JSON.stringify(J));le.write(I.Object),m(le,he.byteLength),le.write(he)}}function v(le){switch(le.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return le.read(d(le)).toString();case S.Buffer:return le.read(d(le)).buffer;case S.VSBuffer:return le.read(d(le));case S.Array:{const he=d(le),re=[];for(let ye=0;ye<he;ye++)re.push(v(le));return re}case S.Object:return JSON.parse(le.read(d(le)).toString());case S.Int:return d(le)}}class O{constructor(J,he,re=null,ye=1e3){this.protocol=J,this.ctx=he,this.logger=re,this.timeoutDelay=ye,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(J,he){this.channels.set(J,he),setTimeout(()=>this.flushPendingRequests(J),0)}sendResponse(J){switch(J.type){case 200:{const he=this.send([J.type]);this.logger?.logOutgoing(he,0,1,o(J.type));return}case 201:case 202:case 204:case 203:{const he=this.send([J.type,J.id],J.data);this.logger?.logOutgoing(he,J.id,1,o(J.type),J.data);return}}}send(J,he=void 0){const re=new r;return $(re,J),$(re,he),this.sendBuffer(re.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onRawMessage(J){const he=new p(J),re=v(he),ye=v(he),V=re[0];switch(V){case 100:return this.logger?.logIncoming(J.byteLength,re[1],1,`${e(V)}: ${re[2]}.${re[3]}`,ye),this.onPromise({type:V,id:re[1],channelName:re[2],name:re[3],arg:ye});case 102:return this.logger?.logIncoming(J.byteLength,re[1],1,`${e(V)}: ${re[2]}.${re[3]}`,ye),this.onEventListen({type:V,id:re[1],channelName:re[2],name:re[3],arg:ye});case 101:return this.logger?.logIncoming(J.byteLength,re[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:re[1]});case 103:return this.logger?.logIncoming(J.byteLength,re[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:re[1]})}}onPromise(J){const he=this.channels.get(J.channelName);if(!he){this.collectPendingRequest(J);return}const re=new z.CancellationTokenSource;let ye;try{ye=he.call(this.ctx,J.name,J.arg,re.token)}catch(ge){ye=Promise.reject(ge)}const V=J.id;ye.then(ge=>{this.sendResponse({id:V,data:ge,type:201})},ge=>{ge instanceof Error?this.sendResponse({id:V,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.sendResponse({id:V,data:ge,type:203})}).finally(()=>{Q.dispose(),this.activeRequests.delete(J.id)});const Q=(0,g.toDisposable)(()=>re.cancel());this.activeRequests.set(J.id,Q)}onEventListen(J){const he=this.channels.get(J.channelName);if(!he){this.collectPendingRequest(J);return}const re=J.id,V=he.listen(this.ctx,J.name,J.arg)(Q=>this.sendResponse({id:re,data:Q,type:204}));this.activeRequests.set(J.id,V)}disposeActiveRequest(J){const he=this.activeRequests.get(J.id);he&&(he.dispose(),this.activeRequests.delete(J.id))}collectPendingRequest(J){let he=this.pendingRequests.get(J.channelName);he||(he=[],this.pendingRequests.set(J.channelName,he));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.sendResponse({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);he.push({request:J,timeoutTimer:re})}flushPendingRequests(J){const he=this.pendingRequests.get(J);if(he){for(const re of he)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(J)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=O;var q;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(q||(t.RequestInitiator=q={}));class L{constructor(J,he=null){this.protocol=J,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=he}getChannel(J){const he=this;return{call(re,ye,V){return he.isDisposed?Promise.reject(new T.CancellationError):he.requestPromise(J,re,ye,V)},listen(re,ye){return he.isDisposed?f.Event.None:he.requestEvent(J,re,ye)}}}requestPromise(J,he,re,ye=z.CancellationToken.None){const V=this.lastRequestId++,ge={id:V,type:100,channelName:J,name:he,arg:re};if(ye.isCancellationRequested)return Promise.reject(new T.CancellationError);let De;return new Promise((Ie,Oe)=>{if(ye.isCancellationRequested)return Oe(new T.CancellationError);const H=()=>{const w=F=>{switch(F.type){case 201:this.handlers.delete(V),Ie(F.data);break;case 202:{this.handlers.delete(V);const n=new Error(F.data.message);n.stack=Array.isArray(F.data.stack)?F.data.stack.join(`
`):F.data.stack,n.name=F.data.name,Oe(n);break}case 203:this.handlers.delete(V),Oe(F.data);break}};this.handlers.set(V,w),this.sendRequest(ge)};let h=null;this.state===l.Idle?H():(h=(0,N.createCancelablePromise)(w=>this.whenInitialized()),h.then(()=>{h=null,H()}));const y=()=>{h?(h.cancel(),h=null):this.sendRequest({id:V,type:101}),Oe(new T.CancellationError)},a=ye.onCancellationRequested(y);De=(0,g.combinedDisposable)((0,g.toDisposable)(y),a),this.activeRequests.add(De)}).finally(()=>{De.dispose(),this.activeRequests.delete(De)})}requestEvent(J,he,re){const ye=this.lastRequestId++,Q={id:ye,type:102,channelName:J,name:he,arg:re};let ge=null;const De=new f.Emitter({onWillAddFirstListener:()=>{ge=(0,N.createCancelablePromise)(Ie=>this.whenInitialized()),ge.then(()=>{ge=null,this.activeRequests.add(De),this.sendRequest(Q)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.activeRequests.delete(De),this.sendRequest({id:ye,type:103}))}}),Ae=Ie=>De.fire(Ie.data);return this.handlers.set(ye,Ae),De.event}sendRequest(J){switch(J.type){case 100:case 102:{const he=this.send([J.type,J.id,J.channelName,J.name],J.arg);this.logger?.logOutgoing(he,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const he=this.send([J.type,J.id]);this.logger?.logOutgoing(he,J.id,0,e(J.type));return}}}send(J,he=void 0){const re=new r;return $(re,J),$(re,he),this.sendBuffer(re.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onBuffer(J){const he=new p(J),re=v(he),ye=v(he),V=re[0];switch(V){case 200:return this.logger?.logIncoming(J.byteLength,0,0,o(V)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(J.byteLength,re[1],0,o(V),ye),this.onResponse({type:re[0],id:re[1],data:ye})}}onResponse(J){if(J.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(J.id)?.(J)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=L,Ze([_.memoize],L.prototype,"onDidInitializePromise",null);class W{get connections(){const J=[];return this._connections.forEach(he=>J.push(he)),J}constructor(J,he,re){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new g.DisposableStore,this.disposables.add(J(({protocol:ye,onDidClientDisconnect:V})=>{const Q=f.Event.once(ye.onMessage);this.disposables.add(Q(ge=>{const De=new p(ge),Ae=v(De),Ie=new O(ye,Ae,he,re),Oe=new L(ye,he);this.channels.forEach((h,y)=>Ie.registerChannel(y,h));const H={channelServer:Ie,channelClient:Oe,ctx:Ae};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(V(()=>{Ie.dispose(),Oe.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(J,he){const re=this;return{call(ye,V,Q){let ge;if((0,c.isFunction)(he)){const Ae=(0,i.getRandomElement)(re.connections.filter(he));ge=Ae?Promise.resolve(Ae):f.Event.toPromise(f.Event.filter(re.onDidAddConnection,he))}else ge=he.routeCall(re,ye,V);const De=ge.then(Ae=>Ae.channelClient.getChannel(J));return G(De).call(ye,V,Q)},listen(ye,V){if((0,c.isFunction)(he))return re.getMulticastEvent(J,he,ye,V);const Q=he.routeEvent(re,ye,V).then(ge=>ge.channelClient.getChannel(J));return G(Q).listen(ye,V)}}}getMulticastEvent(J,he,re,ye){const V=this;let Q;const ge=new f.Emitter({onWillAddFirstListener:()=>{Q=new g.DisposableStore;const De=new f.EventMultiplexer,Ae=new Map,Ie=H=>{const y=H.channelClient.getChannel(J).listen(re,ye),a=De.add(y);Ae.set(H,a)},Oe=H=>{const h=Ae.get(H);h&&(h.dispose(),Ae.delete(H))};V.connections.filter(he).forEach(Ie),f.Event.filter(V.onDidAddConnection,he)(Ie,void 0,Q),V.onDidRemoveConnection(Oe,void 0,Q),De.event(ge.fire,ge,Q),Q.add(De)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return ge.event}registerChannel(J,he){this.channels.set(J,he);for(const re of this._connections)re.channelServer.registerChannel(J,he)}dispose(){this.disposables.dispose();for(const J of this._connections)J.channelClient.dispose(),J.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=W;class M{constructor(J,he,re=null){const ye=new r;$(ye,he),J.send(ye.buffer),this.channelClient=new L(J,re),this.channelServer=new O(J,he,re)}getChannel(J){return this.channelClient.getChannel(J)}registerChannel(J,he){this.channelServer.registerChannel(J,he)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function G(le){return{call(J,he,re){return le.then(ye=>ye.call(J,he,re))},listen(J,he){const re=new f.Relay;return le.then(ye=>re.input=ye.listen(J,he)),re.event}}}function K(le){let J=!1;return{call(he,re,ye){return J?le.call(he,re,ye):(0,N.timeout)(0).then(()=>J=!0).then(()=>le.call(he,re,ye))},listen(he,re){if(J)return le.listen(he,re);const ye=new f.Relay;return(0,N.timeout)(0).then(()=>J=!0).then(()=>ye.input=le.listen(he,re)),ye.event}}}class ae{constructor(J){this.fn=J}routeCall(J){return this.route(J)}routeEvent(J){return this.route(J)}async route(J){for(const he of J.connections)if(await Promise.resolve(this.fn(he.ctx)))return Promise.resolve(he);return await f.Event.toPromise(J.onDidAddConnection),await this.route(J)}}t.StaticRouter=ae;var ie;(function(le){function J(V,Q,ge){const De=V,Ae=ge&&ge.disableMarshalling,Ie=new Map;for(const Oe in De)re(Oe)&&Ie.set(Oe,f.Event.buffer(De[Oe],!0,void 0,Q));return new class{listen(Oe,H,h){const y=Ie.get(H);if(y)return y;const a=De[H];if(typeof a=="function"){if(ye(H))return a.call(De,h);if(re(H))return Ie.set(H,f.Event.buffer(De[H],!0,void 0,Q)),Ie.get(H)}throw new T.ErrorNoTelemetry(`Event not found: ${H}`)}call(Oe,H,h){const y=De[H];if(typeof y=="function"){if(!Ae&&Array.isArray(h))for(let w=0;w<h.length;w++)h[w]=(0,b.revive)(h[w]);let a=y.apply(De,h);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new T.ErrorNoTelemetry(`Method not found: ${H}`)}}}le.fromService=J;function he(V,Q){const ge=Q&&Q.disableMarshalling;return new Proxy({},{get(De,Ae){if(typeof Ae=="string")return Q?.properties?.has(Ae)?Q.properties.get(Ae):ye(Ae)?function(Ie){return V.listen(Ae,Ie)}:re(Ae)?V.listen(Ae):async function(...Ie){let Oe;Q&&!(0,c.isUndefinedOrNull)(Q.context)?Oe=[Q.context,...Ie]:Oe=Ie;const H=await V.call(Ae,Oe);return ge?H:(0,b.revive)(H)};throw new T.ErrorNoTelemetry(`Property not found: ${String(Ae)}`)}})}le.toService=he;function re(V){return V[0]==="o"&&V[1]==="n"&&B.isUpperAsciiLetter(V.charCodeAt(2))}function ye(V){return/^onDynamic/.test(V)&&B.isUpperAsciiLetter(V.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const J=le.toString();if(J!=="[object Object]")return J}return le}function Ee(le){return Array.isArray(le)?le.map(ce):ce(le)}function Se(le,J,he,re,ye,V,Q){Q=Ee(Q);const ge=ee[ye],De=ge[re%ge.length];let Ae=[`%c[${le}]%c[${String(J).padStart(7," ")}]%c[len: ${String(he).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(V)?(Ae=Ae.concat(Q),Ae.push(")")):Ae.push(Q),console.log.apply(console,Ae)}class Pe{constructor(J,he){this._outgoingPrefix=J,this._incomingPrefix=he,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(J,he,re,ye,V){this._totalOutgoing+=J,Se(this._outgoingPrefix,this._totalOutgoing,J,he,re,ye,V)}logIncoming(J,he,re,ye,V){this._totalIncoming+=J,Se(this._incomingPrefix,this._totalIncoming,J,he,re,ye,V)}}t.IPCLogger=Pe}),define(me[145],pe([1,0,43,3,77,102,35]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class T extends x.IPCClient{static createProtocol(){const g=N.Event.fromNodeEventEmitter(_.ipcRenderer,"vscode:message",(b,B)=>i.VSBuffer.wrap(B));return _.ipcRenderer.send("vscode:hello"),new z.Protocol(_.ipcRenderer,g)}constructor(g){const b=T.createProtocol();super(b,g),this.protocol=b}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=T}),define(me[146],pe([13,12]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(me[147],pe([13,12]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(me[50],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=x,t.refineServiceDecorator=z;var i;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function T(f){return f[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=T})(i||(t._util=i={})),t.IInstantiationService=x("instantiationService");function N(_,T,f){T[i.DI_TARGET]===T?T[i.DI_DEPENDENCIES].push({id:_,index:f}):(T[i.DI_DEPENDENCIES]=[{id:_,index:f}],T[i.DI_TARGET]=T)}function x(_){if(i.serviceIds.has(_))return i.serviceIds.get(_);const T=function(f,g,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(T,f,b)};return T.toString=()=>_,i.serviceIds.set(_,T),T}function z(_){return _}}),define(me[148],pe([1,0,50]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=N,t.ID="diagnosticsService",t.IDiagnosticsService=(0,i.createDecorator)(t.ID);function N(z){return!!z.hostName&&!!z.errorMessage}class x{async getPerformanceInfo(_,T){return{}}async getSystemInfo(_,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,T){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}t.NullDiagnosticsService=x}),define(me[149],pe([1,0,99,25,9,10,16,146,50,5,36,23]),function(ne,t,i,N,x,z,_,T,f,g,b,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=c,t.isFileSystemWatcher=o,t.hasReadWriteCapability=d,t.hasFileFolderCopyCapability=C,t.hasFileCloneCapability=m,t.hasOpenReadWriteCloseCapability=p,t.hasFileReadStreamCapability=r,t.hasFileAtomicReadCapability=S,t.hasFileAtomicWriteCapability=A,t.hasFileAtomicDeleteCapability=I,t.hasReadonlyCapability=P,t.createFileSystemProviderError=O,t.ensureFileSystemProviderError=q,t.markAsFileSystemProviderError=L,t.toFileSystemProviderErrorCode=W,t.toFileOperationResult=M,t.isParent=ee,t.etag=J,t.whenProviderRegistered=he,t.getLargeFileConfirmationLimit=ye,t.IFileService=(0,f.createDecorator)("fileService");function c(V){return V.create===!0}var u;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(u||(t.FileType=u={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(V){const Q=V;return!!Q&&typeof Q.onDidChange=="function"}var l;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function d(V){return!!(V.capabilities&2)}function C(V){return!!(V.capabilities&8)}function m(V){return!!(V.capabilities&131072)}function p(V){return!!(V.capabilities&4)}function r(V){return!!(V.capabilities&16)}function S(V){return d(V)?!!(V.capabilities&16384):!1}function A(V){return d(V)?!!(V.capabilities&32768):!1}function I(V){return!!(V.capabilities&65536)}function P(V){return!!(V.capabilities&2048)}var $;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})($||(t.FileSystemProviderErrorCode=$={}));class v extends Error{static create(Q,ge){const De=new v(Q.toString(),ge);return L(De,ge),De}constructor(Q,ge){super(Q),this.code=ge}}t.FileSystemProviderError=v;function O(V,Q){return v.create(V,Q)}function q(V){return V||O((0,T.localize)(0,null),$.Unknown)}function L(V,Q){return V.name=Q?`${Q} (FileSystemError)`:"FileSystemError",V}function W(V){if(!V)return $.Unknown;if(V instanceof v)return V.code;const Q=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Q)return $.Unknown;switch(Q[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function M(V){if(V instanceof ce)return V.fileOperationResult;switch(W(V)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}var G;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(G||(t.FileOperation=G={}));class K{constructor(Q,ge,De){this.resource=Q,this.operation=ge,this.target=De}isOperation(Q){return this.operation===Q}}t.FileOperationEvent=K;var ae;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(ae||(t.FileChangeType=ae={}));class ie{static{this.MIXED_CORRELATION=null}constructor(Q,ge){this.ignorePathCasing=ge,this.correlationId=void 0,this.added=new B.Lazy(()=>{const De=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return De.fill(this.rawAdded.map(Ae=>[Ae,!0])),De}),this.updated=new B.Lazy(()=>{const De=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return De.fill(this.rawUpdated.map(Ae=>[Ae,!0])),De}),this.deleted=new B.Lazy(()=>{const De=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return De.fill(this.rawDeleted.map(Ae=>[Ae,!0])),De}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const De of Q){switch(De.type){case 1:this.rawAdded.push(De.resource);break;case 0:this.rawUpdated.push(De.resource);break;case 2:this.rawDeleted.push(De.resource);break}this.correlationId!==ie.MIXED_CORRELATION&&(typeof De.cId=="number"?this.correlationId===void 0?this.correlationId=De.cId:this.correlationId!==De.cId&&(this.correlationId=ie.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=ie.MIXED_CORRELATION))}}contains(Q,...ge){return this.doContains(Q,{includeChildren:!1},...ge)}affects(Q,...ge){return this.doContains(Q,{includeChildren:!0},...ge)}doContains(Q,ge,...De){if(!Q)return!1;const Ae=De.length>0;return!!((!Ae||De.includes(1))&&(this.added.value.get(Q)||ge.includeChildren&&this.added.value.findSuperstr(Q))||(!Ae||De.includes(0))&&(this.updated.value.get(Q)||ge.includeChildren&&this.updated.value.findSuperstr(Q))||(!Ae||De.includes(2))&&(this.deleted.value.findSubstr(Q)||ge.includeChildren&&this.deleted.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.correlationId===Q}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=ie;function ee(V,Q,ge){return!V||!Q||V===Q||Q.length>V.length?!1:(Q.charAt(Q.length-1)!==N.sep&&(Q+=N.sep),ge?(0,x.startsWithIgnoreCase)(V,Q):V.indexOf(Q)===0)}class ce extends Error{constructor(Q,ge,De){super(Q),this.fileOperationResult=ge,this.options=De}}t.FileOperationError=ce;class Ee extends ce{constructor(Q,ge,De,Ae){super(Q,ge,Ae),this.fileOperationResult=ge,this.size=De}}t.TooLargeFileOperationError=Ee;class Se extends ce{constructor(Q,ge,De){super(Q,2,De),this.stat=ge}}t.NotModifiedSinceFileOperationError=Se;var Pe;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Pe||(t.FileOperationResult=Pe={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var le;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.ETAG_DISABLED="";function J(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function he(V,Q){if(!Q.hasProvider(_.URI.from({scheme:V.scheme})))return new Promise(ge=>{const De=Q.onDidChangeFileSystemProviderRegistrations(Ae=>{Ae.scheme===V.scheme&&Ae.added&&(De.dispose(),ge())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(Q){return(0,z.isNumber)(Q)||(Q=0),Q<re.KB?(0,T.localize)(1,null,Q.toFixed(0)):Q<re.MB?(0,T.localize)(2,null,(Q/re.KB).toFixed(2)):Q<re.GB?(0,T.localize)(3,null,(Q/re.MB).toFixed(2)):Q<re.TB?(0,T.localize)(4,null,(Q/re.GB).toFixed(2)):(0,T.localize)(5,null,(Q/re.TB).toFixed(2))}}t.ByteSize=re;function ye(V){const Q=typeof V=="string"||V?.scheme===b.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===b.Schemas.file?1024*re.MB:Q?10*re.MB:g.isWeb?50*re.MB:1024*re.MB}}),define(me[150],pe([1,0,50]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,i.createDecorator)("mainProcessService");class N{constructor(z,_){this.server=z,this.router=_}getChannel(z){return this.server.getChannel(z,this.router)}registerChannel(z,_){this.server.registerChannel(z,_)}}t.MainProcessService=N}),define(me[151],pe([1,0,2,145]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class x extends i.Disposable{constructor(_){super(),this.mainProcessConnection=this._register(new N.Client(`window:${_}`))}getChannel(_){return this.mainProcessConnection.getChannel(_)}registerChannel(_,T){this.mainProcessConnection.registerChannel(_,T)}}t.ElectronIPCMainProcessService=x});var Si=this&&this.__param||function(ne,t){return function(i,N){t(i,N,ne)}};define(me[152],pe([1,0,77,150]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let x=class{constructor(_,T){return this.windowId=_,i.ProxyChannel.toService(T.getChannel("nativeHost"),{context:_,properties:(()=>{const f=new Map;return f.set("windowId",_),f})()})}};t.NativeHostService=x,t.NativeHostService=x=Ze([Si(1,N.IMainProcessService)],x)}),define(me[78],pe([1,0,37,10]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class x{constructor(){this.data=new Map}add(_,T){i.ok(N.isString(_)),i.ok(N.isObject(T)),i.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,T)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}t.Registry=new x}),define(me[153],pe([1,0,3,78]),function(ne,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function x(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class z{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,g){this.schemasById[x(f)]=g,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new z;N.Registry.add(t.Extensions.JSONContribution,_)}),define(me[154],pe([1,0,11,18,45,19,3,10,16,147,153,78]),function(ne,t,i,N,x,z,_,T,f,g,b,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=o,t.getIconRegistry=l,t.Extensions={IconContribution:"base.contributions.icons"};var c;(function(p){function r(S,A){let I=S.defaults;for(;z.ThemeIcon.isThemeIcon(I);){const P=s.getIcon(I.id);if(!P)return;I=P.defaults}return I}p.getDefinition=r})(c||(t.IconContribution=c={}));var u;(function(p){function r(A){return{weight:A.weight,style:A.style,src:A.src.map(I=>({format:I.format,location:I.location.toString()}))}}p.toJSONObject=r;function S(A){const I=P=>(0,T.isString)(P)?P:void 0;if(A&&Array.isArray(A.src)&&A.src.every(P=>(0,T.isString)(P.format)&&(0,T.isString)(P.location)))return{weight:I(A.weight),style:I(A.style),src:A.src.map(P=>({format:P.format,location:f.URI.parse(P.location)}))}}p.fromJSONObject=S})(u||(t.IconFontDefinition=u={}));class e{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${z.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(r,S,A,I){const P=this.iconsById[r];if(P){if(A&&!P.description){P.description=A,this.iconSchema.properties[r].markdownDescription=`${A} $(${r})`;const O=this.iconReferenceSchema.enum.indexOf(r);O!==-1&&(this.iconReferenceSchema.enumDescriptions[O]=A),this._onDidChange.fire()}return P}const $={id:r,description:A,defaults:S,deprecationMessage:I};this.iconsById[r]=$;const v={$ref:"#/definitions/icons"};return I&&(v.deprecationMessage=I),A&&(v.markdownDescription=`${A}: $(${r})`),this.iconSchema.properties[r]=v,this.iconReferenceSchema.enum.push(r),this.iconReferenceSchema.enumDescriptions.push(A||""),this._onDidChange.fire(),{id:r}}deregisterIcon(r){delete this.iconsById[r],delete this.iconSchema.properties[r];const S=this.iconReferenceSchema.enum.indexOf(r);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(r=>this.iconsById[r])}getIcon(r){return this.iconsById[r]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(r,S){const A=this.iconFontsById[r];return A||(this.iconFontsById[r]=S,this._onDidChange.fire(),S)}deregisterIconFont(r){delete this.iconFontsById[r]}getIconFont(r){return this.iconFontsById[r]}toString(){const r=(P,$)=>P.id.localeCompare($.id),S=P=>{for(;z.ThemeIcon.isThemeIcon(P.defaults);)P=this.iconsById[P.defaults.id];return`codicon codicon-${P?P.id:""}`},A=[];A.push("| preview     | identifier                        | default codicon ID                | description"),A.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const I=Object.keys(this.iconsById).map(P=>this.iconsById[P]);for(const P of I.filter($=>!!$.description).sort(r))A.push(`|<i class="${S(P)}"></i>|${P.id}|${z.ThemeIcon.isThemeIcon(P.defaults)?P.defaults.id:P.id}|${P.description||""}|`);A.push("| preview     | identifier                        "),A.push("| ----------- | --------------------------------- |");for(const P of I.filter($=>!z.ThemeIcon.isThemeIcon($.defaults)).sort(r))A.push(`|<i class="${S(P)}"></i>|${P.id}|`);return A.join(`
`)}}const s=new e;B.Registry.add(t.Extensions.IconContribution,s);function o(p,r,S,A){return s.registerIcon(p,r,S,A)}function l(){return s}function d(){const p=(0,x.getCodiconFontCharacters)();for(const r in p){const S="\\"+p[r].toString(16);s.registerIcon(r,{fontCharacter:S})}}d(),t.iconsSchemaId="vscode://schemas/icons";const C=B.Registry.as(b.Extensions.JSONContribution);C.registerSchema(t.iconsSchemaId,s.getIconSchema());const m=new i.RunOnceScheduler(()=>C.notifySchemaChanged(t.iconsSchemaId),200);s.onDidChange(()=>{m.isScheduled()||m.schedule()}),t.widgetClose=o("widget-close",N.Codicon.close,(0,g.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",N.Codicon.arrowUp,(0,g.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",N.Codicon.arrowDown,(0,g.localize)(4,null)),t.syncing=z.ThemeIcon.modify(N.Codicon.sync,"spin"),t.spinningLoading=z.ThemeIcon.modify(N.Codicon.loading,"spin")}),define(me[155],pe([1,0,4,3,2,19,154]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=T;function T(g){const b=new x.DisposableStore,B=b.add(new N.Emitter),c=(0,_.getIconRegistry)();return b.add(c.onDidChange(()=>B.fire())),g&&b.add(g.onDidProductIconThemeChange(()=>B.fire())),{dispose:()=>b.dispose(),onDidChange:B.event,getCSS(){const u=g?g.getProductIconTheme():new f,e={},s=[],o=[];for(const l of c.getIcons()){const d=u.getIcon(l);if(!d)continue;const C=d.font,m=`--vscode-icon-${l.id}-font-family`,p=`--vscode-icon-${l.id}-content`;C?(e[C.id]=C.definition,o.push(`${m}: ${(0,i.asCSSPropertyValue)(C.id)};`,`${p}: '${d.fontCharacter}';`),s.push(`.codicon-${l.id}:before { content: '${d.fontCharacter}'; font-family: ${(0,i.asCSSPropertyValue)(C.id)}; }`)):(o.push(`${p}: '${d.fontCharacter}'; ${m}: 'codicon';`),s.push(`.codicon-${l.id}:before { content: '${d.fontCharacter}'; }`))}for(const l in e){const d=e[l],C=d.weight?`font-weight: ${d.weight};`:"",m=d.style?`font-style: ${d.style};`:"",p=d.src.map(r=>`${(0,i.asCSSUrl)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${p}; font-family: ${(0,i.asCSSPropertyValue)(l)};${C}${m} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class f{getIcon(b){const B=(0,_.getIconRegistry)();let c=b.defaults;for(;z.ThemeIcon.isThemeIcon(c);){const u=B.getIcon(c.id);if(!u)return;c=u.defaults}return c}}t.UnthemedProductIconTheme=f}),define(me[156],pe([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=N,t.isWorkspaceToOpen=x,t.isFolderToOpen=z,t.isFileToOpen=_,t.getMenuBarVisibility=T,t.hasCustomTitlebar=B,t.hasNativeTitlebar=c,t.getTitleBarStyle=u,t.useWindowControlsOverlay=e,t.useNativeFullScreen=s,t.zoomLevelToZoomFactor=o,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(l){return typeof l.parentId=="number"}function x(l){return!!l.workspaceUri}function z(l){return!!l.folderUri}function _(l){return!!l.fileUri}function T(l){const d=c(l),C=l.getValue("window.menuBarVisibility");return C==="default"||d&&C==="compact"||i.isMacintosh&&i.isNative?"classic":C}var f;(function(l){l.TITLE_BAR_STYLE="window.titleBarStyle",l.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(f||(t.TitleBarSetting=f={}));var g;(function(l){l.NATIVE="native",l.CUSTOM="custom"})(g||(t.TitlebarStyle=g={}));var b;(function(l){l.AUTO="auto",l.WINDOWED="windowed",l.NEVER="never"})(b||(t.CustomTitleBarVisibility=b={}));function B(l,d){return!0}function c(l,d){return d||(d=u(l)),d==="native"}function u(l){if(i.isWeb)return"custom";const d=l.getValue("window");if(d){if(i.isMacintosh&&d.nativeTabs===!0||i.isMacintosh&&d.nativeFullScreen===!1)return"native";const p=d.titleBarStyle;if(p==="native"||p==="custom")return p}return i.isLinux?"native":"custom"}function e(l){return!(!i.isWindows||i.isWeb||c(l))}function s(l){const d=l.getValue("window");return!d||typeof d.nativeFullScreen!="boolean"||d.nativeTabs?!0:d.nativeFullScreen!==!1}function o(l=0){return Math.pow(1.2,l)}}),define(me[157],pe([1,0,17,4,22,35,156]),function(ne,t,i,N,x,z,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=f,t.zoomIn=b,t.zoomOut=B;var T;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(T||(t.ApplyZoomTarget=T={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function f(c,u){c=Math.min(Math.max(c,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];u===T.ACTIVE_WINDOW?e.push((0,N.getActiveWindow)()):u===T.ALL_WINDOWS?e.push(...Array.from((0,N.getWindows)()).map(({window:s})=>s)):e.push(u);for(const s of e)g(s)?.webFrame?.setZoomLevel(c),(0,i.setZoomFactor)((0,_.zoomLevelToZoomFactor)(c),s),(0,i.setZoomLevel)(c,s)}function g(c){if(c===x.mainWindow)return{ipcRenderer:z.ipcRenderer,webFrame:z.webFrame};{const u=c;if(u?.vscode?.ipcRenderer&&u?.vscode?.webFrame)return u.vscode}}function b(c){f((0,i.getZoomLevel)(typeof c=="number"?(0,N.getActiveWindow)():c)+1,c)}function B(c){f((0,i.getZoomLevel)(typeof c=="number"?(0,N.getActiveWindow)():c)-1,c)}}),define(me[158],pe([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(ne,t,i,N,x,z,_,T,f,g,b,B,c,u,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=O;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class d{getHeight(L){return 22}getTemplateId(L){return P(L)?"process":A(L)?"machine":(0,f.isRemoteDiagnosticError)(L)?"error":I(L)?"header":""}}class C{hasChildren(L){return(0,f.isRemoteDiagnosticError)(L)?!1:P(L)?!!L.children?.length:!0}getChildren(L){return P(L)?L.children?L.children:[]:(0,f.isRemoteDiagnosticError)(L)?[]:I(L)?L.processRoots.length>1?L.processRoots:[L.processRoots[0].rootProcess]:A(L)?[L.rootProcess]:[L.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(L){const W=(0,N.append)(L,(0,N.$)(".row")),M=(0,N.append)(W,(0,N.$)(".nameLabel")),G=(0,N.append)(W,(0,N.$)(".cpu")),K=(0,N.append)(W,(0,N.$)(".memory")),ae=(0,N.append)(W,(0,N.$)(".pid"));return{name:M,CPU:G,memory:K,PID:ae}}renderElement(L,W,M,G){M.name.textContent=(0,i.localize)(0,null),M.CPU.textContent=(0,i.localize)(1,null),M.PID.textContent=(0,i.localize)(2,null),M.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(L){}}class p{constructor(){this.templateId="machine"}renderTemplate(L){const W=Object.create(null),M=(0,N.append)(L,(0,N.$)(".row"));return W.name=(0,N.append)(M,(0,N.$)(".nameLabel")),W}renderElement(L,W,M,G){M.name.textContent=L.element.name}disposeTemplate(L){}}class r{constructor(){this.templateId="error"}renderTemplate(L){const W=Object.create(null),M=(0,N.append)(L,(0,N.$)(".row"));return W.name=(0,N.append)(M,(0,N.$)(".nameLabel")),W}renderElement(L,W,M,G){M.name.textContent=L.element.errorMessage}disposeTemplate(L){}}class S{constructor(L,W,M){this.platform=L,this.totalMem=W,this.mapPidToName=M,this.templateId="process"}renderTemplate(L){const W=(0,N.append)(L,(0,N.$)(".row")),M=(0,N.append)(W,(0,N.$)(".nameLabel")),G=(0,N.append)(W,(0,N.$)(".cpu")),K=(0,N.append)(W,(0,N.$)(".memory")),ae=(0,N.append)(W,(0,N.$)(".pid"));return{name:M,CPU:G,PID:ae,memory:K}}renderElement(L,W,M,G){const{element:K}=L,ae=K.pid.toFixed(0);let ie=K.name;this.mapPidToName.has(K.pid)&&(ie=this.mapPidToName.get(K.pid)),M.name.textContent=ie,M.name.title=K.cmd,M.CPU.textContent=K.load.toFixed(0),M.PID.textContent=ae,M.PID.parentElement.id=`pid-${ae}`;const ee=this.platform==="win32"?K.mem:this.totalMem*(K.mem/100);M.memory.textContent=(ee/g.ByteSize.MB).toFixed(0)}disposeTemplate(L){}}function A(q){return!!q.name&&!!q.rootProcess}function I(q){return!!q.processRoots}function P(q){return!!q.pid}class ${constructor(L,W){this.data=W,this.mapPidToName=new Map;const M=new b.ElectronIPCMainProcessService(L);this.nativeHostService=new B.NativeHostService(L,M),this.applyStyles(W.styles),this.setEventHandlers(W),T.ipcRenderer.on("vscode:pidToNameResponse",(G,K)=>{this.mapPidToName.clear();for(const[ae,ie]of K)this.mapPidToName.set(ae,ie)}),T.ipcRenderer.on("vscode:listProcessesResponse",async(G,K)=>{K.forEach((ae,ie)=>{P(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:K}}),this.tree.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth)):await this.createProcessTree(K),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),T.ipcRenderer.send("vscode:pidToNameRequest"),T.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(L){s.mainWindow.document.onkeydown=W=>{const M=L.platform==="darwin"?W.metaKey:W.ctrlKey;M&&W.keyCode===87&&(W.stopPropagation(),W.preventDefault(),T.ipcRenderer.send("vscode:closeProcessExplorer")),M&&W.keyCode===187&&(0,u.zoomIn)(s.mainWindow),M&&W.keyCode===189&&(0,u.zoomOut)(s.mainWindow)}}async createProcessTree(L){const W=s.mainWindow.document.getElementById("process-list");if(!W)return;const{totalmem:M}=await this.nativeHostService.getOSStatistics(),G=[new S(this.data.platform,M,this.mapPidToName),new m,new p,new r];this.tree=new x.DataTree("processExplorer",W,new d,G,new C,{identityProvider:{getId:K=>P(K)?K.pid.toString():(0,f.isRemoteDiagnosticError)(K)?K.hostName:I(K)?"processes":A(K)?K.name:"header"}}),this.tree.setInput({processes:{processRoots:L}}),this.tree.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth),this.tree.onKeyDown(K=>{const ae=new e.StandardKeyboardEvent(K);if(ae.keyCode===35&&ae.altKey){const ie=this.getSelectedPids();Promise.all(ie.map(ee=>this.nativeHostService.killProcess(ee,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(K=>{P(K.element)&&this.showContextMenu(K.element,!0)}),W.style.height=`${s.mainWindow.innerHeight}px`,s.mainWindow.addEventListener("resize",()=>{W.style.height=`${s.mainWindow.innerHeight}px`,this.tree?.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth)})}isDebuggable(L){const W=o.exec(L);return W&&W.groups.port!=="0"||L.indexOf("node ")>=0||L.indexOf("node.exe")>=0}attachTo(L){const W={type:"node",request:"attach",name:`process ${L.pid}`};let M=o.exec(L.cmd);M?W.port=Number(M.groups.port):W.processId=String(L.pid),M=l.exec(L.cmd),M&&(W.port=Number(M.groups.port)),T.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[W]})}applyStyles(L){const W=(0,N.createStyleSheet)(),M=[];L.listFocusBackground&&(M.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${L.listFocusBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${L.listFocusBackground}; }`)),L.listFocusForeground&&M.push(`.monaco-list:focus .monaco-list-row.focused { color: ${L.listFocusForeground}; }`),L.listActiveSelectionBackground&&(M.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${L.listActiveSelectionBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${L.listActiveSelectionBackground}; }`)),L.listActiveSelectionForeground&&M.push(`.monaco-list:focus .monaco-list-row.selected { color: ${L.listActiveSelectionForeground}; }`),L.listHoverBackground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${L.listHoverBackground}; }`),L.listHoverForeground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${L.listHoverForeground}; }`),L.listFocusOutline&&M.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${L.listFocusOutline}; outline-offset: -1px; }`),L.listHoverOutline&&M.push(`.monaco-list-row:hover { outline: 1px dashed ${L.listHoverOutline}; outline-offset: -1px; }`),L.scrollbarShadowColor&&M.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${L.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${L.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${L.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),L.scrollbarSliderBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${L.scrollbarSliderBackgroundColor};
				}
			`),L.scrollbarSliderHoverBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${L.scrollbarSliderHoverBackgroundColor};
				}
			`),L.scrollbarSliderActiveBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${L.scrollbarSliderActiveBackgroundColor};
				}
			`),W.textContent=M.join(`
`),L.color&&(s.mainWindow.document.body.style.color=L.color)}showContextMenu(L,W){const M=[],G=Number(L.pid);W&&(M.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.nativeHostService.killProcess(G,"SIGTERM")}}),M.push({label:(0,i.localize)(5,null),click:()=>{this.nativeHostService.killProcess(G,"SIGKILL")}}),M.push({type:"separator"})),M.push({label:(0,i.localize)(6,null),click:()=>{const K=this.getSelectedPids();K?.includes(G)||(K.length=0,K.push(G));const ae=K?.map(ie=>s.mainWindow.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.nativeHostService.writeClipboardText(ie.join(`
`))}}}),M.push({label:(0,i.localize)(7,null),click:()=>{const K=s.mainWindow.document.getElementById("process-list");K&&this.nativeHostService.writeClipboardText(K.innerText)}}),L&&W&&this.isDebuggable(L.cmd)&&(M.push({type:"separator"}),M.push({label:(0,i.localize)(8,null),click:()=>{this.attachTo(L)}})),(0,_.popup)(M)}requestProcessList(L){setTimeout(()=>{const W=Date.now(),M=L+W-this.lastRequestTime;this.lastRequestTime=W,M>1e3?(T.ipcRenderer.send("vscode:pidToNameRequest"),T.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(M)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(L=>{if(!(!L||!("pid"in L)))return L.pid}).filter(L=>!!L)}}function v(){const q=(0,N.createStyleSheet)();q.id="codiconStyles";const L=(0,c.getIconsStyleSheet)(void 0);function W(){q.textContent=L.getCSS()}const M=new z.RunOnceScheduler(W,0);L.onDidChange(()=>M.schedule()),M.schedule()}function O(q){const L=q.data.platform==="win32"?"windows":q.data.platform==="linux"?"linux":"mac";s.mainWindow.document.body.classList.add(L),v(),(0,u.applyZoom)(q.data.zoomLevel,s.mainWindow),new $(q.windowId,q.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4379b66f0d4dd9881ba96fa086f387725b69a24b/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
